<?php
	function genera_entero( )
	{
		return mt_rand(100000, 300000);
	}

	function genera_cadena( )
	{
		$res = substr(md5(mt_rand( )), 0, mt_rand(4, 7));
		
		for ($i = 0; $i < strlen($res); ++$i) {
			if (ctype_digit($res[$i])) {
				$res[$i] = chr(ord($res[$i]) - ord('0') + ord('g'));
			}
		}
		
		return $res;
	}
	
	function genera_unicos($f, $n)
	{
		$arr = [ ];
		
		while (count($arr) < $n) {
			$arr[$f( )] = true;
		}
		
		return array_keys($arr);
	}
	
	function genera_cadenas_unicas($n)
	{
		return genera_unicos('genera_cadena', $n);
	}
	
	function genera_enteros_unicos($n)
	{
		return genera_unicos('genera_entero', $n);
	}
	
	function genera_carreras($n)
	{
		$nombres = genera_cadenas_unicas($n);
		$correos_pre = genera_cadenas_unicas($n);
		$correos_pos = genera_cadenas_unicas($n);
		$filas = [ ];

		for ($i = 0; $i < $n; ++$i) {
			$filas[] = "('{$nombres[$i]}', '{$correos_pre[$i]}@{$correos_pos[$i]}')";
		}
		
		echo "INSERT INTO carreras (nombre, correo) VALUES\n\t", implode(",\n\t", $filas), ";\n";
		return $nombres;
	}
	
	function genera_materias($n, $c)
	{
		$nombres = genera_cadenas_unicas($n);
		$filas = [ ];
		
		foreach ($nombres as $nombre) {
			$creditos = mt_rand(2, 5) * 3;
			$filas[] = "('$nombre', $creditos)";
		}
		
		echo "INSERT INTO materias (nombre, creditos) VALUES\n\t", implode(",\n\t", $filas), ";\n";
		return $nombres;
	}
	
	function genera_alumnos($n, $c)
	{
		$matriculas = genera_enteros_unicos($n);
		$filas = [ ];

		foreach ($matriculas as $matricula) {
			$nombre = genera_cadena( );
			$apellido = genera_cadena( );
			$carrera = mt_rand(1, $c);

			$filas[] = "($matricula, '$nombre', '$apellido', $carrera)";
		}
		
		echo "INSERT INTO alumnos (matricula, nombre, apellido, carrera) VALUES\n\t", implode(",\n\t", $filas), ";\n";
		return $matriculas;
	}
	
	function genera_kardex($n, $matriculas, $m)
	{
		shuffle($matriculas);
		$filas = [ ];
		
		foreach ($matriculas as $matricula) {
			$cuantas = mt_rand(0, $n);
			
			for ($i = 0; $i < $cuantas; ++$i) {
				$materia = mt_rand(1, $m);
				$trimestre = mt_rand(2003, 2015) * 10 + mt_rand(1, 4);
				$calificacion = mt_rand(5, 10);
				
				$filas[] = "($matricula, $materia, $trimestre, $calificacion)";
			}
		}
		
		echo "INSERT IGNORE INTO kardex (matricula, materia, trimestre, calificacion) VALUES\n\t", implode(",\n\t", $filas), ";\n";
	}
	
	mt_srand(0);
	
	$c = 100;
	$m = 500;
	$n = 1000;
	$k = 20;
	
	ob_start( ); {
		readfile('db_examen2_SIN-FILAS.sql');
		
		echo "\n\n";
		echo "USE ejemplo;\n";
		echo "SET FOREIGN_KEY_CHECKS = 0;\n";
		echo "\n";
		
		$carreras = genera_carreras($c);
		$materias = genera_materias($m, $c);
		$matriculas = genera_alumnos($n, $c);
		genera_kardex($k, $matriculas, $m);
		
		echo "\n";
		echo "SET FOREIGN_KEY_CHECKS = 1;\n";
	} file_put_contents('db_examen2.sql', ob_get_clean( ));
?>