USE ejemplo;
SET FOREIGN_KEY_CHECKS = 0;

DROP TABLE IF EXISTS carreras;
CREATE TABLE carreras (
   id INT NOT NULL AUTO_INCREMENT,
   nombre TEXT NOT NULL,
   correo TEXT NOT NULL,
    
   PRIMARY KEY (id),
   UNIQUE (nombre(16))
) ENGINE=InnoDB;

DROP TABLE IF EXISTS materias;
CREATE TABLE materias (
   id INT NOT NULL AUTO_INCREMENT,
   nombre TEXT NOT NULL,
   creditos INT NOT NULL,
    
   PRIMARY KEY (id),
   UNIQUE (nombre(16))
) ENGINE=InnoDB;

DROP TABLE IF EXISTS alumnos;
CREATE TABLE alumnos (
   matricula INT NOT NULL,
   nombre TEXT NOT NULL,
   apellido TEXT NOT NULL,
   carrera INT NOT NULL,
    
   PRIMARY KEY (matricula),
   FOREIGN KEY (carrera) REFERENCES carreras (id)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS kardex;
CREATE TABLE kardex (
	matricula INT NOT NULL,
	materia INT NULL,
	trimestre INT NOT NULL,
	calificacion INT NOT NULL,
	
	UNIQUE (matricula, materia, trimestre),
	FOREIGN KEY (matricula) REFERENCES alumnos (matricula) ON DELETE CASCADE,
	FOREIGN KEY (materia) REFERENCES materias (id) ON DELETE SET NULL
) ENGINE=InnoDB;

SET FOREIGN_KEY_CHECKS = 1;


USE ejemplo;
SET FOREIGN_KEY_CHECKS = 0;

INSERT INTO carreras (nombre, correo) VALUES
	('dnnkaj', 'dacemo@edopgbd'),
	('lhnd', 'hnaphi@afoo'),
	('dicikhd', 'jedgh@fockg'),
	('hjcdlhi', 'ighic@iolpl'),
	('ceegoj', 'imfn@ndje'),
	('gpcile', 'onhiml@nfbkdh'),
	('bpeml', 'bpklaik@gieibb'),
	('ajjk', 'oiogof@ghlogc'),
	('eiinmf', 'hhhgogo@olpch'),
	('ijmjc', 'clndff@dfjkak'),
	('hhjpggn', 'mdpelo@ifcak'),
	('fjhmao', 'lclfgmi@mfpon'),
	('cjfam', 'ikcfepc@dkpk'),
	('lphafkn', 'jpdi@eefggpn'),
	('bjldo', 'lmcec@odpaamo'),
	('ffcpf', 'obipo@cgpkjea'),
	('bppiib', 'pmkmlho@mojo'),
	('fcle', 'hgdhl@okmhn'),
	('ehpdjah', 'llepdhp@eiakh'),
	('ikob', 'cilhl@akhda'),
	('ilepcl', 'ipfbg@nnpikah'),
	('fnpagbh', 'oalhed@mobbf'),
	('ebmni', 'coin@epodok'),
	('heici', 'nnnoag@oajc'),
	('piehm', 'calle@dibnk'),
	('nlhpp', 'hdfmd@libgj'),
	('oedpe', 'khibok@ibhjgf'),
	('ioea', 'addccj@hipmacj'),
	('fade', 'ieedk@cnmffkp'),
	('ekjgoa', 'olbfa@bjjo'),
	('idnnfpm', 'pcibka@kdbnjb'),
	('acgje', 'logpigk@opib'),
	('ggalapk', 'ahob@fpfbgf'),
	('lfia', 'acgmfln@pkipb'),
	('jjlbcl', 'gbdpd@ffei'),
	('mifc', 'hamfno@ophfdg'),
	('hkokipl', 'bmbb@hccacc'),
	('jcodh', 'biojeep@hlhe'),
	('fmiijhd', 'cgobn@phpb'),
	('ahmpn', 'bkkp@diea'),
	('leogm', 'mcojmdb@kklag'),
	('fmgl', 'hafl@ikkmab'),
	('mepippf', 'egmm@jleejf'),
	('gocl', 'cjcebo@bdcaooh'),
	('ondek', 'cgnpfp@ohomn'),
	('eoee', 'fbfboi@knmmo'),
	('hempkf', 'lebp@lbil'),
	('fmdn', 'bhdjm@nbmdacl'),
	('ahldg', 'fmppnf@pajc'),
	('cnikel', 'hfinieo@bclepdd'),
	('goig', 'hfabaoc@cheaan'),
	('flfhod', 'gldm@aglaaba'),
	('boplooe', 'glpebm@feffl'),
	('jfadc', 'fbplgdi@gpeb'),
	('acfohh', 'ikci@fckacgd'),
	('ieig', 'alngcmb@olkoeo'),
	('blegfd', 'knoib@maimk'),
	('cpodfk', 'lggf@dgiifki'),
	('ejkpm', 'ijiiioc@gaja'),
	('pfhbno', 'dbae@mmlfb'),
	('eebfii', 'kgegdh@lldfal'),
	('epjbhk', 'eldokf@njpf'),
	('gncama', 'bkjj@obpkpm'),
	('anai', 'bfcfk@megk'),
	('igighap', 'jdodnoh@kekk'),
	('gckhma', 'jdde@kgfobfo'),
	('idigcef', 'kacb@naalpg'),
	('pckfl', 'npjd@nofilmn'),
	('jmlfkd', 'gjdpdm@kkjem'),
	('iapnmee', 'mmffoj@nipjl'),
	('bkgl', 'pbkejf@nhbgnjc'),
	('blhmm', 'ebaphk@nihdbo'),
	('kmkm', 'dnda@cjepagf'),
	('bklkph', 'kfnl@pglphf'),
	('bmfk', 'icobh@fjmonfa'),
	('mlfbeh', 'olkp@pebdj'),
	('mlphikn', 'bfjh@ggaam'),
	('kcnbf', 'glnjj@jgake'),
	('nkaiec', 'oomalp@cplke'),
	('obona', 'fgljhjc@fioold'),
	('iabnfoh', 'iajfp@hcho'),
	('plldfce', 'gbkclhl@jdhm'),
	('cflp', 'ijlgdd@imhk'),
	('igpldk', 'gofppem@nodi'),
	('fkkcmop', 'dkecjp@mckg'),
	('ajfpok', 'lhjaka@cdjm'),
	('lgldoei', 'ekff@flkb'),
	('oplbldp', 'emeejce@ajfb'),
	('paac', 'injgjii@oodn'),
	('egmdab', 'nhhog@dadhng'),
	('oefaonj', 'goignpe@abdci'),
	('mnaedfo', 'gidchbl@pjdcp'),
	('cgjhoo', 'giip@coobap'),
	('mkbkhdk', 'lehkka@emhjp'),
	('amgji', 'pnikam@ocmcpbk'),
	('noidgh', 'clka@ojdi'),
	('iaiikl', 'ioeok@cbgpho'),
	('gmfafhi', 'kjknpll@fhino'),
	('boogjo', 'ojpe@llgigl'),
	('lceodja', 'cehgpe@jjgnhbm');
INSERT INTO materias (nombre, creditos) VALUES
	('dimppc', 9),
	('iikoj', 12),
	('oekac', 6),
	('dlihnb', 12),
	('ofhf', 12),
	('clacngk', 6),
	('pbcgi', 9),
	('fcaa', 12),
	('aieaihl', 9),
	('jjenn', 15),
	('npkee', 15),
	('adcmdmb', 6),
	('lmpibe', 15),
	('gmbcohj', 12),
	('alcl', 15),
	('cdpha', 6),
	('fcpo', 6),
	('ibfib', 6),
	('hebfm', 6),
	('ijik', 15),
	('dknjcfl', 15),
	('onfci', 12),
	('lecgio', 9),
	('nkmp', 9),
	('ieheo', 9),
	('lkpege', 12),
	('mfijob', 6),
	('pjlmgp', 6),
	('koebdbm', 9),
	('pibjnd', 9),
	('nleaemg', 6),
	('ejddoj', 6),
	('cpcm', 9),
	('ckmfncj', 12),
	('ogkni', 9),
	('ijkdlch', 15),
	('ghjgln', 12),
	('ckbbad', 15),
	('pcgmdb', 9),
	('ffiel', 12),
	('kehm', 9),
	('idodd', 9),
	('ebmga', 6),
	('kdnl', 12),
	('gaeh', 12),
	('eplfl', 9),
	('nhbfik', 15),
	('enbcim', 15),
	('ijnbcnj', 9),
	('ndpk', 9),
	('bpndi', 6),
	('gpnp', 12),
	('oihohjd', 12),
	('ocloei', 12),
	('knfjc', 6),
	('ibbdcga', 6),
	('icinfia', 15),
	('adoako', 12),
	('gffol', 15),
	('pccep', 12),
	('mfmean', 6),
	('bmgb', 6),
	('gogo', 6),
	('kmjgmeo', 15),
	('chdidmi', 15),
	('genlcc', 6),
	('iohp', 12),
	('gndbon', 12),
	('pennk', 6),
	('ofbkdeb', 12),
	('kmgfd', 6),
	('eoloi', 9),
	('phpjn', 9),
	('kblcef', 6),
	('coebhb', 12),
	('iejai', 12),
	('maehn', 15),
	('agde', 15),
	('gjbg', 15),
	('obhdch', 9),
	('hidck', 12),
	('jinkjgm', 9),
	('ahbeloe', 15),
	('mgngm', 12),
	('hmnjoei', 12),
	('kepfho', 12),
	('gdmnofh', 9),
	('dmklj', 12),
	('mhnplh', 12),
	('adod', 6),
	('hkbkk', 6),
	('fklc', 12),
	('hcdlo', 9),
	('ffleij', 9),
	('jgdhjl', 15),
	('gcfd', 15),
	('alklh', 6),
	('dhnljj', 12),
	('oeide', 15),
	('ljiiigi', 9),
	('hiipak', 12),
	('kchabgn', 6),
	('pldk', 6),
	('nkpjjoe', 9),
	('bpnnamm', 15),
	('ndoa', 15),
	('lheo', 6),
	('hndig', 12),
	('mdki', 12),
	('ljdo', 12),
	('ageb', 9),
	('mman', 12),
	('kahbcj', 6),
	('ddcn', 9),
	('bhmdo', 15),
	('daffkci', 9),
	('ehni', 12),
	('enei', 15),
	('bfheaoe', 9),
	('limk', 12),
	('cmjgmb', 15),
	('fpldgfb', 12),
	('djeajaj', 6),
	('gplj', 6),
	('oeeeom', 9),
	('emimi', 9),
	('lpflpp', 15),
	('hjekojk', 6),
	('caldh', 12),
	('njed', 9),
	('emnebmh', 15),
	('olcic', 9),
	('ogjmmb', 12),
	('codmee', 12),
	('mapgfk', 6),
	('egndjdj', 12),
	('igmhlfp', 15),
	('ocih', 9),
	('moddo', 6),
	('emcp', 15),
	('kamjg', 9),
	('kphgcnk', 9),
	('iehl', 9),
	('ipfi', 12),
	('knfbkae', 9),
	('ggehcgh', 15),
	('afhdg', 15),
	('eelem', 9),
	('cmcl', 15),
	('nknn', 12),
	('npncpo', 6),
	('mfdopcl', 12),
	('eoghiko', 9),
	('cdbbn', 9),
	('pfbinn', 6),
	('jlab', 9),
	('cnjgab', 9),
	('hccn', 6),
	('lbnel', 12),
	('ihepm', 12),
	('jedflcl', 12),
	('bjlibcp', 15),
	('obmhbh', 9),
	('fmcdpp', 6),
	('dibb', 12),
	('deoigcj', 6),
	('cmpgim', 9),
	('clfl', 15),
	('cddop', 12),
	('gibajo', 15),
	('pehphh', 12),
	('olbaeil', 9),
	('lpkgj', 9),
	('obhc', 15),
	('olgpah', 6),
	('ohakpp', 9),
	('ifeimnh', 9),
	('hndeko', 9),
	('bpfe', 12),
	('cdffnb', 6),
	('fibfga', 9),
	('eiiebf', 6),
	('cjdpf', 9),
	('ibgllmf', 6),
	('bjlpji', 9),
	('hhph', 6),
	('gcccja', 9),
	('mhfg', 6),
	('igpcgi', 6),
	('ljgbei', 6),
	('dhog', 6),
	('fhldao', 15),
	('igfhgp', 6),
	('lakeldm', 12),
	('bmedg', 12),
	('abohkjc', 15),
	('gbpnk', 9),
	('ohmpg', 12),
	('pladko', 6),
	('cbcei', 12),
	('dldn', 6),
	('ioilicp', 15),
	('cahod', 9),
	('amjclp', 12),
	('naidlj', 9),
	('cpknhj', 9),
	('caijhl', 9),
	('jfhien', 15),
	('mndgeaf', 9),
	('afdh', 6),
	('nfkih', 6),
	('godl', 12),
	('ipah', 9),
	('dkpi', 6),
	('ojbdll', 12),
	('glpjo', 6),
	('cioiilb', 12),
	('ganmaph', 9),
	('odlgj', 9),
	('fjmac', 12),
	('bfbgioo', 15),
	('klndaej', 6),
	('bcjcfg', 9),
	('nbchlk', 15),
	('lddlpc', 15),
	('papnff', 6),
	('eohhopl', 9),
	('apbjeei', 6),
	('dcmob', 15),
	('iaffi', 15),
	('bmchbhb', 6),
	('einoan', 6),
	('damo', 9),
	('madi', 9),
	('bfhahnj', 9),
	('pdmc', 6),
	('ddlilde', 9),
	('nedkf', 9),
	('nbbglc', 12),
	('eogn', 6),
	('dhppjhi', 12),
	('fokcfno', 6),
	('fpfgeeg', 12),
	('goccee', 12),
	('fkgha', 12),
	('jmio', 12),
	('hjaa', 6),
	('hcjbe', 6),
	('bmho', 12),
	('clpmmg', 12),
	('cggabm', 6),
	('bpmo', 9),
	('makno', 6),
	('ccppind', 12),
	('aaacdm', 6),
	('lofndah', 9),
	('ifghi', 9),
	('befcgjc', 6),
	('caepb', 6),
	('ifkjbgj', 12),
	('mcmnf', 9),
	('aiagnf', 12),
	('odgac', 9),
	('oeclk', 9),
	('feboemd', 6),
	('piopnh', 15),
	('agnelnp', 9),
	('mhbic', 6),
	('fmok', 6),
	('knhfp', 12),
	('cnkf', 9),
	('dfemnk', 15),
	('pgpl', 15),
	('nbgb', 15),
	('fegk', 9),
	('dmbmmk', 9),
	('ijpo', 9),
	('fgmfnd', 12),
	('pglfimn', 15),
	('hjahamh', 12),
	('cdejmk', 12),
	('hhommkg', 9),
	('pjbkhj', 9),
	('oiajgdh', 12),
	('lhpimf', 15),
	('jmflmmc', 6),
	('npeag', 12),
	('npma', 15),
	('apao', 6),
	('ngdnifl', 15),
	('nfoedaj', 12),
	('donmd', 9),
	('nmml', 15),
	('gpdhko', 15),
	('bfnf', 15),
	('ekpeff', 6),
	('pagm', 9),
	('pbej', 6),
	('cdmipaa', 6),
	('pppno', 9),
	('hdgnb', 15),
	('pjmdkek', 6),
	('fjpjo', 12),
	('lkjofn', 12),
	('ppjil', 6),
	('bdkmpf', 9),
	('kobgm', 12),
	('hdcllak', 15),
	('nidaa', 12),
	('jpej', 12),
	('icbiob', 9),
	('fnnef', 6),
	('obhla', 15),
	('ahdgdb', 15),
	('cnmg', 9),
	('ompi', 6),
	('nodid', 12),
	('fbjooal', 12),
	('ohcjijo', 6),
	('meikb', 12),
	('kiaj', 12),
	('kidlhj', 12),
	('biahd', 12),
	('hfpfp', 6),
	('bcobh', 15),
	('jffhhb', 9),
	('ekap', 6),
	('bahlke', 9),
	('dkhlfj', 9),
	('eckanb', 15),
	('macop', 6),
	('ipbohdp', 9),
	('oopim', 9),
	('fbigoi', 12),
	('ghnfci', 15),
	('hpem', 12),
	('naophbk', 15),
	('lcga', 9),
	('apkmec', 6),
	('icljdm', 15),
	('oaeebp', 15),
	('gnip', 12),
	('nlmae', 12),
	('odihg', 12),
	('bhfli', 9),
	('ajfpgpm', 15),
	('ihahchj', 9),
	('iofocgm', 12),
	('pipmfgn', 6),
	('bmcdkc', 6),
	('goac', 9),
	('mgikclc', 12),
	('gfgji', 12),
	('hjhl', 12),
	('pkbl', 6),
	('jdmnhdp', 15),
	('dmdjmkc', 9),
	('ijeokjp', 6),
	('lpknf', 9),
	('mhkccb', 15),
	('pfdci', 15),
	('nemk', 15),
	('nbjj', 6),
	('lcji', 9),
	('mlenbnl', 6),
	('cjncoj', 6),
	('fjnf', 12),
	('nboi', 6),
	('kbadejn', 15),
	('pnoagm', 9),
	('lckniai', 15),
	('kpgoi', 9),
	('bebnchh', 15),
	('kpndho', 15),
	('hodl', 9),
	('emiiai', 12),
	('njkanb', 9),
	('kgcdjil', 12),
	('bbnfkop', 6),
	('pfkh', 6),
	('eonhdcp', 15),
	('mpmnkbl', 9),
	('ccoe', 6),
	('imlha', 15),
	('lbonna', 6),
	('imal', 6),
	('ijeioa', 15),
	('eipmmje', 15),
	('fmebjnl', 9),
	('lmenlia', 9),
	('gkbl', 12),
	('mpijl', 15),
	('ggnak', 9),
	('foiljd', 12),
	('nbonhal', 12),
	('pkcc', 12),
	('gmagmb', 6),
	('aaocecf', 12),
	('chklo', 9),
	('heijj', 15),
	('hljnbb', 6),
	('aohg', 9),
	('hlaf', 12),
	('gibg', 9),
	('gjjk', 9),
	('oiiioam', 9),
	('hcfk', 6),
	('fjeb', 15),
	('lbkjbca', 15),
	('aclacc', 6),
	('djld', 6),
	('cdclhj', 12),
	('bnnn', 12),
	('mfgem', 12),
	('nhgh', 15),
	('bklhe', 12),
	('mhmb', 12),
	('eidbnfn', 12),
	('idcb', 15),
	('kpopbi', 9),
	('cjbigl', 9),
	('bjpbjeo', 12),
	('fmjjoki', 15),
	('gbpo', 15),
	('fjdoii', 6),
	('akjpjg', 12),
	('ikceh', 15),
	('ibmlfb', 15),
	('idfhaej', 12),
	('ofgdjc', 15),
	('dolhak', 9),
	('fnpfnbo', 9),
	('mmam', 9),
	('mgjek', 15),
	('dmnol', 9),
	('gdfo', 12),
	('dpgeilh', 9),
	('eabp', 15),
	('bkec', 12),
	('mmcfngf', 15),
	('neme', 6),
	('kgmdb', 9),
	('aaklho', 6),
	('finhk', 9),
	('flbl', 6),
	('neknfok', 6),
	('gpfdh', 12),
	('kmphgb', 15),
	('lmblkek', 12),
	('ffiafim', 9),
	('obee', 12),
	('ngej', 9),
	('fien', 6),
	('mloohe', 15),
	('nnegehc', 9),
	('hoga', 12),
	('ldhljol', 9),
	('ldjk', 6),
	('ineic', 15),
	('hbbpml', 9),
	('millack', 15),
	('dden', 9),
	('gcihcd', 9),
	('olpeed', 15),
	('bajgo', 12),
	('ojif', 15),
	('njcj', 6),
	('ojhoe', 12),
	('gfcmlmh', 9),
	('mnmkfl', 6),
	('abfb', 9),
	('obeh', 12),
	('pgddhac', 9),
	('keeanbi', 6),
	('lcjheo', 15),
	('mcdj', 15),
	('moin', 12),
	('bhlodbl', 9),
	('joljpl', 15),
	('dpih', 6),
	('ifoohi', 6),
	('okpeil', 12),
	('palo', 12),
	('ffhhl', 6),
	('cfoc', 12),
	('kloj', 15),
	('afgp', 15),
	('fdgo', 6),
	('lpnnif', 6),
	('aaplhgc', 12),
	('anbcjpo', 12),
	('eolaljm', 9),
	('npjch', 9),
	('khjfii', 9),
	('fcaldhl', 12),
	('abbfdlg', 15),
	('dlelh', 9),
	('gjilne', 9),
	('ldpj', 12),
	('gannj', 9);
INSERT INTO alumnos (matricula, nombre, apellido, carrera) VALUES
	(195506, 'mhmk', 'memdgl', 95),
	(254260, 'ckbn', 'jlfea', 90),
	(150911, 'llajd', 'hodnnlh', 53),
	(250988, 'dpid', 'oolb', 10),
	(240841, 'mfcbmfj', 'gmicdm', 70),
	(254240, 'miaojjp', 'hpane', 77),
	(265779, 'diamn', 'jeknbab', 2),
	(184124, 'miipac', 'gehio', 15),
	(173713, 'enekjbc', 'opibj', 77),
	(195894, 'hcidp', 'iaoe', 72),
	(128829, 'mgjiogn', 'acbj', 88),
	(266347, 'kgkn', 'iaagd', 84),
	(211858, 'gbgjk', 'ngaeb', 40),
	(115995, 'heamdgb', 'bkcdf', 46),
	(139300, 'gjkaopj', 'mmgfhhp', 9),
	(257668, 'ckljb', 'aoeolh', 52),
	(156882, 'jcpai', 'ljchoj', 82),
	(257425, 'dbiho', 'bnaodpg', 42),
	(188284, 'eepcp', 'oenmo', 1),
	(107227, 'pakin', 'mgehe', 3),
	(240173, 'dbcpcef', 'bpgajl', 99),
	(109898, 'ojebfcf', 'dkkmk', 69),
	(222519, 'kdlnah', 'abmib', 51),
	(276617, 'khdnon', 'mlijle', 47),
	(113338, 'eghgb', 'nhcd', 19),
	(180024, 'kicfm', 'lghphpj', 85),
	(141974, 'cgap', 'eged', 52),
	(105693, 'akjknl', 'eeipob', 96),
	(126095, 'agdbpcf', 'ppleah', 54),
	(129615, 'lmbpd', 'foefdn', 96),
	(109732, 'bcbgi', 'gehon', 12),
	(101554, 'mbffjf', 'gnkm', 17),
	(267064, 'oojcnnl', 'meaja', 100),
	(262119, 'eglilji', 'fgiad', 30),
	(292504, 'epdjboa', 'bpcem', 13),
	(157139, 'bcbpgl', 'kdaif', 98),
	(156307, 'hjalf', 'kfoi', 51),
	(279924, 'paoa', 'khmedo', 86),
	(214084, 'cebh', 'gbjh', 73),
	(262716, 'kddm', 'pljlhn', 9),
	(189237, 'plpocdm', 'ilcip', 11),
	(202978, 'cnnlp', 'odmh', 12),
	(233698, 'ilneo', 'bjhab', 42),
	(149417, 'kjjoacn', 'lehllj', 52),
	(220177, 'hpbl', 'bibmplb', 12),
	(240398, 'hjnhaa', 'bplgjl', 41),
	(166900, 'dlccnjk', 'afkjmjo', 47),
	(188830, 'cbbfm', 'jnbaopp', 3),
	(258188, 'coni', 'fmgo', 74),
	(229378, 'ijig', 'jnbm', 58),
	(223470, 'gifo', 'ndfnmk', 92),
	(136583, 'cgmeien', 'pkpjhkc', 22),
	(117804, 'emipcac', 'bhkcac', 7),
	(163597, 'nolpooc', 'lihdcio', 29),
	(154174, 'dmeae', 'ofdda', 66),
	(270627, 'ejpn', 'bcclka', 46),
	(153136, 'ackmcp', 'miol', 10),
	(207833, 'ckoii', 'hfif', 54),
	(196768, 'boem', 'imofff', 59),
	(111066, 'iapjd', 'kpjai', 12),
	(274421, 'jnlad', 'bkikini', 87),
	(258411, 'cofham', 'cenmfc', 40),
	(294125, 'lcike', 'ckkmbgb', 43),
	(120950, 'pbggfm', 'okjckm', 5),
	(230380, 'efpkli', 'nmge', 67),
	(190018, 'kkef', 'oifaoho', 96),
	(117397, 'ecmcgo', 'ccme', 59),
	(269642, 'mblgje', 'cofe', 96),
	(108413, 'nenepm', 'jegaidb', 18),
	(217142, 'cjanao', 'kefo', 82),
	(180925, 'canhf', 'apmjn', 38),
	(194253, 'kjnkh', 'jncidcd', 22),
	(258668, 'odhefhh', 'ceejkij', 86),
	(125443, 'depjag', 'oohdel', 85),
	(125483, 'clcnojp', 'ljggfi', 17),
	(224075, 'fhenpl', 'fpbabbj', 68),
	(197216, 'oomca', 'efpk', 10),
	(155829, 'hfci', 'lpnkho', 79),
	(122514, 'afcp', 'ammenpm', 16),
	(282449, 'agddojp', 'kheeo', 69),
	(159914, 'jeiejad', 'gpmca', 86),
	(165589, 'idcebof', 'almgh', 49),
	(126361, 'kjcp', 'icaollb', 9),
	(197644, 'jedpdh', 'ildeee', 74),
	(132642, 'bingd', 'bfmo', 19),
	(142779, 'agpdk', 'mheddho', 9),
	(114420, 'ijjb', 'okefd', 39),
	(227363, 'fddf', 'cldic', 75),
	(191238, 'jcdjb', 'gendook', 26),
	(200620, 'nnjj', 'imjfae', 33),
	(254152, 'goah', 'dfanfph', 50),
	(273331, 'fgflo', 'chlkncd', 44),
	(123027, 'jbphdmo', 'gjfk', 12),
	(241408, 'bmbhnf', 'bojppa', 67),
	(118765, 'ncaffpm', 'pelhbe', 86),
	(168847, 'hgjmb', 'pjpdbo', 43),
	(292387, 'gcjkknd', 'elcdaaf', 15),
	(129887, 'pnflce', 'jmaa', 49),
	(101495, 'ipcd', 'fjamlj', 62),
	(215412, 'midck', 'jjhn', 91),
	(124616, 'nheebpk', 'hjpdm', 54),
	(183098, 'kaioh', 'mmingem', 65),
	(168948, 'afma', 'nnfdndg', 79),
	(257563, 'eeleb', 'leeag', 15),
	(240563, 'jbap', 'legfoal', 36),
	(107699, 'bdelml', 'jhic', 89),
	(156214, 'lidgp', 'hifjegn', 79),
	(165263, 'nhjcl', 'cike', 66),
	(277541, 'okaohnf', 'jadie', 50),
	(197309, 'gbhknda', 'ianbbgh', 88),
	(107370, 'cojndpm', 'gdhignl', 2),
	(180988, 'cbclf', 'noligo', 73),
	(138654, 'hfkejk', 'nilmid', 32),
	(235210, 'ekalgd', 'ndedebd', 40),
	(286322, 'pllie', 'adeodp', 44),
	(177649, 'djbnm', 'djakh', 53),
	(135919, 'hcdphb', 'baibflm', 95),
	(130701, 'pankmkc', 'gcckjh', 37),
	(271018, 'eipji', 'jeop', 72),
	(299115, 'ocdm', 'bkmeahk', 30),
	(115571, 'bllgc', 'njllj', 50),
	(279103, 'hjgfdek', 'ohid', 76),
	(262330, 'plaee', 'lijjlpk', 89),
	(179839, 'cjenkoe', 'ombl', 100),
	(239320, 'ckkke', 'nonm', 21),
	(156419, 'gchbd', 'nljdned', 67),
	(240920, 'hmdi', 'eljo', 28),
	(138682, 'ipgjfa', 'komdkjd', 24),
	(242197, 'gbknpi', 'comkoef', 90),
	(218194, 'mlii', 'fglokd', 51),
	(159765, 'amnfm', 'flai', 4),
	(183719, 'aecaajb', 'jpaca', 55),
	(178934, 'paopgel', 'eklpme', 8),
	(140376, 'jbehp', 'bnkp', 49),
	(239712, 'oennbab', 'ffaoib', 94),
	(191862, 'nocd', 'pbioa', 74),
	(255230, 'paaem', 'cfjgh', 53),
	(116845, 'kofodbk', 'knaln', 58),
	(288825, 'elogg', 'dghfgl', 66),
	(162969, 'ignbi', 'pfpcgk', 50),
	(117692, 'eglmk', 'ofdc', 89),
	(151249, 'ckhhhh', 'aokk', 6),
	(162265, 'hljpo', 'folhm', 37),
	(288345, 'dphm', 'plodlj', 90),
	(137990, 'pbejjb', 'hfnikhk', 78),
	(274357, 'mjfm', 'fcfjae', 48),
	(145388, 'nhpcai', 'ieggcj', 89),
	(121370, 'bmjnna', 'cidmb', 83),
	(163756, 'gmanmgg', 'lkmjbkl', 48),
	(296598, 'ngfn', 'kojk', 8),
	(183491, 'biodb', 'mibfjgi', 70),
	(171799, 'lgdbka', 'enak', 58),
	(230951, 'coheld', 'ddml', 59),
	(259201, 'daknknj', 'oidk', 78),
	(144142, 'fhoaono', 'ppmnkn', 60),
	(141067, 'gaonjj', 'pidnagb', 93),
	(159328, 'omap', 'piid', 47),
	(179875, 'lpnfc', 'nmphif', 53),
	(132434, 'delo', 'madmbm', 54),
	(192188, 'gbjjpmj', 'gpjklb', 97),
	(280638, 'cpjhojo', 'gjmad', 48),
	(152185, 'iaieb', 'gbfolgn', 75),
	(205704, 'ahjohl', 'ciopo', 55),
	(212593, 'jedn', 'eejbhll', 39),
	(163415, 'mdnfgla', 'jgdafc', 84),
	(224774, 'neng', 'gojcbi', 79),
	(235244, 'lbempih', 'bdnplk', 17),
	(249775, 'agekj', 'anln', 57),
	(204097, 'dklacjk', 'pcidhcl', 72),
	(267543, 'hhflego', 'hhodbkn', 47),
	(257936, 'abikapc', 'obcnhhn', 66),
	(146523, 'oeddfbf', 'ehimka', 25),
	(167189, 'dfflpag', 'mkhd', 100),
	(231616, 'keajk', 'ebhpbe', 13),
	(111828, 'aopmfd', 'pnkm', 77),
	(119309, 'baimodm', 'kjbpl', 47),
	(124479, 'aiiokoi', 'eikcpd', 93),
	(147679, 'ojedfk', 'kebg', 62),
	(212903, 'apai', 'dhmp', 12),
	(245508, 'agpbdh', 'cdnimo', 79),
	(243777, 'calpfpe', 'jmao', 70),
	(165243, 'mkcogeh', 'eoljj', 46),
	(196189, 'bgfcel', 'gdag', 23),
	(275096, 'ocanlop', 'kage', 38),
	(279841, 'nijk', 'fphbphj', 89),
	(265322, 'olkoe', 'bhkmcb', 62),
	(108517, 'bdcfhhm', 'lfpblo', 95),
	(192176, 'ighjp', 'ngena', 65),
	(186889, 'dmfeg', 'abehbj', 86),
	(210783, 'cfdeka', 'oaca', 20),
	(145140, 'ialmb', 'femo', 53),
	(181223, 'bmmhh', 'abeka', 21),
	(141211, 'mcfpdp', 'obli', 99),
	(170010, 'ghjdpd', 'ddaljkl', 78),
	(201269, 'ajbngf', 'ligk', 52),
	(216375, 'ceon', 'nehiic', 60),
	(139574, 'ofoadal', 'jjlhl', 39),
	(263213, 'nlnglog', 'hhjnk', 92),
	(255904, 'nbchnb', 'mealakm', 65),
	(212100, 'jiag', 'cnhleb', 40),
	(160533, 'onkhhn', 'bomm', 13),
	(105658, 'jbfcm', 'hfbn', 85),
	(229151, 'efap', 'fgfggb', 70),
	(153110, 'cffh', 'pjbl', 12),
	(260708, 'obdb', 'gopf', 10),
	(106244, 'mlfmkmp', 'gcead', 36),
	(184348, 'nnpl', 'heieddn', 59),
	(149445, 'cnbkj', 'febf', 85),
	(194908, 'ielba', 'naihk', 89),
	(282603, 'anecii', 'ldpmkbp', 13),
	(102616, 'mjpaml', 'jibebn', 37),
	(118992, 'hbnkj', 'hkdkmd', 36),
	(182329, 'hdfmpkn', 'gbfkn', 50),
	(248836, 'bhjoddc', 'heljoa', 85),
	(181632, 'bilphf', 'dhpiamm', 33),
	(297709, 'odhlj', 'fcljkgp', 46),
	(162174, 'emnhe', 'jkol', 41),
	(262131, 'hlfj', 'dgmlko', 55),
	(113253, 'ijlna', 'diiaka', 52),
	(250695, 'ehpofk', 'nncbng', 1),
	(299390, 'eidbkgm', 'jknop', 38),
	(139120, 'enjdh', 'lcbfgaa', 82),
	(254717, 'odjf', 'npldenb', 38),
	(295124, 'nehkim', 'afhcm', 12),
	(250600, 'ihfb', 'pehgoh', 30),
	(200064, 'ifai', 'dcldam', 14),
	(291215, 'namg', 'iinmk', 98),
	(280734, 'iofn', 'deiog', 25),
	(276771, 'kfifdke', 'laidah', 1),
	(247098, 'mkcim', 'dbfga', 64),
	(199895, 'jminfm', 'alnhfp', 83),
	(237234, 'dmkialg', 'dahea', 97),
	(141043, 'jccnmag', 'pmbbep', 37),
	(218214, 'appc', 'obpjapf', 34),
	(193024, 'kpagnm', 'gbmiml', 58),
	(229459, 'fnodbm', 'pfdgnf', 97),
	(141183, 'kmbh', 'aniif', 3),
	(120115, 'annakf', 'lhegmi', 7),
	(260282, 'oiigh', 'eknihhb', 76),
	(159734, 'dmhe', 'fepk', 30),
	(178677, 'abhao', 'pealegm', 6),
	(135175, 'elmdh', 'pfgdof', 75),
	(242066, 'bgcnf', 'mnkf', 48),
	(191900, 'fikfgpn', 'ibkaa', 62),
	(183720, 'hdia', 'ijciloa', 25),
	(281131, 'fepdga', 'ihhep', 89),
	(252817, 'cogpfeo', 'flcimji', 28),
	(247902, 'idpg', 'knjjng', 24),
	(291324, 'bcgch', 'bbcn', 43),
	(124740, 'cjaofa', 'oohj', 92),
	(248234, 'lapn', 'jdnce', 94),
	(153910, 'knpdm', 'jpohlab', 39),
	(148898, 'ikocn', 'jooelgl', 60),
	(105904, 'ghcec', 'omeme', 85),
	(158522, 'gegd', 'nfbfhk', 38),
	(128585, 'jclhboa', 'efnmpe', 35),
	(195541, 'paphhp', 'hglanjn', 39),
	(197878, 'fmef', 'pmkpl', 32),
	(218887, 'igkfb', 'pnnp', 1),
	(207427, 'bakb', 'inkkom', 96),
	(296460, 'bedcp', 'abgl', 45),
	(127721, 'gjhikb', 'gpiamd', 23),
	(249171, 'ijbmpb', 'ebdj', 5),
	(295320, 'flmec', 'cjodif', 26),
	(298752, 'eebllii', 'jehe', 48),
	(143289, 'mpbg', 'dkacb', 6),
	(282541, 'cfkppni', 'pfia', 37),
	(209932, 'hekdhh', 'mnnd', 70),
	(181843, 'lkmfbki', 'aglgla', 67),
	(209751, 'lcclf', 'gikgpij', 77),
	(213112, 'nnnmpl', 'lkifc', 82),
	(171639, 'ifghnjn', 'gmjan', 59),
	(179197, 'memgd', 'dinieb', 73),
	(143183, 'piaai', 'fkdn', 75),
	(231414, 'nceld', 'kfpgj', 99),
	(295958, 'occb', 'janojm', 80),
	(146988, 'pflocd', 'npco', 42),
	(122399, 'ofbn', 'coeibon', 66),
	(194770, 'eifomcp', 'objhhnh', 14),
	(292520, 'iljangl', 'ijpok', 25),
	(204606, 'aonga', 'bpnd', 63),
	(164209, 'agoeoma', 'fpfacon', 80),
	(154558, 'oend', 'jogaad', 79),
	(171628, 'mhna', 'nfkj', 6),
	(230743, 'ljcjk', 'ioocc', 41),
	(193728, 'kbap', 'dkafc', 35),
	(186586, 'fkekkg', 'oodi', 32),
	(287177, 'leabj', 'ceaemek', 5),
	(173599, 'edncd', 'pchb', 88),
	(263999, 'ejnb', 'ocbccc', 57),
	(187370, 'iaeifjd', 'afgba', 97),
	(171045, 'nffde', 'glin', 95),
	(216551, 'geoj', 'pfjibb', 75),
	(292646, 'infgaag', 'adhaah', 40),
	(232649, 'gbekh', 'pcnbdp', 78),
	(226774, 'hanga', 'clln', 57),
	(204726, 'ebchol', 'ljaieje', 33),
	(182692, 'oohb', 'nhojbl', 53),
	(279343, 'olpoamo', 'ihbe', 64),
	(113496, 'mbkallp', 'nfobe', 55),
	(163708, 'kmih', 'klffi', 85),
	(208355, 'iaohhf', 'clil', 33),
	(292334, 'hjalo', 'ndfjjij', 25),
	(147646, 'gjbh', 'mplfc', 83),
	(157009, 'odedhgn', 'ondkonn', 89),
	(294394, 'peed', 'lnejldc', 68),
	(253374, 'hgdc', 'ccikj', 5),
	(211996, 'hpkf', 'eehc', 25),
	(242313, 'kdpi', 'jnhacp', 96),
	(123753, 'cjab', 'pcpdjfk', 26),
	(175784, 'cjnlkj', 'lgeob', 8),
	(196522, 'ifebif', 'bgon', 80),
	(171473, 'dofehe', 'gpoomi', 92),
	(200354, 'kmiaab', 'mmnoje', 12),
	(269211, 'dcdig', 'lbknoj', 51),
	(255682, 'aploikj', 'onfkbbd', 74),
	(105486, 'fjmjd', 'oaaco', 42),
	(288068, 'bmdn', 'ldald', 79),
	(212685, 'iegldnc', 'ldcgo', 4),
	(214339, 'mmede', 'eckmfh', 99),
	(273022, 'nnjabel', 'oadc', 32),
	(203565, 'jfcoka', 'pbaj', 48),
	(159067, 'kfag', 'kaak', 27),
	(157938, 'omdkf', 'fijmgi', 41),
	(183848, 'ldjbkd', 'hlmkb', 36),
	(206802, 'hkad', 'iidjhkc', 83),
	(249771, 'lfbjog', 'hfbhjkg', 42),
	(194649, 'fgcg', 'bakcnij', 47),
	(141550, 'bbenjop', 'hbodpgg', 100),
	(288222, 'mgogdk', 'gcfohac', 29),
	(225503, 'chgioeh', 'hgifng', 14),
	(173047, 'ibdgp', 'cbgbi', 85),
	(238973, 'gkfpn', 'nioo', 100),
	(238151, 'abjk', 'cmdal', 73),
	(134823, 'dhnc', 'ljbb', 64),
	(219339, 'hepjafb', 'lehmcg', 96),
	(104188, 'imcd', 'jhjbd', 28),
	(107252, 'igdedhc', 'ocloc', 14),
	(109227, 'gcki', 'mhfebba', 31),
	(174953, 'ekcjg', 'fgfa', 81),
	(212942, 'mjjbmh', 'hapnb', 47),
	(119053, 'lpldj', 'fhmo', 3),
	(244044, 'pmnam', 'lfmee', 52),
	(105061, 'gphdpa', 'lmabai', 55),
	(240934, 'lemajco', 'gjej', 86),
	(172848, 'ibad', 'icnioao', 88),
	(217006, 'acdfaac', 'njppbn', 69),
	(237269, 'hdabj', 'lbamm', 67),
	(275939, 'dalah', 'bllldg', 75),
	(213386, 'gjho', 'nhdg', 14),
	(239140, 'cnbl', 'pegg', 38),
	(117934, 'gkkf', 'pkkgdh', 27),
	(256223, 'adek', 'bjgbdhe', 5),
	(275728, 'hakk', 'bbggc', 26),
	(288194, 'nofddbc', 'jiio', 88),
	(270208, 'ieoncka', 'jinm', 25),
	(114414, 'iefnpec', 'bpcpk', 34),
	(232881, 'ajlk', 'ggbml', 21),
	(129196, 'aephafk', 'faec', 92),
	(287551, 'nkpijef', 'fdgfpl', 14),
	(130466, 'bfdk', 'jekjgh', 4),
	(244029, 'ajiao', 'hmcjh', 48),
	(116203, 'abelogf', 'bfjlj', 83),
	(175840, 'mabapeb', 'lgjnphn', 67),
	(181158, 'lfcjpdm', 'bbphn', 19),
	(243990, 'mlciifl', 'nieio', 84),
	(118468, 'oamgn', 'ooeakig', 41),
	(113582, 'jcidk', 'ibgiamk', 39),
	(239649, 'bdmkd', 'ijjla', 13),
	(212178, 'nemmfb', 'abmb', 34),
	(273808, 'khpa', 'clcce', 87),
	(221599, 'aeikjhg', 'kpedm', 22),
	(228499, 'jddkip', 'dibd', 5),
	(131586, 'fgdk', 'ijmh', 62),
	(140524, 'pnim', 'dpdn', 100),
	(211136, 'dlodkfl', 'jfpcdm', 17),
	(278395, 'inkdpp', 'dbbhia', 34),
	(138482, 'njfekno', 'cpblbkh', 15),
	(229427, 'ajcg', 'cgbonnf', 85),
	(107927, 'eanl', 'chnnlej', 8),
	(245036, 'ggkeehh', 'pdfkjb', 14),
	(133802, 'engll', 'pmjkoj', 94),
	(116721, 'fnifcba', 'gkcbnm', 71),
	(214172, 'gjnhpj', 'moll', 53),
	(126288, 'mlfp', 'iceecdg', 38),
	(165318, 'cbdmhkm', 'jchd', 29),
	(268048, 'icpc', 'fcml', 96),
	(291841, 'lghmob', 'clkf', 41),
	(160591, 'jcnpde', 'iiph', 96),
	(253720, 'egcemaf', 'fkojl', 74),
	(141382, 'jomle', 'gmii', 90),
	(177041, 'jnpcgk', 'oimnb', 88),
	(187350, 'aimkm', 'opej', 99),
	(250818, 'fjmlmb', 'edee', 26),
	(185770, 'iail', 'ahbb', 87),
	(203156, 'hffcf', 'fhnpp', 97),
	(259413, 'kljohf', 'mgkj', 9),
	(135646, 'gegp', 'glok', 92),
	(267765, 'bibm', 'dbang', 91),
	(235199, 'npmae', 'mhlif', 70),
	(233315, 'nophb', 'kejl', 23),
	(104065, 'pdhh', 'ggmi', 63),
	(258988, 'ogljhp', 'alnf', 21),
	(256337, 'ijehlkj', 'ampc', 51),
	(217825, 'nihcddn', 'hjhgp', 14),
	(159434, 'gkcga', 'ckbgpl', 86),
	(173957, 'oohn', 'khdmhb', 74),
	(294131, 'cgpci', 'peldhab', 6),
	(101654, 'ghcg', 'kanmcb', 4),
	(120883, 'ffnk', 'malhfcp', 88),
	(122693, 'lnkbh', 'daajhfk', 49),
	(299518, 'bblbec', 'kjhmb', 20),
	(198212, 'phnmaeh', 'kmki', 43),
	(223184, 'oplon', 'giadfo', 100),
	(216584, 'mnopmbn', 'lbej', 92),
	(268390, 'micejn', 'nkfmdn', 98),
	(201797, 'kcnbboj', 'amjmci', 48),
	(233990, 'ippc', 'ecooh', 72),
	(115611, 'bijmc', 'fagmge', 31),
	(240717, 'fegel', 'hafg', 24),
	(268826, 'bmeeen', 'dbig', 60),
	(253538, 'lkoh', 'jgnb', 64),
	(253646, 'gejdo', 'legagjn', 77),
	(279091, 'pmoaaod', 'jiaka', 57),
	(146587, 'naom', 'akoa', 94),
	(261020, 'afkjdbb', 'bblhgoe', 15),
	(238774, 'blbl', 'fomf', 33),
	(163187, 'ilclp', 'inemfd', 74),
	(234744, 'ajjcgln', 'fkff', 99),
	(274715, 'kpjhfc', 'lcpahei', 53),
	(281878, 'hoaca', 'gonnhb', 86),
	(161687, 'aflckl', 'gbocmgp', 10),
	(240448, 'jlmd', 'ikmf', 79),
	(253793, 'mbjdfal', 'ppchmh', 31),
	(295722, 'fhkiadj', 'ablagid', 54),
	(263871, 'ecidhdk', 'bfhi', 6),
	(212578, 'njkgma', 'opep', 98),
	(238792, 'poda', 'alnkm', 48),
	(283764, 'gjhpai', 'gmknngf', 58),
	(238571, 'bpifg', 'hhfh', 94),
	(228353, 'dllan', 'ldhj', 22),
	(162609, 'ogldpmk', 'dnhinc', 37),
	(211707, 'pnmef', 'mchjk', 71),
	(109110, 'fcjcj', 'fklkiih', 2),
	(261409, 'gcmo', 'dbbk', 54),
	(202691, 'lodfbf', 'ehghbm', 54),
	(197959, 'adgheaf', 'peadoki', 22),
	(122344, 'gjbo', 'pkjdmif', 34),
	(213779, 'anghkb', 'kagn', 23),
	(231566, 'mbclknf', 'khjimo', 21),
	(168723, 'ilkhg', 'bpnc', 66),
	(110059, 'ibon', 'cemc', 16),
	(137890, 'aelampc', 'mjdbk', 56),
	(255091, 'hokcf', 'ngefof', 86),
	(224652, 'ojbncp', 'lpfpbhn', 53),
	(289679, 'gonpa', 'dljnnjf', 67),
	(160742, 'nccpmek', 'cbbll', 95),
	(128014, 'ckafbc', 'mlgei', 8),
	(219268, 'hepld', 'hfhgh', 9),
	(196541, 'nbidh', 'fcgcb', 46),
	(147194, 'ifal', 'ibln', 83),
	(189021, 'ogfbcci', 'akbhn', 90),
	(254560, 'oebldlg', 'beiii', 56),
	(167811, 'hlpjmn', 'aplc', 93),
	(101998, 'hfahi', 'pdhp', 12),
	(263094, 'chnl', 'mobgaeh', 17),
	(267360, 'amdm', 'pkclk', 27),
	(225604, 'jahhlge', 'fjobjf', 42),
	(233108, 'ldpcipl', 'oeonfoe', 18),
	(209109, 'jahlj', 'laoo', 36),
	(217797, 'foinlmi', 'bjgol', 93),
	(243579, 'keaob', 'ognajk', 13),
	(187975, 'ogbjda', 'cbio', 66),
	(111594, 'egljkhl', 'dedlld', 12),
	(211794, 'opmigd', 'ieekmi', 11),
	(280597, 'iaknil', 'ngeebnh', 29),
	(192155, 'pdkigia', 'ibleke', 42),
	(278773, 'hanpfmm', 'mnloba', 34),
	(140840, 'ocaimp', 'ooolm', 58),
	(243085, 'pmckj', 'fiph', 33),
	(218284, 'jmpoebl', 'lddhj', 87),
	(263231, 'aloag', 'ojgn', 24),
	(130376, 'fcmd', 'hifa', 12),
	(286590, 'ebhlg', 'ndil', 54),
	(227948, 'ccnobn', 'fhknhoj', 57),
	(194529, 'lijlf', 'ngmallp', 29),
	(203499, 'kphgo', 'anep', 61),
	(222616, 'inceihb', 'bglp', 79),
	(278248, 'oofgbod', 'nefpfap', 52),
	(140463, 'kjpojgg', 'hpbegp', 83),
	(177963, 'fffdgnm', 'gbiccf', 85),
	(205172, 'djdjg', 'dnoa', 1),
	(241473, 'gildp', 'cnikmm', 26),
	(242009, 'khea', 'jhdk', 58),
	(117879, 'pfnem', 'hmnaa', 15),
	(154409, 'mdfljm', 'adoanc', 39),
	(159868, 'gmbfjp', 'jadmlim', 100),
	(275967, 'labfn', 'iphga', 68),
	(229202, 'icae', 'lieia', 42),
	(278053, 'ppbhgc', 'bnfgnjd', 96),
	(160508, 'hnli', 'clfccdf', 46),
	(292886, 'jnmnm', 'oallop', 41),
	(234356, 'odfm', 'ehmcl', 87),
	(218391, 'cdli', 'mnnchfb', 62),
	(239545, 'elhcdbm', 'mahhb', 49),
	(266902, 'glala', 'cifnc', 39),
	(251686, 'aipnpan', 'enldafh', 88),
	(112239, 'abgebmk', 'konppm', 10),
	(242594, 'pdjk', 'feao', 7),
	(123494, 'lggok', 'npjlijp', 6),
	(139026, 'lcfknh', 'djip', 85),
	(106452, 'mlmlip', 'dcmkbkh', 54),
	(248671, 'djdcma', 'phbgh', 52),
	(167460, 'glpjg', 'lefppbh', 74),
	(134710, 'hfna', 'adhfol', 10),
	(182958, 'cjhep', 'bihpbl', 37),
	(157120, 'jodeopl', 'doap', 96),
	(137270, 'kedmog', 'nnifllg', 8),
	(268136, 'oaamfej', 'nmkdl', 95),
	(160954, 'lfjc', 'molf', 49),
	(123608, 'lpajae', 'ehahka', 52),
	(247534, 'ggenogc', 'chne', 29),
	(264142, 'mipdp', 'ccig', 65),
	(196436, 'eeppcke', 'lblmkcn', 69),
	(130061, 'dnibf', 'jplcd', 57),
	(137554, 'kpbi', 'onlc', 28),
	(101087, 'epjghn', 'gpjbka', 9),
	(272223, 'ahbbkdd', 'dpanl', 17),
	(118916, 'njglcnh', 'lhcna', 72),
	(125717, 'ippac', 'dgcd', 61),
	(216141, 'cifoh', 'fmbdfi', 78),
	(133385, 'mmaicn', 'ogcd', 45),
	(290597, 'ejhci', 'kbmcjad', 38),
	(164109, 'aklcgcc', 'bpbg', 93),
	(126855, 'ijle', 'jfmoon', 80),
	(174734, 'plll', 'enojc', 88),
	(147375, 'ccogai', 'hajdbc', 92),
	(114836, 'kfgi', 'miojmic', 20),
	(104901, 'ifdle', 'ofim', 79),
	(182239, 'kggilm', 'cdgkmpe', 70),
	(212486, 'nkpoini', 'dlfkk', 10),
	(101071, 'lljlg', 'kjcpnel', 36),
	(234801, 'akkbhj', 'kalgg', 14),
	(256185, 'fobl', 'egjocg', 58),
	(239971, 'ebepof', 'adlhfb', 14),
	(152847, 'ehci', 'ipjjm', 44),
	(243142, 'pfhmkj', 'ckklac', 45),
	(203605, 'cjllmpp', 'dihfepi', 40),
	(151463, 'pdkifdm', 'clpa', 78),
	(118661, 'cilbi', 'mmcdnee', 62),
	(131694, 'ggofbel', 'lhlh', 81),
	(294936, 'khpf', 'ldhh', 40),
	(164204, 'gddebh', 'ofdi', 88),
	(257767, 'bfhpm', 'dnnjn', 42),
	(164807, 'bkfe', 'dmehcf', 21),
	(229186, 'jpgib', 'iedofo', 73),
	(220189, 'kmgnbo', 'ajkb', 12),
	(114903, 'aomaj', 'gpbnmid', 94),
	(222470, 'holh', 'aiemobe', 75),
	(288518, 'pbcjn', 'ilakjb', 51),
	(120860, 'igmg', 'maljfj', 94),
	(135881, 'dbdddk', 'nlce', 89),
	(285770, 'aocmpf', 'anjckg', 48),
	(152061, 'phnjhjg', 'hkmajmo', 17),
	(148042, 'ddnpoc', 'dmaiihh', 50),
	(254128, 'ldkphpk', 'boklib', 43),
	(231826, 'lfpaa', 'knaefj', 67),
	(145627, 'fhkl', 'fioejm', 3),
	(142757, 'nhpf', 'iopahfi', 26),
	(124760, 'ldoliob', 'fbbajoo', 50),
	(225844, 'iioc', 'dmbgon', 75),
	(187396, 'dlli', 'dolpam', 73),
	(209380, 'liiciba', 'nkggoj', 82),
	(283707, 'mofliic', 'dccn', 13),
	(298999, 'gddcjpc', 'obdkoka', 2),
	(156879, 'cmbocm', 'eclpdn', 35),
	(198792, 'nepaje', 'pggjnll', 5),
	(177012, 'hjnie', 'clbd', 30),
	(207813, 'dekoe', 'koamfjf', 29),
	(158389, 'nime', 'mkchj', 52),
	(255228, 'bnjpe', 'hpchoao', 10),
	(253882, 'bndm', 'mmffilb', 54),
	(211683, 'pfcjk', 'kaap', 67),
	(271962, 'lgmjnma', 'mcnnp', 72),
	(193128, 'gheiboh', 'pganp', 92),
	(199960, 'fmpeaij', 'plgdl', 22),
	(192919, 'eildi', 'oldmn', 65),
	(203161, 'lfnjppd', 'jgcmnai', 14),
	(191237, 'fdio', 'hpnoji', 82),
	(222594, 'mghcgjm', 'lpccal', 61),
	(133104, 'elkbp', 'gjhkfgh', 87),
	(244355, 'oenk', 'fjnb', 2),
	(240950, 'nbgd', 'iplgdhn', 64),
	(223713, 'iehlh', 'lbmi', 8),
	(135791, 'hdnfc', 'hmha', 89),
	(225834, 'ajdjo', 'blacmhh', 87),
	(264736, 'kond', 'fnio', 48),
	(207339, 'cfgfn', 'pceba', 83),
	(121062, 'mpieem', 'cifg', 38),
	(222352, 'icnddm', 'ihca', 48),
	(226946, 'bnfp', 'nkdkf', 91),
	(198765, 'bibhkc', 'cgcodp', 10),
	(163798, 'dgllo', 'acakmg', 75),
	(128885, 'lhieck', 'nbkc', 87),
	(296996, 'ehclji', 'jbpcp', 78),
	(106830, 'dmfln', 'jeade', 16),
	(263264, 'agapifd', 'domdefk', 61),
	(286359, 'ikbb', 'cgapna', 80),
	(203544, 'ecnn', 'ffcekf', 79),
	(265371, 'odfji', 'iiii', 52),
	(232699, 'jjolmi', 'kadd', 4),
	(155810, 'jngbllo', 'femm', 62),
	(219667, 'kkim', 'bpkjjk', 76),
	(250697, 'emkg', 'gfpf', 86),
	(262017, 'odgkamf', 'dnoddfl', 32),
	(229517, 'ldmkii', 'ibok', 28),
	(150487, 'cmodja', 'boeo', 4),
	(160061, 'clki', 'omedkkp', 34),
	(268769, 'pliiak', 'inkeg', 52),
	(156649, 'bbnfjgo', 'gcfnhca', 7),
	(291674, 'edkal', 'hlmj', 82),
	(118878, 'gjbcgko', 'kema', 29),
	(206477, 'cmcfgj', 'fjgcc', 92),
	(261854, 'mglck', 'gfbgk', 26),
	(152700, 'aoapmpi', 'knpgoaj', 37),
	(139193, 'bpfajhd', 'kcegjb', 60),
	(128693, 'mlbm', 'onbipgj', 39),
	(248306, 'mfhj', 'bhdhn', 6),
	(179515, 'phfgjpj', 'nickock', 81),
	(147656, 'kbkgac', 'flnpc', 1),
	(234093, 'fleklo', 'ncbkoj', 56),
	(130268, 'djplnf', 'jhgfad', 73),
	(245347, 'pkphknl', 'dcjlfaj', 83),
	(137225, 'doio', 'flhpj', 83),
	(164852, 'mlme', 'ckild', 44),
	(126065, 'efej', 'iibmf', 4),
	(134574, 'dgka', 'kfmli', 16),
	(224873, 'imamekm', 'dkkppji', 65),
	(284468, 'lhgmde', 'icichgk', 65),
	(227272, 'cafokpg', 'jhccli', 80),
	(120486, 'mlijenp', 'jcjech', 27),
	(252614, 'jmpd', 'pkld', 74),
	(108681, 'legoll', 'nckp', 100),
	(256655, 'icci', 'bfhjj', 48),
	(293738, 'nangmeh', 'bebka', 99),
	(160962, 'ifidih', 'ljnhgn', 17),
	(102791, 'obnp', 'cblggah', 36),
	(110672, 'bblhj', 'ebidfbf', 97),
	(290576, 'ejkg', 'pmpome', 61),
	(132533, 'aeiik', 'gfjcgin', 69),
	(279984, 'nchjo', 'ndfa', 98),
	(263111, 'gkljaoj', 'dodfkil', 38),
	(283598, 'iieoelj', 'dlakkl', 43),
	(106837, 'nice', 'lifpfk', 44),
	(275614, 'ekepho', 'hkdo', 66),
	(127609, 'godm', 'fjifp', 60),
	(230996, 'lcmkj', 'kfphep', 15),
	(163698, 'klnjf', 'ench', 62),
	(288632, 'enjgi', 'macjemg', 81),
	(126994, 'oafihgh', 'edloi', 83),
	(254381, 'ngkf', 'dfcohch', 98),
	(144381, 'llill', 'dlolfcp', 3),
	(266022, 'ollo', 'pajkmbc', 58),
	(274664, 'olcm', 'kllfjid', 97),
	(173572, 'iigolpc', 'oinlj', 48),
	(296870, 'hmchk', 'lekhn', 16),
	(177993, 'jdmd', 'pmdpeie', 9),
	(122740, 'eplo', 'bmkgffk', 50),
	(264584, 'demc', 'kcinhf', 49),
	(172925, 'kiefdhj', 'belp', 31),
	(141869, 'fojhi', 'eenpjl', 44),
	(256852, 'eoloa', 'knni', 58),
	(145485, 'mcglbpn', 'lifecog', 62),
	(239119, 'cbihnhi', 'bkpoek', 48),
	(148619, 'jfcpfe', 'jeffof', 18),
	(214993, 'afbhgo', 'ghpcp', 47),
	(209742, 'abklnnc', 'gaah', 52),
	(267471, 'pnhf', 'ililc', 97),
	(265467, 'ehchc', 'lblgpkf', 79),
	(117975, 'cmjbb', 'bmomhk', 100),
	(123038, 'mape', 'moglfb', 78),
	(278728, 'poje', 'onpch', 71),
	(115697, 'lfbl', 'deobicn', 82),
	(209672, 'plifkca', 'npeol', 60),
	(115998, 'lomm', 'llhdcdj', 75),
	(223887, 'flmlo', 'ecnpkb', 33),
	(270502, 'nacb', 'bonlb', 68),
	(270049, 'dbfdo', 'eofacfo', 49),
	(162199, 'lfooif', 'cfogb', 78),
	(106344, 'oegbl', 'llpiio', 90),
	(287773, 'dhpj', 'lhmbloc', 55),
	(122568, 'mdilp', 'aglk', 33),
	(265420, 'ecaefno', 'njcp', 64),
	(251950, 'nnnn', 'fflpdl', 45),
	(286085, 'mibjac', 'ccpmdn', 93),
	(181827, 'mpedgmb', 'daiijbd', 48),
	(145345, 'fmjh', 'eakldn', 96),
	(207525, 'ppekhh', 'onohoan', 73),
	(129659, 'lfcgph', 'fhlkmc', 98),
	(204334, 'npnd', 'mchj', 68),
	(299905, 'hclda', 'iejjhml', 8),
	(259622, 'cogae', 'dnko', 100),
	(277995, 'elalpca', 'pcopjf', 43),
	(145353, 'lnadg', 'baee', 35),
	(210714, 'cfcnnh', 'mmnjk', 60),
	(245847, 'ocnoj', 'fgfdpgb', 74),
	(210584, 'fhblalf', 'aodn', 38),
	(211576, 'gkjbgd', 'hdann', 27),
	(259766, 'kngo', 'glden', 3),
	(161519, 'fbnhao', 'ahbiim', 42),
	(188143, 'holgg', 'oaik', 8),
	(200857, 'ockdmb', 'cbpmflo', 10),
	(291919, 'aoml', 'afnnlo', 93),
	(224118, 'nnodfg', 'odhemli', 30),
	(116635, 'jcilapb', 'agmk', 41),
	(254351, 'ofcfajo', 'lelleka', 5),
	(129795, 'hlolf', 'mhjf', 59),
	(114620, 'kljmbj', 'ikgc', 6),
	(169522, 'jdjpnm', 'fifee', 46),
	(237462, 'lnpd', 'jeobd', 79),
	(191879, 'nmaa', 'jkcfnhj', 69),
	(232604, 'naoaio', 'kahni', 99),
	(292559, 'eadg', 'ogbhi', 63),
	(208293, 'nhbk', 'oiimj', 57),
	(143730, 'lefggkn', 'lkfgipo', 19),
	(108915, 'diaj', 'adniji', 12),
	(137381, 'edfi', 'ohngln', 68),
	(163783, 'ccdjc', 'phmp', 74),
	(217377, 'dgeec', 'fehon', 82),
	(254892, 'dnoa', 'dkopfoh', 15),
	(296173, 'dcjnali', 'ojgjci', 39),
	(179286, 'ndacnm', 'kbioj', 17),
	(126172, 'fifonkc', 'ccmhnjf', 6),
	(272035, 'jmikn', 'aggem', 39),
	(195759, 'kibea', 'ojbeji', 40),
	(244894, 'kiblco', 'hinid', 30),
	(270481, 'lmhp', 'jdoidf', 33),
	(258472, 'aghb', 'ifkidbh', 40),
	(205233, 'leiom', 'ikjf', 53),
	(205161, 'cppnlc', 'cfdde', 78),
	(211771, 'ldllkg', 'pifp', 7),
	(116534, 'iljjik', 'fkhd', 79),
	(292148, 'enfbhhd', 'dhoom', 7),
	(248365, 'alpdga', 'chalgm', 5),
	(293864, 'ikckldl', 'kgadeg', 58),
	(214236, 'npdpm', 'kdgn', 3),
	(126944, 'oncoip', 'jhnian', 40),
	(140159, 'haikgg', 'fdiefkk', 19),
	(115115, 'lffilak', 'biim', 56),
	(103848, 'hddpcam', 'djelap', 83),
	(268845, 'egfn', 'ncgnh', 40),
	(143163, 'ehenk', 'blhpjol', 5),
	(268938, 'anad', 'panefml', 8),
	(161791, 'hegnplb', 'ooeb', 73),
	(294960, 'nlbmobl', 'gjln', 49),
	(228070, 'lkkck', 'pphm', 80),
	(136863, 'pjnfhlc', 'enkchea', 46),
	(106913, 'licadfd', 'njpf', 34),
	(261025, 'lign', 'mfio', 62),
	(246179, 'ejec', 'ecnca', 18),
	(248402, 'cmepop', 'pnldj', 25),
	(184821, 'ioping', 'joie', 63),
	(161757, 'lgnlee', 'mgcdp', 83),
	(219567, 'ipknbjb', 'bbcio', 20),
	(258578, 'lenojn', 'gahhjj', 46),
	(181506, 'dnjlbdp', 'jblhjpd', 47),
	(102857, 'appkhca', 'ffcfnkp', 65),
	(121120, 'fojai', 'fdhpk', 41),
	(233533, 'olliic', 'mljd', 6),
	(193691, 'hccam', 'npienhh', 45),
	(144751, 'neamai', 'nmhkh', 96),
	(240139, 'cenigbb', 'cafgoci', 55),
	(185012, 'mfkkil', 'aljo', 24),
	(199254, 'mbopjm', 'jpkp', 59),
	(208679, 'ocjnae', 'llao', 2),
	(235775, 'bolio', 'omfeehd', 80),
	(125372, 'hhmjeea', 'jmbjom', 57),
	(113776, 'migdb', 'nola', 45),
	(231836, 'bldjp', 'ponlgn', 1),
	(262408, 'nngjadl', 'ecjhc', 60),
	(218709, 'jalkck', 'pekhb', 74),
	(127655, 'indoj', 'mmpo', 61),
	(150413, 'icjdme', 'nhbdlod', 77),
	(205147, 'dmodm', 'hnkopj', 9),
	(167268, 'jakih', 'ggick', 72),
	(122139, 'klgiili', 'bpcl', 26),
	(251175, 'iadbc', 'faicooh', 4),
	(131038, 'ndledj', 'dneib', 62),
	(269693, 'agcdd', 'jnmnjl', 32),
	(114634, 'joakcn', 'mffjk', 25),
	(195255, 'paiim', 'kpol', 30),
	(102207, 'olloeon', 'jaidjg', 41),
	(279534, 'moojma', 'ldkljc', 39),
	(274315, 'okfp', 'mffacg', 72),
	(224853, 'ejjajca', 'ifao', 20),
	(199993, 'adpffg', 'nfepl', 39),
	(174921, 'fkchb', 'kpcken', 68),
	(178388, 'ooajdan', 'jmcegbn', 21),
	(141454, 'gdmmk', 'anlkgnb', 66),
	(149211, 'eghem', 'bdpipk', 50),
	(214213, 'ofbkmcc', 'gffbl', 69),
	(176162, 'gckkipi', 'dekhpn', 16),
	(176397, 'gbpk', 'ilecihm', 85),
	(247443, 'icdg', 'odnjnie', 81),
	(148135, 'eielf', 'pejjmkh', 58),
	(191034, 'gccpkj', 'fdnoj', 34),
	(268286, 'mnpi', 'gafd', 47),
	(166035, 'khnnfi', 'fhdenge', 54),
	(240697, 'mgpil', 'nldkc', 39),
	(146608, 'lelbipl', 'bjpnfkp', 26),
	(280584, 'pndj', 'afipdf', 70),
	(271107, 'eigmj', 'agio', 66),
	(179065, 'pkcfkkk', 'mnaknh', 92),
	(155889, 'lbbgii', 'lcpfne', 31),
	(292122, 'efdkmp', 'dgbnbb', 91),
	(177424, 'fbllkc', 'cnpan', 19),
	(108421, 'lmcb', 'phfeika', 24),
	(288180, 'lchbb', 'mphgib', 97),
	(190015, 'bdog', 'dibem', 98),
	(257596, 'lpfll', 'lnck', 82),
	(184392, 'lddk', 'akpag', 2),
	(150407, 'bmmjhd', 'ipolodb', 53),
	(157393, 'bjana', 'hhcich', 81),
	(195857, 'bbgel', 'nibeo', 3),
	(274396, 'jbkjh', 'lhhkbfp', 9),
	(163689, 'adge', 'ecap', 29),
	(103955, 'gapoae', 'hdnckk', 53),
	(229513, 'eoapo', 'hhmnjmn', 88),
	(212898, 'hooebl', 'eiknbli', 98),
	(166321, 'doambe', 'kcnjbej', 91),
	(260435, 'omjdpj', 'gjipc', 1),
	(235106, 'helnn', 'faedf', 35),
	(223286, 'ncplbh', 'goaha', 47),
	(151898, 'daplmb', 'bnki', 71),
	(154711, 'lmkkkc', 'ppdmb', 70),
	(166260, 'nhgo', 'pgmfkc', 8),
	(299870, 'edao', 'imjmho', 68),
	(238075, 'gmho', 'klko', 77),
	(295837, 'eakb', 'gonncnn', 59),
	(195784, 'mmlijaj', 'dapblg', 19),
	(259336, 'gibmcj', 'igldkp', 62),
	(295489, 'glpmacc', 'npcbcp', 60),
	(294933, 'mnnpl', 'fpjp', 56),
	(242340, 'nbdp', 'ijimda', 25),
	(194052, 'acjci', 'oklbd', 87),
	(215928, 'jbgicko', 'ampehg', 72),
	(112491, 'mgmnka', 'nbgpn', 82),
	(130670, 'pjdhfnh', 'jjadhl', 12),
	(100908, 'nfdg', 'heceal', 54),
	(183677, 'lbhckmi', 'chcafg', 4),
	(206006, 'dnihkh', 'ilfi', 57),
	(135500, 'lolm', 'jibepcl', 63),
	(102734, 'nopk', 'emgehep', 4),
	(152721, 'dnahjg', 'mmkdndi', 92),
	(281021, 'njenpnj', 'jejd', 2),
	(112557, 'ckfgblp', 'cjappdl', 52),
	(292929, 'fgeemn', 'kkicld', 14),
	(227275, 'ffonklm', 'jmaj', 84),
	(215571, 'bpclc', 'hpgge', 32),
	(180074, 'gkmgpj', 'cgoe', 84),
	(257079, 'koepn', 'amolcbk', 16),
	(191436, 'ggcifa', 'kjmbbn', 30),
	(219578, 'dokmiam', 'pindhjk', 2),
	(223198, 'keknfle', 'ihdbnil', 69),
	(144923, 'onlnke', 'ifgd', 99),
	(248909, 'lkgjm', 'feij', 60),
	(174904, 'bhoklk', 'dapdfd', 37),
	(245712, 'godkf', 'boghfa', 53),
	(213633, 'chfkde', 'jaooaf', 16),
	(241997, 'ohgjdk', 'ejfccnm', 6),
	(137951, 'bgma', 'glpbj', 33),
	(268898, 'mekkdd', 'fobaibp', 21),
	(226170, 'ejic', 'mijkek', 71),
	(165075, 'hakkkj', 'kpab', 21),
	(175662, 'cfib', 'gnno', 40),
	(187173, 'cpneib', 'kmfcf', 7),
	(280701, 'eikm', 'leblfn', 7),
	(285166, 'bcfc', 'fdgkoj', 82),
	(133027, 'nenpln', 'pkngpp', 43),
	(151567, 'dfljm', 'hkhia', 85),
	(205754, 'bjinpp', 'okeknpj', 82),
	(210374, 'hdhp', 'hecma', 73),
	(149414, 'lldki', 'mhnk', 44),
	(221076, 'omnnhjo', 'edkjfk', 25),
	(141613, 'pnbghid', 'noknen', 11),
	(266646, 'fjklce', 'gaodnhn', 46),
	(220401, 'pmic', 'knljcf', 83),
	(137360, 'iihoj', 'anio', 81),
	(286284, 'copkgil', 'bafbi', 93),
	(293586, 'njfph', 'omop', 20),
	(245645, 'ighgai', 'cdgo', 80),
	(285795, 'mafmblf', 'bclp', 88),
	(235841, 'foof', 'gafj', 22),
	(146597, 'hoohb', 'beji', 87),
	(221027, 'cpii', 'mkmmklf', 54),
	(298719, 'jiekl', 'ghfofin', 76),
	(253807, 'dmgd', 'nfnjl', 40),
	(220698, 'hhdijbc', 'bjnlg', 95),
	(251221, 'kfhdb', 'aggf', 93),
	(238538, 'gddbd', 'cnbf', 55),
	(224421, 'phjg', 'glfia', 10),
	(110194, 'mifed', 'kgmn', 54),
	(125816, 'kpkmbkn', 'jjilpca', 61),
	(103426, 'jbpfd', 'okekgni', 9),
	(281777, 'odhnjoj', 'fldbmoa', 22),
	(297495, 'lbdfle', 'hfikcik', 51),
	(275055, 'boip', 'fccmh', 98),
	(108983, 'ljoaif', 'ohhe', 43),
	(144206, 'icbalg', 'pdjmnhc', 16),
	(252678, 'eojg', 'ghhpl', 82),
	(260840, 'mmdbl', 'mjccn', 30),
	(198390, 'cpbgge', 'hlocg', 56),
	(136181, 'nkohe', 'jpli', 45),
	(242578, 'pnpkll', 'mjeeh', 60),
	(254333, 'jgjin', 'ikiil', 75),
	(257800, 'amec', 'dpan', 33),
	(142136, 'afagm', 'gelem', 60),
	(287649, 'chkkma', 'obnnj', 37),
	(285442, 'kilejfo', 'pdjgaci', 72),
	(155214, 'aeklp', 'ffdl', 3),
	(281814, 'chff', 'iocacd', 24),
	(226029, 'kjmhn', 'gkemk', 30),
	(292007, 'kkphf', 'ainmn', 5),
	(113352, 'ajopddf', 'jcihmdf', 28),
	(294082, 'jaad', 'bfpe', 57),
	(240696, 'pbgfeff', 'kglkm', 48),
	(186608, 'lobbjj', 'hfgp', 82),
	(196058, 'kpnncfk', 'ehocmd', 7),
	(256276, 'elnpk', 'ioho', 70),
	(225816, 'klboao', 'hmpj', 23),
	(257452, 'ealfpo', 'mijjbmk', 4),
	(244865, 'mmkjgon', 'kbbfdbm', 78),
	(294758, 'okdcnh', 'bkfc', 87),
	(238136, 'ejhnkj', 'lhhjoe', 73),
	(176124, 'ggojed', 'ghcgjf', 77),
	(233168, 'fmfp', 'oeiaek', 94),
	(258585, 'pelo', 'lnhph', 89),
	(179377, 'embj', 'gmoe', 69),
	(234065, 'llgecok', 'hkdimlo', 44),
	(179530, 'bihk', 'opoke', 62),
	(279217, 'dfalj', 'lmeejg', 22),
	(194444, 'ndlopin', 'maojl', 40),
	(284032, 'aifdjmj', 'epnolad', 22),
	(277683, 'kndjkle', 'mimgnp', 88),
	(273482, 'pikgpl', 'kfengm', 67),
	(176485, 'glom', 'lljjjf', 14),
	(244012, 'fbplga', 'cnepcb', 14),
	(114506, 'mohoppp', 'lmelg', 8),
	(121610, 'apim', 'cdblgan', 37),
	(260576, 'cmmfpa', 'pkecj', 71),
	(250685, 'ahmdei', 'gafno', 13),
	(294217, 'fego', 'fkbfnc', 53),
	(177031, 'dfmkm', 'jnfp', 74),
	(171081, 'jhea', 'kobjajj', 52),
	(239250, 'adnomb', 'mgmgh', 54),
	(264026, 'hpfagff', 'jpnj', 83),
	(296677, 'pcebok', 'bkdjpp', 24),
	(111572, 'plnb', 'plnh', 19),
	(226423, 'eplfaj', 'agjol', 94),
	(209918, 'ppkcmdd', 'inpgng', 67),
	(148294, 'eodf', 'meph', 85),
	(109306, 'geomnf', 'jlngd', 55),
	(195471, 'pfknj', 'nggilfa', 49),
	(158506, 'ghkioh', 'beng', 40),
	(276625, 'jpalm', 'ibfand', 44),
	(253925, 'ehkgpi', 'gfbkdo', 8),
	(153067, 'aennkck', 'liejk', 14),
	(107967, 'jaej', 'kdcocha', 70),
	(199932, 'jhhnbj', 'ibdegj', 41),
	(231934, 'jioilp', 'jbmdadj', 36),
	(112827, 'knkicbk', 'pbndjap', 99),
	(137291, 'libk', 'mhempg', 57),
	(263632, 'imec', 'plfe', 17),
	(148073, 'plcoki', 'olcj', 93),
	(123476, 'ogie', 'poicj', 69),
	(143959, 'fhefno', 'cipc', 69),
	(245725, 'eaanlnf', 'iokgjc', 29),
	(213777, 'dkdjjf', 'jgobg', 79),
	(101721, 'anck', 'jgdcmfh', 42),
	(163436, 'oaighfl', 'mbocd', 30),
	(187783, 'ghmolp', 'dhhci', 34),
	(227886, 'nilidc', 'agmo', 50),
	(222784, 'pigp', 'lnemgbc', 9),
	(162939, 'cjdp', 'eham', 99),
	(164309, 'kddh', 'lfigb', 75),
	(291759, 'dkbnl', 'lgbdekg', 95),
	(144892, 'dldd', 'nafi', 91),
	(142157, 'gbooe', 'dhbnd', 66),
	(268352, 'aopb', 'kkmkm', 43),
	(135542, 'nlphpoe', 'pcdgm', 53),
	(169786, 'pnkbeeh', 'odhb', 97),
	(190283, 'ndima', 'jnfaac', 73),
	(104904, 'ohcodk', 'cdmdi', 1),
	(192659, 'hnadhae', 'lhbhej', 73),
	(219107, 'fpmo', 'ncjob', 38),
	(223146, 'nlifgnd', 'padonp', 56),
	(241733, 'pbcjfod', 'kbbjed', 68),
	(161565, 'ifga', 'ekggbd', 51),
	(112365, 'ngbb', 'nlejik', 9),
	(126936, 'jhmec', 'ilfdlp', 79);
INSERT IGNORE INTO kardex (matricula, materia, trimestre, calificacion) VALUES
	(122344, 22, 20124, 9),
	(122344, 107, 20032, 7),
	(122344, 35, 20143, 6),
	(122344, 491, 20051, 6),
	(122344, 430, 20142, 8),
	(122344, 332, 20031, 9),
	(122344, 369, 20052, 7),
	(122344, 372, 20152, 10),
	(122344, 46, 20112, 9),
	(122344, 16, 20142, 8),
	(122344, 486, 20054, 10),
	(122344, 383, 20042, 7),
	(158522, 1, 20081, 5),
	(158522, 371, 20102, 7),
	(158522, 249, 20101, 8),
	(158522, 161, 20124, 5),
	(158522, 346, 20063, 10),
	(158522, 216, 20114, 9),
	(158522, 133, 20154, 9),
	(158522, 382, 20074, 10),
	(158522, 29, 20111, 10),
	(158522, 404, 20113, 5),
	(158522, 103, 20122, 9),
	(158522, 492, 20151, 6),
	(158522, 129, 20031, 5),
	(158522, 132, 20063, 5),
	(158522, 485, 20071, 10),
	(113496, 260, 20062, 5),
	(113496, 106, 20053, 10),
	(113496, 234, 20112, 6),
	(113496, 464, 20154, 7),
	(113496, 82, 20083, 9),
	(113496, 150, 20133, 8),
	(113496, 124, 20122, 7),
	(113496, 456, 20073, 10),
	(113496, 65, 20083, 5),
	(113496, 479, 20054, 9),
	(113496, 181, 20061, 9),
	(113496, 113, 20111, 9),
	(113496, 310, 20053, 10),
	(113496, 36, 20064, 7),
	(155214, 460, 20103, 6),
	(155214, 105, 20041, 5),
	(155214, 274, 20043, 10),
	(155214, 393, 20104, 8),
	(155214, 474, 20151, 10),
	(155214, 258, 20114, 6),
	(155214, 224, 20112, 5),
	(155214, 267, 20034, 9),
	(176485, 438, 20112, 7),
	(176485, 4, 20061, 7),
	(176485, 43, 20151, 8),
	(176485, 187, 20123, 10),
	(176485, 479, 20031, 8),
	(176485, 330, 20092, 6),
	(187370, 413, 20031, 9),
	(187370, 222, 20104, 6),
	(288345, 319, 20153, 9),
	(288345, 25, 20142, 5),
	(288345, 123, 20142, 7),
	(288345, 24, 20104, 9),
	(288345, 68, 20054, 7),
	(288345, 279, 20032, 6),
	(288345, 141, 20134, 7),
	(288345, 121, 20101, 8),
	(288345, 104, 20034, 6),
	(288345, 171, 20151, 10),
	(288345, 3, 20054, 6),
	(288345, 169, 20033, 9),
	(288345, 409, 20114, 6),
	(288345, 205, 20141, 8),
	(288345, 162, 20122, 6),
	(288345, 312, 20074, 5),
	(288345, 181, 20051, 9),
	(288345, 70, 20031, 8),
	(218709, 270, 20134, 7),
	(218709, 124, 20143, 10),
	(218709, 334, 20073, 9),
	(218709, 386, 20132, 10),
	(218709, 430, 20084, 10),
	(218709, 289, 20034, 7),
	(218709, 446, 20142, 7),
	(218709, 460, 20111, 8),
	(218709, 183, 20123, 9),
	(218709, 398, 20102, 9),
	(218709, 277, 20033, 5),
	(218709, 312, 20131, 8),
	(218709, 259, 20134, 7),
	(218709, 44, 20124, 5),
	(193024, 476, 20053, 7),
	(193024, 391, 20031, 9),
	(193024, 228, 20061, 7),
	(193024, 177, 20054, 9),
	(193024, 26, 20102, 9),
	(193024, 407, 20133, 7),
	(193024, 497, 20131, 10),
	(193024, 414, 20071, 5),
	(299518, 248, 20051, 7),
	(299518, 488, 20111, 9),
	(299518, 5, 20042, 9),
	(299518, 371, 20044, 8),
	(299518, 78, 20144, 6),
	(299518, 241, 20053, 9),
	(299518, 455, 20044, 5),
	(299518, 43, 20123, 8),
	(299518, 429, 20093, 7),
	(299518, 333, 20141, 7),
	(299518, 417, 20044, 9),
	(299518, 3, 20091, 6),
	(299518, 101, 20121, 10),
	(299518, 400, 20142, 5),
	(299518, 127, 20122, 7),
	(299518, 401, 20073, 7),
	(299518, 50, 20124, 9),
	(299518, 164, 20151, 10),
	(114420, 469, 20071, 5),
	(114420, 18, 20053, 6),
	(114420, 188, 20061, 6),
	(114420, 391, 20102, 5),
	(114420, 420, 20093, 8),
	(258988, 290, 20081, 5),
	(258988, 437, 20092, 5),
	(258988, 27, 20123, 5),
	(258988, 350, 20073, 7),
	(258988, 402, 20131, 6),
	(258988, 45, 20141, 10),
	(209742, 446, 20102, 7),
	(209742, 476, 20033, 5),
	(209742, 192, 20101, 6),
	(209742, 159, 20124, 8),
	(209742, 388, 20114, 5),
	(263111, 317, 20113, 6),
	(263111, 45, 20093, 6),
	(263111, 319, 20094, 8),
	(263111, 447, 20052, 7),
	(263111, 245, 20044, 7),
	(263111, 335, 20051, 10),
	(263111, 14, 20094, 6),
	(263111, 489, 20041, 5),
	(263111, 399, 20154, 9),
	(263111, 40, 20033, 8),
	(263111, 291, 20131, 5),
	(263111, 392, 20081, 6),
	(263111, 448, 20113, 9),
	(263111, 393, 20032, 5),
	(263111, 374, 20043, 7),
	(263111, 238, 20072, 10),
	(263111, 367, 20094, 7),
	(263111, 134, 20134, 9),
	(137225, 437, 20083, 8),
	(137225, 23, 20084, 8),
	(137225, 224, 20131, 5),
	(137225, 239, 20102, 9),
	(137225, 477, 20102, 6),
	(137225, 239, 20144, 9),
	(137225, 158, 20081, 7),
	(137225, 156, 20031, 8),
	(137225, 103, 20032, 7),
	(137225, 143, 20034, 5),
	(137225, 275, 20102, 9),
	(137225, 52, 20113, 5),
	(137225, 369, 20143, 6),
	(255682, 336, 20033, 5),
	(255682, 427, 20073, 6),
	(255682, 167, 20121, 8),
	(255682, 149, 20083, 9),
	(255682, 17, 20123, 10),
	(255682, 60, 20074, 5),
	(255682, 321, 20152, 8),
	(255682, 326, 20051, 5),
	(255682, 201, 20032, 8),
	(255682, 453, 20153, 9),
	(255682, 451, 20042, 10),
	(136583, 453, 20114, 8),
	(136583, 233, 20053, 9),
	(136583, 426, 20134, 8),
	(136583, 136, 20111, 8),
	(136583, 111, 20083, 7),
	(136583, 360, 20043, 10),
	(136583, 192, 20042, 6),
	(136583, 492, 20074, 9),
	(136583, 334, 20091, 9),
	(136583, 277, 20103, 10),
	(136583, 470, 20061, 7),
	(136583, 95, 20104, 8),
	(160533, 126, 20102, 10),
	(160533, 10, 20124, 7),
	(160533, 410, 20131, 8),
	(160533, 114, 20031, 6),
	(160533, 328, 20054, 7),
	(160533, 444, 20032, 6),
	(160533, 47, 20071, 7),
	(160533, 148, 20073, 5),
	(160533, 164, 20034, 8),
	(293864, 453, 20114, 8),
	(293864, 242, 20152, 7),
	(293864, 289, 20082, 5),
	(293864, 457, 20112, 9),
	(293864, 40, 20073, 9),
	(101495, 349, 20121, 10),
	(101495, 5, 20043, 10),
	(148042, 171, 20071, 7),
	(148042, 125, 20051, 9),
	(148042, 354, 20081, 9),
	(148042, 9, 20074, 8),
	(148042, 475, 20124, 5),
	(148042, 56, 20103, 6),
	(148042, 222, 20062, 6),
	(148042, 111, 20042, 7),
	(148042, 313, 20132, 9),
	(148042, 10, 20063, 6),
	(148042, 82, 20152, 7),
	(145627, 360, 20122, 10),
	(145627, 142, 20113, 6),
	(145627, 236, 20061, 7),
	(145627, 493, 20081, 9),
	(145627, 46, 20092, 10),
	(145627, 392, 20041, 8),
	(145627, 239, 20101, 5),
	(145627, 119, 20084, 5),
	(145627, 192, 20102, 7),
	(152847, 480, 20141, 9),
	(152847, 305, 20141, 6),
	(152847, 210, 20153, 6),
	(162609, 113, 20113, 7),
	(162609, 186, 20153, 7),
	(162609, 31, 20123, 10),
	(162609, 293, 20081, 6),
	(162609, 315, 20062, 7),
	(162609, 16, 20041, 8),
	(162609, 272, 20091, 9),
	(162609, 484, 20081, 6),
	(162609, 304, 20043, 9),
	(191879, 201, 20091, 8),
	(191879, 275, 20093, 10),
	(191879, 135, 20064, 5),
	(191879, 322, 20121, 5),
	(299390, 151, 20072, 9),
	(299390, 12, 20044, 9),
	(299390, 377, 20101, 6),
	(299390, 93, 20103, 8),
	(299390, 356, 20064, 10),
	(299390, 228, 20071, 7),
	(299390, 26, 20083, 9),
	(299390, 321, 20034, 5),
	(163415, 498, 20121, 10),
	(163415, 481, 20064, 7),
	(163415, 373, 20142, 5),
	(163415, 464, 20041, 5),
	(163415, 333, 20062, 8),
	(163415, 223, 20133, 8),
	(163415, 205, 20071, 10),
	(163415, 137, 20124, 6),
	(163415, 15, 20082, 7),
	(163415, 243, 20032, 5),
	(247098, 186, 20062, 7),
	(247098, 37, 20154, 10),
	(247098, 196, 20073, 8),
	(247098, 372, 20034, 9),
	(247098, 3, 20152, 10),
	(247098, 25, 20144, 8),
	(247098, 316, 20132, 10),
	(247098, 262, 20144, 6),
	(247098, 369, 20151, 7),
	(247098, 345, 20082, 5),
	(247098, 221, 20071, 6),
	(247098, 469, 20083, 8),
	(100908, 312, 20071, 10),
	(132434, 337, 20053, 8),
	(132434, 127, 20044, 10),
	(132434, 143, 20101, 9),
	(132434, 57, 20134, 5),
	(224853, 341, 20141, 10),
	(224853, 288, 20033, 10),
	(224853, 307, 20113, 7),
	(224853, 249, 20093, 8),
	(224853, 417, 20092, 10),
	(224853, 420, 20122, 8),
	(224853, 313, 20034, 5),
	(224853, 386, 20091, 6),
	(187350, 197, 20094, 7),
	(187350, 256, 20133, 9),
	(187350, 341, 20064, 6),
	(187350, 278, 20144, 5),
	(187350, 138, 20031, 6),
	(187350, 360, 20052, 10),
	(187350, 227, 20042, 10),
	(187350, 186, 20113, 7),
	(187350, 185, 20144, 7),
	(187350, 7, 20131, 8),
	(187350, 114, 20152, 9),
	(187350, 259, 20154, 9),
	(187350, 339, 20134, 6),
	(187350, 301, 20114, 7),
	(131586, 103, 20041, 9),
	(131586, 247, 20074, 10),
	(131586, 25, 20101, 5),
	(131586, 162, 20152, 7),
	(131586, 194, 20151, 5),
	(131586, 147, 20063, 10),
	(131586, 342, 20043, 7),
	(131586, 434, 20072, 5),
	(131586, 195, 20131, 6),
	(131586, 462, 20092, 6),
	(131586, 469, 20081, 6),
	(131586, 452, 20064, 5),
	(131586, 400, 20154, 5),
	(131586, 26, 20104, 6),
	(131586, 99, 20031, 5),
	(131586, 145, 20104, 5),
	(131586, 130, 20034, 7),
	(109898, 388, 20131, 5),
	(109898, 427, 20073, 9),
	(109898, 94, 20063, 10),
	(109898, 142, 20094, 5),
	(109898, 372, 20122, 5),
	(109898, 47, 20151, 5),
	(109898, 198, 20133, 9),
	(109898, 444, 20144, 5),
	(109898, 274, 20134, 9),
	(109898, 119, 20093, 6),
	(109898, 66, 20103, 7),
	(109898, 375, 20052, 10),
	(109898, 34, 20033, 6),
	(109898, 99, 20131, 8),
	(109898, 321, 20044, 5),
	(109898, 141, 20082, 6),
	(109898, 100, 20073, 5),
	(203605, 224, 20081, 8),
	(203605, 437, 20132, 10),
	(203605, 223, 20074, 8),
	(203605, 227, 20073, 5),
	(203605, 32, 20051, 9),
	(203605, 52, 20143, 8),
	(203605, 450, 20052, 10),
	(203605, 17, 20044, 6),
	(218284, 91, 20092, 9),
	(218284, 192, 20104, 10),
	(218284, 374, 20141, 10),
	(218284, 221, 20102, 6),
	(249775, 227, 20084, 7),
	(249775, 151, 20053, 5),
	(249775, 50, 20102, 6),
	(249775, 5, 20073, 8),
	(249775, 300, 20144, 8),
	(249775, 475, 20094, 9),
	(249775, 94, 20152, 10),
	(249775, 259, 20101, 7),
	(249775, 422, 20082, 8),
	(249775, 182, 20032, 6),
	(249775, 296, 20104, 6),
	(249775, 448, 20104, 8),
	(249775, 163, 20054, 10),
	(249775, 172, 20102, 10),
	(249775, 493, 20071, 5),
	(249775, 129, 20143, 7),
	(249775, 51, 20064, 6),
	(218194, 252, 20052, 7),
	(218194, 341, 20072, 8),
	(218194, 253, 20073, 9),
	(218194, 300, 20102, 7),
	(218194, 428, 20131, 5),
	(218194, 55, 20124, 8),
	(218194, 17, 20101, 10),
	(218194, 470, 20154, 8),
	(218194, 333, 20061, 9),
	(218194, 25, 20063, 5),
	(218194, 151, 20074, 5),
	(218194, 236, 20042, 10),
	(218194, 241, 20044, 7),
	(218194, 348, 20154, 7),
	(180988, 385, 20084, 6),
	(180988, 89, 20102, 5),
	(180988, 481, 20122, 5),
	(180988, 468, 20104, 5),
	(180988, 461, 20134, 9),
	(180988, 463, 20134, 9),
	(180988, 241, 20071, 8),
	(180988, 436, 20062, 6),
	(180988, 276, 20131, 8),
	(180988, 449, 20143, 6),
	(180988, 294, 20054, 7),
	(184392, 87, 20104, 9),
	(184392, 261, 20074, 9),
	(184392, 475, 20072, 9),
	(141974, 426, 20123, 7),
	(141974, 321, 20153, 7),
	(141974, 5, 20033, 6),
	(141974, 96, 20151, 10),
	(141974, 190, 20152, 9),
	(141974, 138, 20123, 7),
	(141974, 338, 20071, 7),
	(141974, 233, 20101, 9),
	(141974, 286, 20083, 5),
	(141974, 420, 20134, 6),
	(141974, 342, 20092, 10),
	(141974, 141, 20084, 8),
	(141974, 134, 20053, 8),
	(141974, 153, 20124, 6),
	(141974, 460, 20084, 7),
	(141974, 189, 20124, 7),
	(141974, 352, 20031, 10),
	(141974, 347, 20064, 7),
	(141974, 369, 20063, 6),
	(126936, 354, 20113, 8),
	(126936, 153, 20044, 10),
	(126936, 18, 20093, 6),
	(126936, 134, 20102, 5),
	(126936, 401, 20121, 8),
	(126936, 178, 20031, 5),
	(126936, 78, 20092, 5),
	(126936, 377, 20093, 10),
	(126936, 311, 20151, 9),
	(126936, 232, 20143, 10),
	(229427, 117, 20134, 8),
	(229427, 23, 20091, 10),
	(229427, 459, 20124, 6),
	(229427, 444, 20144, 9),
	(229427, 271, 20094, 6),
	(229427, 329, 20091, 7),
	(229427, 238, 20042, 9),
	(229427, 89, 20114, 7),
	(229427, 456, 20114, 7),
	(229427, 160, 20064, 8),
	(229427, 125, 20101, 7),
	(229427, 473, 20091, 9),
	(229427, 475, 20093, 6),
	(229427, 495, 20042, 6),
	(229427, 311, 20063, 10),
	(229427, 325, 20031, 10),
	(229427, 370, 20123, 5),
	(229427, 404, 20073, 7),
	(175840, 37, 20123, 5),
	(175840, 254, 20051, 5),
	(175840, 73, 20133, 5),
	(175840, 34, 20041, 10),
	(175840, 184, 20063, 10),
	(175840, 223, 20073, 10),
	(175840, 140, 20143, 9),
	(175840, 407, 20132, 5),
	(175840, 164, 20123, 8),
	(175840, 57, 20032, 6),
	(175840, 60, 20031, 10),
	(175840, 81, 20091, 7),
	(175840, 470, 20144, 7),
	(175840, 79, 20081, 5),
	(175840, 341, 20064, 7),
	(175840, 204, 20131, 7),
	(175840, 247, 20041, 8),
	(175840, 22, 20081, 10),
	(175840, 400, 20062, 8),
	(175840, 112, 20054, 6),
	(223713, 231, 20081, 9),
	(223713, 306, 20051, 8),
	(223713, 193, 20054, 8),
	(272035, 119, 20143, 10),
	(272035, 146, 20133, 6),
	(272035, 327, 20031, 7),
	(272035, 443, 20092, 8),
	(272035, 36, 20041, 10),
	(272035, 215, 20123, 6),
	(272035, 387, 20133, 9),
	(113582, 497, 20042, 6),
	(113582, 69, 20132, 7),
	(113582, 282, 20104, 5),
	(113582, 274, 20152, 5),
	(113582, 216, 20124, 7),
	(113582, 472, 20033, 7),
	(113582, 369, 20074, 10),
	(113582, 182, 20101, 9),
	(113582, 488, 20122, 6),
	(113582, 229, 20073, 8),
	(189237, 322, 20101, 8),
	(189237, 163, 20031, 7),
	(189237, 375, 20114, 6),
	(189237, 180, 20071, 8),
	(189237, 279, 20133, 5),
	(189237, 332, 20132, 9),
	(189237, 489, 20034, 5),
	(189237, 163, 20102, 7),
	(189237, 333, 20062, 7),
	(189237, 355, 20063, 5),
	(189237, 256, 20074, 10),
	(189237, 147, 20061, 10),
	(189237, 224, 20031, 6),
	(189237, 221, 20083, 9),
	(189237, 244, 20032, 10),
	(189237, 235, 20094, 10),
	(189237, 215, 20073, 8),
	(189237, 74, 20042, 5),
	(189237, 333, 20093, 5),
	(189237, 317, 20132, 10),
	(282449, 58, 20064, 9),
	(282449, 172, 20071, 9),
	(282449, 155, 20131, 9),
	(282449, 88, 20073, 5),
	(139120, 48, 20084, 8),
	(139120, 288, 20103, 5),
	(139120, 64, 20111, 10),
	(139120, 296, 20062, 7),
	(139120, 164, 20142, 9),
	(139120, 249, 20121, 8),
	(139120, 424, 20154, 7),
	(139120, 318, 20134, 8),
	(139120, 6, 20052, 10),
	(139120, 105, 20123, 9),
	(114414, 88, 20031, 10),
	(114414, 173, 20103, 10),
	(114414, 70, 20101, 5),
	(114414, 232, 20082, 7),
	(114414, 352, 20132, 7),
	(114414, 306, 20031, 6),
	(114414, 46, 20062, 5),
	(114414, 265, 20151, 10),
	(114414, 423, 20104, 6),
	(114414, 148, 20052, 8),
	(114414, 297, 20051, 9),
	(114414, 72, 20032, 7),
	(114414, 48, 20132, 6),
	(114414, 207, 20143, 8),
	(114414, 406, 20132, 7),
	(114414, 51, 20064, 7),
	(114414, 340, 20152, 6),
	(171639, 479, 20122, 9),
	(171639, 329, 20081, 10),
	(230951, 14, 20152, 10),
	(230951, 448, 20063, 10),
	(230951, 98, 20093, 5),
	(230951, 140, 20123, 5),
	(230951, 36, 20074, 10),
	(230951, 115, 20084, 8),
	(230951, 359, 20073, 6),
	(230951, 9, 20122, 9),
	(230951, 327, 20063, 8),
	(230951, 6, 20144, 10),
	(230951, 427, 20054, 9),
	(230951, 150, 20144, 10),
	(230951, 204, 20123, 8),
	(230951, 148, 20061, 10),
	(230951, 277, 20084, 10),
	(230951, 181, 20111, 8),
	(230951, 76, 20081, 7),
	(230951, 259, 20061, 8),
	(171799, 38, 20142, 10),
	(171799, 268, 20073, 5),
	(171799, 71, 20153, 8),
	(171799, 141, 20071, 7),
	(171799, 309, 20073, 8),
	(171799, 98, 20051, 9),
	(171799, 169, 20114, 9),
	(171799, 268, 20102, 5),
	(171799, 311, 20044, 9),
	(171799, 260, 20154, 9),
	(171799, 485, 20132, 7),
	(204334, 199, 20033, 6),
	(204334, 465, 20114, 7),
	(204334, 396, 20052, 6),
	(204334, 214, 20061, 5),
	(204334, 393, 20121, 8),
	(204334, 267, 20104, 8),
	(204334, 477, 20063, 5),
	(204334, 9, 20033, 5),
	(204334, 284, 20051, 8),
	(204334, 243, 20031, 9),
	(204334, 318, 20034, 8),
	(204334, 144, 20034, 7),
	(204334, 371, 20114, 10),
	(200064, 74, 20053, 9),
	(292122, 315, 20051, 5),
	(292122, 350, 20132, 6),
	(292122, 145, 20051, 5),
	(292122, 47, 20154, 6),
	(292122, 17, 20114, 10),
	(292122, 283, 20084, 10),
	(151463, 120, 20143, 10),
	(151463, 461, 20061, 9),
	(151463, 141, 20141, 6),
	(151463, 112, 20052, 10),
	(151463, 30, 20151, 8),
	(151463, 438, 20153, 9),
	(151463, 203, 20153, 9),
	(151463, 182, 20083, 5),
	(151463, 190, 20103, 5),
	(151463, 308, 20154, 8),
	(151463, 223, 20134, 7),
	(151463, 464, 20042, 10),
	(151463, 63, 20032, 7),
	(151463, 83, 20123, 8),
	(103426, 215, 20131, 6),
	(103426, 407, 20042, 8),
	(103426, 255, 20153, 8),
	(103426, 11, 20112, 7),
	(103426, 278, 20042, 9),
	(103426, 467, 20102, 6),
	(103426, 94, 20112, 6),
	(103426, 203, 20073, 5),
	(103426, 13, 20033, 7),
	(141550, 457, 20101, 8),
	(141550, 439, 20103, 9),
	(141550, 18, 20071, 8),
	(141550, 480, 20124, 6),
	(141550, 487, 20122, 6),
	(148898, 291, 20062, 9),
	(148898, 420, 20034, 5),
	(148898, 36, 20093, 5),
	(163798, 162, 20111, 8),
	(163798, 151, 20092, 7),
	(163798, 84, 20094, 7),
	(163798, 358, 20054, 10),
	(163798, 375, 20091, 8),
	(163798, 301, 20091, 8),
	(163798, 278, 20124, 10),
	(163798, 5, 20112, 6),
	(163798, 27, 20142, 10),
	(163798, 231, 20084, 7),
	(163798, 109, 20043, 6),
	(163798, 425, 20102, 9),
	(163798, 453, 20053, 8),
	(163798, 9, 20103, 8),
	(163798, 440, 20081, 5),
	(163798, 260, 20062, 10),
	(292387, 70, 20101, 8),
	(292387, 260, 20041, 9),
	(261020, 270, 20064, 7),
	(261020, 293, 20122, 7),
	(261020, 346, 20074, 6),
	(188143, 1, 20114, 8),
	(188143, 355, 20124, 7),
	(188143, 162, 20052, 7),
	(188143, 131, 20122, 6),
	(188143, 344, 20054, 9),
	(188143, 385, 20034, 9),
	(188143, 248, 20084, 6),
	(188143, 336, 20152, 8),
	(188143, 112, 20071, 6),
	(188143, 467, 20054, 10),
	(188143, 343, 20094, 5),
	(188143, 95, 20143, 5),
	(188143, 215, 20112, 10),
	(188143, 395, 20033, 5),
	(188143, 238, 20063, 9),
	(188143, 470, 20084, 9),
	(188143, 203, 20102, 5),
	(137291, 284, 20092, 10),
	(137291, 368, 20072, 7),
	(137291, 467, 20073, 6),
	(137291, 117, 20094, 8),
	(137291, 145, 20114, 8),
	(137291, 330, 20152, 5),
	(137291, 201, 20102, 6),
	(137291, 487, 20154, 8),
	(137291, 337, 20143, 6),
	(137291, 130, 20111, 5),
	(137291, 136, 20074, 7),
	(137291, 225, 20064, 8),
	(137291, 420, 20093, 10),
	(137291, 485, 20102, 5),
	(150407, 466, 20121, 10),
	(150407, 439, 20073, 8),
	(237462, 56, 20152, 9),
	(237462, 130, 20094, 5),
	(237462, 236, 20083, 10),
	(237462, 446, 20143, 7),
	(237462, 461, 20131, 10),
	(237462, 187, 20112, 10),
	(237462, 215, 20061, 6),
	(237462, 407, 20053, 9),
	(237462, 405, 20042, 6),
	(237462, 22, 20151, 10),
	(237462, 302, 20073, 10),
	(237462, 93, 20143, 6),
	(237462, 479, 20061, 5),
	(237462, 160, 20033, 7),
	(250695, 200, 20093, 10),
	(250695, 411, 20074, 6),
	(250695, 480, 20041, 5),
	(250695, 194, 20094, 10),
	(250695, 114, 20113, 5),
	(250695, 306, 20084, 5),
	(250695, 12, 20094, 5),
	(250695, 46, 20081, 7),
	(250695, 362, 20132, 9),
	(250695, 391, 20063, 9),
	(250695, 87, 20094, 7),
	(250695, 373, 20092, 10),
	(250695, 420, 20133, 8),
	(196436, 39, 20111, 6),
	(196436, 178, 20084, 6),
	(110194, 115, 20131, 8),
	(110194, 55, 20082, 9),
	(110194, 48, 20141, 9),
	(110194, 442, 20111, 10),
	(110194, 448, 20042, 10),
	(110194, 95, 20154, 6),
	(110194, 210, 20053, 6),
	(110194, 403, 20032, 8),
	(110194, 20, 20134, 6),
	(110194, 130, 20154, 9),
	(110194, 394, 20052, 10),
	(110194, 205, 20083, 9),
	(110194, 187, 20101, 9),
	(257936, 204, 20073, 7),
	(299115, 479, 20112, 5),
	(131038, 196, 20104, 5),
	(131038, 400, 20122, 7),
	(131038, 253, 20134, 8),
	(131038, 129, 20061, 7),
	(131038, 34, 20114, 7),
	(131038, 278, 20044, 10),
	(131038, 110, 20034, 9),
	(131038, 367, 20054, 9),
	(131038, 494, 20104, 6),
	(131038, 245, 20132, 8),
	(131038, 51, 20102, 7),
	(113776, 37, 20071, 10),
	(113776, 405, 20051, 8),
	(113776, 258, 20142, 7),
	(113776, 234, 20033, 8),
	(113776, 245, 20043, 8),
	(113776, 312, 20042, 8),
	(113776, 128, 20033, 9),
	(207833, 406, 20114, 6),
	(207833, 375, 20031, 8),
	(207833, 453, 20073, 7),
	(207833, 403, 20151, 5),
	(207833, 15, 20114, 9),
	(207833, 359, 20121, 8),
	(207833, 379, 20062, 5),
	(207833, 401, 20043, 8),
	(207833, 205, 20073, 5),
	(207833, 296, 20034, 7),
	(207833, 356, 20134, 7),
	(207833, 225, 20124, 7),
	(207833, 249, 20052, 5),
	(207833, 36, 20152, 8),
	(153067, 103, 20064, 8),
	(153067, 59, 20132, 7),
	(153067, 107, 20144, 7),
	(153067, 54, 20132, 6),
	(153067, 10, 20051, 10),
	(153067, 241, 20153, 6),
	(153067, 462, 20101, 9),
	(153067, 355, 20054, 5),
	(153067, 415, 20153, 6),
	(153067, 282, 20061, 6),
	(153067, 241, 20032, 7),
	(217142, 369, 20124, 7),
	(144142, 320, 20051, 7),
	(171045, 376, 20121, 5),
	(171045, 242, 20113, 8),
	(171045, 407, 20112, 7),
	(171045, 376, 20054, 6),
	(171045, 154, 20061, 9),
	(109227, 93, 20132, 6),
	(109227, 470, 20133, 6),
	(109227, 439, 20041, 6),
	(109227, 317, 20032, 10),
	(109227, 426, 20083, 8),
	(109227, 437, 20151, 5),
	(109227, 35, 20094, 5),
	(109227, 427, 20044, 6),
	(109227, 432, 20094, 7),
	(109227, 221, 20141, 5),
	(109227, 85, 20032, 8),
	(190015, 57, 20122, 8),
	(190015, 92, 20123, 8),
	(190015, 40, 20071, 7),
	(190015, 49, 20144, 10),
	(190015, 247, 20072, 5),
	(190015, 188, 20103, 6),
	(226029, 24, 20124, 5),
	(226029, 483, 20064, 6),
	(226029, 62, 20103, 6),
	(226029, 448, 20083, 10),
	(226029, 302, 20134, 9),
	(226029, 154, 20153, 6),
	(226029, 296, 20072, 7),
	(226029, 400, 20132, 5),
	(226029, 297, 20074, 6),
	(226029, 128, 20153, 6),
	(226029, 198, 20043, 9),
	(226029, 75, 20142, 7),
	(226029, 363, 20113, 8),
	(226029, 210, 20093, 5),
	(226029, 314, 20134, 6),
	(226029, 174, 20094, 9),
	(149414, 372, 20041, 10),
	(149414, 201, 20122, 9),
	(149414, 382, 20092, 7),
	(149414, 71, 20124, 9),
	(149414, 262, 20101, 5),
	(149414, 315, 20053, 6),
	(149414, 146, 20132, 10),
	(149414, 100, 20112, 5),
	(149414, 370, 20101, 7),
	(149414, 412, 20052, 5),
	(149414, 50, 20102, 9),
	(149414, 306, 20092, 5),
	(149414, 179, 20141, 7),
	(149414, 315, 20083, 6),
	(149414, 467, 20082, 8),
	(149414, 5, 20032, 9),
	(261025, 429, 20093, 10),
	(261025, 468, 20103, 8),
	(261025, 333, 20152, 7),
	(261025, 165, 20113, 7),
	(261025, 491, 20053, 7),
	(261025, 166, 20084, 10),
	(261025, 395, 20052, 5),
	(224075, 43, 20124, 10),
	(224075, 351, 20113, 9),
	(167268, 485, 20101, 9),
	(167268, 185, 20134, 8),
	(167268, 250, 20061, 7),
	(167268, 36, 20061, 6),
	(167268, 268, 20031, 9),
	(167268, 280, 20103, 8),
	(167268, 116, 20122, 7),
	(167268, 196, 20072, 5),
	(167268, 153, 20124, 9),
	(167268, 445, 20081, 10),
	(269211, 64, 20064, 9),
	(269211, 282, 20031, 8),
	(269211, 478, 20042, 10),
	(269211, 233, 20154, 10),
	(187173, 239, 20153, 6),
	(187173, 74, 20054, 5),
	(187173, 315, 20081, 6),
	(187173, 327, 20141, 5),
	(187173, 367, 20092, 5),
	(187173, 460, 20031, 10),
	(187173, 468, 20031, 5),
	(276771, 246, 20071, 8),
	(276771, 80, 20151, 8),
	(276771, 261, 20051, 8),
	(276771, 477, 20041, 6),
	(276771, 76, 20094, 8),
	(194253, 95, 20141, 7),
	(194253, 384, 20074, 8),
	(194253, 168, 20091, 6),
	(194253, 447, 20073, 9),
	(194253, 152, 20034, 8),
	(194253, 12, 20103, 6),
	(194253, 362, 20123, 7),
	(111594, 110, 20143, 9),
	(111594, 17, 20072, 8),
	(111594, 446, 20154, 8),
	(111594, 321, 20132, 8),
	(111594, 137, 20124, 9),
	(111594, 175, 20111, 8),
	(111594, 413, 20122, 9),
	(111594, 277, 20081, 9),
	(111594, 119, 20072, 10),
	(277541, 258, 20062, 8),
	(277541, 126, 20073, 7),
	(277541, 422, 20063, 5),
	(277541, 464, 20112, 9),
	(277541, 42, 20133, 7),
	(277541, 148, 20142, 6),
	(277541, 125, 20153, 10),
	(277541, 464, 20034, 5),
	(277541, 289, 20124, 9),
	(277541, 298, 20054, 5),
	(277541, 408, 20151, 6),
	(277541, 186, 20043, 7),
	(277541, 459, 20113, 10),
	(277541, 307, 20111, 7),
	(238075, 123, 20051, 6),
	(238075, 33, 20073, 10),
	(238075, 180, 20063, 9),
	(238075, 73, 20061, 8),
	(238075, 375, 20142, 7),
	(238075, 29, 20053, 8),
	(238075, 172, 20141, 6),
	(160508, 413, 20073, 6),
	(160508, 111, 20052, 8),
	(160508, 416, 20063, 8),
	(160508, 173, 20134, 6),
	(160508, 280, 20113, 5),
	(160508, 331, 20133, 7),
	(179875, 283, 20134, 9),
	(179875, 317, 20112, 6),
	(179875, 33, 20101, 10),
	(179875, 428, 20083, 10),
	(179875, 283, 20111, 5),
	(179875, 45, 20092, 7),
	(179875, 306, 20152, 6),
	(179875, 435, 20143, 7),
	(179875, 261, 20033, 7),
	(117879, 47, 20154, 6),
	(117879, 50, 20034, 7),
	(117879, 65, 20071, 9),
	(117879, 456, 20071, 10),
	(117879, 249, 20053, 8),
	(117879, 163, 20111, 7),
	(117879, 293, 20102, 8),
	(117879, 109, 20064, 7),
	(117879, 55, 20114, 9),
	(117879, 274, 20113, 6),
	(117879, 179, 20032, 9),
	(117879, 297, 20142, 7),
	(117879, 158, 20142, 9),
	(117879, 187, 20093, 6),
	(277683, 48, 20063, 7),
	(277683, 449, 20044, 8),
	(245508, 486, 20092, 8),
	(245508, 202, 20031, 7),
	(245508, 19, 20072, 5),
	(245508, 270, 20071, 6),
	(146523, 110, 20094, 9),
	(146523, 81, 20133, 8),
	(146523, 491, 20133, 9),
	(216375, 97, 20113, 9),
	(216375, 479, 20102, 8),
	(216375, 207, 20124, 8),
	(216375, 157, 20102, 7),
	(216375, 262, 20033, 8),
	(216375, 78, 20102, 10),
	(216375, 379, 20031, 5),
	(216375, 33, 20153, 10),
	(216375, 219, 20121, 10),
	(216375, 473, 20052, 6),
	(216375, 203, 20142, 5),
	(114836, 202, 20054, 10),
	(114836, 60, 20153, 10),
	(146988, 278, 20144, 5),
	(146988, 186, 20142, 9),
	(146988, 68, 20104, 8),
	(146988, 351, 20121, 10),
	(146988, 424, 20031, 6),
	(146988, 430, 20033, 10),
	(146988, 265, 20082, 9),
	(146988, 148, 20101, 8),
	(146988, 435, 20043, 9),
	(146988, 350, 20121, 5),
	(146988, 241, 20133, 9),
	(146988, 134, 20112, 7),
	(146988, 50, 20041, 7),
	(114620, 217, 20042, 9),
	(114620, 405, 20043, 8),
	(114620, 15, 20031, 9),
	(114620, 354, 20043, 8),
	(114620, 50, 20131, 6),
	(114620, 104, 20054, 9),
	(114620, 249, 20093, 8),
	(156879, 456, 20063, 8),
	(156879, 456, 20061, 6),
	(156879, 171, 20104, 8),
	(156879, 232, 20132, 10),
	(156879, 376, 20084, 5),
	(156879, 151, 20094, 6),
	(156879, 235, 20063, 10),
	(156879, 69, 20041, 5),
	(295489, 361, 20093, 7),
	(295489, 360, 20044, 5),
	(295489, 238, 20132, 5),
	(295489, 172, 20113, 6),
	(295489, 394, 20123, 8),
	(295489, 277, 20073, 10),
	(295489, 39, 20042, 9),
	(295489, 222, 20084, 6),
	(130376, 279, 20134, 8),
	(130376, 350, 20084, 6),
	(130376, 499, 20111, 5),
	(130376, 178, 20044, 5),
	(130376, 266, 20114, 10),
	(130376, 464, 20123, 10),
	(130376, 427, 20152, 9),
	(130376, 135, 20154, 9),
	(101721, 416, 20063, 5),
	(101721, 295, 20031, 8),
	(162174, 432, 20041, 5),
	(162174, 249, 20091, 10),
	(162174, 316, 20052, 10),
	(162174, 180, 20093, 9),
	(162174, 56, 20033, 5),
	(162174, 346, 20102, 10),
	(128014, 173, 20104, 9),
	(128014, 351, 20153, 8),
	(128014, 148, 20044, 10),
	(128014, 444, 20131, 6),
	(128014, 454, 20134, 8),
	(128014, 449, 20134, 5),
	(128014, 498, 20072, 10),
	(128014, 94, 20052, 5),
	(128014, 348, 20092, 5),
	(128014, 278, 20152, 6),
	(128014, 315, 20081, 9),
	(257563, 114, 20032, 5),
	(257563, 365, 20053, 7),
	(155829, 147, 20152, 10),
	(155829, 257, 20121, 9),
	(155829, 282, 20143, 8),
	(155829, 228, 20052, 7),
	(155829, 5, 20064, 9),
	(223887, 413, 20043, 6),
	(223887, 9, 20154, 6),
	(223887, 459, 20133, 5),
	(223887, 476, 20142, 9),
	(223887, 303, 20094, 9),
	(223887, 7, 20122, 5),
	(223887, 401, 20073, 10),
	(223887, 480, 20041, 5),
	(223887, 162, 20074, 10),
	(223887, 490, 20152, 6),
	(223887, 109, 20073, 6),
	(223887, 97, 20094, 7),
	(223887, 353, 20072, 9),
	(223887, 402, 20101, 10),
	(223887, 318, 20154, 10),
	(223887, 499, 20131, 7),
	(253793, 407, 20063, 6),
	(253793, 23, 20032, 8),
	(283764, 394, 20081, 5),
	(283764, 180, 20061, 8),
	(283764, 488, 20073, 9),
	(283764, 487, 20122, 7),
	(283764, 395, 20141, 7),
	(283764, 190, 20031, 5),
	(283764, 260, 20043, 10),
	(283764, 6, 20043, 9),
	(283764, 54, 20043, 8),
	(283764, 99, 20094, 7),
	(283764, 349, 20034, 9),
	(283764, 167, 20081, 7),
	(283764, 447, 20033, 9),
	(283764, 283, 20041, 9),
	(283764, 70, 20044, 10),
	(283764, 210, 20064, 10),
	(283764, 359, 20113, 6),
	(283764, 496, 20103, 10),
	(294125, 401, 20133, 8),
	(294125, 74, 20134, 9),
	(294125, 263, 20083, 7),
	(294125, 228, 20134, 10),
	(294125, 382, 20124, 5),
	(294125, 339, 20091, 7),
	(294125, 411, 20073, 6),
	(294125, 73, 20121, 5),
	(294125, 467, 20112, 8),
	(294125, 18, 20152, 5),
	(294125, 393, 20114, 8),
	(294125, 278, 20144, 6),
	(270627, 85, 20151, 6),
	(270627, 271, 20153, 5),
	(270627, 18, 20082, 7),
	(270627, 493, 20151, 10),
	(281131, 125, 20044, 6),
	(281131, 210, 20073, 9),
	(281131, 372, 20111, 8),
	(281131, 16, 20091, 10),
	(281131, 18, 20051, 8),
	(281131, 122, 20104, 7),
	(145353, 131, 20144, 9),
	(145353, 353, 20152, 8),
	(145353, 184, 20094, 5),
	(145353, 186, 20042, 5),
	(145353, 62, 20132, 7),
	(145353, 74, 20133, 9),
	(145353, 286, 20081, 9),
	(145353, 257, 20071, 9),
	(145353, 291, 20153, 5),
	(145353, 348, 20033, 10),
	(145353, 227, 20071, 8),
	(145353, 459, 20064, 9),
	(145353, 452, 20132, 8),
	(145353, 78, 20123, 8),
	(145353, 340, 20032, 10),
	(162265, 105, 20042, 5),
	(162265, 376, 20084, 5),
	(162265, 479, 20091, 5),
	(162265, 435, 20123, 9),
	(162265, 277, 20123, 7),
	(162265, 14, 20082, 7),
	(162265, 214, 20031, 8),
	(162265, 13, 20112, 9),
	(162265, 359, 20092, 6),
	(162265, 14, 20092, 6),
	(162265, 98, 20114, 8),
	(162265, 311, 20064, 8),
	(162265, 112, 20032, 6),
	(162265, 151, 20134, 6),
	(162265, 150, 20092, 8),
	(162265, 180, 20082, 10),
	(162265, 311, 20042, 5),
	(143730, 178, 20084, 6),
	(143730, 473, 20083, 8),
	(143730, 25, 20072, 5),
	(227948, 437, 20042, 10),
	(227948, 256, 20103, 10),
	(234744, 242, 20042, 10),
	(234744, 374, 20143, 5),
	(234744, 16, 20071, 7),
	(234744, 163, 20084, 8),
	(234744, 131, 20103, 5),
	(234744, 226, 20062, 8),
	(234744, 281, 20142, 8),
	(234744, 172, 20092, 10),
	(234744, 72, 20061, 6),
	(234744, 425, 20064, 5),
	(234744, 407, 20064, 5),
	(234744, 304, 20144, 6),
	(234744, 386, 20083, 8),
	(234744, 324, 20082, 7),
	(183677, 185, 20121, 7),
	(183677, 441, 20152, 6),
	(183677, 386, 20094, 7),
	(183677, 408, 20114, 5),
	(183677, 283, 20131, 10),
	(183677, 327, 20052, 5),
	(183677, 117, 20133, 9),
	(183677, 11, 20043, 7),
	(183677, 292, 20101, 6),
	(183677, 369, 20073, 9),
	(183677, 484, 20043, 9),
	(183677, 476, 20122, 10),
	(183677, 158, 20031, 9),
	(183677, 450, 20084, 10),
	(183677, 409, 20113, 5),
	(183677, 270, 20113, 10),
	(183677, 322, 20111, 8),
	(284032, 426, 20032, 8),
	(284032, 261, 20071, 8),
	(284032, 408, 20093, 10),
	(200857, 71, 20153, 8),
	(200857, 436, 20104, 5),
	(200857, 116, 20042, 6),
	(200857, 426, 20152, 10),
	(200857, 258, 20043, 6),
	(200857, 20, 20104, 10),
	(200857, 268, 20043, 7),
	(200857, 273, 20073, 9),
	(129659, 6, 20063, 10),
	(129659, 238, 20043, 5),
	(129659, 383, 20141, 8),
	(129659, 359, 20031, 9),
	(129659, 342, 20154, 10),
	(129659, 205, 20073, 9),
	(129659, 176, 20121, 6),
	(129659, 413, 20103, 7),
	(120883, 378, 20101, 9),
	(120883, 31, 20074, 7),
	(120883, 329, 20031, 5),
	(120883, 410, 20052, 6),
	(120883, 373, 20102, 10),
	(120883, 130, 20123, 9),
	(120883, 443, 20123, 7),
	(120883, 22, 20131, 5),
	(120883, 15, 20122, 6),
	(120883, 400, 20033, 6),
	(120883, 283, 20074, 7),
	(120883, 242, 20151, 10),
	(120883, 294, 20112, 6),
	(184124, 255, 20071, 10),
	(184124, 302, 20033, 9),
	(184124, 139, 20154, 6),
	(184124, 456, 20114, 8),
	(184124, 74, 20082, 9),
	(184124, 172, 20053, 7),
	(184124, 48, 20043, 7),
	(184124, 334, 20144, 5),
	(184124, 336, 20113, 6),
	(184124, 203, 20144, 10),
	(184124, 348, 20043, 10),
	(184124, 308, 20033, 6),
	(184124, 493, 20094, 8),
	(197959, 397, 20062, 7),
	(197959, 483, 20154, 6),
	(197959, 95, 20064, 7),
	(197959, 380, 20051, 5),
	(197959, 362, 20044, 7),
	(197959, 420, 20143, 10),
	(197959, 76, 20124, 9),
	(197959, 107, 20121, 5),
	(197959, 10, 20122, 5),
	(197959, 443, 20032, 10),
	(197959, 104, 20033, 9),
	(197959, 421, 20101, 9),
	(197959, 179, 20032, 10),
	(197959, 63, 20114, 10),
	(197959, 472, 20094, 6),
	(197959, 466, 20121, 10),
	(197959, 29, 20113, 7),
	(293586, 466, 20061, 10),
	(293586, 283, 20094, 7),
	(293586, 367, 20102, 5),
	(293586, 127, 20074, 8),
	(293586, 227, 20092, 5),
	(123027, 341, 20071, 10),
	(123027, 164, 20051, 9),
	(123027, 238, 20064, 5),
	(123027, 92, 20104, 9),
	(123027, 286, 20104, 10),
	(123027, 445, 20052, 7),
	(123027, 461, 20133, 8),
	(123027, 144, 20052, 9),
	(123027, 10, 20092, 10),
	(123027, 117, 20153, 10),
	(123027, 435, 20082, 10),
	(123027, 80, 20114, 10),
	(123027, 68, 20044, 7),
	(123027, 391, 20114, 8),
	(123027, 368, 20134, 6),
	(123027, 172, 20064, 6),
	(253882, 402, 20074, 10),
	(253882, 211, 20103, 5),
	(253882, 409, 20121, 9),
	(253882, 204, 20084, 10),
	(253882, 170, 20152, 9),
	(253882, 339, 20104, 5),
	(253882, 275, 20043, 10),
	(253882, 87, 20052, 5),
	(253882, 152, 20033, 5),
	(253882, 29, 20154, 9),
	(253882, 482, 20132, 7),
	(253882, 57, 20082, 5),
	(119309, 345, 20061, 6),
	(119309, 142, 20111, 9),
	(119309, 460, 20142, 8),
	(119309, 277, 20131, 7),
	(119309, 70, 20111, 5),
	(119309, 58, 20154, 10),
	(119309, 412, 20084, 7),
	(119309, 281, 20084, 8),
	(119309, 312, 20083, 9),
	(119309, 487, 20141, 6),
	(167189, 101, 20074, 10),
	(167189, 421, 20123, 5),
	(167189, 176, 20044, 6),
	(167189, 208, 20061, 5),
	(167189, 220, 20031, 8),
	(167189, 282, 20031, 9),
	(167189, 494, 20152, 8),
	(167189, 186, 20142, 10),
	(167189, 345, 20112, 6),
	(167189, 90, 20053, 6),
	(285770, 462, 20033, 6),
	(285770, 439, 20134, 10),
	(285770, 476, 20113, 6),
	(285770, 469, 20043, 5),
	(285770, 267, 20054, 9),
	(285770, 398, 20154, 7),
	(285770, 478, 20074, 6),
	(182692, 332, 20152, 6),
	(182692, 245, 20143, 8),
	(182692, 398, 20033, 7),
	(182692, 15, 20093, 9),
	(248234, 319, 20121, 10),
	(248234, 88, 20083, 8),
	(248234, 75, 20134, 9),
	(248234, 107, 20083, 8),
	(248234, 25, 20154, 10),
	(248234, 199, 20151, 7),
	(241733, 280, 20113, 9),
	(241733, 414, 20092, 9),
	(241733, 217, 20042, 6),
	(241733, 143, 20151, 5),
	(241733, 144, 20083, 10),
	(241733, 330, 20131, 5),
	(241733, 135, 20053, 9),
	(241733, 311, 20073, 5),
	(241733, 285, 20113, 6),
	(241733, 452, 20063, 6),
	(241733, 15, 20031, 9),
	(241733, 304, 20061, 6),
	(241733, 144, 20081, 9),
	(241733, 33, 20142, 8),
	(241733, 409, 20134, 7),
	(171628, 394, 20133, 9),
	(171628, 229, 20113, 5),
	(171628, 79, 20073, 9),
	(171628, 313, 20081, 10),
	(171628, 238, 20091, 5),
	(171628, 406, 20082, 7),
	(171628, 227, 20091, 10),
	(171628, 495, 20142, 7),
	(171628, 213, 20071, 9),
	(171628, 74, 20121, 6),
	(171628, 215, 20091, 10),
	(171628, 415, 20144, 5),
	(171628, 40, 20104, 5),
	(171628, 311, 20141, 5),
	(171628, 414, 20082, 5),
	(171628, 318, 20123, 7),
	(171628, 84, 20123, 7),
	(233315, 151, 20101, 10),
	(233315, 262, 20041, 7),
	(233315, 357, 20093, 5),
	(233315, 331, 20033, 10),
	(233315, 406, 20113, 6),
	(233315, 356, 20094, 5),
	(233315, 110, 20093, 10),
	(233315, 257, 20141, 9),
	(233315, 283, 20154, 5),
	(233315, 110, 20112, 7),
	(233315, 240, 20124, 6),
	(233315, 7, 20051, 8),
	(233315, 79, 20051, 6),
	(233315, 282, 20032, 7),
	(233315, 287, 20053, 5),
	(233315, 472, 20111, 10),
	(233315, 41, 20033, 9),
	(128585, 252, 20121, 7),
	(128585, 312, 20064, 6),
	(128585, 79, 20123, 10),
	(128585, 230, 20054, 5),
	(128585, 147, 20043, 6),
	(128585, 210, 20081, 5),
	(128585, 293, 20113, 9),
	(128585, 168, 20052, 8),
	(128585, 316, 20072, 9),
	(297709, 158, 20132, 9),
	(297709, 95, 20051, 8),
	(297709, 396, 20132, 8),
	(297709, 469, 20101, 6),
	(297709, 68, 20124, 5),
	(297709, 459, 20052, 10),
	(297709, 215, 20093, 10),
	(297709, 14, 20064, 6),
	(297709, 395, 20114, 6),
	(297709, 195, 20052, 5),
	(297709, 442, 20034, 10),
	(297709, 401, 20114, 9),
	(107967, 250, 20143, 6),
	(107967, 195, 20132, 8),
	(107967, 389, 20064, 8),
	(159914, 11, 20033, 8),
	(159914, 331, 20074, 6),
	(159914, 349, 20044, 6),
	(208355, 401, 20073, 8),
	(208355, 330, 20142, 7),
	(208355, 417, 20053, 10),
	(208355, 450, 20061, 7),
	(208355, 7, 20151, 7),
	(208355, 314, 20152, 7),
	(208355, 201, 20081, 9),
	(208355, 236, 20053, 10),
	(208355, 65, 20101, 6),
	(208355, 131, 20114, 8),
	(208355, 88, 20124, 7),
	(208355, 349, 20082, 10),
	(208355, 381, 20131, 6),
	(208355, 96, 20031, 8),
	(208355, 65, 20103, 8),
	(208355, 110, 20053, 9),
	(166900, 335, 20054, 9),
	(166900, 102, 20072, 8),
	(166900, 5, 20064, 5),
	(166900, 498, 20144, 9),
	(166900, 288, 20141, 5),
	(166900, 195, 20051, 6),
	(166900, 339, 20054, 6),
	(166900, 169, 20152, 5),
	(256655, 206, 20121, 7),
	(256655, 433, 20054, 5),
	(256655, 437, 20113, 5),
	(256655, 199, 20051, 5),
	(256655, 432, 20034, 8),
	(256655, 452, 20041, 9),
	(173047, 308, 20132, 6),
	(173047, 37, 20031, 8),
	(173047, 465, 20072, 6),
	(173047, 263, 20064, 9),
	(173047, 274, 20033, 6),
	(173047, 433, 20081, 6),
	(173047, 418, 20071, 5),
	(173047, 194, 20142, 10),
	(173047, 105, 20132, 8),
	(173047, 1, 20061, 8),
	(173047, 96, 20111, 5),
	(173047, 406, 20121, 5),
	(250600, 332, 20134, 9),
	(250600, 241, 20054, 5),
	(250600, 243, 20143, 6),
	(250600, 436, 20084, 5),
	(264026, 377, 20142, 7),
	(264026, 96, 20081, 9),
	(264026, 177, 20053, 9),
	(264026, 207, 20112, 7),
	(153110, 376, 20061, 9),
	(153110, 467, 20061, 7),
	(153110, 120, 20113, 6),
	(153110, 235, 20114, 7),
	(153110, 422, 20142, 5),
	(153110, 56, 20034, 5),
	(153110, 282, 20044, 8),
	(153110, 266, 20052, 6),
	(153110, 278, 20143, 10),
	(153110, 140, 20101, 7),
	(153110, 42, 20111, 6),
	(153110, 304, 20081, 7),
	(149417, 95, 20141, 7),
	(149417, 269, 20063, 5),
	(149417, 399, 20133, 7),
	(149417, 244, 20071, 9),
	(149417, 80, 20063, 6),
	(149417, 47, 20124, 8),
	(149417, 256, 20084, 9),
	(171473, 370, 20132, 9),
	(171473, 235, 20153, 10),
	(171473, 162, 20083, 10),
	(171473, 470, 20081, 9),
	(171473, 35, 20123, 10),
	(171473, 465, 20052, 10),
	(171473, 200, 20042, 8),
	(171473, 263, 20094, 8),
	(171473, 373, 20113, 6),
	(171473, 432, 20111, 8),
	(171473, 128, 20154, 7),
	(171473, 340, 20133, 8),
	(171473, 158, 20094, 10),
	(171473, 130, 20074, 6),
	(171473, 492, 20073, 7),
	(171473, 362, 20042, 6),
	(171473, 438, 20054, 5),
	(171473, 391, 20094, 9),
	(278728, 206, 20051, 6),
	(278728, 175, 20094, 10),
	(278728, 25, 20083, 7),
	(278728, 490, 20043, 10),
	(278728, 96, 20064, 8),
	(284468, 159, 20153, 8),
	(284468, 15, 20132, 8),
	(284468, 180, 20144, 7),
	(284468, 122, 20104, 6),
	(265322, 305, 20034, 8),
	(265322, 352, 20073, 7),
	(265322, 4, 20113, 6),
	(265322, 90, 20121, 7),
	(265322, 120, 20104, 5),
	(265322, 55, 20031, 5),
	(265322, 292, 20043, 9),
	(222784, 122, 20062, 9),
	(222784, 194, 20081, 9),
	(222784, 196, 20121, 6),
	(222784, 129, 20091, 7),
	(222784, 97, 20101, 5),
	(222784, 173, 20083, 10),
	(222784, 31, 20093, 5),
	(222784, 65, 20093, 5),
	(222784, 405, 20143, 5),
	(222784, 327, 20083, 7),
	(222784, 396, 20113, 10),
	(222784, 59, 20092, 10),
	(193128, 207, 20101, 9),
	(193128, 432, 20093, 6),
	(193128, 286, 20153, 9),
	(193128, 129, 20081, 5),
	(193128, 213, 20034, 9),
	(193128, 261, 20062, 10),
	(193128, 404, 20053, 5),
	(193128, 402, 20094, 5),
	(193128, 231, 20073, 7),
	(193128, 150, 20123, 6),
	(193128, 404, 20121, 7),
	(193128, 46, 20041, 9),
	(193128, 273, 20104, 8),
	(193128, 451, 20053, 9),
	(193128, 338, 20033, 6),
	(193128, 432, 20034, 5),
	(193128, 109, 20051, 6),
	(193128, 252, 20092, 5),
	(193128, 292, 20134, 9),
	(248836, 34, 20121, 5),
	(248836, 224, 20104, 10),
	(248836, 85, 20112, 5),
	(248836, 118, 20072, 5),
	(248836, 228, 20144, 5),
	(248836, 336, 20054, 5),
	(248836, 245, 20114, 8),
	(248836, 340, 20124, 8),
	(248836, 471, 20121, 7),
	(248836, 130, 20074, 6),
	(248836, 234, 20152, 6),
	(248836, 486, 20153, 9),
	(248836, 440, 20092, 8),
	(248836, 324, 20073, 5),
	(248836, 475, 20032, 6),
	(248836, 344, 20033, 8),
	(248836, 185, 20081, 6),
	(248836, 37, 20154, 9),
	(263871, 100, 20153, 10),
	(263871, 252, 20052, 7),
	(263871, 204, 20062, 5),
	(263871, 393, 20081, 10),
	(263871, 307, 20144, 10),
	(263871, 158, 20061, 6),
	(263871, 433, 20042, 9),
	(263871, 264, 20093, 9),
	(263871, 50, 20143, 7),
	(263871, 214, 20032, 10),
	(217006, 497, 20063, 8),
	(217006, 174, 20113, 7),
	(217006, 95, 20042, 6),
	(217006, 8, 20151, 10),
	(217006, 153, 20054, 7),
	(217006, 42, 20081, 7),
	(217006, 173, 20091, 7),
	(217006, 435, 20143, 6),
	(217006, 334, 20133, 9),
	(217006, 144, 20061, 5),
	(217006, 179, 20154, 10),
	(283707, 472, 20044, 10),
	(283707, 479, 20151, 6),
	(283707, 1, 20113, 5),
	(283707, 363, 20144, 8),
	(283707, 418, 20124, 5),
	(283707, 325, 20044, 10),
	(283707, 61, 20134, 8),
	(283707, 121, 20141, 7),
	(283707, 104, 20063, 8),
	(283707, 120, 20144, 8),
	(283707, 33, 20054, 7),
	(283707, 35, 20133, 8),
	(283707, 465, 20071, 6),
	(283707, 176, 20152, 5),
	(264584, 240, 20103, 10),
	(264584, 345, 20051, 5),
	(264584, 344, 20073, 10),
	(264584, 71, 20114, 6),
	(264584, 68, 20103, 7),
	(264584, 286, 20123, 5),
	(264584, 434, 20051, 10),
	(264584, 257, 20071, 8),
	(264584, 272, 20101, 9),
	(264584, 430, 20112, 10),
	(264584, 427, 20081, 6),
	(264584, 191, 20092, 10),
	(105904, 121, 20133, 9),
	(105904, 391, 20143, 9),
	(105904, 30, 20104, 8),
	(105904, 378, 20041, 7),
	(105904, 125, 20083, 8),
	(105904, 71, 20112, 5),
	(105904, 493, 20032, 10),
	(105904, 210, 20044, 6),
	(105904, 375, 20083, 9),
	(105904, 466, 20051, 8),
	(105904, 1, 20063, 5),
	(105904, 173, 20032, 6),
	(105904, 354, 20051, 8),
	(105904, 130, 20144, 10),
	(105904, 19, 20083, 9),
	(224774, 156, 20093, 5),
	(224774, 165, 20144, 6),
	(224774, 381, 20033, 8),
	(224774, 280, 20092, 7),
	(224774, 469, 20071, 9),
	(224774, 114, 20103, 9),
	(224774, 74, 20104, 9),
	(224774, 278, 20031, 5),
	(224774, 499, 20064, 5),
	(173957, 484, 20064, 9),
	(173957, 15, 20081, 8),
	(150911, 12, 20034, 10),
	(150911, 80, 20071, 9),
	(150911, 153, 20054, 5),
	(150911, 306, 20062, 9),
	(150911, 211, 20081, 7),
	(150911, 196, 20043, 5),
	(150911, 157, 20144, 10),
	(150911, 46, 20063, 9),
	(150911, 36, 20081, 10),
	(150911, 122, 20073, 5),
	(150911, 397, 20123, 5),
	(218887, 77, 20134, 8),
	(218887, 376, 20113, 8),
	(218887, 397, 20112, 7),
	(218887, 283, 20074, 10),
	(218887, 305, 20043, 8),
	(223184, 282, 20043, 8),
	(213633, 346, 20072, 6),
	(213633, 425, 20114, 9),
	(213633, 426, 20103, 9),
	(213633, 169, 20073, 8),
	(213633, 187, 20101, 6),
	(213633, 285, 20134, 9),
	(213633, 137, 20153, 9),
	(213633, 283, 20072, 6),
	(213633, 364, 20061, 5),
	(213633, 336, 20032, 8),
	(213633, 1, 20092, 6),
	(213633, 320, 20154, 6),
	(213633, 139, 20042, 9),
	(213633, 498, 20033, 7),
	(213633, 17, 20062, 5),
	(213633, 66, 20041, 7),
	(213633, 212, 20153, 6),
	(213633, 104, 20072, 9),
	(213633, 400, 20044, 8),
	(105658, 442, 20124, 5),
	(105658, 4, 20062, 5),
	(105658, 197, 20051, 8),
	(105658, 139, 20091, 8),
	(105658, 64, 20103, 6),
	(105658, 469, 20123, 10),
	(105658, 382, 20092, 8),
	(105658, 7, 20082, 8),
	(105658, 296, 20032, 10),
	(105658, 432, 20122, 5),
	(105658, 65, 20071, 5),
	(105658, 13, 20141, 7),
	(105658, 23, 20101, 5),
	(105658, 200, 20131, 5),
	(105658, 259, 20092, 9),
	(105658, 376, 20043, 6),
	(105658, 489, 20151, 6),
	(145485, 338, 20041, 6),
	(145485, 259, 20122, 8),
	(145485, 302, 20113, 5),
	(145485, 236, 20032, 8),
	(145485, 120, 20084, 6),
	(145485, 285, 20154, 8),
	(145485, 213, 20132, 9),
	(145485, 474, 20044, 9),
	(145485, 129, 20041, 5),
	(254351, 423, 20131, 6),
	(254351, 454, 20071, 7),
	(254351, 268, 20102, 9),
	(254351, 370, 20081, 10),
	(165318, 22, 20113, 8),
	(165318, 404, 20103, 6),
	(165318, 144, 20051, 6),
	(165318, 56, 20073, 5),
	(165318, 305, 20052, 10),
	(165318, 275, 20094, 6),
	(165318, 72, 20082, 8),
	(165318, 158, 20084, 5),
	(165318, 245, 20113, 6),
	(165318, 301, 20074, 10),
	(165318, 400, 20083, 10),
	(165318, 244, 20133, 9),
	(165318, 253, 20031, 5),
	(165318, 467, 20152, 8),
	(165318, 121, 20151, 8),
	(165318, 338, 20084, 9),
	(165318, 432, 20053, 8),
	(165318, 253, 20042, 6),
	(165318, 198, 20061, 8),
	(165318, 166, 20102, 7),
	(273482, 304, 20034, 8),
	(273482, 276, 20081, 10),
	(273482, 471, 20141, 8),
	(273482, 259, 20144, 7),
	(273482, 221, 20074, 8),
	(273482, 212, 20113, 7),
	(273482, 64, 20064, 6),
	(273482, 106, 20121, 10),
	(273482, 41, 20114, 6),
	(273482, 163, 20043, 5),
	(273482, 417, 20141, 7),
	(273482, 173, 20132, 6),
	(258668, 205, 20053, 8),
	(258668, 43, 20051, 5),
	(258668, 269, 20141, 10),
	(258668, 99, 20151, 10),
	(258668, 399, 20092, 5),
	(258668, 235, 20132, 6),
	(258668, 278, 20081, 8),
	(258668, 418, 20134, 6),
	(258668, 437, 20152, 9),
	(258668, 456, 20143, 6),
	(258668, 161, 20064, 6),
	(258668, 243, 20114, 10),
	(258668, 74, 20064, 10),
	(258668, 145, 20034, 5),
	(258668, 323, 20072, 7),
	(258668, 405, 20152, 9),
	(258668, 384, 20092, 8),
	(258668, 247, 20091, 8),
	(129887, 284, 20031, 8),
	(129887, 414, 20052, 10),
	(129887, 209, 20071, 6),
	(129887, 361, 20073, 8),
	(129887, 185, 20061, 8),
	(129887, 4, 20071, 7),
	(129887, 459, 20051, 10),
	(129887, 34, 20114, 6),
	(129887, 153, 20101, 6),
	(129887, 36, 20081, 8),
	(129887, 147, 20152, 8),
	(129887, 463, 20064, 9),
	(129887, 242, 20143, 7),
	(129887, 374, 20063, 7),
	(239971, 306, 20153, 9),
	(239971, 365, 20083, 9),
	(239971, 77, 20064, 5),
	(239971, 262, 20083, 6),
	(239971, 356, 20123, 5),
	(239971, 283, 20103, 10),
	(239971, 276, 20044, 6),
	(239971, 332, 20141, 9),
	(239971, 42, 20032, 5),
	(239971, 461, 20084, 5),
	(239971, 433, 20054, 5),
	(239971, 341, 20094, 7),
	(239971, 139, 20043, 5),
	(239971, 146, 20083, 10),
	(239971, 264, 20113, 8),
	(239971, 366, 20053, 10),
	(239971, 14, 20121, 10),
	(239971, 367, 20044, 6),
	(239971, 93, 20094, 5),
	(239971, 233, 20143, 6),
	(169786, 148, 20144, 7),
	(169786, 190, 20093, 6),
	(169786, 167, 20091, 6),
	(169786, 2, 20133, 6),
	(169786, 467, 20113, 10),
	(169786, 187, 20081, 7),
	(169786, 186, 20134, 9),
	(169786, 141, 20131, 5),
	(169786, 450, 20042, 8),
	(169786, 50, 20051, 7),
	(250697, 166, 20072, 10),
	(250697, 275, 20082, 7),
	(250697, 30, 20062, 5),
	(250697, 396, 20154, 7),
	(250697, 224, 20081, 9),
	(250697, 98, 20042, 5),
	(250697, 411, 20132, 8),
	(250697, 466, 20071, 9),
	(120950, 11, 20082, 10),
	(120950, 497, 20154, 10),
	(120950, 434, 20082, 8),
	(120950, 82, 20033, 6),
	(120950, 36, 20114, 8),
	(120950, 157, 20154, 9),
	(120950, 111, 20083, 5),
	(120950, 404, 20084, 10),
	(120950, 498, 20061, 7),
	(120950, 350, 20102, 5),
	(120950, 378, 20041, 6),
	(120950, 68, 20034, 6),
	(120950, 260, 20112, 9),
	(172925, 206, 20072, 10),
	(172925, 496, 20073, 7),
	(172925, 482, 20053, 7),
	(172925, 57, 20142, 8),
	(172925, 408, 20094, 9),
	(172925, 252, 20042, 5),
	(172925, 294, 20031, 10),
	(172925, 121, 20072, 7),
	(172925, 445, 20044, 7),
	(172925, 389, 20093, 10),
	(172925, 266, 20144, 5),
	(172925, 340, 20044, 7),
	(231414, 114, 20072, 10),
	(231414, 272, 20041, 10),
	(231414, 195, 20143, 5),
	(231414, 313, 20123, 10),
	(231414, 413, 20104, 9),
	(231414, 140, 20094, 7),
	(231414, 69, 20112, 7),
	(231414, 204, 20041, 5),
	(231414, 344, 20073, 6),
	(231414, 20, 20092, 10),
	(231414, 355, 20061, 10),
	(231414, 301, 20122, 9),
	(231414, 215, 20151, 5),
	(231414, 159, 20042, 6),
	(231414, 84, 20151, 8),
	(231414, 73, 20144, 6),
	(231414, 394, 20093, 5),
	(231414, 60, 20071, 8),
	(231414, 47, 20053, 5),
	(110672, 484, 20062, 8),
	(110672, 319, 20084, 6),
	(110672, 372, 20133, 9),
	(110672, 88, 20063, 5),
	(110672, 332, 20101, 9),
	(110672, 153, 20094, 10),
	(110672, 244, 20092, 6),
	(110672, 308, 20133, 6),
	(110672, 406, 20143, 10),
	(110672, 109, 20072, 10),
	(110672, 234, 20043, 5),
	(110672, 476, 20142, 8),
	(110672, 15, 20111, 5),
	(110672, 389, 20083, 7),
	(110672, 470, 20132, 6),
	(110672, 416, 20141, 5),
	(110672, 429, 20043, 8),
	(110672, 13, 20133, 10),
	(110672, 146, 20082, 9),
	(110672, 269, 20091, 6),
	(125443, 496, 20124, 7),
	(125443, 368, 20104, 5),
	(125443, 89, 20134, 8),
	(125443, 491, 20073, 9),
	(125443, 156, 20043, 8),
	(125443, 144, 20154, 6),
	(279091, 380, 20121, 7),
	(279091, 413, 20064, 5),
	(279091, 280, 20073, 9),
	(279091, 376, 20103, 5),
	(279091, 42, 20062, 10),
	(279091, 50, 20104, 9),
	(279091, 430, 20074, 7),
	(279091, 140, 20063, 10),
	(279091, 208, 20063, 7),
	(279091, 177, 20051, 9),
	(279091, 416, 20101, 5),
	(279091, 457, 20073, 6),
	(279091, 18, 20154, 8),
	(279091, 255, 20072, 5),
	(264736, 492, 20112, 10),
	(264736, 262, 20151, 9),
	(264736, 151, 20063, 8),
	(264736, 461, 20103, 7),
	(264736, 376, 20152, 7),
	(264736, 229, 20142, 5),
	(264736, 420, 20041, 9),
	(264736, 341, 20123, 5),
	(264736, 495, 20103, 5),
	(264736, 159, 20102, 5),
	(264736, 27, 20044, 6),
	(264736, 89, 20062, 10),
	(264736, 245, 20043, 9),
	(264736, 39, 20083, 7),
	(264736, 266, 20061, 6),
	(264736, 429, 20043, 7),
	(264736, 216, 20141, 7),
	(264736, 277, 20103, 10),
	(264736, 313, 20094, 10),
	(264736, 403, 20134, 7),
	(268286, 179, 20051, 6),
	(268286, 274, 20063, 5),
	(268286, 362, 20092, 8),
	(268286, 8, 20143, 9),
	(268286, 448, 20122, 6),
	(268286, 461, 20133, 8),
	(268286, 205, 20081, 9),
	(268286, 80, 20043, 10),
	(268286, 208, 20152, 10),
	(268286, 465, 20143, 9),
	(268286, 325, 20032, 5),
	(268286, 59, 20143, 8),
	(268286, 303, 20084, 8),
	(268286, 293, 20151, 7),
	(126361, 76, 20102, 9),
	(126361, 162, 20081, 10),
	(126361, 235, 20114, 5),
	(126361, 4, 20094, 8),
	(126361, 143, 20142, 7),
	(126361, 491, 20151, 5),
	(126361, 166, 20084, 8),
	(126361, 150, 20122, 5),
	(156214, 29, 20084, 10),
	(156214, 147, 20133, 10),
	(156214, 453, 20064, 6),
	(156214, 439, 20053, 8),
	(213386, 382, 20033, 7),
	(213386, 202, 20121, 8),
	(213386, 409, 20091, 10),
	(213386, 404, 20042, 10),
	(213386, 58, 20151, 8),
	(213386, 444, 20154, 6),
	(213386, 374, 20041, 10),
	(213386, 401, 20092, 6),
	(213386, 213, 20064, 10),
	(213386, 245, 20112, 9),
	(213386, 110, 20093, 9),
	(213386, 442, 20131, 10),
	(213386, 139, 20084, 10),
	(213386, 27, 20031, 7),
	(213386, 44, 20053, 8),
	(213386, 305, 20111, 10),
	(213386, 191, 20081, 7),
	(213386, 23, 20151, 7),
	(213386, 435, 20071, 6),
	(213386, 387, 20094, 8),
	(199932, 309, 20104, 10),
	(199932, 262, 20082, 7),
	(199932, 376, 20111, 8),
	(199932, 214, 20043, 6),
	(199932, 303, 20143, 6),
	(199932, 203, 20094, 6),
	(199932, 243, 20121, 10),
	(199932, 34, 20123, 5),
	(216584, 298, 20063, 7),
	(216584, 147, 20052, 5),
	(199960, 6, 20043, 6),
	(199960, 412, 20053, 10),
	(199960, 472, 20052, 7),
	(199960, 204, 20084, 8),
	(199960, 275, 20033, 6),
	(199960, 44, 20143, 7),
	(199960, 379, 20082, 10),
	(199960, 252, 20082, 9),
	(199960, 220, 20071, 6),
	(199960, 313, 20104, 8),
	(199960, 177, 20061, 5),
	(199960, 25, 20113, 6),
	(199960, 144, 20112, 7),
	(199960, 360, 20053, 10),
	(199960, 391, 20101, 9),
	(199960, 126, 20131, 8),
	(199960, 427, 20072, 10),
	(199960, 480, 20053, 10),
	(199960, 344, 20071, 9),
	(199960, 122, 20074, 8),
	(203544, 350, 20091, 8),
	(203544, 178, 20084, 8),
	(203544, 470, 20051, 8),
	(203544, 21, 20111, 9),
	(203544, 155, 20141, 6),
	(203544, 59, 20151, 8),
	(203544, 357, 20053, 8),
	(203544, 27, 20044, 5),
	(203544, 149, 20072, 8),
	(203544, 323, 20121, 10),
	(134823, 240, 20061, 5),
	(134823, 298, 20134, 9),
	(134823, 13, 20123, 6),
	(134823, 202, 20064, 10),
	(134823, 141, 20104, 5),
	(134823, 163, 20064, 8),
	(134823, 41, 20153, 5),
	(134823, 222, 20083, 10),
	(134823, 327, 20071, 9),
	(134823, 470, 20061, 10),
	(134823, 328, 20042, 9),
	(244355, 289, 20134, 6),
	(244355, 440, 20051, 10),
	(244355, 184, 20134, 7),
	(244355, 15, 20074, 9),
	(244355, 402, 20152, 10),
	(244355, 106, 20112, 6),
	(244355, 339, 20074, 9),
	(244355, 59, 20131, 7),
	(244355, 214, 20082, 7),
	(133027, 34, 20142, 8),
	(133027, 406, 20034, 10),
	(133027, 498, 20073, 7),
	(133027, 392, 20114, 8),
	(133027, 223, 20121, 6),
	(133027, 221, 20074, 8),
	(133027, 377, 20101, 8),
	(133027, 29, 20111, 5),
	(133027, 166, 20064, 10),
	(133027, 114, 20144, 9),
	(133027, 199, 20083, 8),
	(133027, 69, 20114, 6),
	(133027, 479, 20064, 7),
	(133027, 226, 20131, 8),
	(133027, 67, 20044, 7),
	(133027, 386, 20154, 5),
	(295722, 131, 20143, 8),
	(295722, 207, 20033, 8),
	(295722, 34, 20092, 5),
	(295722, 113, 20031, 7),
	(295722, 238, 20052, 9),
	(295722, 51, 20153, 5),
	(295722, 89, 20032, 10),
	(295722, 131, 20071, 6),
	(295722, 31, 20052, 9),
	(295722, 177, 20111, 5),
	(295722, 296, 20154, 8),
	(295722, 416, 20132, 8),
	(295722, 475, 20092, 6),
	(295722, 196, 20121, 8),
	(295722, 13, 20071, 9),
	(233698, 288, 20093, 9),
	(233698, 183, 20061, 9),
	(233698, 383, 20122, 7),
	(233698, 440, 20092, 7),
	(233698, 316, 20033, 6),
	(174921, 332, 20143, 5),
	(174921, 125, 20104, 8),
	(174921, 359, 20151, 5),
	(174921, 474, 20094, 8),
	(174921, 389, 20114, 10),
	(174921, 160, 20061, 10),
	(174921, 404, 20083, 7),
	(174921, 219, 20124, 9),
	(174921, 161, 20082, 5),
	(174921, 108, 20112, 8),
	(174921, 47, 20041, 6),
	(174921, 52, 20152, 5),
	(174921, 132, 20043, 10),
	(214172, 310, 20141, 8),
	(214172, 170, 20094, 7),
	(214172, 362, 20033, 7),
	(214172, 448, 20083, 8),
	(266646, 149, 20103, 10),
	(266646, 67, 20064, 8),
	(266646, 112, 20114, 9),
	(266646, 76, 20083, 6),
	(266646, 118, 20064, 7),
	(266646, 160, 20054, 7),
	(266646, 29, 20104, 9),
	(266646, 215, 20141, 10),
	(266646, 216, 20054, 8),
	(266646, 59, 20034, 9),
	(266646, 391, 20073, 8),
	(266646, 267, 20073, 7),
	(266646, 279, 20122, 9),
	(245036, 180, 20034, 8),
	(120115, 471, 20113, 7),
	(120115, 96, 20141, 6),
	(120115, 283, 20134, 9),
	(120115, 477, 20124, 5),
	(120115, 159, 20153, 8),
	(120115, 166, 20032, 6),
	(120115, 225, 20151, 10),
	(120115, 212, 20111, 6),
	(120115, 24, 20112, 7),
	(120115, 276, 20154, 6),
	(219107, 196, 20154, 9),
	(219107, 334, 20041, 8),
	(219107, 469, 20043, 7),
	(219107, 367, 20111, 6),
	(219107, 291, 20094, 5),
	(219107, 62, 20124, 7),
	(141613, 496, 20092, 10),
	(141613, 37, 20124, 9),
	(141613, 6, 20141, 9),
	(141613, 445, 20151, 9),
	(141613, 458, 20054, 5),
	(141613, 268, 20071, 10),
	(141613, 449, 20084, 6),
	(141613, 161, 20044, 9),
	(141613, 441, 20051, 8),
	(141613, 21, 20062, 10),
	(141613, 91, 20112, 5),
	(141613, 129, 20073, 7),
	(141613, 266, 20033, 8),
	(141613, 459, 20113, 6),
	(141613, 42, 20074, 8),
	(141613, 81, 20052, 5),
	(141613, 293, 20091, 8),
	(141613, 15, 20044, 9),
	(292007, 125, 20153, 5),
	(292007, 220, 20133, 8),
	(292007, 448, 20043, 10),
	(292007, 375, 20154, 6),
	(292007, 151, 20113, 6),
	(292007, 376, 20101, 8),
	(292007, 436, 20082, 7),
	(292007, 7, 20142, 10),
	(292007, 361, 20044, 8),
	(292007, 233, 20152, 6),
	(292007, 11, 20134, 6),
	(292007, 391, 20092, 9),
	(292007, 362, 20094, 7),
	(292007, 155, 20143, 10),
	(292007, 426, 20153, 9),
	(292007, 457, 20083, 9),
	(292007, 130, 20142, 7),
	(219268, 311, 20124, 9),
	(219268, 154, 20083, 10),
	(219268, 340, 20043, 8),
	(219268, 481, 20112, 10),
	(261854, 473, 20051, 9),
	(261854, 459, 20064, 6),
	(261854, 79, 20034, 6),
	(261854, 463, 20154, 6),
	(261854, 450, 20131, 10),
	(261854, 314, 20152, 6),
	(261854, 409, 20083, 5),
	(261854, 217, 20132, 8),
	(261854, 326, 20134, 9),
	(261854, 65, 20104, 10),
	(273331, 438, 20091, 6),
	(273331, 457, 20072, 8),
	(273331, 273, 20113, 9),
	(273331, 38, 20071, 5),
	(273331, 184, 20054, 5),
	(273331, 124, 20094, 5),
	(273331, 141, 20042, 5),
	(273331, 147, 20143, 9),
	(273331, 451, 20084, 8),
	(273331, 15, 20131, 10),
	(273331, 67, 20093, 9),
	(273331, 265, 20054, 5),
	(273331, 89, 20153, 6),
	(273331, 108, 20123, 5),
	(258411, 401, 20152, 8),
	(258411, 133, 20042, 10),
	(258411, 92, 20082, 5),
	(258411, 439, 20062, 8),
	(258411, 23, 20123, 5),
	(258411, 451, 20073, 8),
	(258411, 403, 20132, 7),
	(258411, 376, 20101, 5),
	(258411, 197, 20051, 7),
	(258411, 216, 20093, 5),
	(258411, 96, 20072, 8),
	(258411, 449, 20084, 8),
	(258411, 155, 20102, 9),
	(258411, 155, 20143, 7),
	(258411, 30, 20143, 7),
	(258411, 81, 20132, 6),
	(258411, 47, 20032, 10),
	(130268, 286, 20073, 10),
	(130268, 130, 20154, 8),
	(130268, 351, 20054, 6),
	(130268, 5, 20152, 6),
	(130268, 497, 20152, 8),
	(130268, 201, 20083, 5),
	(130268, 321, 20044, 10),
	(130268, 64, 20061, 7),
	(130268, 52, 20053, 5),
	(130268, 106, 20063, 5),
	(130268, 105, 20134, 10),
	(130268, 311, 20072, 8),
	(233533, 500, 20064, 5),
	(233533, 22, 20142, 10),
	(233533, 496, 20131, 10),
	(233533, 470, 20041, 6),
	(233533, 119, 20143, 9),
	(151898, 137, 20073, 6),
	(151898, 38, 20071, 7),
	(151898, 216, 20074, 10),
	(151898, 120, 20102, 6),
	(151898, 287, 20133, 7),
	(151898, 401, 20113, 7),
	(151898, 200, 20072, 9),
	(151898, 114, 20144, 7),
	(151898, 322, 20083, 10),
	(151898, 35, 20052, 6),
	(151898, 227, 20034, 7),
	(151898, 417, 20124, 8),
	(151898, 328, 20082, 8),
	(151898, 370, 20104, 5),
	(151898, 420, 20084, 8),
	(151898, 472, 20041, 9),
	(209751, 6, 20152, 7),
	(209751, 99, 20074, 5),
	(209751, 160, 20072, 6),
	(209751, 191, 20103, 10),
	(209751, 31, 20124, 6),
	(209751, 360, 20071, 9),
	(209751, 67, 20073, 5),
	(209751, 425, 20033, 7),
	(209751, 54, 20111, 6),
	(209751, 489, 20151, 5),
	(209751, 490, 20063, 6),
	(209751, 122, 20063, 6),
	(209751, 275, 20111, 8),
	(288180, 60, 20143, 8),
	(288180, 249, 20073, 8),
	(288180, 82, 20144, 10),
	(288180, 32, 20143, 5),
	(288180, 240, 20073, 7),
	(192919, 36, 20153, 8),
	(192919, 452, 20063, 6),
	(192919, 373, 20091, 10),
	(192919, 39, 20092, 5),
	(192919, 375, 20121, 10),
	(192919, 207, 20101, 7),
	(192919, 405, 20142, 10),
	(192919, 12, 20151, 5),
	(192919, 179, 20052, 9),
	(192919, 485, 20043, 9),
	(192919, 325, 20114, 8),
	(192919, 448, 20144, 5),
	(192919, 5, 20083, 7),
	(192919, 300, 20141, 6),
	(192919, 476, 20122, 6),
	(184821, 385, 20121, 6),
	(184821, 341, 20032, 5),
	(184821, 238, 20052, 9),
	(184821, 99, 20051, 7),
	(184821, 435, 20061, 10),
	(184821, 270, 20133, 8),
	(184821, 490, 20124, 5),
	(184821, 327, 20063, 7),
	(184821, 242, 20083, 5),
	(184821, 113, 20084, 10),
	(184821, 65, 20054, 9),
	(184821, 344, 20061, 7),
	(184821, 85, 20071, 9),
	(184821, 141, 20133, 9),
	(184821, 227, 20111, 5),
	(182958, 95, 20152, 9),
	(182958, 495, 20083, 5),
	(182958, 261, 20041, 8),
	(182958, 235, 20133, 6),
	(163783, 241, 20092, 7),
	(163783, 24, 20033, 5),
	(163783, 404, 20042, 10),
	(163783, 106, 20044, 8),
	(163783, 118, 20093, 7),
	(163783, 351, 20044, 5),
	(163783, 208, 20103, 10),
	(163783, 303, 20113, 8),
	(163783, 499, 20143, 9),
	(163783, 442, 20083, 6),
	(163783, 147, 20133, 9),
	(265779, 404, 20153, 6),
	(265779, 494, 20122, 5),
	(265779, 266, 20122, 7),
	(265779, 413, 20092, 8),
	(265779, 159, 20052, 5),
	(265779, 384, 20103, 6),
	(268898, 173, 20112, 5),
	(268898, 36, 20052, 5),
	(268898, 104, 20101, 9),
	(268898, 21, 20034, 8),
	(268898, 370, 20153, 10),
	(268898, 421, 20141, 10),
	(268898, 177, 20062, 6),
	(268898, 251, 20061, 10),
	(268898, 202, 20111, 5),
	(268898, 416, 20043, 10),
	(268898, 308, 20112, 6),
	(268898, 20, 20071, 7),
	(268898, 250, 20074, 8),
	(268898, 239, 20052, 10),
	(268898, 446, 20064, 7),
	(268898, 463, 20031, 6),
	(268898, 103, 20144, 7),
	(125816, 453, 20063, 7),
	(125816, 461, 20154, 5),
	(125816, 475, 20114, 10),
	(125816, 181, 20133, 7),
	(125816, 195, 20142, 7),
	(125816, 322, 20053, 8),
	(125816, 401, 20071, 7),
	(125816, 460, 20083, 6),
	(125816, 168, 20044, 10),
	(125816, 107, 20034, 5),
	(125816, 343, 20034, 7),
	(125816, 9, 20102, 10),
	(125816, 229, 20134, 6),
	(125816, 1, 20112, 10),
	(225834, 65, 20051, 5),
	(225834, 137, 20062, 6),
	(225834, 412, 20122, 7),
	(225834, 128, 20063, 9),
	(225834, 95, 20102, 7),
	(225834, 1, 20104, 7),
	(225834, 111, 20041, 8),
	(225834, 288, 20084, 10),
	(225834, 302, 20132, 9),
	(225834, 208, 20061, 7),
	(225834, 159, 20153, 5),
	(225834, 351, 20144, 6),
	(225834, 340, 20154, 5),
	(225834, 45, 20072, 8),
	(225834, 76, 20094, 5),
	(225834, 328, 20144, 5),
	(225834, 155, 20071, 6),
	(225834, 377, 20124, 10),
	(296173, 123, 20031, 7),
	(141043, 140, 20061, 6),
	(288068, 421, 20132, 5),
	(288068, 133, 20141, 9),
	(161757, 21, 20043, 6),
	(161757, 77, 20031, 5),
	(161757, 260, 20092, 9),
	(161757, 365, 20133, 10),
	(161757, 227, 20091, 9),
	(161757, 349, 20094, 7),
	(161757, 146, 20063, 6),
	(140463, 444, 20123, 6),
	(140463, 208, 20144, 8),
	(140463, 337, 20052, 5),
	(140463, 432, 20071, 6),
	(140463, 126, 20114, 10),
	(140463, 173, 20153, 8),
	(140463, 192, 20074, 8),
	(140463, 95, 20081, 6),
	(140463, 392, 20031, 5),
	(140463, 17, 20071, 8),
	(140463, 83, 20151, 10),
	(140463, 37, 20131, 8),
	(140463, 25, 20152, 8),
	(143183, 226, 20144, 7),
	(143183, 228, 20123, 6),
	(143183, 369, 20152, 8),
	(143183, 425, 20094, 6),
	(143183, 282, 20052, 7),
	(143183, 438, 20102, 7),
	(143183, 287, 20142, 7),
	(143183, 446, 20154, 8),
	(143183, 292, 20121, 6),
	(143183, 31, 20062, 8),
	(143183, 123, 20092, 8),
	(143183, 231, 20052, 9),
	(143183, 408, 20084, 8),
	(143183, 181, 20121, 10),
	(143183, 294, 20143, 9),
	(143183, 155, 20111, 9),
	(242066, 363, 20074, 8),
	(242066, 117, 20041, 5),
	(242066, 390, 20091, 8),
	(242066, 190, 20122, 5),
	(242066, 456, 20062, 6),
	(242066, 340, 20054, 6),
	(242066, 476, 20031, 6),
	(242066, 113, 20031, 10),
	(242066, 212, 20072, 9),
	(242066, 131, 20064, 9),
	(242066, 497, 20104, 7),
	(242066, 226, 20041, 6),
	(242066, 370, 20123, 8),
	(242066, 267, 20051, 5),
	(242066, 417, 20033, 5),
	(242066, 97, 20041, 8),
	(242066, 262, 20084, 7),
	(242066, 465, 20113, 6),
	(242066, 120, 20043, 6),
	(179197, 416, 20052, 7),
	(179197, 476, 20083, 10),
	(179197, 263, 20092, 9),
	(179286, 446, 20081, 5),
	(179286, 468, 20152, 7),
	(179286, 393, 20123, 8),
	(179286, 198, 20142, 8),
	(181223, 205, 20081, 6),
	(181223, 249, 20092, 10),
	(181223, 80, 20034, 10),
	(181223, 272, 20031, 8),
	(181223, 380, 20141, 5),
	(181223, 297, 20114, 9),
	(181223, 373, 20091, 5),
	(181223, 214, 20092, 7),
	(181223, 350, 20092, 8),
	(181223, 212, 20051, 10),
	(181223, 112, 20033, 6),
	(181223, 169, 20062, 10),
	(181223, 13, 20081, 8),
	(181223, 226, 20051, 5),
	(254381, 136, 20093, 10),
	(254381, 325, 20044, 6),
	(254381, 444, 20104, 9),
	(254381, 97, 20042, 7),
	(254381, 297, 20084, 5),
	(254381, 99, 20112, 5),
	(254381, 426, 20062, 10),
	(254381, 480, 20064, 10),
	(254381, 31, 20122, 7),
	(254381, 16, 20111, 7),
	(254381, 66, 20073, 8),
	(254381, 28, 20063, 6),
	(254381, 489, 20032, 5),
	(254381, 77, 20142, 10),
	(254381, 81, 20081, 6),
	(254381, 410, 20134, 9),
	(254381, 236, 20084, 7),
	(254381, 280, 20092, 7),
	(254381, 112, 20061, 6),
	(183719, 176, 20044, 5),
	(183719, 429, 20111, 5),
	(183719, 317, 20033, 9),
	(183719, 441, 20093, 9),
	(183719, 143, 20044, 6),
	(183719, 240, 20103, 10),
	(183719, 473, 20132, 9),
	(183719, 190, 20144, 5),
	(183719, 304, 20153, 5),
	(183719, 476, 20133, 10),
	(183719, 485, 20073, 7),
	(183719, 130, 20062, 7),
	(160962, 379, 20031, 6),
	(160962, 205, 20114, 6),
	(160962, 101, 20101, 6),
	(160962, 116, 20113, 10),
	(160962, 437, 20081, 5),
	(160962, 313, 20142, 10),
	(160962, 238, 20084, 8),
	(160962, 414, 20113, 9),
	(160962, 496, 20041, 8),
	(160962, 109, 20111, 5),
	(228499, 189, 20142, 9),
	(228499, 219, 20104, 6),
	(228499, 186, 20091, 6),
	(228499, 107, 20052, 6),
	(228499, 77, 20133, 6),
	(228499, 78, 20054, 10),
	(216551, 99, 20113, 6),
	(216551, 181, 20061, 7),
	(216551, 463, 20131, 5),
	(216551, 209, 20083, 9),
	(216551, 389, 20102, 10),
	(216551, 359, 20133, 9),
	(216551, 451, 20044, 9),
	(216551, 13, 20122, 7),
	(216551, 478, 20084, 7),
	(216551, 249, 20101, 8),
	(178677, 490, 20113, 8),
	(178677, 155, 20142, 6),
	(178677, 97, 20071, 10),
	(178677, 154, 20061, 9),
	(178677, 35, 20121, 5),
	(178677, 15, 20083, 6),
	(178677, 40, 20062, 6),
	(178677, 117, 20034, 7),
	(178677, 369, 20044, 9),
	(178677, 478, 20152, 7),
	(178677, 410, 20152, 6),
	(178677, 495, 20142, 7),
	(203499, 462, 20073, 6),
	(203499, 346, 20052, 9),
	(203499, 156, 20084, 10),
	(203499, 446, 20153, 9),
	(203499, 434, 20101, 8),
	(203499, 412, 20052, 7),
	(203499, 414, 20041, 10),
	(203499, 375, 20144, 8),
	(203499, 36, 20101, 8),
	(203499, 26, 20141, 7),
	(203499, 294, 20102, 9),
	(203499, 472, 20061, 7),
	(203499, 196, 20121, 7),
	(203499, 431, 20143, 10),
	(203499, 332, 20133, 7),
	(129196, 153, 20104, 5),
	(129196, 379, 20074, 9),
	(129196, 110, 20074, 10),
	(129196, 133, 20112, 10),
	(129196, 87, 20102, 7),
	(129196, 454, 20121, 6),
	(129196, 423, 20151, 7),
	(129196, 189, 20052, 10),
	(129196, 307, 20042, 8),
	(129196, 261, 20143, 8),
	(129196, 324, 20123, 9),
	(129196, 439, 20054, 6),
	(227363, 165, 20101, 9),
	(227363, 134, 20131, 7),
	(227363, 468, 20111, 7),
	(262716, 469, 20114, 6),
	(262716, 179, 20132, 10),
	(262716, 35, 20091, 5),
	(262716, 209, 20083, 9),
	(170010, 163, 20103, 7),
	(170010, 45, 20082, 5),
	(170010, 334, 20051, 5),
	(170010, 177, 20081, 5),
	(170010, 36, 20044, 8),
	(170010, 154, 20064, 10),
	(170010, 163, 20102, 6),
	(170010, 465, 20114, 9),
	(170010, 150, 20154, 9),
	(250988, 171, 20124, 7),
	(250988, 341, 20103, 7),
	(250988, 392, 20094, 6),
	(250988, 199, 20052, 10),
	(250988, 353, 20123, 6),
	(250988, 4, 20101, 7),
	(250988, 325, 20102, 8),
	(250988, 318, 20041, 5),
	(250988, 78, 20063, 8),
	(250988, 307, 20132, 8),
	(250988, 102, 20111, 6),
	(260708, 102, 20041, 8),
	(260708, 484, 20114, 6),
	(260708, 377, 20033, 10),
	(260708, 240, 20132, 7),
	(260708, 142, 20092, 9),
	(260708, 48, 20084, 8),
	(260708, 405, 20062, 10),
	(260708, 440, 20041, 7),
	(260708, 271, 20123, 5),
	(260708, 471, 20122, 8),
	(260708, 452, 20102, 5),
	(119053, 483, 20132, 10),
	(119053, 31, 20111, 9),
	(119053, 431, 20091, 9),
	(119053, 403, 20044, 7),
	(119053, 340, 20071, 9),
	(119053, 386, 20132, 7),
	(119053, 138, 20144, 5),
	(119053, 215, 20043, 10),
	(119053, 285, 20124, 9),
	(119053, 496, 20044, 7),
	(138682, 35, 20053, 9),
	(138682, 94, 20101, 9),
	(138682, 302, 20143, 9),
	(138682, 112, 20154, 6),
	(138682, 453, 20083, 7),
	(138682, 272, 20124, 7),
	(138682, 8, 20033, 10),
	(138682, 273, 20154, 7),
	(138682, 356, 20114, 8),
	(138682, 411, 20064, 7),
	(138682, 475, 20152, 5),
	(138682, 7, 20152, 10),
	(138682, 165, 20092, 9),
	(138682, 142, 20054, 9),
	(138682, 486, 20052, 9),
	(138682, 207, 20033, 7),
	(138682, 286, 20051, 6),
	(255228, 230, 20044, 5),
	(255228, 434, 20134, 9),
	(255228, 132, 20154, 5),
	(255228, 3, 20044, 7),
	(255228, 87, 20114, 5),
	(255228, 272, 20123, 6),
	(255228, 352, 20122, 6),
	(255228, 442, 20113, 10),
	(255228, 394, 20113, 6),
	(255228, 219, 20093, 8),
	(204606, 1, 20031, 7),
	(204606, 411, 20131, 10),
	(204606, 207, 20062, 7),
	(204606, 47, 20051, 7),
	(204606, 340, 20051, 5),
	(204606, 347, 20043, 10),
	(204606, 325, 20071, 10),
	(204606, 29, 20094, 10),
	(204606, 16, 20143, 6),
	(204606, 447, 20071, 7),
	(168723, 377, 20142, 8),
	(168723, 182, 20093, 10),
	(203156, 231, 20122, 10),
	(203156, 15, 20052, 10),
	(219667, 228, 20133, 6),
	(219667, 112, 20122, 7),
	(219667, 500, 20121, 6),
	(254152, 115, 20123, 5),
	(254152, 299, 20072, 7),
	(254152, 360, 20051, 7),
	(254152, 411, 20033, 9),
	(254152, 186, 20144, 7),
	(229517, 321, 20073, 9),
	(229517, 6, 20063, 5),
	(229517, 405, 20114, 5),
	(229517, 79, 20052, 6),
	(229517, 154, 20054, 6),
	(229517, 256, 20072, 7),
	(229517, 490, 20104, 9),
	(229517, 369, 20041, 5),
	(229517, 399, 20092, 9),
	(229517, 204, 20103, 5),
	(229517, 271, 20121, 7),
	(229517, 119, 20072, 5),
	(229517, 271, 20054, 8),
	(229517, 481, 20123, 7),
	(229517, 106, 20031, 5),
	(229517, 227, 20151, 6),
	(229517, 295, 20142, 7),
	(229517, 308, 20112, 9),
	(229517, 204, 20042, 5),
	(275096, 353, 20042, 8),
	(275096, 184, 20061, 9),
	(275096, 284, 20071, 6),
	(275096, 125, 20153, 9),
	(275096, 441, 20083, 9),
	(275096, 17, 20144, 9),
	(275096, 403, 20041, 5),
	(275096, 417, 20052, 8),
	(275096, 219, 20032, 5),
	(275096, 293, 20082, 8),
	(275096, 316, 20104, 7),
	(275096, 16, 20104, 8),
	(275096, 129, 20103, 10),
	(275096, 497, 20104, 7),
	(275096, 318, 20043, 6),
	(292148, 298, 20113, 8),
	(292148, 57, 20043, 8),
	(292148, 37, 20063, 6),
	(292148, 82, 20081, 10),
	(292148, 26, 20141, 5),
	(292148, 283, 20101, 7),
	(292148, 83, 20153, 6),
	(292148, 342, 20121, 5),
	(292148, 278, 20113, 9),
	(292148, 328, 20111, 6),
	(292148, 255, 20152, 9),
	(292148, 324, 20052, 7),
	(292148, 119, 20042, 6),
	(292148, 213, 20151, 7),
	(292148, 204, 20073, 7),
	(292148, 159, 20084, 10),
	(292148, 408, 20063, 8),
	(292148, 126, 20141, 8),
	(194908, 382, 20073, 5),
	(194908, 33, 20111, 10),
	(194908, 441, 20144, 5),
	(194908, 186, 20034, 6),
	(194908, 23, 20131, 6),
	(194908, 36, 20064, 6),
	(194908, 71, 20102, 5),
	(194908, 270, 20141, 9),
	(194908, 216, 20124, 7),
	(194908, 142, 20142, 10),
	(194908, 320, 20041, 8),
	(245725, 91, 20081, 9),
	(245725, 484, 20072, 5),
	(245725, 47, 20072, 6),
	(245725, 263, 20042, 8),
	(245725, 263, 20043, 8),
	(245725, 362, 20081, 7),
	(245725, 78, 20143, 10),
	(131694, 339, 20143, 5),
	(131694, 191, 20143, 10),
	(259336, 212, 20063, 5),
	(259336, 182, 20101, 6),
	(259336, 356, 20034, 8),
	(259336, 217, 20131, 9),
	(259336, 453, 20104, 5),
	(259336, 34, 20103, 7),
	(259336, 111, 20114, 10),
	(259336, 156, 20113, 10),
	(259336, 87, 20073, 8),
	(259336, 479, 20092, 9),
	(259336, 121, 20144, 8),
	(259336, 8, 20074, 9),
	(225503, 265, 20142, 6),
	(225503, 43, 20101, 7),
	(225503, 90, 20032, 9),
	(225503, 441, 20063, 8),
	(225503, 352, 20042, 6),
	(225503, 480, 20042, 8),
	(225503, 372, 20044, 5),
	(225503, 346, 20133, 9),
	(225503, 98, 20133, 6),
	(225503, 425, 20153, 10),
	(225503, 381, 20114, 5),
	(225503, 382, 20104, 5),
	(225503, 479, 20131, 8),
	(225503, 87, 20082, 6),
	(225503, 326, 20153, 9),
	(225503, 53, 20094, 8),
	(189021, 105, 20123, 9),
	(189021, 134, 20081, 7),
	(189021, 181, 20112, 6),
	(189021, 66, 20043, 9),
	(189021, 282, 20034, 6),
	(189021, 370, 20124, 7),
	(189021, 214, 20034, 7),
	(189021, 424, 20032, 7),
	(189021, 456, 20083, 7),
	(189021, 14, 20143, 8),
	(189021, 277, 20112, 7),
	(189021, 22, 20044, 8),
	(189021, 428, 20124, 5),
	(189021, 157, 20052, 8),
	(189021, 392, 20151, 7),
	(189021, 51, 20134, 8),
	(189021, 269, 20103, 8),
	(189021, 453, 20074, 7),
	(294758, 196, 20082, 10),
	(294758, 127, 20052, 9),
	(294758, 132, 20073, 6),
	(294758, 391, 20141, 5),
	(294758, 124, 20142, 6),
	(294758, 313, 20154, 9),
	(294758, 173, 20041, 5),
	(294758, 170, 20133, 5),
	(137381, 133, 20143, 7),
	(137381, 347, 20063, 10),
	(137381, 28, 20091, 8),
	(137381, 432, 20052, 9),
	(137381, 27, 20063, 6),
	(137381, 68, 20101, 5),
	(137381, 24, 20101, 6),
	(137381, 443, 20052, 9),
	(137381, 329, 20141, 5),
	(137381, 470, 20101, 10),
	(137381, 8, 20034, 5),
	(137381, 471, 20083, 7),
	(137381, 72, 20123, 10),
	(137381, 7, 20121, 5),
	(176124, 242, 20031, 9),
	(176124, 214, 20032, 9),
	(176124, 267, 20153, 8),
	(176124, 339, 20141, 10),
	(176124, 48, 20052, 6),
	(176124, 403, 20143, 7),
	(176124, 297, 20091, 10),
	(176124, 216, 20141, 6),
	(176124, 415, 20072, 8),
	(176124, 344, 20052, 10),
	(240950, 309, 20143, 10),
	(240950, 29, 20083, 7),
	(240950, 33, 20133, 8),
	(240950, 389, 20044, 7),
	(240950, 433, 20072, 5),
	(240950, 83, 20154, 7),
	(174734, 374, 20141, 5),
	(174734, 188, 20072, 10),
	(174734, 22, 20114, 10),
	(174734, 381, 20062, 5),
	(174734, 46, 20104, 7),
	(174734, 123, 20101, 6),
	(174734, 409, 20153, 6),
	(174734, 88, 20103, 7),
	(174734, 119, 20132, 9),
	(174734, 357, 20121, 6),
	(174734, 185, 20101, 9),
	(174734, 398, 20111, 8),
	(174734, 164, 20102, 6),
	(174734, 86, 20154, 6),
	(174734, 92, 20154, 8),
	(174734, 119, 20102, 5),
	(203565, 161, 20084, 6),
	(203565, 18, 20123, 7),
	(203565, 166, 20094, 8),
	(203565, 122, 20104, 10),
	(203565, 485, 20052, 6),
	(203565, 346, 20082, 7),
	(203565, 30, 20114, 6),
	(203565, 433, 20094, 5),
	(203565, 333, 20144, 5),
	(203565, 220, 20073, 6),
	(203565, 269, 20151, 9),
	(203565, 191, 20094, 7),
	(203565, 260, 20092, 10),
	(203565, 361, 20061, 6),
	(203565, 135, 20113, 6),
	(203565, 106, 20061, 5),
	(203565, 452, 20124, 7),
	(203565, 50, 20083, 6),
	(203565, 116, 20072, 10),
	(203565, 366, 20102, 6),
	(272223, 59, 20071, 10),
	(272223, 218, 20132, 6),
	(272223, 215, 20043, 10),
	(272223, 436, 20151, 9),
	(272223, 73, 20111, 10),
	(272223, 256, 20142, 7),
	(272223, 415, 20063, 5),
	(272223, 161, 20102, 6),
	(272223, 174, 20053, 8),
	(272223, 393, 20074, 9),
	(272223, 446, 20122, 8),
	(272223, 448, 20114, 6),
	(237269, 75, 20141, 5),
	(237269, 367, 20133, 7),
	(237269, 441, 20152, 9),
	(237269, 140, 20142, 7),
	(237269, 448, 20054, 5),
	(237269, 237, 20092, 9),
	(237269, 498, 20103, 8),
	(237269, 495, 20104, 10),
	(237269, 7, 20113, 7),
	(237269, 232, 20033, 8),
	(237269, 307, 20092, 5),
	(237269, 72, 20074, 10),
	(256223, 426, 20072, 5),
	(256223, 211, 20083, 5),
	(256223, 319, 20042, 10),
	(256223, 266, 20073, 10),
	(256223, 345, 20092, 6),
	(256223, 145, 20052, 5),
	(256223, 470, 20081, 10),
	(256223, 306, 20074, 6),
	(148294, 414, 20153, 8),
	(148294, 454, 20062, 6),
	(148294, 479, 20092, 7),
	(148294, 205, 20031, 6),
	(148294, 420, 20053, 7),
	(148294, 255, 20133, 10),
	(148294, 351, 20113, 8),
	(148294, 73, 20063, 7),
	(148294, 477, 20052, 9),
	(148294, 222, 20103, 10),
	(148294, 212, 20031, 9),
	(148294, 265, 20154, 10),
	(148294, 374, 20103, 6),
	(148294, 121, 20053, 10),
	(148294, 147, 20131, 8),
	(148294, 222, 20144, 8),
	(148294, 396, 20064, 7),
	(148294, 65, 20074, 10),
	(148294, 400, 20032, 7),
	(204097, 314, 20141, 8),
	(204097, 356, 20084, 9),
	(204097, 314, 20112, 8),
	(204097, 111, 20044, 7),
	(204097, 418, 20054, 7),
	(133104, 262, 20113, 5),
	(133104, 224, 20104, 10),
	(133104, 251, 20034, 10),
	(133104, 60, 20084, 10),
	(133104, 336, 20122, 6),
	(133104, 36, 20121, 6),
	(133104, 290, 20101, 5),
	(133104, 451, 20053, 8),
	(133104, 171, 20082, 6),
	(133104, 345, 20032, 7),
	(133104, 74, 20074, 10),
	(133104, 123, 20112, 9),
	(133104, 464, 20152, 9),
	(133104, 3, 20131, 7),
	(133104, 194, 20132, 7),
	(133104, 54, 20094, 6),
	(133104, 145, 20083, 10),
	(205161, 246, 20103, 6),
	(205161, 354, 20131, 10),
	(205161, 145, 20044, 10),
	(205161, 424, 20071, 10),
	(205161, 105, 20034, 5),
	(205161, 190, 20082, 7),
	(205161, 163, 20153, 10),
	(205161, 130, 20064, 7),
	(205161, 1, 20114, 8),
	(205161, 24, 20043, 5),
	(205161, 436, 20041, 9),
	(205161, 387, 20102, 6),
	(205161, 61, 20121, 10),
	(205161, 266, 20093, 7),
	(205161, 80, 20051, 5),
	(210783, 447, 20152, 5),
	(210783, 97, 20111, 9),
	(210783, 160, 20061, 8),
	(210783, 56, 20053, 10),
	(210783, 176, 20124, 8),
	(210783, 349, 20151, 10),
	(210783, 265, 20101, 8),
	(210783, 189, 20144, 6),
	(210783, 94, 20052, 7),
	(210783, 195, 20081, 7),
	(210783, 67, 20153, 6),
	(210783, 55, 20122, 5),
	(149445, 329, 20044, 10),
	(149445, 77, 20144, 8),
	(149445, 461, 20052, 6),
	(149445, 311, 20142, 10),
	(149445, 76, 20121, 7),
	(149445, 10, 20131, 7),
	(149445, 410, 20103, 7),
	(149445, 167, 20102, 10),
	(149445, 199, 20053, 8),
	(149445, 336, 20064, 7),
	(149445, 399, 20043, 5),
	(149445, 310, 20043, 7),
	(149445, 483, 20061, 10),
	(149445, 331, 20034, 5),
	(149445, 68, 20094, 9),
	(149445, 373, 20152, 7),
	(149445, 58, 20131, 9),
	(149445, 165, 20054, 7),
	(165589, 245, 20053, 7),
	(165589, 355, 20073, 5),
	(165589, 433, 20051, 10),
	(165589, 454, 20092, 6),
	(165589, 174, 20143, 5),
	(165589, 302, 20041, 5),
	(165589, 343, 20112, 7),
	(165589, 148, 20063, 6),
	(165589, 239, 20141, 7),
	(165589, 211, 20083, 10),
	(165589, 322, 20131, 5),
	(165589, 496, 20072, 10),
	(165589, 306, 20041, 9),
	(165589, 466, 20103, 6),
	(147679, 483, 20042, 7),
	(147679, 410, 20133, 6),
	(147679, 188, 20044, 9),
	(147679, 476, 20083, 10),
	(147679, 445, 20074, 5),
	(147679, 117, 20112, 10),
	(147679, 17, 20032, 7),
	(147679, 278, 20052, 10),
	(147679, 422, 20081, 7),
	(147679, 144, 20062, 5),
	(147679, 72, 20093, 7),
	(147679, 99, 20074, 5),
	(147679, 354, 20131, 10),
	(147679, 250, 20141, 10),
	(147679, 494, 20061, 8),
	(147679, 467, 20122, 6),
	(147679, 13, 20052, 8),
	(147679, 225, 20073, 7),
	(147679, 36, 20113, 7),
	(147679, 210, 20063, 6),
	(295837, 77, 20081, 8),
	(295837, 465, 20132, 5),
	(295837, 379, 20084, 7),
	(295837, 288, 20054, 10),
	(295837, 213, 20084, 5),
	(295837, 141, 20082, 7),
	(295837, 198, 20131, 10),
	(295837, 212, 20124, 6),
	(295837, 345, 20073, 6),
	(295837, 239, 20112, 6),
	(295837, 282, 20044, 7),
	(295837, 127, 20042, 6),
	(295837, 438, 20101, 7),
	(223146, 329, 20143, 9),
	(223146, 175, 20051, 9),
	(223146, 28, 20034, 6),
	(223146, 435, 20092, 7),
	(223146, 152, 20104, 8),
	(223146, 130, 20152, 6),
	(223146, 309, 20111, 6),
	(223146, 213, 20094, 7),
	(223146, 141, 20064, 10),
	(223146, 203, 20044, 8),
	(223146, 7, 20113, 5),
	(223146, 173, 20042, 10),
	(223146, 186, 20094, 10),
	(223146, 245, 20082, 9),
	(223146, 385, 20144, 5),
	(223146, 335, 20142, 8),
	(223146, 138, 20093, 10),
	(223146, 58, 20113, 6),
	(223146, 79, 20151, 5),
	(279103, 468, 20102, 5),
	(279103, 341, 20153, 10),
	(279103, 142, 20111, 7),
	(279103, 221, 20111, 6),
	(158506, 450, 20043, 9),
	(158506, 293, 20114, 6),
	(158506, 196, 20031, 9),
	(158506, 411, 20053, 10),
	(158506, 365, 20063, 8),
	(158506, 446, 20044, 10),
	(219567, 162, 20142, 10),
	(219567, 58, 20072, 8),
	(219567, 435, 20112, 8),
	(219567, 384, 20082, 9),
	(219567, 108, 20063, 8),
	(219567, 63, 20111, 5),
	(219567, 166, 20133, 6),
	(219567, 353, 20034, 6),
	(219567, 325, 20111, 10),
	(219567, 361, 20123, 5),
	(219567, 309, 20131, 7),
	(219567, 391, 20151, 6),
	(219567, 268, 20043, 7),
	(123476, 377, 20044, 8),
	(123476, 111, 20062, 10),
	(123476, 438, 20094, 8),
	(123476, 140, 20152, 9),
	(123476, 289, 20094, 10),
	(123476, 333, 20121, 10),
	(123476, 73, 20092, 6),
	(123476, 336, 20061, 8),
	(123476, 235, 20061, 8),
	(123476, 189, 20121, 8),
	(123476, 135, 20031, 10),
	(123476, 257, 20064, 6),
	(123476, 398, 20031, 9),
	(257596, 129, 20154, 9),
	(257596, 62, 20073, 7),
	(257596, 131, 20064, 6),
	(257596, 469, 20112, 9),
	(257596, 63, 20112, 5),
	(257596, 327, 20154, 5),
	(257596, 440, 20061, 5),
	(257596, 363, 20032, 5),
	(257596, 215, 20083, 9),
	(257596, 343, 20102, 9),
	(257596, 380, 20031, 9),
	(257596, 248, 20034, 5),
	(257596, 124, 20154, 9),
	(257596, 17, 20062, 9),
	(257596, 494, 20104, 7),
	(257596, 368, 20132, 10),
	(257596, 264, 20154, 6),
	(115571, 128, 20143, 9),
	(115571, 355, 20132, 8),
	(115571, 120, 20084, 6),
	(115571, 335, 20092, 7),
	(115571, 167, 20114, 5),
	(115571, 153, 20034, 10),
	(115571, 113, 20123, 5),
	(115571, 75, 20104, 9),
	(115571, 228, 20112, 8),
	(115571, 165, 20074, 6),
	(115571, 158, 20081, 8),
	(115571, 173, 20094, 10),
	(115571, 447, 20032, 9),
	(115571, 463, 20062, 5),
	(115571, 320, 20133, 5),
	(115571, 418, 20064, 7),
	(115571, 269, 20033, 9),
	(115571, 222, 20071, 7),
	(115571, 368, 20134, 5),
	(228353, 12, 20144, 9),
	(228353, 267, 20131, 7),
	(228353, 96, 20081, 5),
	(228353, 158, 20142, 7),
	(228353, 336, 20091, 10),
	(228353, 241, 20083, 7),
	(228353, 153, 20083, 10),
	(228353, 237, 20052, 7),
	(228353, 161, 20084, 9),
	(228353, 368, 20061, 5),
	(228353, 328, 20032, 6),
	(228353, 304, 20111, 5),
	(228353, 457, 20051, 6),
	(228353, 266, 20112, 9),
	(228353, 165, 20121, 5),
	(228353, 5, 20132, 10),
	(213112, 62, 20041, 6),
	(213112, 471, 20111, 10),
	(213112, 83, 20043, 8),
	(213112, 366, 20063, 6),
	(262330, 220, 20053, 7),
	(262330, 37, 20034, 10),
	(262330, 197, 20063, 9),
	(262330, 113, 20074, 8),
	(262330, 423, 20114, 7),
	(262330, 391, 20121, 8),
	(262330, 251, 20043, 5),
	(262330, 296, 20031, 8),
	(262330, 102, 20094, 10),
	(262330, 345, 20103, 7),
	(262330, 87, 20122, 9),
	(262330, 17, 20113, 5),
	(262330, 301, 20134, 8),
	(262330, 294, 20103, 6),
	(254717, 473, 20071, 7),
	(254717, 260, 20142, 10),
	(254717, 77, 20093, 10),
	(254717, 400, 20122, 5),
	(254717, 375, 20131, 5),
	(254717, 176, 20103, 8),
	(254717, 227, 20053, 8),
	(254717, 433, 20112, 10),
	(254717, 234, 20154, 8),
	(254333, 384, 20051, 7),
	(254333, 167, 20031, 6),
	(254333, 368, 20073, 5),
	(254333, 249, 20084, 5),
	(254333, 44, 20101, 7),
	(254333, 456, 20123, 7),
	(254333, 297, 20094, 8),
	(254333, 307, 20121, 8),
	(254333, 457, 20081, 9),
	(254333, 43, 20121, 6),
	(254333, 385, 20144, 5),
	(254333, 238, 20124, 6),
	(254333, 474, 20144, 6),
	(254333, 244, 20122, 9),
	(254333, 377, 20031, 10),
	(254333, 282, 20042, 10),
	(196768, 375, 20082, 8),
	(196768, 403, 20102, 8),
	(196768, 251, 20073, 6),
	(196768, 447, 20104, 7),
	(196768, 289, 20121, 7),
	(196768, 278, 20141, 6),
	(196768, 463, 20044, 5),
	(196768, 68, 20111, 8),
	(196768, 402, 20153, 5),
	(196768, 465, 20103, 6),
	(196768, 393, 20081, 7),
	(196768, 369, 20141, 6),
	(196768, 116, 20141, 5),
	(196768, 37, 20042, 9),
	(196768, 362, 20061, 8),
	(196768, 192, 20132, 7),
	(196768, 88, 20094, 8),
	(196768, 94, 20053, 10),
	(196768, 457, 20153, 7),
	(196768, 309, 20094, 9),
	(205233, 236, 20074, 8),
	(205233, 487, 20032, 8),
	(205233, 496, 20073, 5),
	(205233, 299, 20144, 10),
	(205233, 269, 20102, 10),
	(205233, 336, 20153, 5),
	(205233, 266, 20102, 5),
	(205233, 274, 20081, 6),
	(205233, 388, 20113, 10),
	(205233, 109, 20124, 5),
	(205233, 457, 20151, 6),
	(205233, 5, 20101, 9),
	(205233, 180, 20074, 10),
	(205233, 225, 20041, 5),
	(205233, 257, 20044, 9),
	(205233, 475, 20083, 8),
	(205233, 355, 20083, 8),
	(205233, 427, 20044, 10),
	(232699, 389, 20154, 5),
	(232699, 17, 20151, 7),
	(232699, 421, 20122, 7),
	(232699, 24, 20143, 9),
	(232699, 344, 20154, 7),
	(232699, 108, 20132, 9),
	(232699, 326, 20034, 5),
	(232699, 315, 20082, 10),
	(232699, 367, 20101, 6),
	(232699, 244, 20072, 5),
	(232699, 283, 20034, 10),
	(232699, 26, 20043, 7),
	(232699, 325, 20132, 5),
	(232699, 224, 20111, 5),
	(157120, 128, 20083, 5),
	(157120, 432, 20093, 7),
	(157120, 351, 20154, 10),
	(157120, 375, 20133, 6),
	(157120, 53, 20074, 9),
	(157120, 409, 20082, 9),
	(157120, 100, 20064, 6),
	(157120, 38, 20132, 8),
	(157120, 343, 20111, 7),
	(157120, 42, 20083, 5),
	(157120, 162, 20123, 9),
	(157120, 375, 20052, 9),
	(157120, 277, 20071, 9),
	(157120, 186, 20081, 8),
	(157120, 1, 20102, 10),
	(157120, 172, 20083, 8),
	(157120, 80, 20043, 6),
	(157120, 140, 20102, 6),
	(157120, 325, 20031, 7),
	(216141, 241, 20092, 8),
	(216141, 216, 20101, 8),
	(216141, 399, 20122, 7),
	(216141, 140, 20033, 9),
	(216141, 477, 20153, 9),
	(216141, 70, 20104, 10),
	(216141, 155, 20143, 10),
	(211576, 262, 20091, 5),
	(211576, 344, 20104, 8),
	(211576, 380, 20111, 5),
	(211576, 414, 20094, 7),
	(211576, 214, 20132, 7),
	(211576, 180, 20032, 7),
	(211576, 390, 20031, 5),
	(211576, 190, 20141, 7),
	(211576, 172, 20134, 10),
	(211576, 416, 20121, 5),
	(211576, 172, 20064, 7),
	(211576, 227, 20064, 7),
	(211576, 440, 20112, 7),
	(211576, 367, 20134, 9),
	(211576, 29, 20034, 9),
	(211576, 428, 20123, 5),
	(211576, 237, 20132, 8),
	(242594, 491, 20064, 10),
	(242594, 27, 20092, 8),
	(242594, 112, 20122, 7),
	(242594, 423, 20124, 5),
	(211996, 179, 20153, 6),
	(211996, 104, 20053, 7),
	(211996, 296, 20151, 9),
	(211996, 320, 20124, 8),
	(211996, 477, 20102, 10),
	(211996, 236, 20152, 8),
	(211996, 355, 20054, 9),
	(211996, 397, 20113, 8),
	(211996, 112, 20064, 7),
	(211996, 118, 20093, 9),
	(211996, 165, 20031, 6),
	(211996, 127, 20061, 7),
	(211996, 224, 20133, 9),
	(211996, 421, 20053, 10),
	(211996, 13, 20133, 7),
	(211996, 458, 20124, 10),
	(211996, 480, 20113, 8),
	(211996, 95, 20133, 8),
	(211996, 177, 20144, 6),
	(160061, 252, 20112, 5),
	(160061, 406, 20063, 6),
	(160061, 470, 20053, 6),
	(160061, 34, 20081, 10),
	(160061, 152, 20133, 6),
	(160061, 175, 20141, 6),
	(160061, 300, 20051, 9),
	(160061, 233, 20103, 6),
	(160061, 322, 20112, 10),
	(160061, 332, 20054, 6),
	(160061, 410, 20073, 10),
	(160061, 314, 20083, 7),
	(160061, 25, 20062, 8),
	(160061, 496, 20084, 6),
	(240696, 387, 20103, 7),
	(240696, 318, 20051, 7),
	(240696, 302, 20052, 6),
	(240696, 186, 20094, 6),
	(240696, 69, 20034, 10),
	(240696, 110, 20063, 5),
	(121610, 383, 20124, 7),
	(121610, 360, 20113, 8),
	(121610, 420, 20051, 8),
	(121610, 221, 20112, 10),
	(121610, 1, 20094, 8),
	(121610, 405, 20042, 6),
	(121610, 466, 20033, 7),
	(121610, 161, 20113, 5),
	(121610, 500, 20034, 5),
	(121610, 415, 20053, 9),
	(121610, 226, 20124, 7),
	(121610, 109, 20143, 5),
	(121610, 372, 20084, 8),
	(121610, 315, 20072, 10),
	(121610, 108, 20111, 5),
	(121610, 118, 20052, 6),
	(214236, 134, 20153, 9),
	(214236, 129, 20093, 8),
	(214236, 196, 20131, 5),
	(214236, 270, 20042, 8),
	(255904, 282, 20032, 9),
	(255904, 393, 20044, 6),
	(255904, 364, 20073, 5),
	(255904, 481, 20051, 8),
	(255904, 13, 20044, 5),
	(255904, 173, 20044, 8),
	(255904, 10, 20143, 6),
	(255904, 131, 20081, 5),
	(255904, 489, 20151, 9),
	(255904, 325, 20101, 5),
	(168847, 461, 20072, 9),
	(168847, 14, 20153, 5),
	(168847, 488, 20084, 9),
	(168847, 395, 20114, 6),
	(168847, 389, 20092, 7),
	(168847, 82, 20043, 7),
	(168847, 427, 20063, 7),
	(168847, 161, 20153, 6),
	(168847, 220, 20153, 9),
	(168847, 188, 20114, 7),
	(168847, 447, 20041, 8),
	(168847, 364, 20052, 7),
	(168847, 270, 20063, 6),
	(239649, 470, 20042, 6),
	(239649, 32, 20093, 8),
	(239649, 71, 20133, 10),
	(161565, 49, 20123, 9),
	(161565, 41, 20144, 9),
	(161565, 495, 20124, 6),
	(161565, 138, 20134, 10),
	(232604, 277, 20133, 10),
	(232604, 73, 20033, 6),
	(232604, 268, 20062, 10),
	(232604, 83, 20123, 10),
	(232604, 388, 20031, 6),
	(232604, 119, 20033, 8),
	(191862, 285, 20144, 7),
	(191862, 84, 20054, 8),
	(191862, 6, 20082, 9),
	(191862, 344, 20062, 6),
	(157009, 251, 20152, 10),
	(148073, 232, 20061, 8),
	(148073, 417, 20114, 10),
	(148073, 306, 20031, 9),
	(148073, 132, 20141, 8),
	(148073, 102, 20143, 8),
	(148073, 320, 20153, 5),
	(298752, 475, 20043, 6),
	(298752, 367, 20034, 5),
	(298752, 380, 20031, 8),
	(298752, 422, 20071, 6),
	(210584, 328, 20081, 6),
	(210584, 201, 20064, 10),
	(210584, 369, 20101, 6),
	(210584, 242, 20102, 9),
	(210584, 174, 20112, 10),
	(210584, 334, 20074, 8),
	(210584, 245, 20033, 8),
	(210584, 101, 20112, 7),
	(210584, 234, 20132, 8),
	(282603, 174, 20091, 9),
	(282603, 103, 20034, 6),
	(282603, 474, 20124, 8),
	(282603, 180, 20152, 7),
	(282603, 498, 20133, 5),
	(282603, 486, 20032, 10),
	(282603, 126, 20042, 5),
	(282603, 176, 20141, 7),
	(282603, 81, 20071, 9),
	(282603, 314, 20093, 8),
	(282603, 421, 20063, 7),
	(282603, 479, 20131, 6),
	(282603, 404, 20114, 7),
	(188830, 142, 20044, 8),
	(188830, 390, 20152, 6),
	(188830, 206, 20031, 7),
	(188830, 477, 20143, 10),
	(188830, 277, 20031, 7),
	(188830, 20, 20114, 6),
	(188830, 272, 20093, 6),
	(188830, 448, 20102, 8),
	(188830, 17, 20044, 6),
	(188830, 109, 20092, 6),
	(188830, 177, 20064, 5),
	(188830, 57, 20101, 7),
	(188830, 355, 20063, 7),
	(188830, 235, 20042, 5),
	(188830, 284, 20112, 5),
	(188830, 476, 20031, 9),
	(188830, 485, 20051, 6),
	(188830, 313, 20034, 7),
	(197309, 349, 20142, 8),
	(197309, 154, 20081, 8),
	(197309, 452, 20103, 8),
	(197309, 175, 20042, 10),
	(103955, 266, 20084, 10),
	(103955, 340, 20142, 9),
	(103955, 17, 20061, 8),
	(103955, 328, 20131, 5),
	(103955, 426, 20104, 10),
	(103955, 42, 20063, 5),
	(103955, 204, 20052, 10),
	(103955, 152, 20041, 8),
	(103955, 422, 20032, 8),
	(103955, 25, 20134, 7),
	(103955, 108, 20102, 5),
	(103955, 172, 20034, 5),
	(103955, 235, 20042, 10),
	(103955, 347, 20124, 7),
	(103955, 110, 20133, 5),
	(103955, 39, 20151, 5),
	(142157, 325, 20131, 6),
	(142157, 61, 20103, 9),
	(142157, 400, 20114, 8),
	(142157, 319, 20111, 5),
	(142157, 127, 20034, 9),
	(142157, 97, 20112, 5),
	(142157, 417, 20073, 7),
	(142157, 108, 20104, 10),
	(238571, 300, 20104, 8),
	(238571, 17, 20152, 10),
	(238571, 481, 20133, 6),
	(238571, 400, 20112, 9),
	(238571, 469, 20123, 7),
	(238571, 287, 20064, 5),
	(238571, 407, 20033, 7),
	(238571, 132, 20064, 5),
	(238571, 49, 20103, 6),
	(238571, 30, 20143, 7),
	(238571, 258, 20061, 5),
	(238571, 162, 20092, 7),
	(238571, 483, 20102, 7),
	(238571, 176, 20043, 7),
	(238571, 206, 20071, 9),
	(238571, 52, 20152, 9),
	(190018, 407, 20134, 7),
	(190018, 408, 20144, 8),
	(190018, 25, 20042, 8),
	(190018, 186, 20063, 7),
	(190018, 233, 20134, 7),
	(190018, 411, 20144, 9),
	(190018, 254, 20132, 9),
	(190018, 423, 20131, 6),
	(190018, 465, 20081, 9),
	(190018, 348, 20062, 8),
	(190018, 54, 20153, 10),
	(218391, 364, 20142, 7),
	(218391, 11, 20113, 7),
	(218391, 88, 20073, 5),
	(218391, 162, 20034, 6),
	(218391, 141, 20081, 8),
	(218391, 104, 20072, 9),
	(218391, 110, 20133, 10),
	(218391, 433, 20113, 6),
	(218391, 239, 20034, 5),
	(167460, 238, 20124, 8),
	(167460, 46, 20063, 9),
	(167460, 109, 20132, 7),
	(167460, 485, 20082, 5),
	(167460, 428, 20123, 7),
	(167460, 19, 20104, 7),
	(167460, 442, 20152, 9),
	(167460, 112, 20034, 7),
	(167460, 123, 20152, 5),
	(167460, 92, 20064, 7),
	(167460, 159, 20103, 10),
	(167460, 370, 20053, 9),
	(167460, 382, 20073, 8),
	(167460, 347, 20042, 9),
	(167460, 152, 20064, 10),
	(209932, 429, 20033, 5),
	(209932, 367, 20084, 5),
	(209932, 260, 20054, 9),
	(209932, 437, 20131, 6),
	(209932, 116, 20034, 5),
	(257668, 197, 20121, 5),
	(257668, 26, 20074, 9),
	(257668, 479, 20063, 10),
	(257668, 56, 20043, 5),
	(257668, 56, 20054, 8),
	(257668, 343, 20134, 10),
	(257668, 493, 20074, 8),
	(257668, 443, 20142, 8),
	(257668, 73, 20114, 5),
	(257668, 340, 20094, 7),
	(290597, 352, 20034, 6),
	(290597, 143, 20111, 10),
	(290597, 367, 20121, 9),
	(290597, 50, 20033, 7),
	(290597, 35, 20124, 10),
	(136181, 360, 20121, 9),
	(136181, 456, 20131, 9),
	(136181, 88, 20082, 6),
	(136181, 407, 20053, 9),
	(136181, 22, 20151, 9),
	(136181, 246, 20152, 9),
	(136181, 212, 20142, 6),
	(136181, 196, 20121, 9),
	(136181, 223, 20102, 7),
	(136181, 189, 20072, 5),
	(136181, 233, 20101, 6),
	(136181, 277, 20094, 9),
	(136181, 98, 20081, 5),
	(198212, 373, 20071, 5),
	(198212, 431, 20122, 5),
	(198212, 472, 20031, 9),
	(198212, 251, 20032, 8),
	(198212, 314, 20084, 10),
	(198212, 107, 20043, 6),
	(198212, 450, 20092, 8),
	(152061, 392, 20112, 5),
	(152061, 493, 20123, 9),
	(152061, 450, 20043, 5),
	(152061, 386, 20053, 10),
	(152061, 133, 20054, 9),
	(152061, 267, 20032, 5),
	(152061, 91, 20083, 7),
	(152061, 36, 20094, 5),
	(152061, 231, 20074, 6),
	(152061, 324, 20062, 5),
	(152061, 279, 20073, 8),
	(152061, 33, 20142, 8),
	(152061, 115, 20052, 7),
	(152061, 475, 20151, 5),
	(152061, 272, 20113, 9),
	(152061, 59, 20042, 9),
	(152061, 126, 20143, 8),
	(152061, 430, 20141, 7),
	(199254, 458, 20111, 6),
	(199254, 208, 20133, 8),
	(199254, 483, 20121, 5),
	(199254, 462, 20153, 9),
	(199254, 164, 20073, 10),
	(199254, 460, 20113, 9),
	(199254, 237, 20102, 6),
	(199254, 475, 20044, 7),
	(199254, 212, 20091, 10),
	(199254, 191, 20152, 5),
	(287649, 250, 20043, 8),
	(287649, 31, 20051, 10),
	(287649, 152, 20093, 9),
	(287649, 430, 20123, 5),
	(287649, 353, 20061, 10),
	(287649, 376, 20101, 7),
	(287649, 161, 20092, 9),
	(295958, 16, 20104, 5),
	(295958, 188, 20154, 7),
	(295958, 59, 20081, 9),
	(295958, 185, 20152, 6),
	(295958, 384, 20064, 9),
	(295958, 371, 20034, 9),
	(295958, 305, 20071, 5),
	(295958, 387, 20134, 9),
	(295958, 128, 20043, 8),
	(295958, 38, 20032, 6),
	(295958, 161, 20122, 9),
	(295958, 500, 20111, 7),
	(295958, 207, 20111, 5),
	(295958, 69, 20084, 9),
	(295958, 107, 20102, 5),
	(295958, 227, 20104, 7),
	(295958, 126, 20071, 6),
	(295958, 249, 20061, 10),
	(295958, 339, 20101, 9),
	(279343, 140, 20122, 6),
	(279343, 298, 20072, 10),
	(279343, 170, 20084, 5),
	(279343, 337, 20052, 6),
	(279343, 363, 20122, 8),
	(279343, 381, 20081, 8),
	(279343, 46, 20074, 8),
	(279343, 5, 20074, 10),
	(279343, 138, 20141, 6),
	(257079, 170, 20073, 10),
	(257079, 89, 20062, 5),
	(257079, 177, 20054, 7),
	(257079, 156, 20074, 7),
	(257079, 421, 20111, 5),
	(257079, 268, 20051, 10),
	(257079, 130, 20121, 9),
	(257079, 65, 20063, 9),
	(257079, 416, 20033, 8),
	(257079, 129, 20124, 10),
	(257079, 139, 20063, 8),
	(257079, 117, 20051, 10),
	(257079, 324, 20124, 10),
	(257079, 366, 20131, 5),
	(257079, 307, 20151, 6),
	(257079, 483, 20043, 5),
	(257079, 107, 20054, 6),
	(257079, 241, 20072, 7),
	(257079, 196, 20101, 8),
	(257079, 415, 20144, 8),
	(191034, 492, 20144, 5),
	(191034, 49, 20041, 6),
	(191034, 449, 20114, 10),
	(191034, 9, 20133, 9),
	(191034, 364, 20134, 5),
	(159868, 434, 20152, 7),
	(159868, 198, 20072, 10),
	(159868, 183, 20073, 8),
	(159868, 146, 20131, 8),
	(159868, 48, 20081, 10),
	(159868, 22, 20152, 9),
	(159868, 407, 20053, 7),
	(159868, 230, 20092, 5),
	(159868, 307, 20112, 6),
	(262131, 204, 20081, 7),
	(262131, 227, 20062, 6),
	(262131, 308, 20044, 5),
	(262131, 451, 20143, 5),
	(262131, 335, 20064, 9),
	(262131, 231, 20073, 6),
	(262131, 44, 20151, 10),
	(262131, 399, 20112, 5),
	(262131, 2, 20113, 8),
	(262131, 477, 20041, 6),
	(262131, 141, 20071, 6),
	(262131, 385, 20073, 8),
	(262131, 303, 20081, 9),
	(262131, 97, 20094, 5),
	(262131, 174, 20144, 6),
	(262131, 50, 20121, 10),
	(262131, 49, 20051, 9),
	(262131, 498, 20122, 5),
	(262131, 398, 20084, 8),
	(262131, 92, 20093, 10),
	(282541, 459, 20091, 5),
	(282541, 347, 20053, 9),
	(282541, 67, 20114, 9),
	(282541, 430, 20132, 7),
	(282541, 499, 20043, 6),
	(122139, 113, 20103, 8),
	(122139, 139, 20061, 6),
	(122139, 395, 20114, 5),
	(122139, 251, 20122, 10),
	(122139, 306, 20063, 10),
	(122139, 255, 20104, 8),
	(122139, 27, 20134, 7),
	(122139, 16, 20071, 8),
	(122139, 17, 20123, 6),
	(122139, 88, 20082, 8),
	(122139, 160, 20143, 9),
	(224118, 166, 20052, 8),
	(224118, 313, 20121, 5),
	(224118, 434, 20131, 7),
	(224118, 213, 20092, 10),
	(224118, 446, 20152, 8),
	(224118, 30, 20104, 9),
	(224118, 170, 20043, 6),
	(224118, 131, 20092, 9),
	(108983, 306, 20103, 8),
	(108983, 415, 20144, 9),
	(108983, 138, 20031, 5),
	(108983, 482, 20082, 6),
	(108983, 479, 20122, 10),
	(108983, 386, 20071, 6),
	(108983, 296, 20074, 7),
	(108983, 355, 20133, 9),
	(108983, 376, 20084, 6),
	(108983, 255, 20154, 8),
	(108983, 185, 20063, 5),
	(108983, 460, 20081, 8),
	(108983, 53, 20041, 5),
	(108983, 43, 20052, 5),
	(108983, 196, 20102, 5),
	(108983, 174, 20042, 9),
	(108983, 200, 20052, 9),
	(108983, 414, 20064, 10),
	(144206, 162, 20084, 8),
	(144206, 120, 20073, 8),
	(144206, 113, 20053, 10),
	(144206, 312, 20084, 8),
	(144206, 418, 20151, 9),
	(144206, 133, 20102, 5),
	(144206, 137, 20063, 5),
	(144206, 450, 20031, 6),
	(144206, 485, 20071, 6),
	(144206, 285, 20054, 9),
	(144206, 277, 20031, 5),
	(144206, 367, 20101, 9),
	(144206, 191, 20113, 7),
	(144206, 426, 20101, 10),
	(266902, 105, 20112, 7),
	(266902, 440, 20044, 5),
	(266902, 94, 20052, 10),
	(266902, 163, 20044, 6),
	(266902, 80, 20032, 7),
	(266902, 133, 20091, 6),
	(266902, 116, 20062, 9),
	(266902, 100, 20144, 10),
	(266902, 484, 20153, 8),
	(266902, 155, 20051, 5),
	(266902, 152, 20143, 9),
	(266902, 435, 20113, 8),
	(266902, 190, 20123, 10),
	(266902, 169, 20063, 5),
	(266902, 100, 20113, 8),
	(266902, 427, 20042, 10),
	(266902, 459, 20111, 6),
	(266902, 134, 20041, 6),
	(266902, 85, 20092, 10),
	(266902, 482, 20082, 8),
	(217825, 385, 20124, 8),
	(217825, 136, 20072, 5),
	(217825, 421, 20043, 10),
	(217825, 439, 20092, 6),
	(217825, 291, 20131, 8),
	(212685, 437, 20041, 8),
	(212685, 204, 20153, 8),
	(212685, 398, 20094, 8),
	(212685, 25, 20061, 5),
	(212685, 327, 20052, 5),
	(212685, 199, 20154, 10),
	(212685, 391, 20051, 8),
	(212685, 276, 20143, 10),
	(212685, 345, 20044, 10),
	(212685, 146, 20143, 5),
	(212685, 55, 20062, 9),
	(212685, 400, 20101, 8),
	(212685, 5, 20151, 8),
	(212685, 206, 20053, 10),
	(212685, 470, 20033, 10),
	(127655, 77, 20074, 8),
	(127655, 374, 20083, 9),
	(127655, 232, 20083, 8),
	(127655, 275, 20121, 6),
	(127655, 261, 20041, 5),
	(127655, 454, 20074, 10),
	(127655, 466, 20143, 7),
	(127655, 464, 20041, 5),
	(127655, 6, 20153, 10),
	(127655, 346, 20042, 5),
	(127655, 167, 20054, 6),
	(127655, 178, 20121, 6),
	(127655, 199, 20063, 5),
	(127655, 70, 20064, 8),
	(127655, 242, 20143, 8),
	(288222, 441, 20114, 7),
	(288222, 377, 20122, 5),
	(288222, 489, 20062, 5),
	(288222, 147, 20033, 8),
	(288222, 399, 20061, 8),
	(288222, 405, 20074, 8),
	(288222, 462, 20111, 6),
	(288222, 105, 20063, 5),
	(288222, 120, 20081, 5),
	(288222, 451, 20133, 6),
	(288222, 151, 20091, 9),
	(288222, 442, 20112, 7),
	(288222, 340, 20042, 10),
	(288222, 266, 20112, 10),
	(249171, 150, 20091, 8),
	(249171, 253, 20153, 5),
	(249171, 185, 20091, 10),
	(249171, 64, 20051, 5),
	(178388, 171, 20124, 5),
	(178388, 182, 20104, 7),
	(178388, 373, 20043, 5),
	(178388, 347, 20041, 6),
	(178388, 93, 20152, 10),
	(178388, 205, 20034, 6),
	(178388, 228, 20141, 8),
	(240448, 344, 20084, 10),
	(240448, 339, 20152, 6),
	(112365, 490, 20054, 10),
	(112365, 289, 20093, 6),
	(112365, 243, 20073, 6),
	(112365, 389, 20122, 6),
	(112365, 366, 20151, 9),
	(112365, 316, 20153, 10),
	(195255, 485, 20131, 10),
	(195255, 85, 20083, 10),
	(195255, 302, 20113, 10),
	(195255, 229, 20101, 9),
	(195255, 198, 20121, 6),
	(195255, 449, 20072, 5),
	(195255, 235, 20151, 8),
	(195255, 329, 20114, 7),
	(195255, 75, 20061, 7),
	(195255, 115, 20053, 9),
	(195255, 380, 20032, 8),
	(195255, 151, 20113, 7),
	(195255, 249, 20083, 10),
	(195255, 55, 20041, 9),
	(195255, 130, 20132, 10),
	(136863, 245, 20092, 9),
	(136863, 405, 20061, 5),
	(136863, 423, 20133, 10),
	(136863, 493, 20133, 10),
	(257452, 12, 20083, 8),
	(257452, 239, 20142, 10),
	(257452, 29, 20052, 8),
	(257452, 388, 20113, 8),
	(257452, 66, 20092, 9),
	(257452, 361, 20121, 5),
	(257452, 361, 20093, 7),
	(257452, 8, 20043, 7),
	(257452, 231, 20142, 9),
	(257452, 206, 20104, 7),
	(257452, 451, 20092, 6),
	(257452, 270, 20062, 5),
	(257452, 186, 20062, 8),
	(257452, 482, 20042, 5),
	(257452, 345, 20092, 7),
	(257452, 288, 20122, 5),
	(257452, 186, 20054, 7),
	(257452, 41, 20122, 7),
	(257452, 10, 20061, 7),
	(257452, 357, 20144, 8),
	(160591, 457, 20073, 10),
	(160591, 360, 20123, 6),
	(160591, 43, 20121, 8),
	(160591, 419, 20091, 7),
	(245645, 114, 20081, 9),
	(245645, 260, 20122, 8),
	(245645, 319, 20093, 8),
	(245645, 223, 20122, 6),
	(245645, 51, 20064, 7),
	(245645, 370, 20142, 8),
	(245645, 209, 20142, 6),
	(245645, 496, 20052, 10),
	(245645, 20, 20102, 9),
	(245645, 436, 20064, 5),
	(245645, 336, 20054, 9),
	(245645, 49, 20034, 8),
	(245645, 268, 20143, 9),
	(245645, 339, 20062, 8),
	(112557, 60, 20123, 5),
	(112557, 199, 20141, 7),
	(112557, 314, 20071, 7),
	(112557, 453, 20103, 5),
	(112557, 379, 20101, 7),
	(112557, 104, 20043, 10),
	(112557, 349, 20121, 5),
	(112557, 420, 20053, 10),
	(112557, 174, 20082, 9),
	(112557, 320, 20072, 10),
	(112557, 175, 20151, 6),
	(112557, 296, 20071, 10),
	(112557, 57, 20151, 10),
	(112557, 16, 20061, 10),
	(112557, 245, 20063, 5),
	(112557, 483, 20052, 9),
	(112557, 167, 20122, 10),
	(112557, 5, 20103, 6),
	(112557, 160, 20053, 9),
	(199993, 299, 20111, 5),
	(199993, 80, 20044, 5),
	(199993, 26, 20152, 10),
	(199993, 248, 20122, 5),
	(199993, 23, 20102, 8),
	(199993, 447, 20054, 7),
	(199993, 293, 20131, 6),
	(199993, 260, 20092, 5),
	(199993, 245, 20121, 6),
	(199993, 18, 20151, 10),
	(199993, 473, 20081, 5),
	(199993, 266, 20054, 10),
	(229459, 170, 20063, 10),
	(229459, 3, 20144, 10),
	(229459, 293, 20034, 9),
	(229459, 41, 20093, 5),
	(229459, 39, 20091, 10),
	(229459, 424, 20064, 9),
	(238774, 340, 20132, 10),
	(238774, 349, 20133, 7),
	(238774, 14, 20104, 5),
	(238774, 370, 20143, 7),
	(107370, 200, 20072, 10),
	(107370, 193, 20033, 9),
	(107370, 49, 20034, 9),
	(107370, 491, 20081, 10),
	(107370, 309, 20062, 10),
	(107370, 184, 20123, 8),
	(107370, 347, 20122, 10),
	(107370, 333, 20042, 7),
	(101554, 67, 20134, 6),
	(101554, 191, 20132, 9),
	(101554, 23, 20144, 7),
	(101554, 476, 20143, 6),
	(101554, 482, 20064, 7),
	(101554, 462, 20144, 8),
	(101554, 489, 20063, 10),
	(101554, 136, 20124, 5),
	(101554, 293, 20034, 6),
	(101554, 392, 20042, 7),
	(101554, 105, 20113, 7),
	(279841, 346, 20134, 9),
	(279841, 65, 20134, 5),
	(274664, 432, 20082, 5),
	(274664, 205, 20033, 10),
	(274664, 382, 20142, 8),
	(274664, 335, 20123, 8),
	(274664, 368, 20151, 8),
	(274664, 211, 20071, 6),
	(274664, 384, 20112, 10),
	(274664, 292, 20154, 8),
	(274664, 224, 20052, 6),
	(274664, 377, 20062, 9),
	(274664, 472, 20131, 6),
	(274664, 217, 20122, 5),
	(274664, 32, 20041, 6),
	(274664, 282, 20071, 8),
	(274664, 306, 20094, 7),
	(274664, 127, 20052, 6),
	(274664, 385, 20042, 10),
	(274664, 369, 20032, 10),
	(116635, 498, 20053, 5),
	(116635, 299, 20122, 9),
	(116635, 3, 20053, 6),
	(116635, 143, 20113, 9),
	(116635, 471, 20122, 10),
	(116635, 305, 20111, 9),
	(116635, 58, 20124, 10),
	(116635, 240, 20091, 9),
	(116635, 151, 20142, 10),
	(116635, 297, 20063, 7),
	(116635, 222, 20052, 6),
	(116635, 104, 20102, 6),
	(116635, 487, 20034, 8),
	(116635, 266, 20083, 5),
	(116635, 442, 20154, 6),
	(116635, 66, 20101, 8),
	(116635, 157, 20051, 6),
	(116635, 425, 20081, 8),
	(116635, 424, 20101, 10),
	(116635, 494, 20143, 7),
	(288632, 230, 20093, 10),
	(288632, 411, 20092, 9),
	(288632, 293, 20092, 10),
	(288632, 444, 20134, 6),
	(288632, 335, 20091, 10),
	(288632, 462, 20093, 6),
	(288632, 103, 20034, 6),
	(288632, 351, 20073, 6),
	(288632, 493, 20122, 8),
	(288632, 269, 20144, 8),
	(179515, 172, 20113, 7),
	(179515, 7, 20032, 9),
	(179515, 228, 20064, 9),
	(179515, 264, 20074, 10),
	(179515, 118, 20074, 7),
	(179515, 168, 20092, 5),
	(179515, 292, 20044, 8),
	(179515, 313, 20041, 10),
	(179515, 192, 20031, 5),
	(283598, 264, 20031, 7),
	(283598, 471, 20084, 8),
	(283598, 327, 20062, 5),
	(283598, 463, 20044, 6),
	(283598, 158, 20114, 10),
	(283598, 367, 20153, 6),
	(283598, 429, 20091, 5),
	(283598, 492, 20094, 10),
	(283598, 409, 20154, 6),
	(283598, 224, 20061, 10),
	(283598, 445, 20072, 5),
	(283598, 173, 20142, 10),
	(283598, 313, 20063, 10),
	(283598, 399, 20102, 5),
	(283598, 470, 20111, 10),
	(283598, 294, 20072, 6),
	(283598, 365, 20134, 8),
	(283598, 112, 20031, 5),
	(283598, 163, 20061, 9),
	(109732, 484, 20061, 9),
	(109732, 397, 20102, 5),
	(109732, 473, 20053, 8),
	(109732, 188, 20132, 6),
	(109732, 274, 20031, 6),
	(109732, 204, 20052, 5),
	(267765, 483, 20044, 10),
	(267765, 131, 20061, 7),
	(267765, 498, 20081, 7),
	(267765, 54, 20134, 8),
	(267765, 361, 20042, 7),
	(267765, 14, 20153, 5),
	(267765, 404, 20033, 10),
	(129615, 418, 20102, 10),
	(129615, 136, 20132, 5),
	(129615, 362, 20132, 10),
	(129615, 54, 20154, 8),
	(129615, 418, 20072, 10),
	(270208, 30, 20034, 8),
	(270208, 433, 20032, 5),
	(270208, 35, 20053, 6),
	(270208, 450, 20132, 7),
	(270208, 207, 20152, 8),
	(270208, 129, 20082, 7),
	(270208, 292, 20034, 7),
	(270208, 297, 20094, 7),
	(270208, 143, 20044, 5),
	(270208, 86, 20041, 5),
	(270208, 491, 20063, 10),
	(127721, 246, 20093, 6),
	(127721, 389, 20031, 7),
	(127721, 184, 20031, 6),
	(127721, 40, 20042, 10),
	(127721, 222, 20151, 5),
	(127721, 488, 20043, 8),
	(127721, 168, 20081, 7),
	(127721, 12, 20142, 6),
	(127721, 288, 20073, 10),
	(127721, 394, 20092, 6),
	(127721, 36, 20062, 5),
	(279217, 439, 20154, 5),
	(279217, 317, 20103, 7),
	(279217, 249, 20071, 6),
	(279217, 385, 20032, 6),
	(279217, 208, 20151, 10),
	(279217, 191, 20033, 7),
	(279217, 183, 20033, 6),
	(279217, 255, 20043, 9),
	(279217, 452, 20143, 7),
	(279217, 254, 20081, 5),
	(279217, 496, 20093, 8),
	(279217, 4, 20132, 7),
	(279217, 241, 20084, 5),
	(279217, 52, 20073, 9),
	(279217, 310, 20031, 9),
	(279217, 185, 20092, 8),
	(279217, 387, 20114, 7),
	(279217, 485, 20061, 7),
	(279217, 105, 20154, 8),
	(279217, 233, 20042, 10),
	(274357, 289, 20123, 8),
	(274357, 146, 20122, 9),
	(274357, 54, 20074, 5),
	(274357, 213, 20152, 9),
	(274357, 163, 20082, 5),
	(274357, 199, 20112, 5),
	(274357, 401, 20041, 6),
	(274357, 459, 20093, 8),
	(274357, 389, 20122, 7),
	(274357, 234, 20123, 7),
	(274357, 295, 20082, 5),
	(274357, 479, 20031, 7),
	(274357, 235, 20101, 7),
	(226946, 360, 20054, 5),
	(226946, 110, 20032, 10),
	(226946, 336, 20082, 10),
	(226946, 349, 20084, 5),
	(226946, 280, 20034, 6),
	(226946, 81, 20113, 8),
	(226946, 186, 20091, 8),
	(226946, 10, 20092, 7),
	(226946, 55, 20034, 7),
	(226946, 27, 20073, 10),
	(143163, 373, 20073, 7),
	(143163, 138, 20111, 6),
	(143163, 491, 20093, 6),
	(143163, 229, 20062, 8),
	(143163, 38, 20121, 10),
	(143163, 387, 20153, 8),
	(143163, 24, 20102, 5),
	(143163, 351, 20063, 7),
	(143163, 464, 20101, 7),
	(143163, 354, 20131, 6),
	(143163, 193, 20074, 7),
	(143163, 337, 20101, 6),
	(143163, 52, 20054, 10),
	(143163, 360, 20082, 5),
	(143163, 299, 20153, 6),
	(143163, 107, 20052, 7),
	(143163, 38, 20041, 8),
	(294082, 182, 20102, 8),
	(294082, 231, 20112, 10),
	(294082, 347, 20093, 6),
	(294082, 194, 20114, 9),
	(294082, 53, 20114, 9),
	(294082, 395, 20104, 5),
	(294082, 330, 20053, 8),
	(277995, 333, 20111, 9),
	(277995, 104, 20151, 9),
	(277995, 289, 20102, 9),
	(277995, 206, 20064, 5),
	(277995, 77, 20154, 6),
	(277995, 361, 20141, 10),
	(277995, 136, 20084, 6),
	(277995, 92, 20143, 7),
	(277995, 283, 20031, 6),
	(277995, 401, 20133, 6),
	(289679, 334, 20102, 9),
	(289679, 214, 20151, 7),
	(289679, 369, 20111, 8),
	(289679, 481, 20133, 6),
	(289679, 133, 20114, 6),
	(289679, 276, 20151, 5),
	(289679, 400, 20062, 8),
	(289679, 177, 20032, 5),
	(289679, 500, 20153, 6),
	(289679, 93, 20063, 9),
	(289679, 135, 20043, 10),
	(289679, 101, 20151, 10),
	(289679, 243, 20123, 9),
	(289679, 76, 20064, 8),
	(289679, 220, 20041, 8),
	(289679, 422, 20031, 6),
	(289679, 330, 20071, 6),
	(278248, 352, 20052, 8),
	(278248, 206, 20112, 5),
	(278248, 27, 20073, 5),
	(278248, 114, 20034, 7),
	(240139, 99, 20033, 5),
	(240139, 376, 20072, 9),
	(240139, 351, 20031, 7),
	(240139, 126, 20113, 10),
	(227272, 329, 20144, 10),
	(227272, 332, 20043, 8),
	(227272, 375, 20033, 5),
	(227272, 216, 20062, 10),
	(227272, 402, 20082, 9),
	(227272, 306, 20054, 6),
	(227272, 227, 20031, 9),
	(227272, 405, 20102, 6),
	(227272, 422, 20104, 10),
	(227272, 169, 20123, 9),
	(227272, 40, 20143, 7),
	(227272, 467, 20091, 8),
	(177031, 407, 20082, 8),
	(177031, 158, 20123, 6),
	(177031, 473, 20133, 6),
	(177031, 189, 20041, 10),
	(177031, 27, 20103, 6),
	(177031, 278, 20094, 5),
	(177031, 192, 20063, 9),
	(177031, 314, 20074, 10),
	(177031, 128, 20141, 7),
	(177031, 164, 20124, 7),
	(177031, 53, 20071, 9),
	(126095, 232, 20114, 6),
	(126095, 245, 20131, 8),
	(126095, 396, 20051, 7),
	(126095, 84, 20111, 9),
	(219578, 197, 20112, 9),
	(219578, 381, 20062, 10),
	(219578, 425, 20152, 10),
	(219578, 244, 20031, 8),
	(219578, 437, 20114, 6),
	(219578, 447, 20073, 8),
	(219578, 240, 20081, 6),
	(219578, 403, 20124, 9),
	(219578, 245, 20093, 7),
	(219578, 480, 20031, 7),
	(219578, 363, 20142, 10),
	(219578, 6, 20034, 7),
	(219578, 159, 20131, 5),
	(219578, 203, 20151, 7),
	(121120, 118, 20093, 6),
	(121120, 149, 20044, 7),
	(121120, 38, 20122, 6),
	(121120, 280, 20131, 9),
	(121120, 91, 20043, 10),
	(121120, 405, 20093, 7),
	(121120, 41, 20123, 9),
	(121120, 143, 20102, 9),
	(121120, 26, 20102, 8),
	(121120, 181, 20151, 8),
	(121120, 482, 20112, 9),
	(128829, 231, 20041, 9),
	(128829, 303, 20112, 7),
	(292504, 30, 20044, 5),
	(292504, 128, 20152, 5),
	(292504, 129, 20103, 7),
	(292504, 388, 20081, 9),
	(292504, 500, 20093, 7),
	(292504, 213, 20123, 10),
	(292504, 286, 20091, 7),
	(234801, 450, 20153, 6),
	(234801, 55, 20101, 5),
	(234801, 55, 20154, 10),
	(117934, 216, 20103, 8),
	(245347, 257, 20144, 5),
	(245347, 246, 20124, 9),
	(245347, 398, 20072, 9),
	(245347, 450, 20104, 8),
	(245347, 263, 20104, 7),
	(245347, 99, 20093, 7),
	(245347, 193, 20111, 10),
	(245347, 488, 20123, 6),
	(245347, 59, 20143, 9),
	(245347, 409, 20142, 6),
	(245347, 289, 20073, 10),
	(245347, 329, 20104, 8),
	(163436, 332, 20052, 7),
	(163436, 179, 20082, 6),
	(163436, 274, 20134, 5),
	(163436, 456, 20084, 5),
	(163436, 66, 20044, 6),
	(163436, 490, 20071, 7),
	(163436, 118, 20053, 9),
	(163436, 219, 20042, 7),
	(163436, 290, 20092, 7),
	(163436, 31, 20101, 6),
	(163436, 44, 20033, 8),
	(163436, 78, 20133, 5),
	(163436, 134, 20061, 10),
	(163436, 198, 20083, 8),
	(163436, 279, 20104, 8),
	(163436, 289, 20092, 6),
	(163436, 106, 20072, 9),
	(163436, 46, 20152, 7),
	(124740, 365, 20122, 7),
	(124740, 180, 20154, 6),
	(124740, 325, 20084, 5),
	(124740, 4, 20134, 10),
	(124740, 492, 20151, 9),
	(124740, 51, 20051, 10),
	(124740, 381, 20073, 6),
	(124740, 467, 20114, 10),
	(124740, 204, 20033, 9),
	(124740, 485, 20082, 5),
	(124740, 290, 20101, 10),
	(124740, 66, 20062, 5),
	(124740, 112, 20111, 10),
	(124740, 352, 20053, 5),
	(124740, 379, 20112, 10),
	(124740, 102, 20113, 7),
	(240920, 477, 20142, 9),
	(240920, 183, 20111, 8),
	(240920, 64, 20141, 7),
	(240920, 426, 20112, 5),
	(291759, 183, 20144, 7),
	(291759, 321, 20121, 7),
	(291759, 432, 20081, 9),
	(291759, 113, 20103, 7),
	(291759, 180, 20092, 5),
	(291759, 300, 20143, 5),
	(291759, 140, 20044, 10),
	(291759, 99, 20152, 8),
	(291759, 112, 20053, 8),
	(291759, 225, 20151, 8),
	(291759, 342, 20034, 10),
	(291759, 248, 20153, 10),
	(291759, 132, 20151, 8),
	(291759, 151, 20151, 6),
	(291759, 103, 20083, 5),
	(231826, 472, 20112, 5),
	(231826, 205, 20042, 6),
	(231826, 165, 20064, 10),
	(231826, 229, 20094, 6),
	(231826, 398, 20082, 9),
	(231826, 229, 20152, 10),
	(231826, 451, 20032, 6),
	(231826, 138, 20043, 8),
	(231826, 80, 20062, 7),
	(231826, 58, 20032, 6),
	(231826, 307, 20061, 10),
	(231826, 249, 20134, 6),
	(231826, 240, 20063, 6),
	(231826, 268, 20101, 6),
	(271018, 175, 20042, 10),
	(258472, 419, 20121, 8),
	(258472, 399, 20124, 6),
	(258472, 289, 20151, 10),
	(258472, 284, 20062, 8),
	(258472, 79, 20114, 8),
	(258472, 30, 20154, 8),
	(258472, 217, 20094, 5),
	(258472, 260, 20114, 10),
	(258472, 456, 20031, 7),
	(258472, 149, 20111, 9),
	(258472, 261, 20043, 10),
	(270481, 470, 20042, 5),
	(270481, 57, 20041, 6),
	(270481, 276, 20131, 6),
	(270481, 382, 20054, 10),
	(270481, 110, 20102, 10),
	(142779, 30, 20044, 10),
	(142779, 393, 20111, 5),
	(142779, 149, 20111, 10),
	(252614, 209, 20092, 6),
	(252614, 170, 20134, 5),
	(252614, 327, 20102, 9),
	(252614, 278, 20043, 8),
	(252614, 312, 20061, 10),
	(252614, 372, 20121, 9),
	(252614, 130, 20132, 9),
	(252614, 375, 20062, 5),
	(252614, 256, 20093, 8),
	(252614, 155, 20093, 6),
	(252614, 58, 20064, 10),
	(252614, 500, 20104, 9),
	(252614, 204, 20103, 10),
	(252614, 220, 20103, 6),
	(252614, 446, 20121, 6),
	(252614, 326, 20124, 9),
	(108421, 139, 20113, 8),
	(108421, 268, 20154, 10),
	(108421, 267, 20051, 6),
	(108421, 230, 20124, 10),
	(108421, 474, 20053, 9),
	(108421, 255, 20042, 7),
	(108421, 166, 20074, 5),
	(108421, 86, 20053, 5),
	(108421, 407, 20134, 6),
	(108421, 139, 20053, 8),
	(108421, 134, 20111, 8),
	(108421, 156, 20041, 5),
	(108421, 38, 20153, 10),
	(108421, 314, 20082, 9),
	(147194, 145, 20042, 8),
	(147194, 247, 20102, 7),
	(147194, 238, 20114, 7),
	(147194, 197, 20043, 8),
	(147194, 349, 20134, 9),
	(147194, 475, 20032, 8),
	(147194, 102, 20084, 5),
	(147194, 232, 20034, 6),
	(147194, 143, 20031, 10),
	(147194, 132, 20091, 6),
	(147194, 451, 20061, 10),
	(256337, 37, 20113, 9),
	(256337, 343, 20044, 8),
	(256337, 409, 20133, 7),
	(256337, 109, 20092, 5),
	(256337, 152, 20122, 8),
	(256337, 385, 20124, 6),
	(256337, 485, 20133, 6),
	(256337, 155, 20152, 10),
	(256337, 186, 20091, 9),
	(256337, 45, 20061, 10),
	(256337, 105, 20054, 5),
	(205704, 37, 20062, 10),
	(205704, 389, 20063, 7),
	(205704, 318, 20052, 9),
	(205704, 230, 20112, 9),
	(188284, 182, 20133, 10),
	(188284, 115, 20093, 9),
	(188284, 251, 20083, 5),
	(188284, 447, 20032, 7),
	(188284, 451, 20084, 5),
	(188284, 438, 20144, 9),
	(188284, 156, 20084, 8),
	(188284, 250, 20054, 6),
	(188284, 388, 20104, 7),
	(188284, 112, 20054, 7),
	(188284, 199, 20141, 9),
	(143289, 367, 20144, 9),
	(143289, 334, 20132, 9),
	(143289, 219, 20143, 7),
	(143289, 449, 20152, 6),
	(143289, 224, 20053, 10),
	(143289, 245, 20114, 8),
	(143289, 205, 20061, 10),
	(212942, 411, 20082, 8),
	(212942, 370, 20032, 8),
	(212942, 442, 20083, 6),
	(212942, 211, 20134, 6),
	(212942, 298, 20042, 5),
	(212942, 403, 20052, 5),
	(212942, 379, 20071, 10),
	(212942, 301, 20063, 10),
	(212942, 27, 20081, 6),
	(212942, 68, 20111, 6),
	(212942, 482, 20153, 10),
	(212942, 219, 20083, 9),
	(287177, 150, 20081, 9),
	(287177, 427, 20111, 7),
	(287177, 328, 20061, 7),
	(287177, 347, 20043, 10),
	(287177, 200, 20124, 5),
	(142136, 447, 20151, 6),
	(142136, 266, 20144, 5),
	(142136, 385, 20133, 9),
	(142136, 92, 20152, 8),
	(142136, 120, 20033, 5),
	(142136, 337, 20041, 8),
	(142136, 483, 20031, 7),
	(142136, 409, 20031, 6),
	(142136, 324, 20102, 5),
	(142136, 145, 20062, 5),
	(142136, 98, 20134, 5),
	(142136, 481, 20064, 5),
	(142136, 112, 20132, 10),
	(142136, 36, 20094, 10),
	(142136, 188, 20082, 10),
	(142136, 468, 20132, 10),
	(142136, 499, 20082, 6),
	(142136, 440, 20121, 10),
	(152185, 450, 20063, 8),
	(152185, 246, 20124, 8),
	(152185, 81, 20032, 10),
	(152185, 383, 20134, 10),
	(152185, 377, 20033, 8),
	(152185, 109, 20103, 9),
	(113352, 152, 20071, 5),
	(113352, 240, 20043, 8),
	(113352, 253, 20074, 5),
	(113352, 181, 20054, 8),
	(113352, 399, 20071, 8),
	(113352, 255, 20034, 6),
	(113352, 500, 20041, 6),
	(113352, 489, 20094, 5),
	(113352, 361, 20122, 8),
	(113352, 489, 20032, 6),
	(113352, 459, 20111, 7),
	(113352, 160, 20101, 6),
	(113352, 353, 20114, 7),
	(113352, 120, 20102, 5),
	(113352, 119, 20033, 10),
	(113352, 416, 20133, 9),
	(222616, 467, 20112, 7),
	(222616, 398, 20143, 9),
	(222616, 106, 20052, 5),
	(222616, 315, 20033, 5),
	(176162, 389, 20082, 9),
	(176162, 44, 20123, 10),
	(176162, 474, 20071, 7),
	(176162, 490, 20134, 6),
	(176162, 16, 20111, 8),
	(176162, 183, 20043, 8),
	(176162, 174, 20142, 6),
	(176162, 170, 20101, 8),
	(176162, 64, 20074, 5),
	(176162, 277, 20094, 8),
	(176162, 183, 20064, 6),
	(224652, 440, 20083, 6),
	(224652, 374, 20142, 5),
	(224652, 77, 20093, 10),
	(224652, 237, 20102, 7),
	(224652, 106, 20132, 7),
	(154409, 475, 20113, 9),
	(154409, 122, 20091, 5),
	(154409, 27, 20044, 7),
	(154409, 214, 20084, 9),
	(227886, 156, 20033, 7),
	(227886, 334, 20083, 6),
	(227886, 129, 20133, 6),
	(227886, 313, 20104, 10),
	(227886, 331, 20062, 7),
	(227886, 482, 20074, 8),
	(227886, 216, 20072, 5),
	(227886, 320, 20043, 6),
	(227886, 224, 20032, 9),
	(227886, 260, 20071, 5),
	(227886, 213, 20101, 10),
	(227886, 93, 20042, 9),
	(227886, 91, 20131, 10),
	(227886, 174, 20114, 9),
	(109306, 466, 20123, 5),
	(109306, 448, 20104, 9),
	(109306, 487, 20132, 8),
	(109306, 404, 20104, 7),
	(109306, 483, 20132, 6),
	(109306, 116, 20114, 6),
	(109306, 131, 20082, 5),
	(109306, 397, 20114, 6),
	(109306, 78, 20074, 9),
	(109306, 281, 20062, 5),
	(109306, 241, 20083, 5),
	(109306, 227, 20102, 7),
	(109306, 411, 20144, 5),
	(109306, 414, 20041, 6),
	(109306, 313, 20141, 8),
	(109306, 166, 20061, 5),
	(109306, 449, 20051, 5),
	(298719, 250, 20054, 9),
	(298719, 39, 20063, 7),
	(298719, 157, 20143, 8),
	(298719, 390, 20053, 8),
	(298719, 91, 20081, 7),
	(298719, 61, 20043, 10),
	(298719, 18, 20054, 9),
	(298719, 30, 20053, 9),
	(298719, 180, 20054, 10),
	(298719, 206, 20153, 6),
	(298719, 433, 20123, 10),
	(298719, 99, 20113, 8),
	(268938, 208, 20143, 5),
	(268938, 242, 20103, 9),
	(268938, 265, 20042, 7),
	(268938, 399, 20113, 9),
	(268938, 148, 20044, 9),
	(268938, 475, 20151, 10),
	(268938, 133, 20104, 6),
	(268938, 313, 20051, 5),
	(268938, 457, 20071, 5),
	(268938, 142, 20114, 8),
	(268938, 439, 20073, 6),
	(268938, 32, 20042, 10),
	(268938, 90, 20074, 10),
	(295124, 429, 20091, 5),
	(295124, 102, 20143, 5),
	(295124, 278, 20134, 9),
	(295124, 229, 20144, 10),
	(295124, 12, 20042, 9),
	(295124, 114, 20053, 8),
	(295124, 445, 20042, 5),
	(295124, 9, 20121, 7),
	(295124, 301, 20102, 5),
	(295124, 69, 20062, 8),
	(295124, 269, 20061, 5),
	(295124, 53, 20044, 7),
	(295124, 99, 20142, 5),
	(295124, 109, 20081, 6),
	(295124, 359, 20061, 6),
	(211771, 489, 20133, 8),
	(211771, 486, 20111, 7),
	(211771, 41, 20121, 10),
	(211771, 304, 20114, 8),
	(211771, 275, 20071, 9),
	(211771, 265, 20063, 7),
	(211771, 426, 20054, 6),
	(211771, 119, 20033, 8),
	(296677, 310, 20052, 7),
	(296677, 220, 20134, 10),
	(296677, 42, 20072, 9),
	(296677, 257, 20153, 5),
	(296677, 54, 20142, 10),
	(194770, 196, 20101, 10),
	(194770, 63, 20114, 10),
	(194770, 385, 20124, 6),
	(194770, 139, 20041, 6),
	(194770, 441, 20062, 8),
	(194770, 98, 20134, 10),
	(194770, 85, 20063, 6),
	(194770, 282, 20134, 8),
	(194770, 482, 20032, 7),
	(194770, 185, 20152, 9),
	(226423, 279, 20124, 7),
	(226423, 472, 20063, 6),
	(226423, 330, 20072, 7),
	(226423, 241, 20094, 8),
	(226423, 457, 20072, 5),
	(226423, 22, 20032, 6),
	(226423, 357, 20044, 6),
	(226423, 467, 20084, 9),
	(226423, 23, 20092, 7),
	(226423, 75, 20031, 9),
	(226423, 246, 20114, 7),
	(226423, 339, 20062, 6),
	(226423, 492, 20112, 8),
	(226423, 18, 20091, 5),
	(226423, 376, 20103, 10),
	(126288, 371, 20034, 5),
	(126288, 396, 20141, 10),
	(126288, 295, 20112, 7),
	(126288, 242, 20131, 6),
	(126288, 8, 20143, 8),
	(126288, 146, 20083, 7),
	(126288, 385, 20034, 6),
	(126288, 2, 20124, 10),
	(126288, 289, 20034, 5),
	(126288, 345, 20111, 8),
	(126288, 278, 20103, 10),
	(126288, 79, 20143, 7),
	(126288, 355, 20141, 7),
	(181843, 228, 20084, 6),
	(181843, 25, 20063, 6),
	(181843, 347, 20054, 6),
	(181843, 184, 20112, 6),
	(181843, 155, 20051, 8),
	(181843, 222, 20144, 8),
	(181843, 468, 20052, 5),
	(181843, 105, 20151, 9),
	(181843, 440, 20043, 5),
	(181843, 164, 20043, 9),
	(181843, 325, 20051, 8),
	(181843, 357, 20071, 9),
	(181843, 66, 20081, 8),
	(181843, 161, 20132, 10),
	(181843, 471, 20123, 7),
	(181843, 360, 20103, 9),
	(245712, 187, 20064, 9),
	(245712, 179, 20074, 10),
	(245712, 452, 20033, 7),
	(245712, 18, 20144, 9),
	(245712, 495, 20101, 5),
	(245712, 146, 20142, 5),
	(186608, 74, 20091, 8),
	(186608, 438, 20042, 6),
	(186608, 273, 20062, 6),
	(108915, 459, 20062, 9),
	(108915, 7, 20084, 6),
	(108915, 246, 20054, 8),
	(108915, 119, 20094, 7),
	(108915, 317, 20102, 9),
	(108915, 343, 20123, 8),
	(108915, 151, 20101, 9),
	(108915, 422, 20144, 7),
	(108915, 317, 20032, 8),
	(108915, 319, 20113, 7),
	(108915, 467, 20111, 7),
	(108915, 199, 20102, 9),
	(108915, 174, 20133, 9),
	(108915, 11, 20034, 9),
	(108915, 290, 20071, 6),
	(108915, 127, 20081, 10),
	(108915, 497, 20091, 5),
	(108915, 94, 20111, 8),
	(108915, 109, 20041, 9),
	(108915, 141, 20051, 10),
	(145388, 218, 20113, 8),
	(145388, 379, 20054, 5),
	(145388, 158, 20054, 5),
	(145388, 196, 20133, 6),
	(145388, 287, 20154, 6),
	(145388, 190, 20062, 10),
	(145388, 489, 20124, 9),
	(145388, 460, 20132, 6),
	(145388, 232, 20153, 5),
	(145388, 6, 20051, 9),
	(145388, 70, 20104, 7),
	(145388, 486, 20034, 5),
	(145388, 402, 20091, 5),
	(145388, 326, 20073, 9),
	(145388, 345, 20072, 8),
	(145388, 51, 20131, 6),
	(145388, 81, 20124, 6),
	(145388, 391, 20092, 9),
	(145388, 8, 20102, 5),
	(145388, 321, 20044, 6),
	(107227, 255, 20051, 10),
	(107227, 312, 20143, 6),
	(107227, 6, 20104, 10),
	(107227, 319, 20041, 6),
	(107227, 295, 20053, 5),
	(209380, 185, 20084, 6),
	(209380, 174, 20152, 5),
	(209380, 307, 20132, 10),
	(108681, 496, 20102, 7),
	(108681, 464, 20152, 6),
	(194649, 256, 20144, 7),
	(194649, 30, 20091, 6),
	(194649, 84, 20123, 9),
	(194649, 108, 20123, 10),
	(194649, 25, 20113, 9),
	(194649, 491, 20032, 8),
	(194649, 400, 20141, 5),
	(194649, 224, 20032, 9),
	(194649, 447, 20152, 10),
	(194649, 484, 20092, 6),
	(194649, 443, 20094, 9),
	(194649, 178, 20094, 5),
	(194649, 14, 20132, 8),
	(194649, 446, 20064, 5),
	(194649, 195, 20124, 7),
	(194649, 187, 20152, 5),
	(194649, 333, 20044, 9),
	(194649, 432, 20033, 8),
	(133385, 279, 20072, 6),
	(133385, 363, 20054, 10),
	(133385, 298, 20051, 6),
	(258578, 282, 20042, 5),
	(258578, 290, 20112, 6),
	(258578, 52, 20034, 8),
	(258578, 368, 20074, 7),
	(258578, 158, 20113, 9),
	(258578, 306, 20131, 8),
	(258578, 56, 20051, 10),
	(258578, 58, 20101, 8),
	(258578, 491, 20141, 7),
	(258578, 11, 20071, 5),
	(140159, 459, 20092, 8),
	(140159, 267, 20053, 8),
	(140159, 233, 20111, 8),
	(140159, 492, 20041, 5),
	(140159, 286, 20121, 9),
	(140159, 191, 20044, 7),
	(140159, 10, 20072, 9),
	(140159, 172, 20122, 5),
	(140159, 446, 20032, 5),
	(140159, 37, 20084, 5),
	(140159, 334, 20131, 9),
	(140159, 409, 20103, 8),
	(140159, 115, 20033, 8),
	(140159, 36, 20072, 8),
	(140159, 428, 20094, 10),
	(291919, 144, 20054, 5),
	(291919, 108, 20064, 7),
	(291919, 321, 20091, 9),
	(291919, 349, 20103, 6),
	(291919, 370, 20104, 9),
	(291919, 471, 20063, 5),
	(291919, 316, 20032, 9),
	(291919, 137, 20031, 9),
	(291919, 291, 20033, 6),
	(291919, 124, 20041, 7),
	(135791, 453, 20033, 9),
	(135791, 311, 20093, 6),
	(135791, 271, 20113, 10),
	(135791, 276, 20132, 10),
	(135791, 393, 20111, 7),
	(292886, 440, 20122, 7),
	(292886, 114, 20083, 8),
	(114506, 1, 20043, 5),
	(114506, 339, 20052, 6),
	(114506, 83, 20111, 7),
	(114506, 148, 20083, 5),
	(114506, 195, 20072, 5),
	(154558, 143, 20032, 9),
	(154558, 374, 20101, 10),
	(154558, 235, 20104, 9),
	(154558, 235, 20124, 5),
	(154558, 480, 20064, 10),
	(154558, 250, 20073, 7),
	(154558, 432, 20042, 7),
	(154558, 261, 20082, 5),
	(154558, 7, 20134, 6),
	(154558, 288, 20123, 8),
	(154558, 468, 20042, 5),
	(154558, 133, 20042, 6),
	(154558, 200, 20041, 5),
	(154558, 357, 20103, 10),
	(154558, 333, 20042, 8),
	(154558, 394, 20041, 7),
	(154558, 294, 20063, 6),
	(211707, 338, 20084, 7),
	(211707, 325, 20061, 5),
	(211707, 311, 20082, 9),
	(211707, 469, 20142, 8),
	(211707, 176, 20152, 8),
	(211707, 168, 20061, 5),
	(211707, 355, 20143, 8),
	(211707, 320, 20084, 8),
	(116534, 289, 20103, 8),
	(116534, 218, 20142, 9),
	(116534, 164, 20073, 8),
	(116534, 142, 20132, 9),
	(116534, 439, 20133, 10),
	(116534, 113, 20074, 8),
	(116534, 104, 20092, 5),
	(116534, 406, 20153, 7),
	(116534, 304, 20131, 9),
	(116534, 68, 20073, 5),
	(116534, 406, 20114, 7),
	(116534, 373, 20072, 5),
	(116534, 275, 20061, 8),
	(116534, 339, 20034, 5),
	(116534, 394, 20062, 8),
	(221076, 276, 20063, 8),
	(221076, 433, 20063, 7),
	(221076, 61, 20053, 10),
	(221076, 457, 20053, 5),
	(221076, 90, 20133, 8),
	(163708, 338, 20123, 6),
	(163708, 234, 20151, 10),
	(146597, 427, 20131, 6),
	(146597, 462, 20042, 8),
	(146597, 334, 20082, 6),
	(146597, 379, 20112, 7),
	(146597, 457, 20101, 5),
	(124479, 308, 20153, 8),
	(247902, 73, 20132, 5),
	(247902, 42, 20052, 9),
	(247902, 291, 20143, 9),
	(253807, 349, 20081, 10),
	(253807, 158, 20132, 6),
	(253807, 29, 20112, 6),
	(253807, 183, 20031, 6),
	(253807, 210, 20082, 6),
	(253807, 422, 20091, 8),
	(253807, 192, 20114, 8),
	(253807, 109, 20124, 8),
	(253807, 304, 20151, 5),
	(253807, 412, 20094, 5),
	(253807, 313, 20141, 8),
	(253807, 394, 20094, 10),
	(253807, 325, 20122, 8),
	(253807, 375, 20081, 5),
	(253807, 177, 20133, 10),
	(253807, 243, 20094, 7),
	(253807, 391, 20111, 7),
	(253807, 368, 20143, 10),
	(103848, 469, 20101, 6),
	(103848, 410, 20131, 6),
	(103848, 84, 20071, 8),
	(103848, 194, 20051, 6),
	(103848, 282, 20144, 5),
	(103848, 52, 20081, 8),
	(103848, 269, 20152, 8),
	(103848, 363, 20112, 6),
	(103848, 436, 20064, 7),
	(103848, 96, 20054, 6),
	(103848, 440, 20061, 6),
	(103848, 68, 20063, 10),
	(103848, 136, 20122, 6),
	(103848, 421, 20074, 7),
	(103848, 478, 20091, 6),
	(214339, 115, 20033, 8),
	(214339, 29, 20074, 9),
	(214339, 420, 20062, 7),
	(214339, 438, 20064, 6),
	(214339, 457, 20153, 7),
	(214339, 471, 20141, 8),
	(214339, 164, 20152, 10),
	(214339, 324, 20074, 7),
	(214339, 361, 20111, 8),
	(214339, 357, 20122, 8),
	(214339, 278, 20064, 5),
	(214339, 226, 20061, 6),
	(286085, 497, 20151, 7),
	(286085, 50, 20122, 7),
	(286085, 22, 20121, 7),
	(286085, 137, 20083, 7),
	(286085, 243, 20113, 6),
	(286085, 44, 20151, 10),
	(286085, 94, 20144, 6),
	(244865, 267, 20054, 7),
	(267543, 77, 20091, 7),
	(267543, 282, 20042, 5),
	(267543, 303, 20061, 5),
	(267543, 123, 20043, 7),
	(267543, 82, 20032, 8),
	(259201, 437, 20082, 10),
	(259201, 188, 20042, 10),
	(259201, 85, 20031, 10),
	(259201, 466, 20124, 10),
	(259201, 390, 20051, 6),
	(259201, 467, 20052, 9),
	(259201, 310, 20041, 5),
	(259201, 67, 20121, 10),
	(259201, 294, 20083, 9),
	(259201, 50, 20104, 8),
	(259201, 417, 20033, 9),
	(259201, 326, 20142, 10),
	(259201, 361, 20114, 9),
	(259201, 327, 20053, 8),
	(259201, 277, 20094, 8),
	(244044, 420, 20123, 9),
	(244044, 249, 20094, 5),
	(205172, 338, 20152, 8),
	(205172, 403, 20154, 9),
	(205172, 499, 20142, 9),
	(205172, 154, 20092, 10),
	(205172, 130, 20054, 10),
	(205172, 172, 20102, 6),
	(205172, 446, 20093, 9),
	(205172, 248, 20124, 6),
	(205172, 90, 20152, 8),
	(205172, 260, 20141, 7),
	(205172, 476, 20054, 6),
	(205172, 367, 20132, 10),
	(205172, 153, 20133, 7),
	(205172, 356, 20134, 8),
	(205172, 447, 20134, 5),
	(205172, 377, 20102, 5),
	(205172, 453, 20034, 10),
	(205172, 256, 20031, 6),
	(205172, 2, 20063, 5),
	(205172, 478, 20122, 6),
	(202691, 35, 20092, 7),
	(202691, 271, 20064, 6),
	(202691, 317, 20072, 7),
	(202691, 195, 20132, 7),
	(245847, 215, 20121, 10),
	(245847, 326, 20042, 7),
	(245847, 380, 20083, 7),
	(245847, 213, 20041, 8),
	(245847, 325, 20112, 9),
	(245847, 222, 20082, 9),
	(275614, 84, 20124, 6),
	(275614, 396, 20112, 5),
	(275614, 287, 20072, 9),
	(275614, 305, 20102, 7),
	(275614, 70, 20122, 6),
	(275614, 428, 20062, 5),
	(275614, 188, 20043, 5),
	(275614, 445, 20144, 6),
	(275614, 130, 20114, 9),
	(275614, 473, 20154, 5),
	(275614, 411, 20101, 8),
	(275614, 295, 20151, 9),
	(275614, 445, 20063, 7),
	(275614, 348, 20154, 10),
	(275614, 27, 20052, 9),
	(275614, 32, 20044, 6),
	(275614, 203, 20144, 5),
	(275614, 128, 20123, 9),
	(118765, 305, 20042, 6),
	(118765, 497, 20141, 10),
	(118765, 441, 20133, 9),
	(206006, 14, 20113, 5),
	(206006, 412, 20112, 7),
	(206006, 270, 20073, 6),
	(206006, 499, 20102, 9),
	(206006, 303, 20111, 9),
	(206006, 31, 20084, 8),
	(206006, 140, 20124, 5),
	(206006, 465, 20121, 10),
	(206006, 305, 20133, 7),
	(206006, 430, 20094, 8),
	(206006, 380, 20073, 8),
	(206006, 279, 20143, 7),
	(206006, 122, 20144, 7),
	(206006, 478, 20144, 10),
	(206006, 15, 20134, 6),
	(206006, 186, 20112, 9),
	(206006, 230, 20133, 10),
	(206006, 351, 20101, 7),
	(141067, 133, 20103, 7),
	(141067, 441, 20094, 7),
	(141067, 396, 20063, 9),
	(141067, 308, 20122, 5),
	(141067, 401, 20042, 5),
	(141067, 231, 20031, 10),
	(141067, 425, 20102, 8),
	(141067, 251, 20132, 10),
	(141067, 422, 20111, 8),
	(141067, 317, 20144, 7),
	(141067, 179, 20074, 10),
	(141067, 137, 20092, 6),
	(141067, 315, 20041, 6),
	(141067, 359, 20141, 9),
	(141067, 28, 20082, 6),
	(141067, 300, 20051, 5),
	(184348, 336, 20073, 8),
	(184348, 330, 20143, 6),
	(174953, 344, 20124, 10),
	(174953, 494, 20052, 5),
	(174953, 369, 20154, 7),
	(174953, 390, 20104, 5),
	(174953, 42, 20153, 9),
	(265371, 125, 20101, 5),
	(265371, 328, 20121, 8),
	(265371, 216, 20151, 9),
	(265371, 482, 20151, 6),
	(265371, 161, 20124, 10),
	(265371, 460, 20063, 9),
	(265371, 198, 20132, 9),
	(265371, 84, 20153, 8),
	(265371, 263, 20094, 5),
	(265371, 315, 20104, 6),
	(112827, 124, 20072, 9),
	(112827, 123, 20083, 9),
	(112827, 412, 20131, 9),
	(112827, 498, 20112, 5),
	(112827, 422, 20133, 8),
	(112827, 414, 20152, 5),
	(112827, 296, 20143, 9),
	(112827, 115, 20112, 10),
	(112827, 289, 20113, 9),
	(112827, 167, 20083, 5),
	(112827, 388, 20122, 5),
	(112827, 92, 20034, 5),
	(112827, 445, 20084, 7),
	(112827, 145, 20053, 7),
	(112827, 419, 20134, 8),
	(113338, 447, 20063, 9),
	(113338, 421, 20142, 7),
	(113338, 114, 20073, 7),
	(113338, 274, 20033, 8),
	(113338, 400, 20051, 6),
	(113338, 438, 20154, 7),
	(113338, 237, 20143, 8),
	(113338, 157, 20151, 9),
	(113338, 85, 20044, 9),
	(113338, 150, 20133, 6),
	(113338, 194, 20153, 10),
	(113338, 62, 20082, 9),
	(113338, 107, 20042, 9),
	(113338, 199, 20064, 9),
	(113338, 264, 20092, 8),
	(113338, 99, 20102, 5),
	(268390, 9, 20044, 5),
	(268390, 185, 20111, 5),
	(268390, 439, 20141, 8),
	(196189, 371, 20062, 8),
	(196189, 451, 20103, 6),
	(196189, 168, 20134, 6),
	(196189, 471, 20123, 6),
	(196189, 432, 20143, 6),
	(196189, 253, 20104, 5),
	(196189, 182, 20103, 6),
	(196189, 487, 20043, 6),
	(196189, 496, 20034, 7),
	(196189, 72, 20103, 5),
	(196189, 496, 20113, 10),
	(196189, 259, 20114, 9),
	(238538, 458, 20122, 8),
	(238538, 77, 20111, 7),
	(238538, 178, 20082, 8),
	(238538, 167, 20044, 8),
	(238538, 58, 20111, 8),
	(238538, 396, 20063, 5),
	(238538, 499, 20154, 9),
	(238538, 369, 20142, 5),
	(238538, 432, 20054, 10),
	(238538, 449, 20124, 5),
	(238538, 291, 20104, 5),
	(104901, 319, 20033, 10),
	(104901, 277, 20111, 5),
	(104901, 259, 20104, 7),
	(104901, 438, 20051, 5),
	(104901, 177, 20072, 9),
	(104901, 290, 20123, 5),
	(104901, 242, 20094, 10),
	(104901, 332, 20144, 5),
	(104901, 460, 20134, 7),
	(104901, 181, 20052, 10),
	(104901, 217, 20112, 9),
	(104901, 235, 20033, 8),
	(104901, 146, 20122, 8),
	(104901, 94, 20082, 7),
	(132642, 64, 20133, 5),
	(132642, 26, 20143, 8),
	(132642, 238, 20081, 6),
	(132642, 320, 20101, 5),
	(132642, 187, 20091, 8),
	(132642, 246, 20102, 10),
	(132642, 96, 20041, 9),
	(132642, 453, 20032, 8),
	(132642, 218, 20114, 8),
	(132642, 264, 20093, 10),
	(194052, 394, 20093, 9),
	(194052, 83, 20111, 8),
	(194052, 153, 20153, 10),
	(194052, 258, 20062, 10),
	(194052, 478, 20132, 6),
	(194052, 84, 20121, 8),
	(194052, 39, 20124, 8),
	(194052, 331, 20044, 7),
	(194052, 292, 20113, 8),
	(194052, 80, 20103, 10),
	(194052, 418, 20122, 8),
	(194052, 392, 20134, 7),
	(206477, 122, 20083, 8),
	(206477, 374, 20122, 7),
	(206477, 382, 20131, 6),
	(206477, 196, 20113, 7),
	(206477, 12, 20031, 7),
	(206477, 107, 20072, 8),
	(206477, 50, 20144, 9),
	(206477, 465, 20081, 9),
	(206477, 99, 20133, 6),
	(206477, 136, 20043, 10),
	(206477, 483, 20071, 8),
	(206477, 11, 20101, 9),
	(206477, 384, 20124, 7),
	(181158, 93, 20084, 8),
	(181158, 431, 20033, 8),
	(181158, 324, 20061, 6),
	(181158, 293, 20132, 5),
	(123038, 142, 20042, 10),
	(123038, 263, 20083, 5),
	(123038, 172, 20132, 6),
	(123038, 399, 20112, 8),
	(123038, 67, 20063, 8),
	(123038, 62, 20054, 5),
	(123038, 82, 20133, 7),
	(123038, 447, 20152, 6),
	(123038, 479, 20141, 6),
	(123038, 300, 20072, 10),
	(123038, 199, 20094, 7),
	(123038, 364, 20034, 5),
	(123038, 110, 20082, 5),
	(147656, 79, 20134, 8),
	(147656, 215, 20051, 8),
	(147656, 130, 20032, 7),
	(147656, 149, 20113, 5),
	(147656, 457, 20104, 5),
	(147656, 301, 20092, 9),
	(147656, 286, 20104, 7),
	(102616, 351, 20084, 6),
	(102616, 168, 20033, 5),
	(102616, 282, 20104, 6),
	(102616, 457, 20054, 8),
	(102616, 184, 20062, 6),
	(102616, 161, 20041, 5),
	(102616, 192, 20052, 8),
	(102616, 318, 20104, 8),
	(102616, 228, 20093, 8),
	(102616, 347, 20152, 5),
	(102616, 189, 20033, 7),
	(102616, 10, 20094, 10),
	(102616, 234, 20071, 10),
	(102616, 481, 20053, 10),
	(102616, 237, 20111, 8),
	(102616, 284, 20152, 7),
	(102616, 119, 20102, 8),
	(195894, 205, 20033, 10),
	(195894, 211, 20104, 5),
	(195894, 222, 20132, 7),
	(195894, 418, 20093, 10),
	(195894, 235, 20082, 7),
	(195894, 450, 20134, 5),
	(195894, 395, 20093, 5),
	(195894, 264, 20123, 10),
	(195894, 221, 20083, 9),
	(195894, 326, 20043, 8),
	(195894, 242, 20082, 8),
	(195894, 499, 20051, 7),
	(195894, 260, 20082, 9),
	(195894, 264, 20093, 10),
	(195894, 379, 20114, 10),
	(195894, 453, 20102, 9),
	(209672, 448, 20083, 7),
	(209672, 351, 20113, 7),
	(209672, 230, 20124, 9),
	(209672, 346, 20122, 8),
	(209672, 167, 20111, 8),
	(209672, 15, 20042, 10),
	(209672, 47, 20034, 8),
	(209672, 131, 20064, 8),
	(209672, 181, 20061, 5),
	(296460, 160, 20053, 9),
	(296460, 38, 20143, 5),
	(296460, 162, 20131, 10),
	(296460, 169, 20113, 7),
	(296460, 407, 20143, 5),
	(296460, 167, 20073, 6),
	(296460, 228, 20103, 9),
	(296460, 346, 20081, 7),
	(296460, 380, 20153, 6),
	(296460, 79, 20082, 6),
	(296460, 379, 20153, 5),
	(296460, 56, 20073, 10),
	(296460, 62, 20114, 9),
	(296460, 152, 20123, 10),
	(296460, 482, 20112, 8),
	(296460, 384, 20134, 10),
	(296460, 55, 20073, 5),
	(201269, 183, 20053, 10),
	(201269, 275, 20041, 10),
	(201269, 428, 20062, 7),
	(201269, 367, 20114, 7),
	(201269, 272, 20091, 7),
	(201269, 232, 20061, 6),
	(201269, 490, 20084, 10),
	(201269, 235, 20092, 7),
	(201269, 27, 20141, 5),
	(201269, 473, 20044, 9),
	(201269, 30, 20054, 7),
	(201269, 319, 20042, 6),
	(201269, 377, 20071, 6),
	(201269, 175, 20091, 7),
	(201269, 170, 20112, 7),
	(201269, 244, 20054, 8),
	(201269, 58, 20081, 6),
	(285795, 465, 20141, 10),
	(285795, 174, 20054, 5),
	(285795, 85, 20031, 9),
	(285795, 476, 20032, 7),
	(285795, 365, 20081, 7),
	(285795, 128, 20114, 9),
	(285795, 226, 20141, 6),
	(285795, 37, 20153, 9),
	(285795, 332, 20043, 8),
	(221027, 473, 20151, 10),
	(221027, 331, 20134, 8),
	(221027, 462, 20114, 8),
	(221027, 454, 20131, 5),
	(221027, 64, 20103, 8),
	(221027, 92, 20073, 9),
	(274315, 13, 20103, 10),
	(274315, 483, 20131, 10),
	(274315, 490, 20071, 9),
	(274315, 445, 20063, 10),
	(274315, 267, 20033, 7),
	(183098, 138, 20071, 5),
	(183098, 431, 20113, 8),
	(183098, 440, 20122, 5),
	(183098, 188, 20084, 7),
	(183098, 11, 20084, 7),
	(183098, 211, 20064, 7),
	(183098, 183, 20033, 9),
	(183098, 318, 20141, 9),
	(183098, 37, 20143, 5),
	(183098, 378, 20151, 7),
	(183098, 456, 20112, 8),
	(183098, 173, 20154, 8),
	(183098, 346, 20041, 7),
	(144751, 112, 20063, 8),
	(144751, 319, 20074, 8),
	(144751, 351, 20142, 9),
	(144751, 429, 20084, 7),
	(144751, 30, 20113, 7),
	(144751, 382, 20144, 9),
	(144751, 347, 20104, 6),
	(144751, 323, 20102, 8),
	(144751, 145, 20041, 6),
	(144751, 273, 20063, 5),
	(144751, 165, 20131, 6),
	(144751, 353, 20101, 7),
	(275939, 299, 20114, 10),
	(275939, 126, 20083, 9),
	(275939, 307, 20092, 7),
	(275939, 164, 20051, 7),
	(275939, 123, 20063, 8),
	(275939, 282, 20033, 5),
	(275939, 251, 20073, 5),
	(275939, 13, 20064, 9),
	(275939, 159, 20092, 10),
	(275939, 403, 20123, 7),
	(275939, 384, 20111, 6),
	(275939, 79, 20122, 10),
	(275939, 489, 20032, 7),
	(275939, 175, 20044, 10),
	(275939, 457, 20134, 7),
	(162969, 162, 20084, 9),
	(162969, 469, 20134, 5),
	(162969, 5, 20054, 10),
	(162969, 357, 20103, 8),
	(162969, 426, 20052, 7),
	(233168, 73, 20093, 10),
	(233168, 19, 20101, 9),
	(233168, 443, 20143, 8),
	(233168, 120, 20061, 8),
	(233168, 101, 20082, 5),
	(233168, 92, 20073, 5),
	(233168, 424, 20032, 6),
	(233168, 469, 20102, 10),
	(233168, 450, 20044, 9),
	(233168, 261, 20154, 8),
	(183720, 409, 20051, 10),
	(183720, 317, 20044, 10),
	(183720, 84, 20081, 7),
	(183720, 450, 20142, 7),
	(183720, 252, 20053, 9),
	(183720, 321, 20121, 9),
	(183720, 359, 20102, 8),
	(183720, 327, 20043, 6),
	(183720, 414, 20043, 7),
	(183720, 189, 20134, 9),
	(183720, 107, 20153, 8),
	(137890, 426, 20142, 9),
	(137890, 222, 20141, 5),
	(137890, 168, 20153, 8),
	(137890, 493, 20112, 9),
	(137890, 245, 20124, 6),
	(137890, 436, 20041, 10),
	(137890, 189, 20052, 6),
	(137890, 298, 20031, 9),
	(137890, 110, 20052, 8),
	(137890, 100, 20034, 8),
	(137890, 198, 20142, 9),
	(137890, 256, 20031, 10),
	(137890, 395, 20121, 10),
	(137890, 298, 20103, 10),
	(142757, 30, 20102, 7),
	(142757, 27, 20124, 9),
	(142757, 496, 20034, 9),
	(142757, 327, 20113, 9),
	(142757, 95, 20092, 10),
	(142757, 475, 20034, 10),
	(142757, 161, 20091, 10),
	(142757, 374, 20152, 10),
	(142757, 140, 20093, 9),
	(142757, 259, 20101, 9),
	(142757, 431, 20081, 9),
	(142757, 499, 20041, 9),
	(142757, 489, 20033, 6),
	(142757, 113, 20071, 6),
	(142757, 324, 20053, 5),
	(142757, 19, 20112, 7),
	(142757, 135, 20063, 10),
	(142757, 63, 20051, 7),
	(161687, 251, 20063, 7),
	(161687, 234, 20141, 10),
	(161687, 328, 20074, 6),
	(161687, 139, 20154, 8),
	(161687, 261, 20092, 7),
	(161687, 160, 20124, 8),
	(161687, 284, 20074, 7),
	(161687, 315, 20133, 5),
	(161687, 177, 20091, 10),
	(161687, 131, 20072, 8),
	(161687, 324, 20031, 8),
	(161687, 439, 20094, 8),
	(161687, 325, 20092, 7),
	(121370, 429, 20051, 7),
	(121370, 339, 20151, 6),
	(121370, 265, 20124, 8),
	(121370, 145, 20063, 6),
	(121370, 234, 20044, 10),
	(121370, 339, 20044, 7),
	(121370, 126, 20054, 7),
	(121370, 397, 20091, 5),
	(121370, 250, 20101, 10),
	(254240, 292, 20112, 5),
	(254240, 40, 20041, 7),
	(254240, 495, 20044, 5),
	(254240, 362, 20072, 8),
	(254240, 78, 20142, 10),
	(254240, 399, 20031, 8),
	(254240, 391, 20043, 8),
	(254240, 243, 20151, 7),
	(254240, 305, 20101, 5),
	(254240, 325, 20053, 9),
	(254240, 61, 20053, 5),
	(280638, 160, 20033, 10),
	(280638, 120, 20061, 10),
	(280638, 201, 20042, 5),
	(293738, 233, 20101, 6),
	(293738, 419, 20074, 10),
	(293738, 17, 20114, 10),
	(293738, 254, 20112, 7),
	(293738, 322, 20044, 5),
	(293738, 208, 20152, 9),
	(293738, 273, 20074, 7),
	(293738, 372, 20134, 6),
	(174904, 15, 20153, 6),
	(174904, 201, 20051, 8),
	(174904, 418, 20081, 5),
	(174904, 9, 20132, 5),
	(174904, 148, 20053, 10),
	(174904, 393, 20081, 7),
	(174904, 45, 20072, 8),
	(174904, 215, 20122, 5),
	(174904, 75, 20034, 5),
	(174904, 430, 20112, 10),
	(174904, 447, 20072, 5),
	(174904, 65, 20052, 7),
	(174904, 496, 20103, 5),
	(174904, 392, 20054, 5),
	(174904, 430, 20101, 9),
	(174904, 33, 20031, 7),
	(174904, 455, 20091, 9),
	(174904, 105, 20122, 10),
	(174904, 62, 20061, 8),
	(174904, 73, 20114, 10),
	(187975, 360, 20052, 7),
	(123753, 497, 20122, 8),
	(123753, 235, 20081, 7),
	(123753, 12, 20053, 10),
	(123753, 77, 20073, 9),
	(123753, 466, 20052, 10),
	(123753, 339, 20091, 7),
	(123753, 301, 20111, 7),
	(123753, 70, 20091, 7),
	(123753, 226, 20061, 9),
	(123753, 193, 20062, 9),
	(179530, 363, 20133, 10),
	(179530, 40, 20061, 9),
	(179530, 197, 20081, 8),
	(179530, 354, 20101, 8),
	(179530, 63, 20041, 5),
	(179530, 416, 20134, 10),
	(179530, 152, 20074, 8),
	(179530, 23, 20091, 10),
	(179530, 61, 20051, 5),
	(179530, 431, 20084, 10),
	(179530, 384, 20153, 7),
	(179530, 28, 20104, 5),
	(179530, 280, 20152, 6),
	(179530, 250, 20051, 5),
	(179530, 456, 20071, 5),
	(179530, 309, 20093, 7),
	(179530, 211, 20152, 10),
	(164807, 308, 20132, 6),
	(164807, 473, 20131, 8),
	(164807, 409, 20063, 10),
	(164807, 419, 20082, 9),
	(164807, 66, 20143, 9),
	(164807, 416, 20032, 10),
	(164807, 461, 20131, 6),
	(164807, 364, 20033, 9),
	(164807, 24, 20132, 7),
	(164807, 339, 20062, 9),
	(164807, 103, 20064, 9),
	(164807, 111, 20113, 7),
	(164807, 21, 20074, 7),
	(233990, 131, 20112, 7),
	(233990, 288, 20154, 6),
	(233990, 349, 20074, 10),
	(233990, 160, 20132, 5),
	(251950, 38, 20071, 6),
	(251950, 396, 20032, 7),
	(251950, 358, 20061, 5),
	(251950, 146, 20141, 10),
	(251950, 150, 20042, 7),
	(251950, 465, 20072, 8),
	(251950, 147, 20064, 7),
	(251950, 149, 20084, 8),
	(251950, 164, 20082, 10),
	(251950, 290, 20064, 6),
	(251950, 42, 20102, 9),
	(251950, 336, 20043, 8),
	(118468, 21, 20062, 10),
	(118468, 379, 20111, 10),
	(118468, 373, 20072, 8),
	(118468, 304, 20151, 10),
	(118468, 77, 20071, 10),
	(118468, 35, 20052, 10),
	(118468, 126, 20133, 7),
	(118468, 220, 20032, 6),
	(118468, 473, 20124, 8),
	(118468, 42, 20133, 8),
	(118468, 229, 20124, 8),
	(118468, 94, 20061, 7),
	(118468, 102, 20101, 5),
	(118468, 301, 20123, 7),
	(118468, 2, 20153, 5),
	(118468, 9, 20103, 9),
	(118468, 396, 20064, 5),
	(118468, 312, 20144, 6),
	(242578, 349, 20112, 8),
	(242578, 382, 20064, 7),
	(242578, 45, 20153, 5),
	(242578, 270, 20101, 5),
	(153910, 230, 20113, 6),
	(153910, 182, 20121, 8),
	(153910, 354, 20093, 9),
	(153910, 370, 20134, 7),
	(153910, 386, 20101, 8),
	(153910, 205, 20151, 6),
	(153910, 28, 20103, 9),
	(106913, 319, 20143, 6),
	(106913, 240, 20123, 7),
	(106913, 6, 20123, 7),
	(106913, 263, 20063, 7),
	(106913, 451, 20102, 6),
	(106913, 447, 20051, 9),
	(230996, 373, 20081, 6),
	(230996, 333, 20064, 10),
	(234356, 168, 20092, 5),
	(234356, 286, 20032, 5),
	(234356, 446, 20062, 8),
	(239320, 462, 20072, 8),
	(213779, 251, 20124, 9),
	(213779, 354, 20111, 8),
	(213779, 195, 20032, 8),
	(263094, 115, 20073, 9),
	(146608, 327, 20034, 8),
	(146608, 38, 20072, 8),
	(146608, 343, 20094, 5),
	(146608, 414, 20034, 10),
	(146608, 450, 20151, 7),
	(146608, 311, 20031, 10),
	(146608, 452, 20121, 9),
	(146608, 312, 20084, 8),
	(146608, 100, 20132, 5),
	(146608, 84, 20073, 8),
	(263999, 133, 20081, 8),
	(263999, 464, 20063, 6),
	(263999, 281, 20111, 10),
	(263999, 58, 20054, 5),
	(263999, 50, 20081, 7),
	(263999, 190, 20032, 8),
	(263999, 184, 20092, 7),
	(263999, 365, 20142, 8),
	(180925, 11, 20152, 10),
	(180925, 64, 20062, 10),
	(180925, 184, 20102, 9),
	(180925, 120, 20084, 6),
	(180925, 206, 20054, 10),
	(180925, 3, 20111, 8),
	(180925, 279, 20143, 10),
	(180925, 130, 20154, 5),
	(180925, 288, 20033, 6),
	(180925, 34, 20153, 10),
	(180925, 472, 20091, 6),
	(219339, 233, 20122, 9),
	(219339, 169, 20054, 10),
	(219339, 134, 20093, 6),
	(219339, 179, 20053, 10),
	(219339, 154, 20043, 7),
	(219339, 453, 20123, 9),
	(219339, 370, 20074, 5),
	(219339, 349, 20084, 10),
	(219339, 301, 20031, 9),
	(219339, 181, 20053, 9),
	(219339, 261, 20141, 9),
	(219339, 96, 20144, 7),
	(261409, 229, 20133, 10),
	(261409, 439, 20081, 5),
	(261409, 79, 20132, 10),
	(261409, 225, 20031, 7),
	(261409, 5, 20064, 9),
	(261409, 85, 20103, 5),
	(261409, 145, 20083, 6),
	(230380, 137, 20113, 7),
	(230380, 154, 20033, 7),
	(230380, 483, 20033, 8),
	(230380, 320, 20141, 8),
	(230380, 213, 20134, 5),
	(230380, 137, 20083, 7),
	(230380, 462, 20113, 5),
	(230380, 176, 20083, 10),
	(230380, 59, 20074, 10),
	(230380, 348, 20154, 7),
	(230380, 167, 20151, 6),
	(230380, 13, 20091, 9),
	(230380, 34, 20033, 9),
	(230380, 417, 20061, 9),
	(230380, 381, 20051, 5),
	(230380, 19, 20111, 9),
	(230380, 130, 20152, 8),
	(230380, 259, 20143, 7),
	(230380, 304, 20054, 9),
	(230380, 440, 20122, 9),
	(193691, 413, 20123, 6),
	(193691, 292, 20042, 10),
	(193691, 87, 20093, 9),
	(193691, 296, 20052, 7),
	(193691, 272, 20143, 5),
	(193691, 342, 20043, 7),
	(193691, 214, 20073, 7),
	(193691, 25, 20064, 10),
	(193691, 196, 20082, 9),
	(193691, 209, 20051, 6),
	(193691, 235, 20042, 10),
	(281814, 24, 20143, 6),
	(281814, 17, 20123, 8),
	(281814, 41, 20031, 6),
	(281814, 348, 20033, 9),
	(281814, 50, 20121, 5),
	(281814, 51, 20103, 8),
	(281814, 234, 20062, 5),
	(281814, 403, 20051, 8),
	(281814, 174, 20143, 5),
	(281814, 487, 20133, 6),
	(281814, 478, 20052, 5),
	(281814, 479, 20051, 10),
	(281814, 437, 20152, 7),
	(281814, 154, 20134, 5),
	(281814, 100, 20104, 7),
	(281814, 471, 20083, 8),
	(281814, 483, 20071, 10),
	(281814, 445, 20061, 6),
	(128693, 417, 20033, 10),
	(128693, 462, 20101, 7),
	(128693, 235, 20051, 6),
	(128693, 250, 20151, 6),
	(128693, 343, 20152, 5),
	(128693, 60, 20101, 9),
	(128693, 242, 20071, 10),
	(128693, 500, 20114, 8),
	(128693, 495, 20094, 5),
	(128693, 112, 20034, 9),
	(128693, 210, 20093, 9),
	(128693, 136, 20081, 6),
	(128693, 177, 20111, 8),
	(128693, 96, 20044, 8),
	(128693, 258, 20122, 10),
	(128693, 371, 20074, 7),
	(128693, 428, 20033, 5),
	(254560, 452, 20143, 5),
	(254560, 97, 20034, 10),
	(254560, 90, 20111, 6),
	(254560, 116, 20074, 5),
	(254560, 106, 20061, 7),
	(254560, 224, 20114, 10),
	(254560, 132, 20032, 9),
	(248671, 155, 20044, 10),
	(248671, 57, 20113, 6),
	(248671, 31, 20044, 9),
	(248671, 39, 20144, 6),
	(248671, 119, 20153, 5),
	(248671, 42, 20152, 7),
	(241408, 444, 20103, 5),
	(241408, 448, 20112, 5),
	(241408, 10, 20062, 8),
	(241408, 68, 20092, 7),
	(241408, 34, 20054, 9),
	(241408, 106, 20051, 10),
	(241408, 110, 20071, 6),
	(241408, 40, 20093, 6),
	(241408, 395, 20063, 8),
	(241408, 35, 20104, 5),
	(241408, 442, 20083, 6),
	(241408, 21, 20103, 5),
	(241408, 466, 20053, 8),
	(241408, 47, 20104, 6),
	(130061, 256, 20133, 10),
	(130061, 271, 20152, 10),
	(130061, 110, 20063, 10),
	(130061, 119, 20121, 9),
	(130061, 221, 20072, 6),
	(130061, 482, 20132, 8),
	(130061, 194, 20031, 7),
	(130061, 486, 20074, 7),
	(130061, 88, 20111, 7),
	(130061, 485, 20123, 9),
	(130061, 333, 20054, 9),
	(130061, 70, 20073, 5),
	(130061, 78, 20064, 5),
	(130061, 265, 20144, 5),
	(130061, 44, 20071, 6),
	(130061, 160, 20051, 10),
	(130061, 424, 20123, 8),
	(130061, 164, 20144, 8),
	(130061, 52, 20084, 5),
	(177041, 15, 20091, 5),
	(177041, 312, 20133, 7),
	(177041, 297, 20043, 6),
	(286590, 137, 20104, 6),
	(286590, 478, 20134, 8),
	(286590, 64, 20104, 9),
	(286590, 60, 20151, 8),
	(286590, 205, 20133, 5),
	(286590, 331, 20131, 6),
	(286590, 479, 20154, 7),
	(286590, 336, 20034, 7),
	(286590, 354, 20074, 10),
	(286590, 488, 20072, 6),
	(286590, 189, 20063, 7),
	(286590, 56, 20043, 5),
	(286590, 71, 20104, 5),
	(286590, 292, 20062, 6),
	(286590, 100, 20052, 8),
	(286590, 227, 20121, 7),
	(286590, 207, 20143, 9),
	(286590, 101, 20032, 6),
	(286590, 248, 20032, 5),
	(156882, 395, 20072, 10),
	(156882, 194, 20122, 8),
	(156882, 9, 20124, 9),
	(156882, 286, 20134, 10),
	(156882, 16, 20124, 8),
	(156882, 8, 20144, 6),
	(156882, 231, 20062, 5),
	(156882, 278, 20152, 7),
	(126944, 60, 20041, 6),
	(126944, 122, 20041, 6),
	(126944, 247, 20051, 6),
	(148619, 41, 20104, 8),
	(148619, 17, 20034, 5),
	(148619, 217, 20042, 8),
	(148619, 142, 20072, 7),
	(148619, 341, 20083, 8),
	(148619, 280, 20133, 5),
	(148619, 114, 20132, 10),
	(148619, 124, 20102, 8),
	(148619, 234, 20151, 6),
	(148619, 316, 20143, 6),
	(148619, 283, 20041, 6),
	(148619, 72, 20112, 10),
	(148619, 397, 20064, 9),
	(148619, 266, 20123, 9),
	(148619, 344, 20064, 10),
	(148619, 176, 20091, 10),
	(148619, 96, 20031, 10),
	(148619, 365, 20103, 6),
	(244012, 442, 20101, 5),
	(244012, 208, 20123, 5),
	(244012, 67, 20102, 10),
	(244012, 360, 20123, 7),
	(244012, 271, 20061, 8),
	(244012, 309, 20053, 7),
	(244012, 264, 20101, 7),
	(244012, 347, 20111, 8),
	(244012, 279, 20032, 9),
	(244012, 66, 20121, 5),
	(244012, 477, 20081, 5),
	(244012, 177, 20092, 8),
	(295320, 145, 20133, 5),
	(295320, 93, 20121, 8),
	(239250, 183, 20084, 5),
	(239250, 78, 20032, 10),
	(239250, 336, 20101, 5),
	(239250, 74, 20144, 8),
	(239250, 4, 20093, 9),
	(239250, 311, 20044, 9),
	(239250, 225, 20043, 6),
	(239250, 310, 20082, 8),
	(239250, 211, 20114, 7),
	(239250, 38, 20153, 7),
	(239250, 179, 20151, 8),
	(239250, 337, 20101, 6),
	(239250, 274, 20034, 6),
	(239250, 274, 20061, 8),
	(239250, 171, 20104, 10),
	(239250, 472, 20134, 9),
	(239250, 360, 20094, 5),
	(106837, 201, 20132, 5),
	(106837, 380, 20121, 6),
	(106837, 187, 20092, 8),
	(106837, 270, 20132, 7),
	(106837, 368, 20084, 6),
	(106837, 22, 20123, 8),
	(106837, 493, 20042, 5),
	(106837, 236, 20051, 6),
	(106837, 110, 20081, 7),
	(106837, 499, 20074, 8),
	(106837, 208, 20131, 8),
	(106837, 56, 20072, 10),
	(106837, 11, 20062, 10),
	(106837, 297, 20072, 6),
	(106837, 121, 20131, 6),
	(106837, 117, 20032, 10),
	(106837, 212, 20083, 8),
	(106837, 166, 20041, 8),
	(296870, 189, 20124, 5),
	(296870, 423, 20122, 7),
	(296870, 358, 20054, 7),
	(296870, 256, 20034, 7),
	(296870, 451, 20151, 9),
	(296870, 387, 20143, 8),
	(296870, 188, 20083, 6),
	(296870, 234, 20102, 6),
	(296870, 218, 20124, 5),
	(296870, 2, 20104, 9),
	(296870, 401, 20133, 7),
	(296870, 329, 20081, 6),
	(296870, 358, 20072, 8),
	(296870, 378, 20063, 9),
	(296870, 278, 20093, 10),
	(296870, 81, 20032, 8),
	(296870, 42, 20031, 7),
	(186889, 4, 20121, 6),
	(186889, 323, 20101, 7),
	(186889, 133, 20112, 6),
	(186889, 77, 20034, 7),
	(186889, 150, 20151, 9),
	(186889, 348, 20082, 10),
	(186889, 300, 20043, 5),
	(186889, 400, 20041, 10),
	(186889, 160, 20091, 7),
	(186889, 69, 20061, 9),
	(186889, 425, 20144, 5),
	(186889, 66, 20141, 8),
	(186889, 244, 20054, 8),
	(186889, 381, 20074, 6),
	(186889, 23, 20032, 6),
	(186889, 470, 20053, 9),
	(186889, 310, 20151, 8),
	(186889, 75, 20044, 9),
	(240173, 285, 20063, 5),
	(240173, 185, 20112, 7),
	(240173, 340, 20091, 9),
	(240173, 298, 20061, 5),
	(240173, 252, 20141, 8),
	(240173, 333, 20131, 5),
	(240173, 382, 20083, 5),
	(240173, 387, 20094, 10),
	(240173, 450, 20041, 5),
	(240173, 412, 20102, 7),
	(240173, 378, 20071, 5),
	(240173, 255, 20081, 7),
	(240173, 402, 20143, 9),
	(240173, 255, 20062, 5),
	(240173, 161, 20111, 5),
	(240173, 157, 20143, 7),
	(240173, 231, 20054, 8),
	(240173, 203, 20083, 5),
	(240173, 164, 20111, 8),
	(240173, 333, 20062, 9),
	(134574, 294, 20071, 7),
	(134574, 413, 20073, 6),
	(134574, 360, 20064, 10),
	(134574, 345, 20153, 6),
	(134574, 270, 20122, 8),
	(134574, 58, 20081, 6),
	(134574, 87, 20121, 9),
	(134574, 189, 20044, 7),
	(134574, 124, 20102, 10),
	(134574, 254, 20134, 6),
	(134574, 37, 20074, 9),
	(134574, 249, 20131, 5),
	(134574, 103, 20032, 9),
	(157393, 65, 20143, 9),
	(157393, 327, 20073, 9),
	(157393, 19, 20061, 6),
	(157393, 158, 20103, 10),
	(157393, 1, 20151, 6),
	(263231, 421, 20034, 8),
	(263231, 48, 20114, 10),
	(263231, 445, 20114, 7),
	(263231, 142, 20141, 10),
	(263231, 83, 20121, 5),
	(263231, 363, 20122, 9),
	(279984, 93, 20062, 8),
	(279984, 242, 20074, 8),
	(279984, 75, 20113, 8),
	(279984, 425, 20063, 7),
	(279984, 66, 20142, 7),
	(279984, 359, 20072, 10),
	(279984, 128, 20034, 8),
	(279984, 1, 20102, 7),
	(279984, 382, 20104, 5),
	(279984, 28, 20074, 9),
	(279984, 270, 20042, 8),
	(279984, 235, 20141, 10),
	(279984, 300, 20074, 8),
	(279984, 201, 20121, 6),
	(279984, 469, 20133, 10),
	(279984, 336, 20122, 5),
	(291324, 274, 20103, 9),
	(291324, 400, 20033, 5),
	(291324, 297, 20074, 10),
	(291324, 419, 20051, 9),
	(291324, 489, 20034, 8),
	(291324, 47, 20051, 8),
	(291324, 133, 20102, 6),
	(291324, 185, 20051, 7),
	(291324, 247, 20054, 6),
	(291324, 298, 20044, 9),
	(281021, 228, 20054, 7),
	(281021, 305, 20154, 7),
	(194444, 273, 20091, 7),
	(194444, 484, 20063, 5),
	(194444, 350, 20092, 10),
	(194444, 252, 20081, 5),
	(194444, 474, 20141, 8),
	(194444, 346, 20121, 10),
	(194444, 283, 20062, 10),
	(194444, 423, 20093, 5),
	(194444, 256, 20054, 10),
	(194444, 192, 20094, 7),
	(252817, 67, 20103, 7),
	(252817, 477, 20091, 6),
	(252817, 406, 20032, 9),
	(252817, 3, 20133, 7),
	(252817, 310, 20031, 8),
	(252817, 22, 20143, 6),
	(252817, 174, 20144, 5),
	(252817, 246, 20152, 9),
	(252817, 478, 20123, 6),
	(252817, 15, 20032, 10),
	(252817, 345, 20104, 6),
	(252817, 268, 20061, 7),
	(252817, 203, 20092, 10),
	(252817, 486, 20033, 10),
	(252817, 83, 20113, 9),
	(252817, 453, 20054, 10),
	(115611, 245, 20123, 10),
	(115611, 387, 20042, 7),
	(115611, 299, 20083, 5),
	(115611, 49, 20033, 6),
	(115611, 410, 20083, 5),
	(115611, 244, 20033, 6),
	(115611, 302, 20132, 9),
	(247534, 342, 20152, 9),
	(247534, 400, 20042, 8),
	(247534, 83, 20033, 9),
	(247534, 230, 20054, 9),
	(247534, 324, 20082, 5),
	(247534, 384, 20053, 8),
	(247534, 403, 20102, 7),
	(247534, 337, 20142, 5),
	(247534, 447, 20101, 9),
	(139300, 96, 20032, 9),
	(105061, 348, 20061, 9),
	(105061, 421, 20072, 10),
	(105061, 338, 20113, 9),
	(105061, 470, 20113, 8),
	(105061, 435, 20143, 10),
	(105061, 288, 20142, 8),
	(105061, 334, 20042, 8),
	(105061, 302, 20134, 8),
	(105061, 24, 20053, 6),
	(105061, 40, 20133, 5),
	(105061, 21, 20072, 5),
	(105061, 266, 20064, 5),
	(105061, 177, 20114, 7),
	(105061, 24, 20082, 9),
	(105061, 341, 20103, 6),
	(105061, 486, 20131, 10),
	(105061, 389, 20143, 5),
	(105061, 383, 20084, 9),
	(105061, 388, 20134, 6),
	(247443, 311, 20044, 6),
	(247443, 79, 20043, 5),
	(247443, 308, 20143, 7),
	(247443, 66, 20044, 5),
	(247443, 287, 20124, 5),
	(247443, 140, 20134, 9),
	(247443, 394, 20102, 5),
	(247443, 361, 20103, 8),
	(247443, 366, 20092, 5),
	(247443, 164, 20101, 5),
	(247443, 46, 20132, 10),
	(247443, 235, 20083, 7),
	(247443, 126, 20054, 5),
	(247443, 246, 20152, 8),
	(247443, 119, 20071, 8),
	(247443, 450, 20143, 10),
	(231934, 222, 20123, 10),
	(231934, 113, 20054, 10),
	(231934, 91, 20133, 9),
	(231934, 59, 20132, 6),
	(231934, 405, 20041, 5),
	(231934, 54, 20132, 9),
	(231934, 343, 20111, 7),
	(231934, 141, 20132, 5),
	(231934, 67, 20034, 7),
	(118661, 465, 20084, 9),
	(118661, 10, 20074, 7),
	(118661, 225, 20143, 9),
	(118661, 162, 20093, 6),
	(118661, 427, 20113, 5),
	(118661, 147, 20102, 8),
	(118661, 29, 20071, 5),
	(118661, 268, 20051, 7),
	(118661, 318, 20051, 5),
	(118661, 60, 20103, 8),
	(118661, 150, 20111, 5),
	(118661, 167, 20084, 7),
	(118661, 420, 20102, 7),
	(118661, 97, 20043, 10),
	(118661, 108, 20094, 5),
	(118661, 16, 20132, 6),
	(118661, 117, 20092, 6),
	(115697, 482, 20033, 8),
	(115697, 139, 20064, 8),
	(115697, 38, 20144, 6),
	(115697, 399, 20082, 9),
	(115697, 75, 20103, 5),
	(115697, 52, 20124, 10),
	(115697, 462, 20122, 7),
	(115697, 477, 20134, 5),
	(115697, 9, 20083, 7),
	(220189, 47, 20142, 5),
	(220189, 413, 20054, 9),
	(220189, 295, 20084, 9),
	(220189, 206, 20093, 8),
	(220189, 7, 20122, 8),
	(220189, 265, 20103, 7),
	(220189, 340, 20123, 7),
	(220189, 435, 20093, 7),
	(220189, 169, 20111, 6),
	(220189, 448, 20121, 7),
	(220189, 180, 20132, 6),
	(220189, 365, 20041, 8),
	(220189, 262, 20134, 8),
	(114903, 199, 20151, 10),
	(114903, 448, 20093, 9),
	(114903, 249, 20151, 10),
	(179065, 361, 20101, 10),
	(179065, 24, 20124, 6),
	(179065, 64, 20034, 6),
	(105693, 321, 20091, 6),
	(105693, 435, 20041, 6),
	(105693, 228, 20083, 10),
	(105693, 130, 20133, 8),
	(105693, 395, 20031, 9),
	(105693, 493, 20131, 9),
	(105693, 335, 20144, 9),
	(105693, 428, 20083, 8),
	(105693, 117, 20154, 10),
	(105693, 338, 20123, 7),
	(105693, 194, 20132, 6),
	(105693, 113, 20123, 10),
	(105693, 119, 20091, 10),
	(105693, 217, 20151, 10),
	(105693, 232, 20113, 10),
	(105693, 308, 20142, 10),
	(137360, 8, 20102, 9),
	(137360, 144, 20103, 9),
	(137360, 382, 20133, 6),
	(137360, 157, 20091, 10),
	(137360, 348, 20121, 6),
	(274421, 477, 20151, 7),
	(274421, 454, 20151, 9),
	(274421, 377, 20083, 9),
	(274421, 474, 20122, 7),
	(274421, 1, 20153, 5),
	(274421, 124, 20151, 10),
	(274421, 168, 20054, 8),
	(274421, 70, 20074, 5),
	(274421, 144, 20054, 5),
	(274421, 75, 20094, 5),
	(274421, 422, 20064, 9),
	(274421, 463, 20091, 6),
	(274421, 44, 20032, 8),
	(274421, 257, 20153, 10),
	(274421, 288, 20153, 9),
	(274421, 214, 20151, 9),
	(260282, 139, 20133, 6),
	(260282, 44, 20081, 5),
	(260282, 89, 20071, 10),
	(260282, 250, 20113, 8),
	(260282, 176, 20144, 6),
	(260282, 382, 20111, 8),
	(260282, 348, 20142, 7),
	(260282, 115, 20144, 6),
	(260282, 261, 20154, 10),
	(191900, 455, 20042, 7),
	(191900, 135, 20082, 8),
	(191900, 431, 20091, 5),
	(191900, 268, 20091, 8),
	(191900, 227, 20054, 10),
	(191900, 208, 20113, 8),
	(191900, 410, 20151, 9),
	(107252, 352, 20054, 7),
	(107252, 49, 20061, 10),
	(107252, 140, 20123, 9),
	(107252, 15, 20053, 9),
	(288825, 18, 20044, 6),
	(288825, 211, 20094, 9),
	(288825, 483, 20064, 5),
	(288825, 277, 20083, 7),
	(263632, 170, 20043, 6),
	(263632, 102, 20054, 7),
	(144923, 378, 20053, 5),
	(144923, 424, 20154, 6),
	(144923, 362, 20092, 10),
	(144923, 393, 20134, 9),
	(144923, 154, 20032, 7),
	(144923, 263, 20151, 6),
	(144923, 5, 20061, 5),
	(144923, 293, 20101, 7),
	(144923, 251, 20043, 8),
	(144923, 485, 20134, 7),
	(144923, 112, 20134, 8),
	(144923, 473, 20133, 10),
	(144923, 162, 20064, 7),
	(144923, 372, 20113, 8),
	(160954, 264, 20033, 9),
	(160954, 158, 20133, 6),
	(160954, 137, 20152, 5),
	(160954, 443, 20043, 5),
	(160954, 393, 20143, 5),
	(160954, 15, 20104, 7),
	(160954, 258, 20104, 9),
	(160954, 227, 20113, 5),
	(160954, 22, 20062, 7),
	(160954, 349, 20033, 9),
	(160954, 367, 20054, 6),
	(160954, 80, 20063, 8),
	(160954, 146, 20104, 10),
	(177012, 421, 20144, 6),
	(177012, 452, 20114, 5),
	(177012, 406, 20103, 7),
	(190283, 432, 20031, 7),
	(190283, 257, 20143, 9),
	(190283, 271, 20031, 7),
	(190283, 269, 20131, 7),
	(190283, 331, 20072, 8),
	(190283, 386, 20112, 10),
	(190283, 341, 20122, 9),
	(190283, 458, 20154, 5),
	(190283, 271, 20091, 7),
	(190283, 21, 20054, 7),
	(190283, 386, 20124, 9),
	(190283, 64, 20111, 9),
	(190283, 242, 20101, 10),
	(251686, 273, 20132, 5),
	(251686, 88, 20043, 9),
	(251686, 11, 20102, 7),
	(251686, 301, 20041, 6),
	(251686, 455, 20063, 5),
	(251686, 268, 20033, 8),
	(251686, 402, 20054, 10),
	(251686, 437, 20111, 5),
	(251686, 63, 20134, 8),
	(251686, 497, 20063, 7),
	(251686, 458, 20073, 8),
	(251686, 480, 20113, 10),
	(251686, 404, 20063, 9),
	(251686, 271, 20052, 10),
	(251686, 392, 20071, 7),
	(251686, 372, 20042, 8),
	(251686, 46, 20103, 5),
	(173713, 89, 20133, 6),
	(173713, 177, 20143, 7),
	(173713, 354, 20081, 6),
	(154174, 20, 20141, 5),
	(154174, 142, 20152, 8),
	(154174, 486, 20073, 8),
	(154174, 72, 20153, 9),
	(154174, 246, 20121, 5),
	(154174, 98, 20091, 8),
	(154174, 91, 20154, 5),
	(154174, 339, 20154, 7),
	(154174, 133, 20054, 10),
	(154174, 387, 20102, 6),
	(154174, 216, 20142, 6),
	(154174, 88, 20073, 10),
	(154174, 468, 20063, 9),
	(154174, 314, 20033, 9),
	(154174, 256, 20061, 8),
	(154174, 354, 20112, 6),
	(154174, 226, 20133, 10),
	(154174, 223, 20082, 6),
	(250685, 481, 20121, 9),
	(250685, 266, 20072, 8),
	(250685, 238, 20142, 6),
	(250685, 55, 20122, 6),
	(250685, 324, 20064, 6),
	(250685, 197, 20133, 8),
	(250685, 179, 20143, 9),
	(120860, 171, 20114, 6),
	(120860, 376, 20152, 7),
	(120860, 95, 20094, 9),
	(120860, 444, 20094, 7),
	(120860, 434, 20091, 6),
	(120860, 339, 20082, 10),
	(120860, 427, 20102, 9),
	(120860, 125, 20094, 9),
	(120860, 454, 20101, 6),
	(120860, 404, 20113, 6),
	(120860, 246, 20061, 5),
	(120860, 379, 20061, 8),
	(120860, 198, 20151, 6),
	(120860, 158, 20081, 6),
	(120860, 140, 20103, 10),
	(120860, 56, 20041, 5),
	(120860, 410, 20111, 9),
	(120860, 101, 20151, 10),
	(151249, 416, 20041, 7),
	(151249, 366, 20152, 6),
	(151249, 192, 20084, 8),
	(151249, 260, 20042, 9),
	(151249, 170, 20131, 5),
	(151249, 412, 20081, 9),
	(151249, 128, 20132, 6),
	(151249, 479, 20112, 6),
	(151249, 348, 20123, 8),
	(151249, 485, 20064, 7),
	(225816, 307, 20092, 8),
	(225816, 256, 20084, 9),
	(235106, 258, 20062, 8),
	(235106, 167, 20092, 6),
	(235106, 222, 20153, 8),
	(235106, 371, 20031, 9),
	(235106, 26, 20131, 7),
	(235106, 453, 20101, 5),
	(235106, 185, 20151, 7),
	(235106, 284, 20104, 7),
	(235106, 480, 20142, 6),
	(235106, 233, 20074, 8),
	(235106, 226, 20133, 5),
	(235106, 417, 20134, 10),
	(235106, 112, 20091, 7),
	(235106, 337, 20032, 7),
	(235106, 406, 20084, 7),
	(235106, 383, 20053, 7),
	(274396, 316, 20051, 5),
	(274396, 43, 20033, 7),
	(274396, 390, 20091, 8),
	(274396, 443, 20051, 5),
	(274396, 429, 20141, 8),
	(274396, 103, 20073, 7),
	(274396, 220, 20131, 9),
	(274396, 477, 20113, 7),
	(274396, 415, 20042, 5),
	(238151, 141, 20083, 9),
	(291215, 190, 20153, 6),
	(291215, 82, 20062, 7),
	(291215, 36, 20071, 10),
	(291215, 328, 20073, 10),
	(291215, 341, 20071, 9),
	(291215, 56, 20123, 10),
	(291215, 425, 20081, 7),
	(291215, 369, 20063, 6),
	(291215, 328, 20114, 6),
	(291215, 4, 20111, 5),
	(291215, 163, 20091, 9),
	(291215, 97, 20153, 5),
	(291215, 370, 20131, 6),
	(291215, 50, 20043, 8),
	(291215, 416, 20054, 5),
	(291215, 115, 20131, 7),
	(291215, 402, 20093, 9),
	(291215, 295, 20073, 6),
	(291215, 368, 20154, 10),
	(166260, 126, 20084, 7),
	(166260, 438, 20152, 8),
	(166260, 408, 20104, 6),
	(166260, 157, 20043, 7),
	(166260, 175, 20112, 10),
	(166260, 303, 20124, 7),
	(166260, 280, 20093, 9),
	(166260, 144, 20102, 7),
	(166260, 426, 20133, 7),
	(166260, 352, 20123, 5),
	(166260, 449, 20093, 6),
	(166260, 470, 20044, 5),
	(166260, 345, 20074, 9),
	(166260, 92, 20051, 10),
	(239119, 420, 20123, 5),
	(239119, 23, 20032, 9),
	(239119, 417, 20084, 7),
	(239119, 168, 20041, 6),
	(239119, 1, 20103, 5),
	(239119, 414, 20082, 8),
	(102734, 469, 20111, 9),
	(102734, 493, 20153, 7),
	(263213, 139, 20092, 8),
	(263213, 379, 20141, 5),
	(263213, 108, 20053, 8),
	(263213, 358, 20151, 8),
	(263213, 299, 20032, 9),
	(263213, 231, 20103, 7),
	(263213, 377, 20141, 10),
	(263213, 48, 20112, 7),
	(263213, 157, 20114, 5),
	(263213, 430, 20083, 6),
	(263213, 72, 20121, 5),
	(263213, 80, 20073, 10),
	(263213, 226, 20132, 9),
	(263213, 176, 20064, 8),
	(263213, 63, 20054, 7),
	(117397, 334, 20094, 8),
	(117397, 255, 20041, 7),
	(117397, 463, 20104, 5),
	(117397, 197, 20131, 9),
	(117397, 440, 20123, 6),
	(117397, 188, 20154, 7),
	(117397, 179, 20064, 7),
	(117397, 177, 20061, 6),
	(117397, 297, 20123, 9),
	(117397, 50, 20124, 10),
	(117397, 414, 20041, 5),
	(117397, 179, 20123, 10),
	(117397, 427, 20084, 10),
	(117397, 326, 20053, 7),
	(117397, 466, 20151, 8),
	(212100, 473, 20073, 10),
	(212100, 382, 20134, 6),
	(244894, 464, 20103, 10),
	(244894, 415, 20034, 9),
	(244894, 87, 20044, 9),
	(244894, 101, 20033, 8),
	(244894, 432, 20103, 8),
	(244894, 263, 20132, 5),
	(244894, 211, 20131, 8),
	(244894, 381, 20053, 7),
	(244894, 150, 20143, 5),
	(244894, 490, 20031, 8),
	(126855, 231, 20103, 7),
	(126855, 139, 20113, 10),
	(126855, 38, 20044, 8),
	(126855, 125, 20121, 5),
	(126855, 482, 20131, 5),
	(126855, 7, 20112, 6),
	(126855, 316, 20074, 5),
	(126855, 449, 20043, 9),
	(126855, 380, 20124, 8),
	(126855, 260, 20141, 5),
	(191237, 181, 20033, 10),
	(191237, 139, 20153, 6),
	(191237, 79, 20031, 5),
	(191237, 456, 20112, 5),
	(191237, 53, 20144, 7),
	(191237, 316, 20034, 6),
	(191237, 192, 20082, 7),
	(191237, 227, 20103, 7),
	(191237, 308, 20064, 8),
	(191237, 21, 20154, 10),
	(191237, 178, 20054, 6),
	(264142, 379, 20133, 8),
	(264142, 408, 20043, 7),
	(264142, 365, 20074, 10),
	(264142, 352, 20121, 7),
	(264142, 112, 20121, 8),
	(264142, 278, 20061, 6),
	(264142, 347, 20041, 9),
	(264142, 229, 20054, 5),
	(264142, 475, 20111, 7),
	(264142, 366, 20074, 8),
	(264142, 245, 20054, 6),
	(264142, 224, 20093, 10),
	(264142, 226, 20091, 10),
	(264142, 249, 20044, 7),
	(264142, 314, 20092, 10),
	(264142, 366, 20113, 8),
	(264142, 467, 20041, 9),
	(264142, 145, 20102, 7),
	(264142, 175, 20141, 10),
	(259413, 58, 20062, 6),
	(259413, 182, 20073, 6),
	(259413, 469, 20034, 8),
	(259413, 422, 20124, 9),
	(259413, 440, 20133, 8),
	(259413, 361, 20113, 6),
	(104188, 443, 20054, 8),
	(104188, 424, 20113, 7),
	(104188, 306, 20072, 7),
	(104188, 33, 20051, 5),
	(104188, 124, 20044, 8),
	(104188, 292, 20064, 8),
	(104188, 235, 20091, 8),
	(104188, 441, 20084, 5),
	(104188, 59, 20042, 6),
	(104188, 396, 20034, 6),
	(279534, 467, 20141, 8),
	(279534, 70, 20141, 8),
	(279534, 349, 20131, 5),
	(279534, 454, 20054, 10),
	(279534, 293, 20091, 8),
	(279534, 415, 20063, 8),
	(279534, 27, 20082, 7),
	(279534, 195, 20072, 10),
	(279534, 296, 20092, 10),
	(279534, 83, 20081, 10),
	(279534, 311, 20112, 8),
	(279534, 49, 20153, 8),
	(175662, 364, 20143, 8),
	(175662, 134, 20054, 5),
	(175662, 120, 20042, 10),
	(175662, 80, 20074, 6),
	(175662, 185, 20044, 7),
	(175662, 269, 20062, 6),
	(175662, 253, 20032, 10),
	(123494, 21, 20032, 8),
	(123494, 427, 20111, 8),
	(123494, 36, 20041, 10),
	(123494, 190, 20134, 10),
	(123494, 400, 20034, 7),
	(163187, 110, 20114, 5),
	(163187, 243, 20153, 8),
	(163187, 245, 20093, 6),
	(163187, 334, 20034, 7),
	(163187, 33, 20053, 5),
	(163187, 294, 20083, 7),
	(163187, 496, 20123, 5),
	(154711, 398, 20152, 5),
	(154711, 291, 20124, 10),
	(154711, 178, 20144, 9),
	(154711, 434, 20041, 9),
	(154711, 123, 20153, 9),
	(154711, 246, 20052, 9),
	(154711, 214, 20061, 7),
	(154711, 43, 20153, 5),
	(154711, 163, 20122, 10),
	(154711, 309, 20093, 8),
	(154711, 375, 20152, 6),
	(154711, 64, 20041, 9),
	(154711, 224, 20071, 9),
	(256276, 252, 20062, 6),
	(256276, 206, 20033, 6),
	(256276, 375, 20114, 9),
	(256276, 144, 20114, 5),
	(256276, 66, 20031, 9),
	(256276, 298, 20074, 5),
	(256276, 313, 20111, 6),
	(256276, 28, 20032, 9),
	(256276, 161, 20053, 9),
	(256276, 344, 20042, 8),
	(256276, 410, 20054, 5),
	(256276, 70, 20111, 6),
	(256276, 319, 20113, 6),
	(256276, 231, 20064, 8),
	(256276, 490, 20044, 6),
	(256276, 494, 20153, 7),
	(256276, 461, 20063, 7),
	(256276, 118, 20153, 10),
	(257425, 21, 20083, 9),
	(257425, 146, 20102, 8),
	(257425, 241, 20054, 9),
	(257425, 307, 20091, 6),
	(265420, 336, 20031, 5),
	(265420, 393, 20104, 8),
	(265420, 321, 20104, 5),
	(265420, 298, 20142, 9),
	(265420, 195, 20082, 7),
	(265420, 92, 20142, 9),
	(265420, 47, 20154, 6),
	(265420, 30, 20044, 8),
	(265420, 173, 20134, 8),
	(265420, 392, 20064, 6),
	(265420, 41, 20131, 5),
	(265420, 335, 20044, 10),
	(265420, 436, 20152, 9),
	(265420, 12, 20151, 6),
	(265420, 410, 20133, 10),
	(265420, 321, 20054, 8),
	(265420, 293, 20042, 5),
	(195541, 296, 20123, 7),
	(195541, 334, 20033, 10),
	(195541, 27, 20154, 9),
	(195541, 450, 20122, 7),
	(195541, 302, 20072, 5),
	(195541, 186, 20091, 8),
	(195541, 311, 20082, 6),
	(195541, 428, 20061, 6),
	(195541, 72, 20091, 7),
	(195541, 420, 20034, 7),
	(195541, 23, 20102, 9),
	(195541, 56, 20123, 5),
	(195541, 329, 20154, 9),
	(195541, 491, 20111, 6),
	(195541, 446, 20114, 10),
	(195541, 282, 20102, 7),
	(195541, 186, 20114, 8),
	(195471, 116, 20031, 5),
	(195471, 405, 20031, 10),
	(195471, 252, 20082, 8),
	(195471, 230, 20151, 5),
	(195471, 407, 20151, 8),
	(195471, 308, 20033, 9),
	(195471, 85, 20134, 5),
	(195471, 348, 20083, 10),
	(195471, 179, 20072, 8),
	(195471, 446, 20122, 5),
	(195471, 427, 20144, 5),
	(195471, 139, 20104, 5),
	(195471, 357, 20052, 6),
	(195471, 186, 20112, 8),
	(195471, 407, 20104, 9),
	(195471, 267, 20143, 10),
	(195471, 55, 20152, 6),
	(195471, 447, 20084, 10),
	(195471, 188, 20053, 6),
	(195471, 472, 20151, 8),
	(204726, 183, 20072, 10),
	(204726, 256, 20111, 7),
	(204726, 18, 20043, 8),
	(204726, 330, 20112, 8),
	(204726, 97, 20104, 9),
	(204726, 236, 20141, 6),
	(204726, 464, 20052, 6),
	(204726, 475, 20031, 6),
	(204726, 144, 20082, 9),
	(204726, 176, 20153, 9),
	(204726, 256, 20101, 9),
	(204726, 300, 20041, 5),
	(204726, 385, 20041, 7),
	(204726, 210, 20153, 10),
	(177993, 467, 20143, 5),
	(177993, 247, 20122, 10),
	(177993, 168, 20073, 6),
	(177993, 228, 20142, 9),
	(177993, 284, 20124, 9),
	(177993, 372, 20113, 7),
	(177993, 23, 20151, 6),
	(177993, 110, 20061, 6),
	(177993, 67, 20031, 9),
	(177993, 32, 20144, 5),
	(262408, 479, 20051, 7),
	(262408, 17, 20124, 8),
	(262408, 86, 20111, 5),
	(262408, 410, 20133, 6),
	(262408, 343, 20091, 9),
	(262408, 86, 20033, 10),
	(262408, 396, 20081, 5),
	(262408, 243, 20064, 9),
	(262408, 392, 20131, 8),
	(262408, 311, 20073, 9),
	(262408, 187, 20152, 5),
	(262408, 299, 20103, 5),
	(144892, 269, 20082, 10),
	(144892, 252, 20051, 5),
	(144892, 159, 20143, 8),
	(144892, 285, 20094, 9),
	(144892, 495, 20054, 9),
	(144892, 464, 20142, 10),
	(144892, 164, 20042, 5),
	(144892, 211, 20154, 5),
	(144892, 142, 20141, 7),
	(144892, 20, 20104, 9),
	(144892, 43, 20031, 9),
	(144892, 303, 20073, 9),
	(144892, 295, 20033, 7),
	(144892, 346, 20134, 10),
	(144892, 4, 20074, 8),
	(144892, 389, 20032, 10),
	(144892, 97, 20083, 10),
	(144892, 177, 20043, 9),
	(144892, 54, 20072, 6),
	(144892, 54, 20044, 8),
	(241473, 47, 20112, 5),
	(115115, 349, 20154, 8),
	(115115, 284, 20073, 10),
	(115115, 66, 20032, 9),
	(115115, 489, 20052, 8),
	(115115, 492, 20152, 9),
	(115115, 207, 20134, 10),
	(115115, 385, 20061, 10),
	(115115, 305, 20144, 10),
	(115115, 266, 20103, 9),
	(115115, 446, 20101, 9),
	(115115, 42, 20034, 6),
	(215571, 369, 20052, 8),
	(215571, 16, 20093, 9),
	(202978, 431, 20104, 10),
	(202978, 429, 20074, 9),
	(202978, 439, 20153, 5),
	(202978, 465, 20091, 7),
	(169522, 238, 20053, 5),
	(169522, 260, 20111, 5),
	(169522, 53, 20081, 5),
	(169522, 79, 20084, 8),
	(169522, 333, 20073, 10),
	(169522, 484, 20031, 7),
	(169522, 48, 20104, 5),
	(169522, 473, 20084, 9),
	(169522, 414, 20051, 9),
	(169522, 395, 20074, 9),
	(169522, 126, 20093, 8),
	(169522, 479, 20072, 8),
	(148135, 154, 20132, 6),
	(148135, 484, 20133, 9),
	(148135, 284, 20133, 6),
	(148135, 31, 20143, 10),
	(148135, 204, 20053, 10),
	(148135, 241, 20112, 5),
	(148135, 406, 20113, 7),
	(148135, 199, 20034, 10),
	(148135, 192, 20031, 9),
	(148135, 72, 20052, 10),
	(148135, 146, 20103, 6),
	(148135, 172, 20061, 10),
	(148135, 112, 20151, 7),
	(148135, 300, 20092, 8),
	(148135, 425, 20081, 7),
	(181506, 312, 20134, 6),
	(181506, 370, 20051, 9),
	(181506, 425, 20082, 6),
	(181506, 348, 20151, 6),
	(181506, 190, 20113, 6),
	(181506, 483, 20033, 5),
	(181506, 229, 20032, 10),
	(181506, 107, 20052, 9),
	(181506, 95, 20093, 6),
	(181506, 63, 20124, 5),
	(181506, 468, 20074, 5),
	(181506, 423, 20044, 9),
	(181506, 164, 20073, 10),
	(181506, 344, 20123, 5),
	(181506, 97, 20111, 9),
	(181506, 355, 20091, 5),
	(181506, 279, 20031, 5),
	(181506, 321, 20122, 9),
	(181506, 180, 20112, 10),
	(117804, 377, 20082, 6),
	(117804, 325, 20064, 10),
	(117804, 153, 20061, 7),
	(117804, 70, 20072, 7),
	(117804, 458, 20032, 9),
	(117804, 489, 20032, 6),
	(117804, 322, 20053, 6),
	(117804, 167, 20091, 10),
	(117804, 191, 20133, 7),
	(117804, 201, 20051, 9),
	(117804, 414, 20032, 8),
	(117804, 166, 20034, 5),
	(117804, 234, 20034, 7),
	(117804, 134, 20084, 5),
	(117804, 135, 20083, 5),
	(117804, 41, 20104, 6),
	(271962, 293, 20091, 10),
	(271962, 120, 20112, 9),
	(271962, 374, 20154, 5),
	(271962, 322, 20044, 7),
	(271962, 327, 20124, 6),
	(271962, 412, 20113, 10),
	(271962, 110, 20123, 6),
	(271962, 466, 20084, 7),
	(271962, 458, 20102, 5),
	(271962, 251, 20094, 10),
	(271962, 465, 20094, 7),
	(271962, 433, 20042, 5),
	(271962, 450, 20054, 6),
	(258188, 243, 20051, 8),
	(262119, 194, 20111, 10),
	(262119, 331, 20144, 10),
	(262119, 164, 20113, 10),
	(262119, 193, 20143, 6),
	(262119, 472, 20153, 9),
	(262119, 440, 20101, 7),
	(262119, 99, 20103, 8),
	(262119, 379, 20041, 10),
	(262119, 424, 20091, 9),
	(262119, 268, 20051, 10),
	(262119, 262, 20093, 10),
	(205147, 170, 20082, 6),
	(205147, 175, 20052, 7),
	(205147, 482, 20104, 8),
	(205147, 108, 20123, 7),
	(205147, 370, 20051, 6),
	(205147, 287, 20093, 5),
	(205147, 377, 20102, 7),
	(205147, 370, 20154, 9),
	(205147, 479, 20063, 9),
	(205147, 407, 20141, 6),
	(205147, 52, 20124, 7),
	(205147, 429, 20114, 7),
	(205147, 14, 20073, 10),
	(205147, 407, 20081, 9),
	(210714, 91, 20042, 9),
	(210714, 329, 20131, 7),
	(210714, 272, 20034, 10),
	(210714, 307, 20062, 5),
	(210714, 44, 20062, 9),
	(210714, 344, 20033, 7),
	(210714, 322, 20111, 7),
	(210714, 5, 20134, 5),
	(210714, 262, 20071, 7),
	(210714, 335, 20072, 9),
	(210714, 343, 20064, 5),
	(210714, 273, 20122, 10),
	(210714, 237, 20052, 9),
	(210714, 147, 20054, 5),
	(210714, 67, 20031, 7),
	(210714, 462, 20152, 8),
	(210714, 488, 20144, 6),
	(180024, 79, 20081, 7),
	(180024, 289, 20063, 5),
	(180024, 53, 20072, 7),
	(180024, 283, 20054, 7),
	(180024, 410, 20054, 8),
	(180024, 341, 20092, 7),
	(180024, 123, 20093, 5),
	(180024, 220, 20043, 10),
	(180024, 190, 20064, 9),
	(180024, 391, 20082, 5),
	(180024, 204, 20093, 9),
	(180024, 5, 20091, 8),
	(180024, 435, 20153, 8),
	(180024, 158, 20152, 10),
	(180024, 279, 20032, 10),
	(181827, 198, 20134, 9),
	(181827, 268, 20072, 5),
	(181827, 410, 20131, 8),
	(159328, 234, 20081, 5),
	(159328, 249, 20141, 10),
	(159328, 7, 20131, 9),
	(159328, 91, 20032, 7),
	(159328, 243, 20031, 6),
	(159328, 471, 20041, 7),
	(159328, 21, 20054, 5),
	(288194, 215, 20093, 9),
	(288194, 422, 20031, 5),
	(288194, 154, 20143, 8),
	(288194, 286, 20081, 6),
	(288194, 202, 20132, 9),
	(288194, 305, 20041, 7),
	(288194, 75, 20041, 8),
	(288194, 388, 20123, 9),
	(288194, 37, 20113, 6),
	(288194, 114, 20143, 9),
	(288194, 127, 20032, 6),
	(288194, 266, 20054, 7),
	(288194, 116, 20114, 9),
	(288194, 55, 20071, 6),
	(288194, 57, 20042, 5),
	(288194, 389, 20142, 9),
	(288194, 219, 20041, 7),
	(288194, 249, 20091, 5),
	(288194, 316, 20131, 8),
	(229513, 211, 20071, 6),
	(229513, 219, 20053, 7),
	(229513, 425, 20101, 7),
	(229513, 70, 20134, 8),
	(108517, 62, 20082, 8),
	(108517, 79, 20151, 8),
	(108517, 367, 20054, 6),
	(108517, 135, 20033, 8),
	(108517, 477, 20112, 9),
	(108517, 21, 20071, 6),
	(108517, 313, 20133, 5),
	(108517, 146, 20103, 7),
	(255230, 219, 20121, 9),
	(255230, 278, 20032, 7),
	(255230, 363, 20123, 7),
	(255230, 430, 20094, 5),
	(255230, 388, 20032, 10),
	(255230, 174, 20061, 6),
	(255230, 12, 20131, 10),
	(107699, 129, 20084, 5),
	(107699, 364, 20141, 10),
	(107699, 158, 20073, 8),
	(107699, 339, 20101, 10),
	(107699, 291, 20154, 5),
	(107699, 411, 20102, 9),
	(107699, 129, 20101, 7),
	(107699, 177, 20151, 7),
	(107699, 335, 20111, 5),
	(107699, 438, 20074, 5),
	(107699, 352, 20113, 10),
	(107699, 280, 20154, 9),
	(172848, 391, 20133, 9),
	(172848, 279, 20122, 8),
	(172848, 433, 20061, 5),
	(172848, 403, 20072, 9),
	(172848, 381, 20152, 9),
	(172848, 24, 20121, 7),
	(172848, 372, 20094, 8),
	(172848, 353, 20121, 8),
	(172848, 243, 20104, 10),
	(172848, 65, 20064, 6),
	(172848, 276, 20113, 9),
	(172848, 211, 20051, 10),
	(172848, 107, 20091, 9),
	(172848, 422, 20122, 6),
	(197644, 173, 20112, 8),
	(197644, 314, 20042, 5),
	(198792, 304, 20142, 7),
	(198792, 13, 20053, 10),
	(198792, 440, 20034, 5),
	(198792, 404, 20151, 7),
	(198792, 177, 20121, 7),
	(198792, 273, 20114, 10),
	(198792, 86, 20142, 6),
	(198792, 233, 20134, 8),
	(198792, 443, 20144, 10),
	(198792, 232, 20042, 9),
	(198792, 461, 20083, 7),
	(198792, 312, 20142, 5),
	(199895, 308, 20031, 5),
	(199895, 453, 20054, 5),
	(199895, 354, 20044, 10),
	(199895, 197, 20093, 10),
	(199895, 391, 20142, 6),
	(199895, 178, 20151, 8),
	(199895, 389, 20061, 9),
	(199895, 417, 20031, 10),
	(195506, 21, 20051, 10),
	(195506, 160, 20081, 8),
	(195506, 413, 20132, 6),
	(195506, 193, 20121, 9),
	(195506, 191, 20144, 8),
	(195506, 350, 20042, 10),
	(195506, 267, 20054, 6),
	(195506, 201, 20044, 7),
	(195506, 259, 20121, 5),
	(195506, 63, 20143, 9),
	(195506, 312, 20063, 5),
	(195506, 133, 20044, 5),
	(195506, 86, 20123, 7),
	(195506, 457, 20101, 9),
	(195506, 323, 20072, 10),
	(195506, 255, 20031, 10),
	(195506, 227, 20061, 9),
	(195506, 36, 20131, 8),
	(195506, 396, 20104, 9),
	(297495, 273, 20154, 9),
	(297495, 287, 20062, 8),
	(297495, 361, 20102, 9),
	(297495, 65, 20152, 9),
	(297495, 14, 20051, 10),
	(297495, 288, 20141, 9),
	(297495, 435, 20042, 8),
	(297495, 413, 20131, 9),
	(297495, 313, 20044, 7),
	(297495, 134, 20111, 8),
	(297495, 4, 20083, 7),
	(297495, 209, 20062, 7),
	(297495, 397, 20064, 10),
	(297495, 105, 20072, 5),
	(297495, 9, 20144, 7),
	(297495, 495, 20034, 6),
	(164209, 334, 20153, 5),
	(164209, 165, 20053, 7),
	(164209, 73, 20052, 7),
	(164209, 218, 20041, 5),
	(164209, 45, 20132, 8),
	(164209, 111, 20032, 5),
	(164209, 234, 20102, 6),
	(243777, 25, 20092, 10),
	(243777, 191, 20101, 5),
	(243777, 426, 20123, 9),
	(243777, 459, 20122, 7),
	(243777, 60, 20093, 7),
	(243777, 381, 20131, 5),
	(243777, 469, 20144, 6),
	(243777, 324, 20033, 8),
	(243777, 446, 20114, 7),
	(243777, 405, 20124, 5),
	(243777, 453, 20144, 9),
	(226774, 271, 20151, 7),
	(226774, 341, 20031, 6),
	(226774, 225, 20124, 10),
	(226774, 425, 20092, 7),
	(226774, 431, 20103, 7),
	(226774, 419, 20143, 6),
	(226774, 234, 20101, 7),
	(226774, 247, 20102, 6),
	(226774, 96, 20131, 7),
	(226774, 185, 20103, 10),
	(226774, 221, 20071, 7),
	(226774, 232, 20073, 5),
	(226774, 332, 20051, 10),
	(226774, 301, 20101, 5),
	(226774, 118, 20133, 8),
	(226774, 431, 20043, 7),
	(226774, 61, 20142, 5),
	(226774, 461, 20124, 8),
	(285166, 228, 20064, 5),
	(285166, 92, 20041, 6),
	(285166, 476, 20073, 6),
	(285166, 171, 20101, 6),
	(285166, 41, 20073, 7),
	(285166, 317, 20044, 5),
	(285166, 137, 20131, 5),
	(285166, 422, 20072, 9),
	(285166, 37, 20091, 10),
	(285166, 20, 20152, 6),
	(285166, 161, 20062, 6),
	(285166, 312, 20073, 7),
	(285166, 477, 20031, 6),
	(285166, 129, 20051, 6),
	(285166, 268, 20143, 9),
	(285166, 347, 20142, 5),
	(285166, 293, 20032, 9),
	(280597, 384, 20052, 6),
	(280597, 78, 20053, 7),
	(280597, 295, 20074, 7),
	(280597, 234, 20151, 9),
	(280597, 131, 20051, 7),
	(280597, 346, 20134, 7),
	(280597, 240, 20094, 6),
	(280597, 140, 20044, 10),
	(280597, 359, 20052, 8),
	(280597, 187, 20101, 9),
	(280597, 484, 20091, 5),
	(280597, 207, 20151, 5),
	(280597, 207, 20141, 10),
	(280597, 82, 20041, 6),
	(280597, 276, 20113, 6),
	(280597, 171, 20044, 8),
	(280597, 215, 20084, 9),
	(280597, 409, 20053, 5),
	(105486, 459, 20083, 10),
	(105486, 437, 20041, 9),
	(105486, 376, 20042, 8),
	(105486, 31, 20061, 6),
	(105486, 6, 20081, 8),
	(105486, 280, 20101, 7),
	(105486, 403, 20054, 10),
	(105486, 470, 20052, 10),
	(105486, 145, 20133, 6),
	(105486, 334, 20124, 5),
	(105486, 488, 20081, 6),
	(105486, 39, 20111, 6),
	(105486, 415, 20151, 7),
	(105486, 43, 20102, 6),
	(105486, 75, 20054, 8),
	(105486, 210, 20064, 6),
	(105486, 361, 20051, 8),
	(130701, 334, 20124, 7),
	(130701, 82, 20042, 10),
	(130701, 319, 20052, 6),
	(130701, 364, 20131, 9),
	(130701, 420, 20154, 10),
	(130701, 308, 20112, 6),
	(130701, 383, 20053, 7),
	(229202, 332, 20111, 8),
	(229202, 274, 20031, 9),
	(229202, 333, 20063, 7),
	(229202, 478, 20143, 10),
	(221599, 175, 20101, 7),
	(221599, 222, 20073, 6),
	(221599, 93, 20121, 8),
	(221599, 305, 20113, 10),
	(221599, 458, 20041, 9),
	(221599, 263, 20143, 8),
	(221599, 460, 20103, 10),
	(221599, 211, 20112, 5),
	(221599, 275, 20111, 6),
	(221599, 52, 20141, 5),
	(221599, 370, 20082, 10),
	(221599, 370, 20093, 10),
	(221599, 67, 20091, 10),
	(221599, 324, 20134, 8),
	(221599, 467, 20123, 6),
	(253538, 288, 20091, 7),
	(253538, 72, 20124, 9),
	(253538, 120, 20134, 9),
	(253538, 216, 20071, 8),
	(253538, 335, 20093, 6),
	(253538, 435, 20044, 5),
	(253538, 133, 20092, 9),
	(253538, 386, 20144, 6),
	(253538, 7, 20081, 7),
	(253538, 296, 20121, 5),
	(253538, 457, 20032, 5),
	(253538, 435, 20142, 7),
	(253538, 484, 20054, 9),
	(253538, 274, 20043, 8),
	(253538, 73, 20072, 6),
	(253538, 262, 20082, 9),
	(253538, 58, 20073, 10),
	(296598, 399, 20042, 9),
	(296598, 139, 20033, 8),
	(296598, 340, 20114, 10),
	(296598, 137, 20103, 9),
	(296598, 305, 20103, 7),
	(296598, 320, 20072, 9),
	(296598, 36, 20133, 6),
	(296598, 16, 20063, 7),
	(296598, 21, 20043, 8),
	(296598, 126, 20131, 10),
	(296598, 298, 20034, 10),
	(296598, 113, 20051, 10),
	(211136, 250, 20054, 8),
	(211136, 492, 20091, 9),
	(211136, 135, 20083, 10),
	(211136, 179, 20143, 8),
	(117692, 494, 20072, 10),
	(117692, 251, 20092, 9),
	(117692, 261, 20092, 10),
	(117692, 339, 20061, 8),
	(117692, 370, 20074, 5),
	(117692, 330, 20044, 8),
	(117692, 369, 20093, 10),
	(117692, 194, 20064, 8),
	(117692, 161, 20132, 8),
	(117692, 217, 20084, 7),
	(117692, 70, 20034, 8),
	(117692, 491, 20154, 9),
	(117692, 451, 20043, 9),
	(164852, 168, 20052, 6),
	(164852, 202, 20081, 10),
	(164852, 426, 20131, 10),
	(164852, 330, 20142, 5),
	(164852, 109, 20102, 6),
	(164852, 483, 20133, 6),
	(164852, 372, 20143, 5),
	(164852, 433, 20142, 10),
	(164852, 167, 20041, 5),
	(164852, 82, 20123, 8),
	(164852, 394, 20103, 5),
	(164852, 303, 20134, 8),
	(164852, 176, 20082, 10),
	(164852, 122, 20114, 8),
	(164852, 259, 20092, 6),
	(122568, 129, 20054, 5),
	(122568, 360, 20113, 8),
	(122568, 416, 20033, 10),
	(122568, 140, 20101, 7),
	(122568, 35, 20062, 9),
	(122568, 283, 20102, 9),
	(215928, 231, 20054, 8),
	(215928, 250, 20082, 9),
	(281777, 220, 20041, 10),
	(281777, 124, 20123, 5),
	(281777, 193, 20043, 5),
	(281777, 157, 20132, 9),
	(281777, 354, 20082, 6),
	(281777, 486, 20123, 7),
	(281777, 157, 20073, 6),
	(281777, 364, 20082, 7),
	(281777, 38, 20092, 10),
	(281777, 229, 20131, 7),
	(281777, 476, 20124, 7),
	(281777, 29, 20101, 7),
	(281777, 208, 20122, 8),
	(281777, 351, 20051, 6),
	(281777, 300, 20152, 8),
	(281777, 499, 20071, 6),
	(234093, 358, 20053, 8),
	(234093, 398, 20083, 5),
	(234093, 271, 20054, 8),
	(234093, 168, 20064, 5),
	(234093, 30, 20134, 5),
	(234093, 26, 20062, 9),
	(234093, 463, 20081, 6),
	(234093, 244, 20054, 6),
	(234093, 455, 20063, 7),
	(234093, 102, 20124, 6),
	(183491, 340, 20112, 8),
	(183491, 393, 20143, 7),
	(183491, 7, 20102, 6),
	(183491, 247, 20101, 5),
	(183491, 55, 20144, 5),
	(183491, 356, 20052, 8),
	(183491, 401, 20074, 9),
	(183491, 94, 20133, 9),
	(183491, 362, 20102, 6),
	(183491, 338, 20153, 9),
	(183491, 231, 20144, 6),
	(183491, 210, 20092, 9),
	(183491, 239, 20041, 8),
	(183491, 183, 20122, 7),
	(183491, 238, 20133, 10),
	(183491, 157, 20121, 6),
	(183491, 11, 20154, 5),
	(224421, 19, 20151, 7),
	(224421, 247, 20124, 10),
	(224421, 60, 20063, 7),
	(224421, 155, 20133, 10),
	(224421, 440, 20061, 9),
	(224421, 193, 20093, 10),
	(224421, 168, 20111, 8),
	(224421, 222, 20142, 5),
	(224421, 194, 20034, 9),
	(224421, 350, 20104, 10),
	(224421, 325, 20124, 10),
	(224421, 369, 20083, 9),
	(224421, 369, 20122, 10),
	(224421, 185, 20074, 5),
	(224421, 272, 20121, 10),
	(224421, 373, 20122, 8),
	(224421, 280, 20053, 8),
	(224421, 135, 20033, 8),
	(224421, 370, 20123, 7),
	(224421, 302, 20044, 9),
	(125483, 136, 20113, 5),
	(125483, 147, 20064, 5),
	(125483, 496, 20142, 7),
	(281878, 324, 20113, 8),
	(281878, 79, 20034, 10),
	(281878, 189, 20131, 6),
	(281878, 143, 20131, 9),
	(281878, 329, 20062, 10),
	(281878, 170, 20144, 7),
	(281878, 395, 20043, 7),
	(281878, 463, 20061, 10),
	(281878, 157, 20093, 5),
	(116203, 87, 20043, 9),
	(116203, 499, 20054, 10),
	(116203, 86, 20034, 6),
	(116203, 428, 20134, 8),
	(116203, 58, 20033, 9),
	(167811, 374, 20083, 6),
	(167811, 23, 20152, 7),
	(167811, 175, 20044, 6),
	(167811, 60, 20084, 8),
	(167811, 499, 20101, 8),
	(167811, 415, 20032, 6),
	(167811, 482, 20141, 5),
	(167811, 158, 20131, 7),
	(167811, 129, 20152, 10),
	(167811, 424, 20133, 7),
	(167811, 495, 20144, 8),
	(167811, 70, 20083, 7),
	(167811, 244, 20112, 7),
	(167811, 462, 20104, 8),
	(167811, 198, 20113, 10),
	(104065, 153, 20062, 9),
	(104065, 248, 20083, 10),
	(104065, 105, 20031, 6),
	(104065, 306, 20153, 6),
	(104065, 455, 20153, 9),
	(104065, 479, 20062, 5),
	(104065, 359, 20081, 10),
	(104065, 80, 20062, 9),
	(104065, 463, 20133, 6),
	(104065, 24, 20134, 10),
	(182329, 252, 20062, 9),
	(182329, 247, 20133, 5),
	(182329, 4, 20131, 10),
	(182329, 189, 20111, 8),
	(182329, 488, 20034, 7),
	(182329, 488, 20072, 8),
	(182329, 353, 20131, 8),
	(141869, 311, 20101, 8),
	(141869, 112, 20122, 6),
	(268845, 325, 20043, 10),
	(268845, 472, 20041, 9),
	(268845, 453, 20114, 10),
	(268845, 453, 20063, 6),
	(124760, 449, 20083, 9),
	(124760, 90, 20081, 10),
	(124760, 188, 20143, 5),
	(124760, 328, 20114, 7),
	(124760, 497, 20092, 10),
	(124760, 260, 20112, 7),
	(124760, 431, 20082, 9),
	(124760, 223, 20124, 7),
	(124760, 147, 20104, 6),
	(124760, 185, 20043, 7),
	(124760, 41, 20131, 5),
	(124760, 90, 20053, 5),
	(124760, 293, 20091, 6),
	(124760, 358, 20133, 9),
	(124760, 135, 20111, 5),
	(124760, 255, 20092, 8),
	(124760, 7, 20061, 6),
	(124760, 55, 20052, 6),
	(218214, 239, 20084, 9),
	(218214, 449, 20092, 9),
	(239140, 358, 20063, 9),
	(239140, 438, 20103, 7),
	(240841, 271, 20032, 5),
	(240841, 235, 20051, 5),
	(240841, 171, 20061, 6),
	(240841, 258, 20152, 9),
	(240841, 184, 20124, 10),
	(240841, 411, 20091, 7),
	(240841, 309, 20123, 5),
	(240841, 118, 20113, 6),
	(254892, 361, 20071, 6),
	(254892, 107, 20111, 9),
	(254892, 421, 20074, 7),
	(254892, 386, 20092, 9),
	(254892, 396, 20073, 5),
	(254892, 470, 20032, 7),
	(254892, 83, 20084, 6),
	(254892, 84, 20122, 6),
	(254892, 87, 20154, 7),
	(254892, 32, 20054, 10),
	(254892, 110, 20092, 7),
	(254892, 160, 20123, 5),
	(254892, 73, 20152, 7),
	(254892, 163, 20034, 6),
	(254892, 37, 20061, 5),
	(292929, 115, 20032, 6),
	(292929, 306, 20043, 10),
	(292929, 104, 20074, 6),
	(292929, 422, 20074, 6),
	(292929, 86, 20123, 9),
	(292929, 443, 20123, 8),
	(292929, 487, 20152, 9),
	(292929, 17, 20151, 5),
	(292929, 332, 20124, 5),
	(292929, 213, 20032, 9),
	(292929, 15, 20074, 9),
	(292929, 424, 20053, 6),
	(292929, 193, 20102, 10),
	(292929, 52, 20063, 7),
	(147646, 123, 20064, 7),
	(147646, 16, 20154, 7),
	(147646, 205, 20102, 5),
	(147646, 349, 20044, 9),
	(147646, 490, 20094, 8),
	(147646, 147, 20032, 6),
	(147646, 476, 20044, 9),
	(147646, 399, 20053, 6),
	(147646, 103, 20062, 10),
	(147646, 308, 20071, 8),
	(147646, 261, 20031, 6),
	(101087, 49, 20123, 10),
	(101087, 384, 20123, 9),
	(101087, 413, 20084, 8),
	(101087, 193, 20071, 7),
	(101087, 305, 20131, 10),
	(101087, 377, 20132, 10),
	(101087, 322, 20032, 5),
	(101087, 438, 20062, 7),
	(101087, 18, 20092, 5),
	(101087, 269, 20061, 8),
	(101087, 320, 20053, 6),
	(101087, 297, 20134, 9),
	(101087, 79, 20152, 7),
	(101087, 223, 20132, 6),
	(101087, 19, 20041, 10),
	(101087, 84, 20112, 5),
	(248365, 249, 20153, 6),
	(248365, 438, 20113, 8),
	(278395, 469, 20071, 7),
	(278395, 316, 20073, 7),
	(248306, 69, 20104, 9),
	(248306, 254, 20111, 10),
	(248306, 459, 20051, 8),
	(248306, 137, 20123, 7),
	(248306, 75, 20062, 8),
	(248306, 308, 20111, 9),
	(248306, 257, 20031, 10),
	(248306, 39, 20102, 8),
	(248306, 155, 20133, 10),
	(248306, 385, 20103, 10),
	(248306, 396, 20134, 10),
	(248306, 61, 20094, 8),
	(248306, 416, 20034, 5),
	(248306, 57, 20043, 9),
	(248306, 57, 20044, 5),
	(248306, 412, 20083, 9),
	(129795, 317, 20043, 6),
	(129795, 289, 20083, 7),
	(129795, 427, 20072, 8),
	(129795, 217, 20154, 10),
	(129795, 357, 20143, 7),
	(129795, 181, 20081, 5),
	(129795, 409, 20083, 10),
	(129795, 200, 20133, 9),
	(129795, 277, 20091, 9),
	(129795, 327, 20112, 9),
	(235775, 230, 20152, 6),
	(235775, 380, 20123, 8),
	(235775, 165, 20084, 9),
	(235775, 214, 20064, 8),
	(235775, 37, 20141, 6),
	(235775, 414, 20114, 7),
	(235775, 351, 20053, 10),
	(235775, 337, 20144, 5),
	(235775, 77, 20131, 5),
	(235775, 400, 20102, 7),
	(235775, 310, 20104, 5),
	(235775, 333, 20034, 10),
	(235775, 137, 20034, 9),
	(235775, 435, 20123, 7),
	(235775, 213, 20074, 5),
	(153136, 450, 20141, 10),
	(153136, 499, 20131, 7),
	(153136, 363, 20052, 9),
	(153136, 329, 20112, 10),
	(153136, 141, 20032, 10),
	(153136, 293, 20134, 5),
	(139026, 196, 20043, 10),
	(139026, 458, 20084, 9),
	(139026, 50, 20124, 9),
	(139026, 30, 20092, 5),
	(139026, 247, 20132, 6),
	(139026, 333, 20143, 5),
	(139026, 279, 20131, 5),
	(139026, 213, 20114, 10),
	(139026, 440, 20112, 10),
	(139026, 249, 20031, 6),
	(139026, 353, 20092, 9),
	(139026, 480, 20153, 9),
	(139026, 307, 20112, 10),
	(139026, 354, 20114, 7),
	(278773, 19, 20051, 7),
	(278773, 6, 20062, 8),
	(278773, 264, 20151, 5),
	(278773, 212, 20041, 7),
	(278773, 254, 20053, 6),
	(278773, 115, 20101, 10),
	(235210, 126, 20034, 7),
	(235210, 193, 20144, 10),
	(235210, 150, 20122, 10),
	(235210, 245, 20102, 7),
	(152700, 259, 20154, 7),
	(152700, 142, 20113, 6),
	(152700, 337, 20152, 6),
	(152700, 206, 20034, 7),
	(152700, 66, 20033, 9),
	(152700, 33, 20053, 9),
	(152700, 463, 20092, 10),
	(152700, 115, 20153, 7),
	(152700, 78, 20073, 9),
	(152700, 456, 20113, 9),
	(152700, 268, 20091, 9),
	(152700, 246, 20084, 7),
	(152700, 10, 20112, 8),
	(152700, 52, 20152, 10),
	(152700, 277, 20053, 7),
	(152700, 209, 20101, 5),
	(152700, 84, 20044, 7),
	(152700, 136, 20142, 10),
	(152700, 274, 20063, 5),
	(234065, 448, 20083, 5),
	(234065, 191, 20131, 9),
	(145140, 386, 20074, 10),
	(145140, 345, 20152, 5),
	(145140, 178, 20112, 7),
	(145140, 452, 20093, 9),
	(145140, 379, 20082, 5),
	(201797, 89, 20053, 10),
	(201797, 493, 20033, 10),
	(201797, 435, 20082, 6),
	(201797, 360, 20141, 7),
	(201797, 255, 20151, 7),
	(201797, 449, 20143, 5),
	(201797, 147, 20052, 6),
	(201797, 31, 20124, 9),
	(201797, 437, 20101, 7),
	(201797, 486, 20044, 8),
	(201797, 218, 20074, 5),
	(201797, 257, 20143, 5),
	(201797, 73, 20063, 7),
	(201797, 193, 20154, 5),
	(201797, 26, 20144, 8),
	(201797, 393, 20054, 6),
	(135919, 401, 20061, 8),
	(135919, 266, 20051, 5),
	(135919, 238, 20153, 6),
	(135919, 233, 20103, 7),
	(135919, 230, 20101, 9),
	(135919, 160, 20044, 7),
	(135919, 153, 20081, 10),
	(135919, 292, 20133, 8),
	(135919, 373, 20081, 10),
	(135919, 385, 20114, 8),
	(135919, 296, 20121, 10),
	(135919, 497, 20151, 8),
	(135919, 471, 20141, 5),
	(135919, 171, 20084, 10),
	(135919, 486, 20052, 10),
	(135919, 247, 20101, 6),
	(135919, 448, 20052, 8),
	(134710, 105, 20101, 8),
	(134710, 194, 20034, 5),
	(134710, 2, 20063, 5),
	(134710, 153, 20044, 10),
	(134710, 371, 20114, 7),
	(134710, 303, 20143, 10),
	(134710, 212, 20074, 5),
	(134710, 333, 20053, 7),
	(134710, 149, 20112, 5),
	(134710, 230, 20103, 9),
	(134710, 218, 20131, 5),
	(134710, 41, 20112, 7),
	(134710, 124, 20062, 6),
	(134710, 172, 20102, 7),
	(134710, 363, 20154, 10),
	(134710, 420, 20073, 8),
	(134710, 312, 20033, 6),
	(134710, 492, 20051, 6),
	(134710, 342, 20124, 9),
	(134710, 128, 20114, 9),
	(296996, 392, 20033, 5),
	(296996, 298, 20091, 5),
	(296996, 61, 20131, 5),
	(296996, 110, 20093, 6),
	(296996, 470, 20151, 6),
	(296996, 75, 20144, 8),
	(296996, 36, 20053, 8),
	(296996, 369, 20084, 6),
	(296996, 360, 20032, 7),
	(296996, 485, 20112, 10),
	(215412, 396, 20041, 5),
	(215412, 71, 20102, 5),
	(215412, 201, 20031, 9),
	(215412, 7, 20044, 5),
	(215412, 277, 20113, 9),
	(215412, 57, 20084, 5),
	(215412, 431, 20052, 5),
	(215412, 120, 20113, 5),
	(215412, 239, 20083, 7),
	(215412, 32, 20032, 5),
	(215412, 312, 20094, 7),
	(215412, 160, 20114, 7),
	(140376, 80, 20114, 7),
	(140376, 482, 20054, 6),
	(140376, 56, 20033, 5),
	(140376, 472, 20082, 10),
	(140376, 315, 20153, 5),
	(140376, 6, 20141, 5),
	(140376, 167, 20071, 9),
	(140376, 322, 20064, 5),
	(140376, 184, 20152, 8),
	(127609, 359, 20134, 7),
	(127609, 227, 20034, 10),
	(127609, 245, 20131, 7),
	(127609, 45, 20033, 6),
	(127609, 212, 20054, 7),
	(127609, 437, 20154, 6),
	(127609, 69, 20102, 9),
	(127609, 367, 20134, 6),
	(127609, 319, 20051, 6),
	(127609, 142, 20123, 9),
	(127609, 249, 20051, 5),
	(127609, 88, 20052, 5),
	(127609, 364, 20093, 5),
	(127609, 1, 20084, 8),
	(212178, 55, 20111, 10),
	(212178, 193, 20144, 9),
	(212178, 405, 20042, 10),
	(212178, 339, 20113, 5),
	(212178, 343, 20092, 8),
	(212178, 25, 20093, 10),
	(212178, 171, 20122, 8),
	(212178, 202, 20142, 9),
	(212178, 434, 20152, 5),
	(212178, 481, 20041, 10),
	(212178, 275, 20142, 8),
	(212178, 450, 20041, 8),
	(212178, 378, 20133, 8),
	(212178, 315, 20121, 6),
	(212178, 265, 20114, 6),
	(212178, 160, 20033, 6),
	(212178, 111, 20093, 6),
	(212178, 355, 20111, 9),
	(212178, 397, 20132, 5),
	(265467, 57, 20111, 5),
	(265467, 28, 20071, 7),
	(265467, 17, 20082, 10),
	(265467, 378, 20054, 9),
	(265467, 104, 20064, 7),
	(265467, 128, 20104, 5),
	(265467, 316, 20091, 6),
	(265467, 102, 20054, 5),
	(265467, 266, 20093, 9),
	(265467, 315, 20082, 10),
	(207427, 489, 20114, 6),
	(207427, 170, 20043, 5),
	(207427, 439, 20093, 8),
	(207427, 184, 20032, 10),
	(207427, 194, 20072, 8),
	(207427, 175, 20073, 8),
	(207427, 87, 20072, 8),
	(207427, 163, 20111, 5),
	(207427, 469, 20093, 10),
	(207427, 361, 20144, 7),
	(207427, 255, 20034, 5),
	(287551, 123, 20082, 5),
	(287551, 171, 20124, 10),
	(287551, 59, 20131, 6),
	(287551, 9, 20103, 6),
	(287551, 157, 20111, 6),
	(287551, 20, 20133, 10),
	(287551, 411, 20034, 10),
	(287551, 342, 20074, 7),
	(287551, 131, 20083, 10),
	(287551, 150, 20132, 5),
	(287551, 134, 20101, 9),
	(155810, 455, 20051, 5),
	(238973, 29, 20061, 7),
	(238973, 341, 20033, 8),
	(238973, 421, 20104, 6),
	(238973, 144, 20131, 8),
	(238973, 500, 20124, 9),
	(238973, 277, 20033, 6),
	(238973, 21, 20113, 6),
	(200620, 343, 20081, 9),
	(200620, 157, 20121, 6),
	(225844, 372, 20072, 8),
	(225844, 493, 20062, 9),
	(225844, 355, 20133, 10),
	(258585, 484, 20134, 7),
	(258585, 339, 20104, 8),
	(258585, 85, 20143, 7),
	(258585, 416, 20122, 8),
	(258585, 30, 20112, 6),
	(258585, 211, 20074, 7),
	(258585, 16, 20033, 10),
	(258585, 387, 20071, 5),
	(258585, 128, 20064, 8),
	(258585, 141, 20114, 6),
	(258585, 329, 20143, 8),
	(122740, 360, 20053, 9),
	(122740, 472, 20041, 5),
	(122740, 266, 20152, 8),
	(122740, 19, 20112, 8),
	(144381, 9, 20134, 8),
	(144381, 218, 20052, 6),
	(232881, 356, 20132, 5),
	(179377, 131, 20043, 7),
	(179377, 308, 20134, 8),
	(179377, 20, 20083, 10),
	(179377, 168, 20113, 8),
	(179377, 216, 20061, 10),
	(179377, 336, 20132, 8),
	(212578, 57, 20154, 10),
	(212578, 358, 20053, 8),
	(212578, 98, 20094, 8),
	(212578, 101, 20144, 7),
	(212578, 439, 20073, 7),
	(212578, 110, 20134, 8),
	(212578, 357, 20152, 8),
	(212578, 113, 20101, 5),
	(212578, 177, 20104, 6),
	(212578, 112, 20104, 9),
	(212578, 431, 20083, 10),
	(212578, 358, 20122, 6),
	(212578, 93, 20032, 6),
	(212578, 333, 20123, 5),
	(205754, 144, 20144, 5),
	(205754, 6, 20043, 8),
	(205754, 139, 20033, 10),
	(205754, 259, 20144, 7),
	(205754, 357, 20062, 9),
	(205754, 72, 20154, 9),
	(205754, 371, 20141, 9),
	(205754, 483, 20111, 9),
	(205754, 264, 20122, 7),
	(205754, 372, 20042, 5),
	(205754, 286, 20064, 5),
	(205754, 175, 20152, 5),
	(205754, 185, 20101, 10),
	(205754, 166, 20133, 5),
	(205754, 456, 20144, 10),
	(205754, 63, 20053, 5),
	(205754, 253, 20112, 8),
	(101998, 179, 20132, 9),
	(101998, 220, 20112, 5),
	(101998, 170, 20083, 8),
	(101998, 315, 20082, 5),
	(101998, 201, 20054, 6),
	(101998, 460, 20043, 6),
	(101998, 238, 20051, 10),
	(227275, 352, 20081, 10),
	(227275, 36, 20061, 10),
	(227275, 136, 20111, 8),
	(227275, 55, 20133, 10),
	(227275, 309, 20152, 9),
	(227275, 282, 20113, 5),
	(227275, 75, 20063, 6),
	(227275, 240, 20032, 5),
	(227275, 194, 20092, 9),
	(227275, 432, 20123, 8),
	(227275, 288, 20031, 6),
	(227275, 453, 20034, 6),
	(227275, 339, 20121, 9),
	(210374, 240, 20093, 6),
	(210374, 301, 20051, 8),
	(210374, 171, 20143, 9),
	(251221, 265, 20032, 8),
	(251221, 359, 20123, 7),
	(251221, 71, 20111, 9),
	(251221, 96, 20152, 5),
	(251221, 63, 20103, 6),
	(251221, 461, 20091, 6),
	(251221, 329, 20062, 10),
	(251221, 324, 20091, 8),
	(251221, 349, 20101, 7),
	(251221, 53, 20043, 10),
	(251221, 436, 20063, 8),
	(197878, 390, 20061, 9),
	(197878, 4, 20074, 10),
	(197878, 312, 20052, 6),
	(197878, 11, 20044, 7),
	(197878, 111, 20114, 5),
	(197878, 255, 20143, 7),
	(197878, 31, 20122, 7),
	(197878, 309, 20041, 8),
	(197878, 448, 20122, 5),
	(141211, 407, 20074, 9),
	(141211, 311, 20102, 6),
	(141211, 221, 20031, 5),
	(141211, 118, 20092, 7),
	(141211, 238, 20141, 8),
	(141211, 238, 20053, 9),
	(141211, 64, 20154, 7),
	(141211, 33, 20123, 9),
	(141211, 19, 20142, 9),
	(141211, 239, 20154, 10),
	(141211, 390, 20123, 8),
	(141211, 253, 20131, 5),
	(141211, 340, 20133, 9),
	(141211, 206, 20091, 8),
	(141211, 367, 20053, 10),
	(156649, 267, 20061, 6),
	(156649, 162, 20082, 5),
	(156649, 439, 20034, 6),
	(156649, 54, 20093, 8),
	(156649, 71, 20033, 5),
	(273808, 371, 20133, 5),
	(273808, 206, 20143, 6),
	(273808, 70, 20102, 8),
	(273808, 221, 20132, 6),
	(273808, 7, 20081, 10),
	(273808, 318, 20143, 9),
	(273808, 58, 20031, 9),
	(273808, 422, 20121, 7),
	(273808, 339, 20132, 7),
	(280584, 168, 20063, 9),
	(268352, 205, 20121, 7),
	(268352, 329, 20033, 9),
	(137270, 477, 20123, 6),
	(137270, 222, 20062, 8),
	(137270, 300, 20033, 9),
	(137270, 15, 20133, 8),
	(137270, 244, 20054, 6),
	(137270, 91, 20124, 9),
	(137270, 169, 20141, 9),
	(137270, 173, 20113, 6),
	(137270, 244, 20104, 5),
	(137270, 386, 20042, 6),
	(137270, 140, 20131, 8),
	(137270, 271, 20112, 9),
	(207525, 176, 20091, 10),
	(207525, 280, 20122, 7),
	(207525, 304, 20102, 6),
	(207525, 154, 20054, 9),
	(207525, 155, 20131, 10),
	(207525, 449, 20082, 8),
	(207525, 172, 20081, 10),
	(207525, 284, 20094, 9),
	(207525, 434, 20123, 9),
	(207525, 385, 20074, 7),
	(207525, 446, 20072, 9),
	(207525, 78, 20033, 8),
	(207525, 456, 20111, 10),
	(207525, 327, 20053, 10),
	(112239, 373, 20124, 6),
	(112239, 440, 20123, 8),
	(112239, 62, 20062, 8),
	(112239, 229, 20134, 5),
	(112239, 246, 20082, 8),
	(112239, 168, 20111, 9),
	(112239, 495, 20081, 7),
	(112239, 83, 20102, 10),
	(112239, 402, 20051, 7),
	(112239, 120, 20033, 8),
	(112239, 325, 20112, 7),
	(112239, 422, 20153, 8),
	(102857, 380, 20111, 10),
	(102857, 118, 20142, 7),
	(102857, 461, 20064, 9),
	(102857, 259, 20122, 10),
	(102857, 425, 20113, 5),
	(102857, 101, 20123, 9),
	(102857, 136, 20092, 8),
	(102857, 329, 20154, 8),
	(102857, 268, 20061, 10),
	(102857, 387, 20102, 6),
	(102857, 327, 20153, 8),
	(102857, 158, 20084, 9),
	(102857, 289, 20092, 8),
	(102857, 409, 20131, 5),
	(108413, 354, 20074, 9),
	(108413, 341, 20134, 8),
	(108413, 31, 20091, 8),
	(108413, 95, 20074, 6),
	(108413, 167, 20062, 6),
	(108413, 70, 20151, 9),
	(108413, 409, 20071, 8),
	(108413, 343, 20112, 7),
	(108413, 11, 20091, 5),
	(108413, 457, 20152, 7),
	(108413, 220, 20121, 8),
	(108413, 493, 20033, 10),
	(108413, 336, 20131, 9),
	(108413, 376, 20113, 5),
	(108413, 146, 20141, 5),
	(108413, 252, 20054, 10),
	(108413, 158, 20141, 5),
	(108413, 204, 20152, 8),
	(108413, 373, 20034, 10),
	(108413, 375, 20122, 7),
	(111066, 215, 20104, 5),
	(111066, 175, 20071, 6),
	(111066, 377, 20033, 6),
	(111066, 57, 20031, 7),
	(111066, 375, 20063, 9),
	(111066, 246, 20074, 5),
	(111066, 450, 20054, 9),
	(111066, 301, 20124, 5),
	(111066, 308, 20154, 9),
	(111066, 103, 20042, 9),
	(111066, 329, 20041, 10),
	(111066, 164, 20093, 8),
	(111066, 255, 20051, 7),
	(111066, 302, 20084, 6),
	(163689, 219, 20133, 6),
	(163689, 263, 20133, 7),
	(163689, 155, 20141, 6),
	(163689, 408, 20074, 9),
	(267064, 69, 20154, 9),
	(267064, 85, 20072, 5),
	(267064, 268, 20153, 9),
	(267064, 43, 20121, 10),
	(267064, 389, 20101, 5),
	(267064, 402, 20074, 6),
	(267064, 7, 20093, 10),
	(267064, 211, 20154, 5),
	(267064, 69, 20051, 8),
	(267064, 374, 20033, 8),
	(267064, 373, 20033, 5),
	(267064, 436, 20063, 10),
	(267064, 229, 20043, 6),
	(267064, 362, 20111, 5),
	(267064, 402, 20134, 7),
	(267064, 299, 20041, 6),
	(285442, 145, 20062, 7),
	(285442, 338, 20141, 6),
	(181632, 34, 20083, 9),
	(181632, 475, 20064, 6),
	(181632, 20, 20071, 8),
	(181632, 350, 20061, 5),
	(181632, 186, 20042, 5),
	(181632, 36, 20111, 10),
	(181632, 59, 20083, 7),
	(181632, 256, 20041, 7),
	(181632, 4, 20131, 5),
	(181632, 78, 20141, 8),
	(181632, 94, 20131, 7),
	(181632, 44, 20112, 5),
	(181632, 466, 20103, 6),
	(181632, 261, 20032, 9),
	(181632, 409, 20103, 9),
	(181632, 468, 20094, 6),
	(181632, 366, 20092, 7),
	(181632, 370, 20044, 7),
	(181632, 71, 20122, 7),
	(243579, 454, 20092, 10),
	(243579, 291, 20064, 8),
	(243579, 344, 20073, 6),
	(243579, 126, 20104, 8),
	(243579, 260, 20151, 6),
	(243579, 16, 20101, 9),
	(243579, 488, 20081, 10),
	(243579, 323, 20094, 9),
	(243579, 71, 20143, 10),
	(243579, 263, 20044, 10),
	(243579, 130, 20034, 5),
	(243579, 3, 20121, 10),
	(243579, 386, 20063, 10),
	(141183, 164, 20031, 8),
	(141183, 269, 20073, 6),
	(141183, 105, 20102, 10),
	(141183, 181, 20043, 10),
	(141183, 189, 20144, 6),
	(141183, 147, 20092, 9),
	(141183, 446, 20034, 5),
	(141183, 154, 20071, 7),
	(141183, 496, 20073, 8),
	(141183, 390, 20041, 6),
	(141183, 280, 20101, 6),
	(141183, 146, 20033, 9),
	(141183, 109, 20083, 9),
	(141183, 263, 20091, 8),
	(141183, 150, 20084, 9),
	(141183, 102, 20141, 5),
	(280701, 396, 20154, 7),
	(280701, 122, 20104, 5),
	(280701, 358, 20052, 5),
	(280701, 467, 20091, 8),
	(280701, 144, 20083, 9),
	(280701, 376, 20153, 9),
	(280701, 415, 20134, 5),
	(280701, 71, 20041, 8),
	(280701, 340, 20062, 8),
	(280701, 49, 20152, 9),
	(280701, 177, 20072, 6),
	(280701, 38, 20123, 6),
	(280701, 373, 20061, 5),
	(280701, 195, 20034, 10),
	(280701, 200, 20111, 5),
	(280701, 41, 20033, 5),
	(280701, 73, 20052, 5),
	(280701, 263, 20053, 8),
	(137554, 235, 20094, 8),
	(137554, 445, 20081, 5),
	(137554, 19, 20113, 9),
	(137554, 269, 20123, 5),
	(137554, 71, 20043, 7),
	(137554, 185, 20112, 6),
	(137554, 219, 20064, 6),
	(137554, 405, 20154, 7),
	(137554, 477, 20041, 5),
	(220401, 223, 20084, 7),
	(220401, 129, 20082, 9),
	(220401, 388, 20041, 8),
	(220401, 1, 20121, 6),
	(220401, 306, 20061, 8),
	(220401, 118, 20123, 8),
	(220401, 169, 20072, 9),
	(220401, 455, 20154, 7),
	(220401, 171, 20082, 6),
	(220401, 289, 20132, 10),
	(220401, 378, 20064, 8),
	(220401, 38, 20053, 9),
	(220401, 495, 20082, 7),
	(220401, 101, 20034, 7),
	(220401, 201, 20074, 9),
	(220401, 349, 20131, 7),
	(220401, 338, 20031, 7),
	(220401, 171, 20081, 6),
	(220401, 186, 20071, 8),
	(220401, 320, 20114, 10),
	(251175, 186, 20124, 10),
	(251175, 471, 20063, 7),
	(251175, 30, 20053, 5),
	(251175, 159, 20141, 9),
	(251175, 428, 20133, 10),
	(251175, 375, 20142, 9),
	(251175, 362, 20063, 5),
	(251175, 494, 20121, 7),
	(251175, 99, 20053, 6),
	(251175, 410, 20093, 7),
	(101071, 356, 20153, 9),
	(101071, 274, 20154, 8),
	(101071, 320, 20074, 6),
	(101071, 34, 20114, 8),
	(101071, 447, 20061, 8),
	(101071, 30, 20032, 10),
	(101071, 330, 20064, 5),
	(101071, 45, 20133, 7),
	(101071, 290, 20072, 7),
	(101071, 170, 20061, 8),
	(101071, 378, 20072, 7),
	(101071, 214, 20044, 7),
	(211683, 345, 20144, 6),
	(211683, 172, 20112, 5),
	(211683, 416, 20121, 8),
	(211683, 50, 20131, 9),
	(211683, 56, 20113, 8),
	(211683, 252, 20041, 9),
	(211683, 295, 20143, 10),
	(211683, 123, 20102, 6),
	(211683, 330, 20123, 7),
	(211683, 333, 20154, 8),
	(211683, 292, 20124, 7),
	(211683, 21, 20134, 10),
	(123608, 355, 20043, 9),
	(123608, 315, 20114, 8),
	(123608, 34, 20081, 5),
	(123608, 321, 20121, 8),
	(123608, 214, 20143, 10),
	(123608, 316, 20111, 6),
	(123608, 68, 20133, 5),
	(123608, 499, 20143, 5),
	(123608, 88, 20043, 5),
	(123608, 157, 20152, 6),
	(294394, 90, 20094, 5),
	(294394, 263, 20102, 10),
	(294394, 51, 20063, 10),
	(294394, 293, 20084, 7),
	(214213, 334, 20134, 5),
	(214213, 114, 20151, 6),
	(214213, 241, 20152, 9),
	(214213, 223, 20111, 10),
	(214213, 393, 20084, 9),
	(198765, 438, 20093, 6),
	(198765, 128, 20104, 10),
	(198765, 104, 20083, 5),
	(198765, 355, 20051, 6),
	(198765, 165, 20154, 6),
	(198765, 69, 20052, 7),
	(198765, 194, 20054, 6),
	(198765, 85, 20033, 6),
	(198765, 30, 20111, 9),
	(198765, 466, 20142, 9),
	(198765, 486, 20114, 8),
	(198765, 50, 20153, 5),
	(266022, 74, 20083, 6),
	(266022, 80, 20122, 5),
	(266022, 155, 20084, 10),
	(266022, 209, 20152, 5),
	(266022, 271, 20033, 7),
	(286359, 424, 20072, 8),
	(286359, 290, 20091, 9),
	(286359, 481, 20074, 10),
	(286359, 395, 20062, 5),
	(286359, 348, 20094, 7),
	(286359, 57, 20041, 6),
	(286359, 459, 20152, 10),
	(286359, 129, 20102, 9),
	(286359, 273, 20071, 7),
	(286359, 99, 20114, 9),
	(286359, 290, 20133, 10),
	(286359, 52, 20074, 9),
	(286359, 133, 20094, 6),
	(286359, 94, 20153, 8),
	(286359, 248, 20054, 9),
	(161519, 232, 20073, 9),
	(161519, 457, 20152, 10),
	(122693, 312, 20114, 8),
	(122693, 199, 20084, 10),
	(122693, 462, 20122, 6),
	(122693, 342, 20154, 7),
	(122693, 272, 20121, 9),
	(122693, 268, 20154, 10),
	(122693, 314, 20131, 6),
	(122693, 177, 20033, 10),
	(122693, 83, 20061, 7),
	(122693, 144, 20053, 6),
	(141382, 326, 20031, 7),
	(141382, 460, 20144, 7),
	(141382, 54, 20133, 6),
	(141382, 287, 20142, 6),
	(141382, 456, 20091, 8),
	(141382, 55, 20142, 7),
	(141382, 94, 20082, 9),
	(141382, 207, 20141, 7),
	(141382, 52, 20132, 9),
	(141382, 362, 20072, 7),
	(141382, 278, 20134, 9),
	(225604, 419, 20142, 8),
	(225604, 292, 20072, 5),
	(225604, 418, 20144, 10),
	(225604, 271, 20142, 6),
	(225604, 214, 20142, 9),
	(225604, 497, 20103, 6),
	(225604, 58, 20134, 9),
	(225604, 69, 20081, 9),
	(225604, 369, 20082, 10),
	(225604, 448, 20062, 8),
	(206802, 404, 20102, 7),
	(206802, 431, 20042, 5),
	(206802, 391, 20084, 9),
	(206802, 112, 20154, 5),
	(280734, 443, 20123, 7),
	(280734, 58, 20131, 7),
	(280734, 492, 20082, 7),
	(280734, 496, 20123, 5),
	(280734, 204, 20121, 5),
	(280734, 462, 20123, 9),
	(280734, 92, 20133, 7),
	(280734, 297, 20124, 7),
	(280734, 479, 20063, 9),
	(280734, 259, 20084, 10),
	(280734, 329, 20124, 5),
	(280734, 98, 20041, 5),
	(280734, 31, 20094, 7),
	(280734, 214, 20031, 9),
	(280734, 184, 20033, 6),
	(280734, 377, 20124, 7),
	(280734, 353, 20053, 9),
	(280734, 186, 20141, 10),
	(280734, 336, 20052, 8),
	(280734, 325, 20054, 6),
	(141454, 139, 20053, 8),
	(141454, 349, 20112, 10),
	(141454, 243, 20081, 7),
	(141454, 126, 20152, 9),
	(141454, 141, 20103, 7),
	(141454, 72, 20033, 10),
	(141454, 452, 20031, 5),
	(145345, 217, 20151, 8),
	(145345, 79, 20124, 9),
	(145345, 206, 20074, 6),
	(145345, 474, 20143, 8),
	(145345, 124, 20073, 7),
	(145345, 249, 20072, 6),
	(145345, 417, 20124, 7),
	(145345, 317, 20032, 8),
	(110059, 444, 20122, 9),
	(110059, 435, 20041, 5),
	(110059, 157, 20141, 9),
	(110059, 34, 20081, 5),
	(110059, 417, 20032, 8),
	(110059, 354, 20101, 5),
	(110059, 51, 20073, 9),
	(214993, 367, 20153, 6),
	(122399, 111, 20144, 9),
	(122399, 29, 20053, 8),
	(122399, 175, 20074, 8),
	(122399, 444, 20063, 6),
	(122399, 477, 20054, 5),
	(122399, 438, 20083, 5),
	(122399, 279, 20093, 8),
	(122399, 20, 20102, 10),
	(122399, 56, 20064, 6),
	(122399, 492, 20062, 8),
	(242197, 254, 20052, 5),
	(242197, 221, 20133, 6),
	(242197, 28, 20132, 8),
	(242197, 130, 20153, 5),
	(242197, 318, 20051, 5),
	(242197, 350, 20084, 5),
	(242197, 32, 20133, 8),
	(242197, 335, 20101, 5),
	(222519, 488, 20043, 10),
	(222519, 139, 20102, 6),
	(222519, 329, 20062, 6),
	(222519, 383, 20084, 6),
	(222519, 223, 20103, 10),
	(222519, 438, 20123, 5),
	(222519, 122, 20132, 5),
	(222519, 222, 20143, 5),
	(222519, 444, 20053, 10),
	(222519, 361, 20073, 8),
	(222519, 388, 20152, 6),
	(253720, 324, 20124, 8),
	(253720, 221, 20154, 7),
	(253720, 148, 20093, 9),
	(226170, 365, 20123, 6),
	(226170, 224, 20111, 6),
	(226170, 318, 20054, 5),
	(226170, 125, 20143, 5),
	(226170, 47, 20124, 10),
	(226170, 383, 20073, 8),
	(226170, 497, 20141, 7),
	(226170, 414, 20074, 7),
	(226170, 284, 20073, 8),
	(226170, 244, 20102, 10),
	(226170, 409, 20052, 6),
	(226170, 398, 20072, 6),
	(226170, 160, 20133, 10),
	(226170, 295, 20073, 5),
	(226170, 147, 20124, 5),
	(226170, 239, 20041, 7),
	(246179, 371, 20094, 10),
	(246179, 201, 20132, 5),
	(246179, 364, 20144, 8),
	(246179, 168, 20124, 6),
	(246179, 15, 20124, 5),
	(114634, 296, 20063, 10),
	(114634, 395, 20101, 10),
	(133802, 201, 20053, 5),
	(133802, 454, 20154, 10),
	(133802, 31, 20043, 5),
	(133802, 306, 20043, 6),
	(133802, 191, 20094, 8),
	(133802, 317, 20034, 10),
	(133802, 114, 20103, 6),
	(133802, 105, 20041, 10),
	(133802, 446, 20063, 8),
	(133802, 5, 20122, 8),
	(133802, 497, 20121, 9),
	(133802, 165, 20071, 10),
	(133802, 442, 20094, 6),
	(133802, 393, 20123, 8),
	(133802, 290, 20133, 10),
	(133802, 123, 20041, 6),
	(133802, 194, 20124, 5),
	(275055, 411, 20073, 7),
	(275055, 440, 20131, 9),
	(102207, 49, 20102, 6),
	(102207, 81, 20102, 10),
	(102207, 287, 20091, 5),
	(102207, 300, 20144, 8),
	(102207, 428, 20114, 5),
	(102207, 447, 20044, 7),
	(102207, 280, 20093, 5),
	(102207, 36, 20111, 6),
	(102207, 221, 20144, 9),
	(102207, 132, 20141, 6),
	(275967, 437, 20061, 6),
	(275967, 376, 20123, 9),
	(275967, 161, 20092, 7),
	(275967, 470, 20092, 5),
	(275967, 55, 20051, 10),
	(275967, 407, 20131, 7),
	(275967, 423, 20112, 7),
	(275967, 278, 20033, 9),
	(275967, 200, 20112, 9),
	(275967, 423, 20142, 8),
	(275967, 155, 20031, 8),
	(275967, 399, 20123, 6),
	(275967, 267, 20151, 10),
	(275967, 210, 20061, 9),
	(243085, 471, 20133, 7),
	(243085, 371, 20114, 7),
	(243085, 43, 20141, 6),
	(243085, 498, 20071, 9),
	(243085, 151, 20134, 5),
	(162939, 389, 20093, 5),
	(162939, 145, 20092, 8),
	(162939, 125, 20102, 10),
	(162939, 177, 20051, 6),
	(162939, 144, 20152, 8),
	(162939, 459, 20103, 8),
	(162939, 37, 20073, 7),
	(162939, 120, 20124, 7),
	(162939, 317, 20092, 5),
	(162939, 231, 20132, 9),
	(162939, 178, 20102, 7),
	(162939, 361, 20033, 8),
	(162939, 313, 20082, 9),
	(237234, 29, 20132, 7),
	(237234, 330, 20111, 5),
	(237234, 40, 20092, 5),
	(237234, 250, 20032, 7),
	(237234, 234, 20084, 5),
	(237234, 344, 20101, 6),
	(237234, 346, 20102, 7),
	(237234, 173, 20133, 10),
	(237234, 308, 20143, 8),
	(237234, 8, 20073, 6),
	(237234, 147, 20051, 9),
	(237234, 164, 20053, 6),
	(237234, 65, 20041, 9),
	(116845, 132, 20113, 6),
	(116845, 358, 20132, 8),
	(116845, 23, 20082, 5),
	(116845, 438, 20101, 8),
	(116845, 46, 20072, 10),
	(116845, 250, 20091, 6),
	(116845, 97, 20104, 9),
	(116845, 227, 20054, 5),
	(116845, 456, 20033, 8),
	(116845, 265, 20093, 7),
	(116845, 395, 20061, 7),
	(116845, 393, 20142, 10),
	(116845, 382, 20081, 6),
	(124616, 34, 20063, 6),
	(124616, 61, 20144, 5),
	(124616, 202, 20102, 10),
	(124616, 171, 20031, 9),
	(124616, 81, 20081, 5),
	(124616, 466, 20033, 7),
	(124616, 160, 20082, 9),
	(124616, 82, 20131, 10),
	(124616, 277, 20053, 10),
	(124616, 439, 20034, 10),
	(183848, 286, 20053, 6),
	(183848, 311, 20092, 9),
	(183848, 182, 20152, 9),
	(183848, 27, 20031, 6),
	(183848, 171, 20073, 8),
	(183848, 151, 20152, 5),
	(164309, 112, 20152, 9),
	(164309, 45, 20053, 5),
	(164309, 366, 20134, 5),
	(164309, 272, 20044, 5),
	(164309, 233, 20072, 7),
	(164309, 360, 20141, 10),
	(164309, 93, 20093, 9),
	(164309, 266, 20052, 7),
	(164309, 247, 20154, 9),
	(164309, 163, 20144, 6),
	(294960, 66, 20052, 8),
	(294960, 202, 20112, 10),
	(294960, 296, 20053, 6),
	(294960, 437, 20084, 8),
	(268048, 300, 20141, 8),
	(268048, 348, 20104, 9),
	(268048, 236, 20114, 6),
	(268048, 407, 20103, 6),
	(268048, 217, 20102, 8),
	(268048, 464, 20113, 6),
	(268048, 354, 20102, 6),
	(268048, 161, 20134, 9),
	(268048, 289, 20102, 9),
	(268048, 418, 20093, 9),
	(268048, 145, 20082, 5),
	(268048, 391, 20083, 7),
	(268048, 254, 20091, 10),
	(268048, 166, 20063, 6),
	(268048, 191, 20144, 10),
	(268048, 366, 20074, 5),
	(268048, 400, 20061, 6),
	(177649, 326, 20082, 7),
	(177649, 17, 20081, 10),
	(177649, 410, 20073, 10),
	(177649, 391, 20033, 6),
	(177649, 413, 20051, 6),
	(177649, 305, 20041, 5),
	(177649, 59, 20042, 8),
	(177649, 380, 20074, 10),
	(177649, 290, 20143, 9),
	(177649, 259, 20073, 6),
	(177649, 249, 20052, 5),
	(177649, 44, 20121, 10),
	(177649, 297, 20031, 6),
	(177649, 269, 20153, 10),
	(177649, 41, 20043, 8),
	(177649, 482, 20033, 10),
	(177649, 235, 20154, 9),
	(177649, 315, 20094, 9),
	(115998, 118, 20061, 7),
	(115998, 74, 20133, 9),
	(115998, 55, 20103, 8),
	(115998, 453, 20093, 6),
	(115998, 393, 20033, 5),
	(115998, 499, 20152, 6),
	(115998, 477, 20091, 9),
	(256185, 347, 20083, 10),
	(256185, 169, 20033, 9),
	(256185, 133, 20103, 9),
	(256185, 81, 20124, 8),
	(256185, 494, 20061, 9),
	(256185, 1, 20104, 8),
	(256185, 329, 20121, 6),
	(256185, 96, 20071, 9),
	(256185, 177, 20144, 8),
	(256185, 371, 20051, 5),
	(256185, 375, 20072, 6),
	(256185, 21, 20043, 10),
	(256185, 347, 20051, 9),
	(256185, 338, 20104, 8),
	(256185, 220, 20141, 10),
	(256185, 350, 20102, 9),
	(256185, 157, 20053, 5),
	(256185, 327, 20122, 9),
	(256185, 386, 20043, 5),
	(112491, 357, 20091, 7),
	(112491, 367, 20032, 10),
	(112491, 221, 20093, 9),
	(112491, 190, 20073, 9),
	(233108, 463, 20093, 9),
	(233108, 154, 20094, 10),
	(233108, 152, 20103, 5),
	(233108, 197, 20114, 7),
	(233108, 7, 20041, 9),
	(233108, 274, 20061, 6),
	(233108, 270, 20083, 10),
	(195759, 202, 20043, 6),
	(195759, 403, 20034, 10),
	(195759, 289, 20112, 6),
	(195759, 245, 20143, 10),
	(195759, 254, 20143, 8),
	(195759, 227, 20131, 7),
	(195759, 362, 20041, 10),
	(195759, 110, 20152, 7),
	(195759, 222, 20151, 6),
	(195759, 139, 20124, 9),
	(195759, 77, 20091, 9),
	(195759, 432, 20061, 5),
	(195759, 380, 20141, 9),
	(195759, 284, 20094, 10),
	(195759, 168, 20101, 7),
	(195759, 124, 20043, 10),
	(195759, 360, 20041, 8),
	(195759, 175, 20153, 8),
	(195759, 223, 20073, 9),
	(243142, 110, 20092, 9),
	(243142, 287, 20081, 7),
	(243142, 287, 20104, 6),
	(243142, 73, 20143, 7),
	(243142, 423, 20061, 10),
	(243142, 125, 20141, 5),
	(243142, 77, 20032, 10),
	(243142, 213, 20042, 6),
	(243142, 350, 20153, 9),
	(243142, 158, 20063, 9),
	(243142, 283, 20081, 6),
	(243142, 446, 20124, 7),
	(243142, 70, 20082, 7),
	(243142, 313, 20101, 5),
	(243142, 191, 20144, 6),
	(260840, 440, 20043, 6),
	(260840, 145, 20053, 9),
	(198390, 137, 20133, 10),
	(198390, 363, 20083, 7),
	(198390, 131, 20054, 8),
	(198390, 365, 20031, 6),
	(198390, 227, 20074, 9),
	(198390, 63, 20103, 10),
	(198390, 90, 20041, 10),
	(198390, 63, 20121, 9),
	(198390, 49, 20132, 5),
	(198390, 435, 20042, 6),
	(198390, 115, 20091, 6),
	(198390, 378, 20082, 5),
	(198390, 374, 20041, 9),
	(198390, 330, 20074, 10),
	(198390, 162, 20054, 5),
	(198390, 154, 20094, 7),
	(198390, 365, 20123, 5),
	(198390, 210, 20041, 8),
	(198390, 170, 20102, 8),
	(198390, 256, 20112, 8),
	(299905, 374, 20083, 10),
	(299905, 384, 20113, 5),
	(299905, 218, 20092, 8),
	(299905, 54, 20111, 10),
	(299905, 396, 20121, 7),
	(299905, 144, 20092, 5),
	(299905, 325, 20094, 5),
	(299905, 56, 20123, 8),
	(299905, 113, 20072, 10),
	(299905, 366, 20052, 6),
	(299905, 259, 20103, 10),
	(203161, 255, 20081, 8),
	(203161, 284, 20032, 5),
	(203161, 36, 20082, 9),
	(203161, 245, 20073, 6),
	(203161, 91, 20081, 9),
	(203161, 264, 20073, 6),
	(203161, 115, 20093, 9),
	(203161, 354, 20152, 9),
	(203161, 283, 20131, 5),
	(203161, 139, 20101, 5),
	(203161, 251, 20094, 9),
	(203161, 137, 20154, 7),
	(203161, 367, 20033, 8),
	(203161, 222, 20144, 9),
	(195857, 104, 20142, 6),
	(195857, 166, 20121, 8),
	(191238, 496, 20041, 6),
	(191238, 420, 20111, 6),
	(191238, 387, 20033, 8),
	(191238, 155, 20103, 9),
	(191238, 485, 20073, 10),
	(191238, 434, 20043, 8),
	(191238, 254, 20074, 10),
	(191238, 255, 20034, 6),
	(191238, 294, 20083, 10),
	(191238, 297, 20092, 7),
	(292646, 406, 20081, 5),
	(292646, 143, 20124, 5),
	(292646, 387, 20143, 8),
	(292646, 66, 20044, 7),
	(292646, 438, 20144, 7),
	(292646, 370, 20042, 10),
	(292646, 425, 20102, 9),
	(292646, 412, 20122, 9),
	(292646, 435, 20033, 9),
	(292646, 460, 20093, 10),
	(269642, 223, 20144, 10),
	(269642, 105, 20131, 8),
	(269642, 312, 20134, 5),
	(269642, 222, 20121, 8),
	(254128, 357, 20152, 7),
	(254128, 233, 20104, 10),
	(254128, 79, 20061, 5),
	(254128, 96, 20072, 9),
	(254128, 193, 20051, 9),
	(254128, 378, 20052, 7),
	(254128, 71, 20132, 9),
	(132533, 257, 20122, 8),
	(132533, 36, 20091, 5),
	(132533, 372, 20042, 6),
	(132533, 348, 20102, 6),
	(132533, 244, 20043, 9),
	(132533, 387, 20032, 6),
	(132533, 194, 20113, 10),
	(132533, 499, 20112, 7),
	(132533, 397, 20131, 5),
	(132533, 285, 20071, 7),
	(211794, 433, 20101, 10),
	(211794, 3, 20141, 9),
	(211794, 132, 20144, 7),
	(211794, 309, 20101, 9),
	(211794, 328, 20121, 8),
	(211794, 353, 20071, 9),
	(211794, 149, 20143, 9),
	(211794, 420, 20083, 7),
	(211794, 266, 20071, 7),
	(209109, 348, 20122, 5),
	(209109, 103, 20092, 6),
	(209109, 13, 20071, 10),
	(209109, 368, 20132, 6),
	(209109, 18, 20114, 10),
	(209109, 107, 20082, 9),
	(209109, 266, 20061, 6),
	(209109, 213, 20094, 7),
	(209109, 130, 20104, 7),
	(209109, 309, 20144, 5),
	(209109, 116, 20101, 9),
	(209109, 449, 20053, 10),
	(209109, 20, 20052, 8),
	(209109, 463, 20061, 6),
	(209109, 312, 20144, 8),
	(209109, 276, 20123, 6),
	(207339, 283, 20043, 5),
	(207339, 161, 20042, 9),
	(207339, 243, 20114, 6),
	(207339, 67, 20151, 8),
	(207339, 443, 20044, 8),
	(207339, 19, 20042, 10),
	(207339, 364, 20062, 6),
	(207339, 67, 20032, 9),
	(207339, 377, 20101, 8),
	(207339, 351, 20141, 10),
	(207339, 292, 20113, 7),
	(207339, 135, 20044, 9),
	(207339, 52, 20153, 9),
	(207339, 270, 20052, 9),
	(207339, 278, 20083, 9),
	(207339, 270, 20063, 10),
	(207339, 273, 20062, 6),
	(260576, 357, 20083, 8),
	(260576, 249, 20121, 9),
	(260576, 375, 20074, 5),
	(260576, 178, 20154, 8),
	(260576, 156, 20093, 10),
	(260576, 72, 20134, 7),
	(260576, 352, 20101, 7),
	(260576, 283, 20131, 9),
	(260576, 442, 20132, 8),
	(260576, 248, 20111, 6),
	(260576, 74, 20123, 6),
	(260576, 423, 20044, 9),
	(156419, 81, 20144, 5),
	(156419, 430, 20084, 5),
	(156419, 432, 20084, 6),
	(152721, 235, 20091, 5),
	(152721, 18, 20111, 5),
	(152721, 204, 20043, 7),
	(152721, 28, 20054, 8),
	(152721, 23, 20142, 9),
	(152721, 165, 20081, 10),
	(152721, 243, 20073, 5),
	(152721, 365, 20072, 9),
	(152721, 496, 20153, 5),
	(152721, 169, 20143, 9),
	(152721, 198, 20042, 6),
	(152721, 286, 20084, 5),
	(152721, 297, 20041, 10),
	(152721, 153, 20073, 8),
	(152721, 218, 20083, 6),
	(152721, 4, 20041, 5),
	(152721, 164, 20043, 8),
	(152721, 374, 20082, 8),
	(152721, 2, 20062, 6),
	(152721, 116, 20153, 5),
	(146587, 191, 20081, 9),
	(146587, 339, 20141, 6),
	(146587, 118, 20042, 6),
	(146587, 357, 20152, 10),
	(242009, 325, 20151, 5),
	(242009, 499, 20142, 9),
	(242009, 22, 20132, 7),
	(242009, 375, 20152, 10),
	(242009, 386, 20101, 8),
	(242009, 299, 20144, 10),
	(242009, 209, 20113, 9),
	(242009, 408, 20034, 5),
	(242009, 361, 20062, 7),
	(242009, 492, 20111, 7),
	(242009, 437, 20113, 5),
	(242009, 357, 20133, 8),
	(242009, 354, 20051, 5),
	(242009, 332, 20082, 5),
	(242009, 337, 20143, 10),
	(242009, 19, 20034, 7),
	(242009, 126, 20103, 7),
	(242009, 39, 20103, 8),
	(242009, 61, 20061, 10),
	(118992, 417, 20113, 7),
	(118992, 9, 20074, 10),
	(118992, 262, 20123, 8),
	(118992, 61, 20093, 9),
	(118992, 174, 20054, 9),
	(118992, 250, 20094, 6),
	(118992, 446, 20111, 5),
	(118992, 104, 20031, 9),
	(118992, 103, 20031, 9),
	(118992, 158, 20034, 7),
	(118992, 117, 20094, 7),
	(118992, 443, 20051, 9),
	(118992, 272, 20103, 7),
	(118992, 325, 20122, 7),
	(118992, 363, 20124, 8),
	(118992, 60, 20051, 9),
	(118992, 77, 20051, 9),
	(185770, 201, 20033, 7),
	(185770, 449, 20054, 7),
	(185770, 175, 20094, 5),
	(185770, 121, 20113, 9),
	(240697, 476, 20052, 9),
	(240697, 76, 20031, 5),
	(240697, 53, 20113, 9),
	(240697, 111, 20064, 5),
	(240697, 55, 20062, 7),
	(240697, 273, 20084, 8),
	(240697, 158, 20031, 10),
	(238136, 31, 20062, 8),
	(238136, 75, 20132, 5),
	(238136, 451, 20034, 10),
	(238136, 127, 20152, 6),
	(238136, 333, 20053, 5),
	(238136, 64, 20134, 5),
	(238136, 166, 20101, 9),
	(238136, 216, 20142, 5),
	(238136, 322, 20091, 7),
	(238136, 323, 20064, 6),
	(238136, 105, 20153, 10),
	(238136, 266, 20081, 5),
	(231566, 453, 20124, 5),
	(231566, 428, 20074, 5),
	(231566, 349, 20112, 9),
	(231566, 250, 20113, 9),
	(231566, 212, 20154, 10),
	(231566, 500, 20134, 9),
	(231566, 491, 20041, 10),
	(231566, 449, 20072, 9),
	(231566, 213, 20141, 9),
	(231566, 451, 20102, 9),
	(231566, 133, 20141, 8),
	(231566, 357, 20132, 9),
	(271107, 3, 20034, 9),
	(271107, 65, 20131, 7),
	(271107, 93, 20092, 8),
	(271107, 49, 20114, 6),
	(271107, 473, 20063, 6),
	(271107, 128, 20103, 6),
	(271107, 382, 20132, 9),
	(271107, 484, 20064, 8),
	(271107, 430, 20153, 5),
	(271107, 268, 20073, 5),
	(271107, 280, 20033, 6),
	(271107, 79, 20081, 7),
	(271107, 383, 20052, 9),
	(271107, 135, 20144, 8),
	(271107, 479, 20042, 10),
	(276625, 377, 20081, 8),
	(276625, 43, 20153, 9),
	(276625, 41, 20063, 7),
	(276625, 405, 20054, 8),
	(276625, 90, 20043, 6),
	(276625, 438, 20031, 10),
	(276625, 378, 20083, 6),
	(276625, 50, 20153, 8),
	(276625, 178, 20083, 8),
	(276625, 436, 20142, 8),
	(276625, 449, 20043, 6),
	(276625, 356, 20063, 10),
	(276625, 164, 20044, 7),
	(276625, 399, 20063, 10),
	(276625, 59, 20094, 5),
	(276625, 486, 20053, 6),
	(249771, 367, 20133, 6),
	(249771, 155, 20033, 9),
	(249771, 354, 20042, 9),
	(249771, 185, 20034, 10),
	(249771, 338, 20144, 10),
	(249771, 453, 20091, 8),
	(249771, 52, 20144, 5),
	(249771, 203, 20074, 8),
	(249771, 294, 20083, 6),
	(249771, 368, 20082, 5),
	(249771, 420, 20132, 9),
	(249771, 383, 20134, 7),
	(249771, 269, 20043, 5),
	(249771, 259, 20152, 5),
	(249771, 130, 20141, 6),
	(249771, 368, 20064, 10),
	(249771, 75, 20042, 6),
	(249771, 191, 20104, 8),
	(249771, 159, 20083, 6),
	(179839, 445, 20034, 6),
	(179839, 217, 20144, 8),
	(179839, 48, 20101, 10),
	(179839, 289, 20074, 9),
	(179839, 353, 20152, 10),
	(179839, 487, 20083, 8),
	(179839, 25, 20141, 10),
	(179839, 267, 20144, 5),
	(179839, 348, 20031, 7),
	(179839, 59, 20133, 7),
	(179839, 85, 20151, 9),
	(179839, 63, 20031, 5),
	(179839, 59, 20104, 8),
	(179839, 204, 20111, 10),
	(179839, 375, 20102, 5),
	(179839, 174, 20061, 9),
	(179839, 352, 20074, 6),
	(179839, 101, 20144, 6),
	(179839, 33, 20073, 6),
	(179839, 282, 20074, 7),
	(207813, 80, 20043, 6),
	(207813, 82, 20093, 7),
	(207813, 89, 20051, 5),
	(207813, 458, 20063, 8),
	(207813, 4, 20074, 6),
	(207813, 466, 20114, 10),
	(207813, 486, 20114, 7),
	(207813, 267, 20144, 10),
	(207813, 153, 20034, 7),
	(207813, 216, 20073, 8),
	(207813, 114, 20083, 9),
	(207813, 489, 20081, 6),
	(207813, 312, 20141, 6),
	(207813, 301, 20044, 5),
	(207813, 370, 20032, 6),
	(207813, 65, 20144, 9),
	(207813, 13, 20081, 7),
	(207813, 406, 20091, 5),
	(248909, 272, 20074, 7),
	(248909, 208, 20152, 10),
	(248909, 384, 20132, 5),
	(248909, 54, 20131, 10),
	(248909, 391, 20063, 5),
	(248909, 309, 20091, 9),
	(248909, 338, 20034, 10),
	(248909, 227, 20054, 8),
	(248909, 300, 20122, 5),
	(248909, 23, 20114, 6),
	(248909, 427, 20062, 10),
	(248909, 81, 20054, 6),
	(248909, 479, 20131, 8),
	(248909, 7, 20151, 7),
	(248909, 233, 20064, 8),
	(248909, 234, 20093, 5),
	(248909, 190, 20092, 6),
	(130466, 194, 20142, 10),
	(130466, 57, 20031, 9),
	(130466, 388, 20082, 7),
	(130466, 147, 20142, 6),
	(130466, 137, 20141, 8),
	(130466, 424, 20094, 10),
	(130466, 297, 20132, 8),
	(130466, 274, 20114, 7),
	(130466, 22, 20131, 6),
	(120486, 385, 20063, 10),
	(120486, 305, 20153, 10),
	(120486, 274, 20031, 8),
	(120486, 297, 20101, 10),
	(120486, 268, 20121, 5),
	(120486, 43, 20091, 7),
	(120486, 29, 20043, 9),
	(120486, 50, 20134, 5),
	(150413, 161, 20134, 9),
	(150413, 183, 20081, 6),
	(150413, 381, 20083, 7),
	(150413, 418, 20084, 8),
	(150413, 148, 20083, 7),
	(150413, 207, 20042, 5),
	(150413, 485, 20032, 5),
	(150413, 356, 20131, 5),
	(150413, 340, 20142, 7),
	(150413, 236, 20113, 7),
	(150413, 150, 20071, 8),
	(217377, 301, 20082, 6),
	(217377, 8, 20061, 9),
	(217377, 359, 20054, 7),
	(217377, 79, 20044, 5),
	(217377, 315, 20084, 6),
	(235841, 79, 20082, 9),
	(235841, 362, 20034, 6),
	(235841, 337, 20043, 10),
	(235841, 104, 20092, 10),
	(235841, 31, 20071, 7),
	(235841, 73, 20072, 5),
	(235841, 130, 20043, 6),
	(235841, 191, 20094, 7),
	(235841, 397, 20122, 7),
	(235841, 482, 20061, 8),
	(235841, 328, 20092, 10),
	(235841, 157, 20131, 10),
	(235841, 393, 20041, 8),
	(235841, 342, 20101, 9),
	(235841, 8, 20072, 9),
	(235841, 105, 20113, 10),
	(235841, 350, 20142, 8),
	(235841, 32, 20091, 7),
	(235841, 140, 20142, 7),
	(192659, 56, 20103, 9),
	(192659, 44, 20044, 9),
	(192659, 95, 20093, 6),
	(192659, 349, 20152, 6),
	(192659, 114, 20111, 10),
	(192659, 246, 20074, 10),
	(192659, 393, 20094, 10),
	(192659, 323, 20102, 9),
	(192659, 375, 20082, 8),
	(192659, 68, 20102, 5),
	(192659, 237, 20051, 6),
	(192659, 441, 20093, 7),
	(192659, 494, 20143, 5),
	(192659, 296, 20083, 9),
	(192659, 292, 20033, 5),
	(192659, 61, 20132, 9),
	(192659, 16, 20102, 7),
	(116721, 355, 20104, 6),
	(116721, 95, 20112, 9),
	(116721, 370, 20054, 9),
	(116721, 158, 20153, 9),
	(116721, 113, 20133, 8),
	(116721, 114, 20034, 9),
	(116721, 183, 20052, 10),
	(116721, 473, 20131, 9),
	(116721, 469, 20121, 5),
	(116721, 408, 20123, 7),
	(116721, 303, 20121, 7),
	(116721, 279, 20054, 9),
	(116721, 46, 20111, 8),
	(116721, 388, 20114, 9),
	(116721, 356, 20144, 9),
	(116721, 471, 20074, 5),
	(116721, 299, 20103, 10),
	(211858, 230, 20123, 6),
	(211858, 473, 20052, 6),
	(211858, 15, 20094, 10),
	(211858, 302, 20092, 9),
	(211858, 84, 20141, 5),
	(211858, 498, 20103, 5),
	(211858, 261, 20104, 9),
	(211858, 264, 20143, 9),
	(211858, 128, 20082, 6),
	(211858, 82, 20084, 5),
	(211858, 449, 20142, 6),
	(211858, 92, 20031, 7),
	(211858, 354, 20054, 9),
	(211858, 374, 20071, 5),
	(211858, 463, 20114, 9),
	(211858, 451, 20094, 10),
	(211858, 50, 20153, 8),
	(211858, 364, 20053, 9),
	(211858, 372, 20141, 5),
	(211858, 419, 20073, 9),
	(149211, 45, 20082, 7),
	(149211, 66, 20104, 6),
	(149211, 210, 20102, 8),
	(149211, 204, 20074, 6),
	(149211, 7, 20124, 7),
	(149211, 52, 20132, 5),
	(149211, 392, 20103, 8),
	(149211, 396, 20111, 10),
	(240398, 419, 20051, 5),
	(240398, 462, 20051, 6),
	(240398, 260, 20144, 7),
	(240398, 241, 20132, 7),
	(240398, 126, 20132, 9),
	(240398, 140, 20094, 8),
	(192155, 64, 20133, 5),
	(192155, 78, 20071, 9),
	(192155, 149, 20042, 9),
	(192155, 394, 20094, 9),
	(161791, 269, 20052, 5),
	(161791, 224, 20153, 6),
	(161791, 446, 20062, 5),
	(161791, 171, 20072, 8),
	(161791, 475, 20131, 9),
	(260435, 272, 20143, 6),
	(260435, 206, 20122, 8),
	(260435, 369, 20062, 6),
	(260435, 316, 20033, 8),
	(260435, 175, 20033, 10),
	(260435, 449, 20111, 7),
	(260435, 315, 20063, 9),
	(260435, 299, 20113, 9),
	(260435, 413, 20081, 10),
	(260435, 400, 20121, 9),
	(260435, 80, 20091, 8),
	(260435, 375, 20092, 5),
	(260435, 323, 20062, 8),
	(220698, 99, 20094, 7),
	(220698, 182, 20154, 7),
	(230743, 281, 20091, 9),
	(230743, 197, 20102, 9),
	(230743, 358, 20061, 10),
	(230743, 375, 20112, 5),
	(230743, 100, 20111, 5),
	(230743, 140, 20042, 8),
	(230743, 450, 20072, 6),
	(230743, 19, 20121, 9),
	(230743, 386, 20041, 6),
	(230743, 338, 20094, 9),
	(230743, 340, 20132, 8),
	(230743, 148, 20054, 6),
	(230743, 466, 20153, 8),
	(220177, 117, 20034, 9),
	(220177, 21, 20103, 7),
	(220177, 310, 20031, 9),
	(220177, 398, 20041, 5),
	(220177, 473, 20134, 9),
	(220177, 369, 20042, 8),
	(220177, 333, 20094, 6),
	(128885, 8, 20081, 9),
	(128885, 383, 20143, 10),
	(128885, 130, 20154, 9),
	(128885, 169, 20103, 7),
	(128885, 252, 20082, 7),
	(128885, 347, 20084, 5),
	(128885, 301, 20064, 9),
	(128885, 51, 20111, 9),
	(128885, 354, 20054, 6),
	(128885, 172, 20034, 7),
	(128885, 483, 20132, 8),
	(128885, 423, 20061, 8),
	(128885, 319, 20052, 10),
	(128885, 109, 20103, 9),
	(128885, 280, 20033, 9),
	(128885, 393, 20031, 6),
	(168948, 202, 20084, 5),
	(168948, 62, 20154, 7),
	(168948, 447, 20141, 9),
	(168948, 69, 20094, 5),
	(168948, 171, 20054, 10),
	(106344, 279, 20034, 5),
	(106344, 39, 20082, 5),
	(106344, 435, 20151, 8),
	(106344, 300, 20154, 6),
	(106344, 168, 20132, 5),
	(106244, 336, 20103, 6),
	(106244, 22, 20081, 6),
	(106244, 131, 20114, 5),
	(106244, 371, 20113, 7),
	(106244, 100, 20113, 7),
	(106244, 100, 20152, 10),
	(106244, 211, 20081, 7),
	(106244, 105, 20124, 6),
	(106244, 463, 20114, 9),
	(106244, 175, 20152, 7),
	(106244, 164, 20101, 7),
	(106244, 99, 20071, 5),
	(106244, 63, 20082, 7),
	(106244, 261, 20104, 7),
	(268136, 103, 20092, 8),
	(268136, 110, 20111, 6),
	(268136, 170, 20083, 7),
	(268136, 177, 20121, 5),
	(268136, 418, 20111, 8),
	(268136, 380, 20034, 8),
	(135881, 423, 20153, 8),
	(135881, 102, 20144, 9),
	(135881, 453, 20072, 5),
	(135881, 104, 20041, 5),
	(135881, 38, 20103, 8),
	(135881, 183, 20072, 5),
	(135881, 386, 20133, 7),
	(135881, 280, 20153, 10),
	(135881, 118, 20134, 6),
	(135881, 49, 20032, 8),
	(137990, 84, 20062, 5),
	(137990, 63, 20141, 5),
	(156307, 170, 20031, 6),
	(156307, 77, 20063, 6),
	(156307, 55, 20043, 6),
	(156307, 396, 20071, 10),
	(156307, 426, 20143, 10),
	(156307, 61, 20103, 7),
	(156307, 355, 20153, 6),
	(166035, 405, 20113, 10),
	(166035, 255, 20082, 10),
	(166035, 119, 20093, 5),
	(166035, 182, 20034, 10),
	(166035, 270, 20083, 10),
	(166035, 126, 20082, 9),
	(166035, 42, 20091, 10),
	(166035, 90, 20063, 5),
	(166035, 80, 20044, 9),
	(166035, 445, 20051, 7),
	(166035, 143, 20133, 6),
	(166035, 112, 20084, 7),
	(166035, 395, 20152, 10),
	(166035, 357, 20064, 7),
	(166035, 158, 20063, 6),
	(166035, 371, 20093, 8),
	(166035, 107, 20053, 9),
	(248402, 108, 20114, 5),
	(248402, 428, 20131, 5),
	(248402, 369, 20092, 7),
	(248402, 492, 20144, 7),
	(248402, 9, 20081, 8),
	(248402, 421, 20034, 6),
	(248402, 295, 20141, 6),
	(248402, 257, 20032, 8),
	(248402, 227, 20074, 7),
	(248402, 145, 20143, 7),
	(248402, 443, 20123, 8),
	(248402, 461, 20044, 6),
	(248402, 15, 20051, 10),
	(248402, 205, 20133, 8),
	(248402, 260, 20081, 8),
	(248402, 316, 20063, 8),
	(248402, 442, 20141, 10),
	(248402, 375, 20131, 7),
	(248402, 392, 20112, 7),
	(248402, 95, 20094, 6),
	(228070, 1, 20152, 5),
	(228070, 89, 20153, 10),
	(228070, 205, 20131, 10),
	(109110, 58, 20131, 10),
	(109110, 456, 20121, 5),
	(126172, 84, 20114, 6),
	(126172, 148, 20072, 10),
	(126172, 401, 20124, 6),
	(126172, 42, 20052, 8),
	(126172, 96, 20142, 6),
	(126172, 303, 20102, 9),
	(126172, 107, 20084, 10),
	(126172, 231, 20083, 10),
	(126172, 416, 20061, 10),
	(126172, 19, 20051, 5),
	(126172, 102, 20031, 5),
	(126172, 8, 20154, 8),
	(126172, 79, 20153, 6),
	(126172, 71, 20043, 7),
	(126172, 431, 20033, 7),
	(126172, 219, 20123, 10),
	(239545, 108, 20094, 7),
	(239545, 143, 20061, 7),
	(239545, 160, 20053, 8),
	(239545, 295, 20041, 10),
	(239545, 69, 20081, 9),
	(239545, 486, 20044, 9),
	(239545, 14, 20031, 9),
	(239545, 307, 20054, 8),
	(239545, 447, 20112, 5),
	(270502, 102, 20152, 10),
	(270502, 216, 20102, 7),
	(270502, 375, 20083, 7),
	(270502, 389, 20141, 6),
	(270502, 124, 20031, 5),
	(270502, 24, 20123, 10),
	(270502, 329, 20051, 8),
	(270502, 220, 20081, 9),
	(270502, 410, 20113, 8),
	(270502, 9, 20052, 5),
	(270502, 382, 20151, 8),
	(178934, 310, 20114, 9),
	(178934, 491, 20101, 8),
	(178934, 174, 20034, 6),
	(241997, 492, 20123, 8),
	(241997, 468, 20154, 6),
	(157139, 496, 20153, 6),
	(157139, 256, 20081, 6),
	(157139, 161, 20062, 6),
	(157139, 258, 20143, 9),
	(157139, 468, 20071, 8),
	(157139, 199, 20061, 8),
	(157139, 227, 20132, 9),
	(157139, 220, 20041, 6),
	(157139, 15, 20092, 9),
	(157139, 140, 20041, 10),
	(157139, 253, 20102, 5),
	(157139, 420, 20124, 7),
	(157139, 78, 20061, 9),
	(157139, 292, 20034, 5),
	(157139, 246, 20062, 7),
	(173599, 480, 20092, 10),
	(173599, 133, 20153, 7),
	(173599, 489, 20151, 5),
	(173599, 458, 20112, 8),
	(173599, 377, 20063, 10),
	(266347, 132, 20052, 8),
	(266347, 77, 20032, 6),
	(266347, 495, 20131, 5),
	(266347, 218, 20092, 8),
	(266347, 255, 20143, 10),
	(266347, 4, 20123, 7),
	(266347, 27, 20093, 6),
	(217797, 65, 20073, 10),
	(217797, 194, 20102, 5),
	(217797, 477, 20131, 10),
	(217797, 105, 20034, 5),
	(217797, 14, 20131, 6),
	(217797, 287, 20093, 8),
	(217797, 126, 20074, 6),
	(217797, 167, 20031, 10),
	(217797, 96, 20153, 8),
	(217797, 208, 20091, 7),
	(217797, 282, 20081, 9),
	(217797, 471, 20101, 9),
	(217797, 309, 20053, 9),
	(217797, 443, 20064, 6),
	(217797, 151, 20063, 7),
	(229378, 280, 20083, 7),
	(229378, 443, 20152, 5),
	(229378, 108, 20133, 7),
	(229378, 396, 20121, 7),
	(229378, 340, 20111, 9),
	(229378, 500, 20041, 9),
	(243990, 294, 20152, 10),
	(222470, 405, 20104, 6),
	(222470, 62, 20131, 5),
	(222470, 499, 20031, 7),
	(176397, 326, 20114, 7),
	(176397, 461, 20053, 8),
	(176397, 381, 20154, 5),
	(176397, 494, 20154, 5),
	(176397, 201, 20051, 8),
	(176397, 165, 20081, 9),
	(176397, 113, 20081, 7),
	(176397, 359, 20134, 9),
	(176397, 491, 20031, 5),
	(176397, 66, 20073, 6),
	(176397, 204, 20061, 5),
	(176397, 79, 20044, 10),
	(250818, 41, 20032, 8),
	(250818, 452, 20053, 6),
	(250818, 307, 20143, 8),
	(250818, 87, 20092, 7),
	(250818, 107, 20112, 10),
	(250818, 95, 20091, 9),
	(250818, 127, 20101, 10),
	(250818, 369, 20054, 8),
	(250818, 202, 20154, 10),
	(250818, 334, 20052, 10),
	(115995, 332, 20064, 8),
	(115995, 180, 20044, 6),
	(115995, 223, 20084, 10),
	(115995, 200, 20112, 9),
	(115995, 89, 20082, 10),
	(115995, 212, 20093, 9),
	(115995, 266, 20031, 5),
	(294933, 477, 20093, 9),
	(294933, 89, 20132, 7),
	(175784, 166, 20154, 7),
	(175784, 408, 20032, 7),
	(175784, 117, 20083, 7),
	(175784, 336, 20072, 9),
	(193728, 429, 20061, 10),
	(193728, 52, 20154, 10),
	(193728, 107, 20134, 9),
	(193728, 199, 20094, 9),
	(193728, 223, 20142, 9),
	(193728, 130, 20151, 5),
	(193728, 483, 20072, 7),
	(193728, 136, 20041, 9),
	(193728, 97, 20072, 5),
	(193728, 436, 20141, 9),
	(193728, 178, 20033, 10),
	(193728, 329, 20123, 9),
	(193728, 346, 20081, 9),
	(193728, 252, 20073, 6),
	(193728, 378, 20152, 5),
	(193728, 306, 20074, 7),
	(193728, 268, 20122, 6),
	(193728, 176, 20041, 7),
	(193728, 242, 20124, 6),
	(102791, 56, 20053, 8),
	(102791, 155, 20081, 9),
	(102791, 452, 20152, 10),
	(102791, 112, 20034, 7),
	(102791, 94, 20114, 8),
	(102791, 49, 20083, 9),
	(102791, 178, 20063, 6),
	(102791, 100, 20071, 5),
	(102791, 405, 20154, 6),
	(102791, 298, 20131, 7),
	(102791, 443, 20082, 5),
	(102791, 139, 20033, 8),
	(102791, 64, 20082, 5),
	(102791, 395, 20104, 8),
	(102791, 53, 20153, 10),
	(102791, 285, 20152, 8),
	(102791, 192, 20122, 6),
	(102791, 496, 20031, 9),
	(102791, 39, 20152, 7),
	(164204, 300, 20151, 8),
	(164204, 77, 20051, 6),
	(164204, 231, 20143, 9),
	(164204, 364, 20124, 7),
	(164204, 188, 20114, 8),
	(164204, 185, 20154, 10),
	(164204, 5, 20031, 5),
	(164204, 45, 20132, 7),
	(164204, 22, 20072, 6),
	(164204, 167, 20102, 10),
	(164204, 187, 20123, 7),
	(164204, 347, 20141, 7),
	(101654, 161, 20101, 7),
	(101654, 449, 20084, 10),
	(101654, 174, 20052, 7),
	(101654, 99, 20101, 5),
	(101654, 341, 20152, 6),
	(101654, 7, 20131, 5),
	(101654, 333, 20052, 8),
	(101654, 381, 20131, 8),
	(101654, 326, 20053, 9),
	(162199, 88, 20111, 7),
	(162199, 271, 20112, 9),
	(162199, 299, 20101, 7),
	(162199, 103, 20153, 7),
	(162199, 443, 20103, 8),
	(162199, 304, 20132, 10),
	(162199, 108, 20152, 7),
	(162199, 332, 20093, 6),
	(162199, 380, 20134, 7),
	(162199, 6, 20083, 7),
	(162199, 47, 20054, 7),
	(162199, 403, 20151, 5),
	(162199, 231, 20142, 9),
	(162199, 470, 20144, 5),
	(292520, 311, 20143, 8),
	(292520, 130, 20063, 5),
	(292520, 461, 20122, 8),
	(292520, 256, 20052, 5),
	(139193, 368, 20131, 9),
	(139193, 287, 20093, 10),
	(139193, 300, 20144, 7),
	(139193, 253, 20093, 9),
	(139193, 447, 20033, 10),
	(117975, 493, 20104, 8),
	(117975, 308, 20134, 7),
	(117975, 42, 20131, 6),
	(117975, 114, 20112, 7),
	(117975, 43, 20052, 9),
	(117975, 211, 20144, 7),
	(117975, 351, 20122, 8),
	(117975, 452, 20034, 8),
	(117975, 121, 20094, 7),
	(117975, 26, 20041, 10),
	(117975, 190, 20051, 6),
	(117975, 27, 20064, 6),
	(117975, 72, 20041, 7),
	(117975, 353, 20082, 6),
	(117975, 322, 20082, 5),
	(117975, 338, 20093, 5),
	(117975, 418, 20084, 7),
	(117975, 285, 20033, 10),
	(291674, 337, 20104, 5),
	(291674, 395, 20103, 5),
	(291674, 175, 20121, 10),
	(291674, 40, 20094, 10),
	(291674, 134, 20084, 5),
	(291674, 100, 20152, 8),
	(291674, 189, 20062, 9),
	(291674, 241, 20144, 8),
	(222594, 8, 20132, 10),
	(222594, 151, 20092, 5),
	(222594, 34, 20094, 7),
	(222594, 326, 20132, 10),
	(222594, 88, 20043, 8),
	(288518, 470, 20054, 5),
	(255091, 489, 20154, 7),
	(255091, 122, 20063, 6),
	(255091, 315, 20073, 6),
	(255091, 283, 20043, 9),
	(255091, 498, 20063, 7),
	(255091, 287, 20044, 5),
	(255091, 4, 20121, 6),
	(255091, 406, 20122, 6),
	(255091, 349, 20041, 5),
	(255091, 368, 20083, 6),
	(255091, 40, 20042, 9),
	(255091, 170, 20113, 9),
	(255091, 360, 20093, 7),
	(255091, 468, 20031, 10),
	(255091, 154, 20043, 8),
	(155889, 203, 20043, 10),
	(155889, 448, 20052, 7),
	(155889, 26, 20152, 8),
	(155889, 89, 20044, 5),
	(155889, 461, 20091, 9),
	(155889, 360, 20124, 10),
	(155889, 101, 20081, 9),
	(155889, 230, 20061, 6),
	(155889, 352, 20113, 7),
	(155889, 25, 20083, 9),
	(155889, 413, 20074, 5),
	(155889, 412, 20064, 5),
	(155889, 452, 20043, 5),
	(155889, 446, 20072, 8),
	(155889, 481, 20033, 10),
	(155889, 308, 20142, 7),
	(155889, 419, 20143, 5),
	(242313, 212, 20093, 7),
	(242313, 215, 20154, 5),
	(242313, 452, 20144, 5),
	(242313, 302, 20104, 6),
	(242313, 291, 20033, 8),
	(242313, 306, 20072, 10),
	(242313, 395, 20101, 5),
	(242313, 489, 20072, 8),
	(242313, 22, 20082, 9),
	(242313, 376, 20041, 10),
	(242313, 386, 20101, 9),
	(242313, 455, 20103, 7),
	(242313, 345, 20083, 8),
	(294217, 159, 20112, 7),
	(294217, 426, 20102, 8),
	(294217, 282, 20094, 5),
	(294217, 345, 20083, 5),
	(294217, 336, 20033, 9),
	(294217, 361, 20034, 7),
	(294217, 207, 20113, 7),
	(294217, 482, 20153, 7),
	(294217, 240, 20053, 9),
	(294217, 77, 20041, 7),
	(287773, 188, 20101, 5),
	(287773, 361, 20151, 6),
	(287773, 106, 20111, 8),
	(287773, 385, 20032, 10),
	(287773, 43, 20034, 5),
	(287773, 191, 20132, 6),
	(287773, 393, 20141, 9),
	(287773, 211, 20042, 7),
	(287773, 17, 20133, 8),
	(287773, 11, 20152, 9),
	(287773, 357, 20132, 7),
	(287773, 96, 20154, 6),
	(287773, 35, 20143, 6),
	(287773, 17, 20103, 10),
	(287773, 43, 20102, 6),
	(182239, 464, 20123, 7),
	(182239, 298, 20033, 10),
	(182239, 220, 20081, 9),
	(182239, 267, 20043, 5),
	(182239, 109, 20111, 5),
	(182239, 167, 20062, 5),
	(182239, 231, 20101, 10),
	(182239, 484, 20041, 6),
	(182239, 276, 20092, 6),
	(182239, 78, 20103, 8),
	(182239, 178, 20111, 10),
	(182239, 202, 20102, 7),
	(182239, 1, 20131, 6),
	(182239, 243, 20062, 9),
	(214084, 348, 20132, 8),
	(214084, 272, 20132, 8),
	(214084, 249, 20101, 10),
	(214084, 441, 20083, 6),
	(214084, 456, 20071, 10),
	(214084, 187, 20152, 6),
	(214084, 434, 20051, 5),
	(214084, 187, 20141, 8),
	(214084, 287, 20113, 8),
	(214084, 134, 20082, 9),
	(214084, 342, 20061, 6),
	(214084, 459, 20112, 10),
	(214084, 358, 20133, 9),
	(214084, 311, 20052, 8),
	(192188, 155, 20113, 8),
	(192188, 395, 20064, 7),
	(192188, 47, 20142, 10),
	(192188, 48, 20072, 8),
	(192188, 321, 20112, 6),
	(192188, 82, 20141, 9),
	(192188, 302, 20061, 9),
	(192188, 44, 20102, 8),
	(192188, 444, 20074, 10),
	(192188, 298, 20112, 6),
	(192188, 410, 20092, 10),
	(192188, 46, 20154, 10),
	(192188, 229, 20091, 5),
	(192188, 136, 20093, 6),
	(238792, 194, 20041, 5),
	(238792, 164, 20081, 6),
	(238792, 435, 20054, 6),
	(238792, 173, 20092, 9),
	(238792, 115, 20093, 8),
	(238792, 270, 20133, 6),
	(238792, 213, 20114, 8),
	(238792, 386, 20034, 7),
	(238792, 194, 20151, 9),
	(238792, 122, 20151, 10),
	(238792, 488, 20043, 7),
	(238792, 52, 20082, 7),
	(238792, 263, 20122, 6),
	(238792, 492, 20092, 8),
	(238792, 131, 20092, 10),
	(238792, 8, 20062, 8),
	(238792, 429, 20113, 10),
	(238792, 373, 20144, 8),
	(238792, 66, 20044, 6),
	(238792, 9, 20092, 5),
	(180074, 165, 20141, 5),
	(180074, 174, 20104, 8),
	(180074, 258, 20074, 6),
	(180074, 453, 20031, 9),
	(180074, 445, 20094, 5),
	(180074, 299, 20111, 9),
	(180074, 398, 20084, 8),
	(180074, 387, 20052, 10),
	(180074, 82, 20054, 7),
	(180074, 415, 20061, 7),
	(180074, 291, 20061, 6),
	(180074, 203, 20101, 9),
	(278053, 111, 20083, 8),
	(278053, 52, 20123, 7),
	(278053, 297, 20082, 6),
	(278053, 289, 20142, 6),
	(278053, 131, 20094, 6),
	(278053, 236, 20103, 9),
	(235244, 121, 20121, 6),
	(235244, 2, 20043, 9),
	(235244, 222, 20061, 6),
	(235244, 324, 20143, 8),
	(235244, 215, 20154, 8),
	(235244, 240, 20093, 9),
	(235244, 164, 20101, 7),
	(235244, 85, 20051, 9),
	(235244, 308, 20113, 6),
	(235244, 127, 20083, 9),
	(235244, 381, 20044, 10),
	(235244, 485, 20114, 6),
	(235244, 212, 20053, 10),
	(165243, 89, 20143, 7),
	(165243, 402, 20054, 7),
	(147375, 93, 20132, 9),
	(147375, 267, 20064, 7),
	(147375, 299, 20074, 7),
	(147375, 285, 20093, 6),
	(147375, 244, 20051, 10),
	(147375, 10, 20143, 7),
	(147375, 136, 20114, 6),
	(147375, 352, 20053, 9),
	(147375, 464, 20112, 5),
	(147375, 29, 20064, 9),
	(147375, 479, 20143, 5),
	(147375, 27, 20123, 8),
	(147375, 343, 20051, 8),
	(147375, 437, 20114, 9),
	(165263, 66, 20111, 7),
	(165263, 182, 20133, 6),
	(165263, 480, 20091, 9),
	(165263, 264, 20114, 9),
	(165263, 237, 20031, 8),
	(165263, 189, 20083, 5),
	(165263, 327, 20092, 5),
	(165263, 491, 20073, 9),
	(165263, 464, 20122, 7),
	(165263, 247, 20084, 10),
	(275728, 230, 20091, 6),
	(275728, 172, 20052, 5),
	(275728, 435, 20144, 5),
	(275728, 136, 20043, 9),
	(275728, 331, 20064, 10),
	(275728, 82, 20143, 8),
	(275728, 91, 20143, 10),
	(275728, 30, 20031, 5),
	(275728, 164, 20062, 5),
	(275728, 133, 20032, 6),
	(275728, 51, 20064, 9),
	(275728, 348, 20082, 9),
	(275728, 439, 20102, 6),
	(275728, 104, 20133, 10),
	(275728, 348, 20111, 6),
	(275728, 361, 20041, 9),
	(275728, 306, 20122, 7),
	(275728, 385, 20074, 8),
	(151567, 234, 20102, 7),
	(151567, 249, 20063, 7),
	(151567, 293, 20103, 8),
	(151567, 155, 20122, 9),
	(151567, 276, 20111, 5),
	(151567, 405, 20032, 7),
	(151567, 444, 20052, 8),
	(151567, 424, 20091, 10),
	(151567, 471, 20124, 7),
	(151567, 444, 20132, 6),
	(151567, 320, 20144, 10),
	(151567, 263, 20084, 7),
	(151567, 151, 20053, 6),
	(151567, 279, 20042, 10),
	(151567, 229, 20103, 10),
	(151567, 341, 20102, 6),
	(151567, 102, 20042, 9),
	(224873, 339, 20114, 10),
	(224873, 408, 20134, 9),
	(224873, 156, 20031, 6),
	(224873, 20, 20142, 8),
	(224873, 11, 20053, 8),
	(224873, 102, 20041, 6),
	(224873, 312, 20072, 6),
	(224873, 197, 20151, 8),
	(224873, 28, 20102, 5),
	(224873, 338, 20121, 9),
	(224873, 360, 20064, 9),
	(224873, 112, 20114, 7),
	(224873, 56, 20083, 10),
	(224873, 105, 20052, 8),
	(224873, 162, 20054, 10),
	(224873, 47, 20133, 5),
	(224873, 27, 20032, 9),
	(224873, 339, 20114, 6),
	(224873, 381, 20074, 9),
	(106452, 30, 20034, 7),
	(106452, 2, 20033, 8),
	(106452, 68, 20043, 10),
	(106452, 16, 20134, 5),
	(106452, 471, 20053, 8),
	(106452, 199, 20032, 7),
	(106452, 94, 20143, 10),
	(126065, 493, 20131, 7),
	(126065, 381, 20064, 5),
	(126065, 215, 20074, 6),
	(159734, 205, 20052, 7),
	(159734, 67, 20141, 6),
	(159734, 241, 20053, 10),
	(159734, 340, 20132, 8),
	(159734, 14, 20143, 5),
	(159734, 191, 20134, 10),
	(159734, 192, 20073, 7),
	(159734, 237, 20092, 7),
	(159734, 61, 20123, 7),
	(138654, 292, 20071, 10),
	(138654, 199, 20072, 8),
	(138654, 236, 20091, 6),
	(138654, 75, 20051, 6),
	(138654, 203, 20154, 10),
	(138654, 437, 20153, 6),
	(138654, 353, 20142, 5),
	(138654, 295, 20074, 7),
	(138654, 401, 20053, 9),
	(138654, 236, 20073, 5),
	(138654, 260, 20082, 5),
	(160742, 35, 20134, 10),
	(160742, 103, 20114, 9),
	(160742, 25, 20093, 7),
	(160742, 281, 20053, 7),
	(160742, 452, 20043, 8),
	(160742, 61, 20111, 9),
	(160742, 424, 20042, 10),
	(160742, 6, 20131, 10),
	(160742, 125, 20092, 10),
	(160742, 290, 20071, 10),
	(160742, 233, 20062, 8),
	(160742, 318, 20044, 10),
	(163756, 397, 20141, 9),
	(163756, 414, 20032, 10),
	(163756, 87, 20142, 10),
	(163756, 171, 20134, 7),
	(163756, 361, 20104, 6),
	(163756, 201, 20083, 7),
	(163756, 186, 20053, 7),
	(163756, 110, 20042, 5),
	(163756, 495, 20092, 5),
	(163756, 74, 20061, 8),
	(163756, 311, 20123, 9),
	(163756, 355, 20073, 7),
	(163756, 164, 20114, 8),
	(163756, 441, 20114, 9),
	(163756, 339, 20054, 10),
	(140524, 148, 20114, 7),
	(140524, 232, 20121, 7),
	(140524, 136, 20132, 5),
	(140524, 365, 20122, 9),
	(140524, 272, 20091, 7),
	(140524, 391, 20082, 7),
	(140524, 207, 20113, 10),
	(140524, 495, 20153, 5),
	(140524, 133, 20051, 5),
	(173572, 187, 20043, 7),
	(173572, 244, 20042, 9),
	(173572, 421, 20034, 10),
	(173572, 157, 20123, 9),
	(173572, 272, 20132, 5),
	(173572, 450, 20073, 10),
	(173572, 174, 20093, 7),
	(173572, 157, 20082, 6),
	(173572, 410, 20051, 7),
	(173572, 377, 20123, 5),
	(173572, 135, 20131, 9),
	(173572, 161, 20133, 10),
	(173572, 297, 20074, 5),
	(173572, 483, 20031, 9),
	(173572, 90, 20154, 7),
	(173572, 407, 20083, 8),
	(173572, 495, 20044, 8),
	(173572, 444, 20154, 6),
	(173572, 152, 20102, 6),
	(173572, 414, 20091, 7),
	(231616, 241, 20054, 6),
	(231616, 151, 20102, 6),
	(231616, 470, 20084, 9),
	(231616, 93, 20073, 6),
	(231616, 170, 20031, 7),
	(231616, 370, 20122, 10),
	(231616, 113, 20071, 5),
	(185012, 87, 20144, 10),
	(185012, 329, 20061, 10),
	(185012, 129, 20122, 6),
	(185012, 179, 20082, 9),
	(185012, 20, 20131, 7),
	(185012, 224, 20122, 8),
	(185012, 17, 20032, 5),
	(185012, 470, 20143, 6),
	(185012, 259, 20072, 8),
	(185012, 254, 20094, 5),
	(185012, 166, 20062, 10),
	(185012, 309, 20134, 6),
	(186586, 146, 20083, 8),
	(186586, 249, 20151, 9),
	(186586, 108, 20151, 6),
	(186586, 165, 20034, 9),
	(186586, 483, 20083, 8),
	(186586, 234, 20133, 9),
	(186586, 32, 20044, 7),
	(186586, 143, 20091, 9),
	(186586, 460, 20083, 8),
	(186586, 392, 20034, 6),
	(186586, 35, 20054, 5),
	(259622, 192, 20072, 10),
	(259622, 210, 20152, 9),
	(240934, 254, 20124, 10),
	(240934, 283, 20081, 9),
	(240934, 9, 20113, 9),
	(240934, 25, 20121, 7),
	(240934, 417, 20052, 5),
	(240934, 382, 20152, 7),
	(240934, 236, 20104, 5),
	(240934, 94, 20064, 5),
	(240934, 144, 20082, 9),
	(240934, 205, 20111, 9),
	(240934, 321, 20113, 8),
	(240934, 33, 20151, 8),
	(240934, 192, 20111, 10),
	(240934, 426, 20041, 7),
	(240934, 395, 20063, 9),
	(240934, 35, 20101, 10),
	(240934, 354, 20043, 9),
	(240934, 126, 20081, 10),
	(196058, 495, 20112, 8),
	(196058, 169, 20083, 6),
	(196058, 8, 20131, 10),
	(196058, 153, 20034, 9),
	(196058, 248, 20042, 7),
	(196058, 181, 20071, 9),
	(196058, 272, 20093, 8),
	(196058, 124, 20081, 10),
	(196058, 45, 20062, 8),
	(196058, 244, 20141, 5),
	(196058, 158, 20151, 10),
	(196058, 61, 20104, 8),
	(196058, 140, 20031, 10),
	(196058, 243, 20114, 7),
	(196058, 287, 20042, 7),
	(140840, 427, 20051, 10),
	(140840, 211, 20124, 8),
	(140840, 45, 20121, 8),
	(140840, 82, 20041, 6),
	(140840, 22, 20101, 5),
	(140840, 315, 20103, 6),
	(140840, 381, 20032, 5),
	(140840, 41, 20032, 9),
	(140840, 425, 20143, 6),
	(140840, 416, 20134, 6),
	(140840, 465, 20084, 5),
	(140840, 223, 20143, 9),
	(140840, 279, 20143, 5),
	(140840, 474, 20053, 6),
	(140840, 141, 20084, 9),
	(140840, 309, 20092, 5),
	(113253, 385, 20064, 5),
	(113253, 158, 20124, 10),
	(113253, 32, 20092, 10),
	(113253, 108, 20131, 9),
	(113253, 207, 20031, 8),
	(113253, 130, 20054, 5),
	(113253, 479, 20073, 5),
	(113253, 82, 20044, 7),
	(113253, 257, 20121, 9),
	(113253, 107, 20062, 9),
	(113253, 222, 20103, 9),
	(113253, 286, 20123, 5),
	(113253, 310, 20034, 8),
	(113253, 480, 20123, 6),
	(113253, 500, 20132, 6),
	(113253, 494, 20151, 5),
	(113253, 421, 20032, 9),
	(113253, 307, 20132, 8),
	(113253, 90, 20073, 10),
	(212486, 189, 20052, 9),
	(212486, 300, 20074, 8),
	(212486, 196, 20153, 10),
	(212486, 371, 20152, 10),
	(212486, 221, 20081, 9),
	(212486, 485, 20144, 9),
	(212486, 14, 20101, 8),
	(212486, 380, 20114, 9),
	(212486, 52, 20103, 7),
	(212486, 220, 20031, 10),
	(165075, 60, 20142, 7),
	(165075, 254, 20141, 6),
	(165075, 428, 20142, 9),
	(138482, 56, 20044, 10),
	(208679, 166, 20041, 10),
	(208679, 28, 20073, 7),
	(208679, 499, 20104, 5),
	(208679, 453, 20102, 10),
	(208679, 153, 20141, 9),
	(208679, 124, 20102, 6),
	(208679, 122, 20152, 6),
	(208679, 172, 20122, 9),
	(208679, 336, 20061, 5),
	(208679, 67, 20111, 8),
	(208679, 302, 20101, 6),
	(208679, 341, 20112, 7),
	(208679, 5, 20034, 5),
	(208679, 170, 20052, 5),
	(208679, 346, 20043, 8),
	(208679, 54, 20102, 9),
	(208679, 400, 20084, 5),
	(267471, 450, 20044, 6),
	(191436, 91, 20124, 9),
	(191436, 23, 20123, 10),
	(196522, 487, 20094, 8),
	(196522, 412, 20102, 7),
	(196522, 444, 20102, 5),
	(196522, 454, 20094, 7),
	(196522, 246, 20052, 10),
	(196522, 424, 20092, 7),
	(196522, 99, 20074, 8),
	(196522, 300, 20051, 9),
	(196522, 467, 20122, 7),
	(196522, 15, 20064, 10),
	(196522, 134, 20151, 7),
	(262017, 400, 20093, 7),
	(262017, 312, 20043, 8),
	(262017, 208, 20112, 5),
	(262017, 412, 20041, 8),
	(262017, 303, 20154, 9),
	(262017, 207, 20093, 6),
	(262017, 11, 20114, 9),
	(262017, 218, 20154, 6),
	(262017, 135, 20124, 10),
	(104904, 168, 20133, 6),
	(104904, 65, 20103, 10),
	(104904, 392, 20093, 8),
	(104904, 234, 20141, 9),
	(104904, 365, 20073, 8),
	(104904, 263, 20074, 5),
	(104904, 36, 20123, 9),
	(104904, 303, 20111, 7),
	(104904, 142, 20074, 7),
	(104904, 228, 20101, 8),
	(104904, 202, 20123, 10),
	(104904, 476, 20083, 7),
	(104904, 375, 20112, 5),
	(104904, 484, 20044, 5),
	(104904, 379, 20144, 7),
	(104904, 63, 20104, 5),
	(104904, 275, 20132, 8),
	(104904, 403, 20112, 8),
	(104904, 348, 20072, 5),
	(229151, 179, 20152, 5),
	(229151, 397, 20083, 6),
	(229151, 419, 20123, 9),
	(229151, 138, 20144, 8),
	(229151, 413, 20043, 5),
	(229151, 463, 20143, 6),
	(229151, 451, 20082, 8),
	(229151, 225, 20044, 6),
	(229151, 370, 20061, 7),
	(229151, 500, 20133, 6),
	(229151, 388, 20111, 8),
	(256852, 87, 20081, 8),
	(256852, 173, 20113, 9),
	(256852, 373, 20112, 5),
	(256852, 356, 20141, 5),
	(256852, 200, 20032, 6),
	(256852, 173, 20153, 9),
	(256852, 248, 20111, 10),
	(256852, 456, 20051, 10),
	(256852, 280, 20073, 9),
	(256852, 311, 20092, 6),
	(256852, 207, 20033, 9),
	(256852, 440, 20051, 8),
	(256852, 33, 20153, 8),
	(256852, 47, 20093, 9),
	(256852, 120, 20152, 8),
	(256852, 137, 20044, 9),
	(256852, 321, 20031, 6),
	(292559, 415, 20093, 8),
	(292559, 135, 20132, 7),
	(292559, 145, 20082, 9),
	(292559, 417, 20092, 7),
	(292559, 460, 20142, 9),
	(292559, 329, 20114, 6),
	(292559, 186, 20053, 10),
	(125372, 8, 20081, 7),
	(125372, 141, 20052, 10),
	(125372, 335, 20092, 9),
	(125372, 42, 20033, 6),
	(125372, 288, 20071, 10),
	(106830, 425, 20144, 7),
	(106830, 423, 20092, 5),
	(106830, 451, 20114, 6),
	(106830, 211, 20032, 8),
	(106830, 5, 20091, 8),
	(106830, 341, 20062, 10),
	(106830, 250, 20112, 10),
	(106830, 353, 20062, 5),
	(106830, 117, 20091, 8),
	(106830, 338, 20112, 10),
	(106830, 447, 20123, 10),
	(106830, 224, 20104, 5),
	(106830, 249, 20111, 6),
	(106830, 463, 20112, 5),
	(106830, 479, 20104, 10),
	(159434, 265, 20041, 7),
	(159434, 221, 20054, 9),
	(159434, 470, 20062, 5),
	(159434, 205, 20051, 7),
	(159434, 308, 20094, 8),
	(159434, 154, 20151, 10),
	(159434, 79, 20033, 6),
	(159434, 32, 20142, 7),
	(159434, 87, 20073, 10),
	(159434, 89, 20042, 9),
	(159434, 384, 20031, 10),
	(290576, 172, 20043, 7),
	(290576, 62, 20101, 9),
	(290576, 270, 20084, 5),
	(290576, 329, 20122, 7),
	(290576, 93, 20082, 5),
	(290576, 243, 20082, 7),
	(229186, 57, 20132, 5),
	(229186, 130, 20053, 9),
	(229186, 215, 20031, 8),
	(229186, 219, 20101, 9),
	(229186, 378, 20043, 5),
	(229186, 274, 20114, 9),
	(229186, 430, 20051, 9),
	(229186, 416, 20074, 7),
	(229186, 165, 20111, 8),
	(229186, 405, 20082, 8),
	(229186, 208, 20093, 7),
	(229186, 298, 20134, 5),
	(229186, 91, 20152, 8),
	(229186, 434, 20093, 5),
	(229186, 381, 20092, 10),
	(240717, 199, 20134, 6),
	(240717, 216, 20062, 9),
	(240717, 369, 20052, 7),
	(240717, 374, 20133, 8),
	(240717, 271, 20143, 6),
	(240717, 130, 20074, 5),
	(240717, 248, 20093, 10),
	(240717, 339, 20041, 10),
	(240717, 236, 20144, 10),
	(240717, 358, 20092, 8),
	(240717, 400, 20072, 8),
	(240717, 258, 20114, 8),
	(240717, 300, 20152, 7),
	(240717, 246, 20081, 8),
	(240717, 22, 20151, 9),
	(137951, 116, 20141, 9),
	(137951, 11, 20074, 8),
	(137951, 359, 20124, 5),
	(137951, 250, 20044, 10),
	(268826, 386, 20052, 7),
	(268826, 134, 20043, 7),
	(268826, 99, 20051, 9),
	(268826, 28, 20032, 5),
	(268826, 475, 20144, 7),
	(268826, 452, 20151, 5),
	(268826, 292, 20083, 5),
	(268826, 276, 20142, 10),
	(268826, 210, 20042, 8),
	(268826, 61, 20043, 7),
	(268826, 481, 20073, 6),
	(268826, 372, 20151, 10),
	(268826, 235, 20041, 8),
	(268826, 188, 20143, 8),
	(268826, 105, 20114, 5),
	(268826, 328, 20132, 9),
	(195784, 90, 20124, 8),
	(195784, 205, 20121, 9),
	(195784, 311, 20082, 9),
	(195784, 122, 20073, 5),
	(195784, 351, 20052, 5),
	(195784, 139, 20151, 7),
	(195784, 328, 20052, 6),
	(195784, 476, 20102, 8),
	(135646, 1, 20082, 9),
	(135646, 191, 20104, 7),
	(135646, 376, 20102, 6),
	(135646, 176, 20043, 5),
	(135646, 38, 20121, 8),
	(135646, 417, 20033, 9),
	(135646, 303, 20093, 10),
	(135646, 172, 20114, 5),
	(135646, 216, 20084, 6),
	(135646, 83, 20112, 6),
	(279924, 151, 20093, 6),
	(279924, 385, 20044, 5),
	(279924, 333, 20143, 9),
	(279924, 128, 20054, 7),
	(279924, 382, 20141, 6),
	(279924, 462, 20084, 6),
	(279924, 140, 20074, 10),
	(279924, 111, 20071, 10),
	(279924, 310, 20063, 9),
	(279924, 18, 20141, 8),
	(279924, 79, 20051, 8),
	(279924, 77, 20133, 5),
	(279924, 393, 20143, 9),
	(279924, 440, 20151, 5),
	(279924, 455, 20093, 8),
	(279924, 158, 20132, 5),
	(279924, 318, 20102, 9),
	(279924, 279, 20034, 7),
	(279924, 5, 20104, 5),
	(279924, 495, 20071, 9),
	(257767, 145, 20073, 6),
	(257767, 432, 20031, 8),
	(257767, 357, 20112, 7),
	(257767, 344, 20043, 8),
	(257767, 138, 20141, 10),
	(157938, 257, 20083, 10),
	(157938, 103, 20154, 5),
	(157938, 193, 20104, 10),
	(157938, 107, 20042, 8),
	(157938, 176, 20141, 7),
	(177424, 19, 20124, 8),
	(177424, 428, 20044, 6),
	(177424, 91, 20112, 6),
	(177424, 101, 20141, 5),
	(177424, 304, 20081, 9),
	(177424, 231, 20054, 9),
	(177424, 112, 20153, 5),
	(177424, 150, 20031, 6),
	(177424, 225, 20102, 8),
	(177424, 77, 20072, 5),
	(177424, 314, 20113, 8),
	(177424, 144, 20063, 8),
	(177424, 166, 20042, 7),
	(135175, 198, 20031, 9),
	(135175, 89, 20143, 10),
	(135175, 458, 20112, 6),
	(135175, 259, 20041, 9),
	(135175, 467, 20131, 6),
	(135175, 415, 20092, 10),
	(240563, 166, 20092, 8),
	(240563, 498, 20064, 10),
	(240563, 418, 20151, 6),
	(240563, 288, 20093, 8),
	(240563, 390, 20114, 7),
	(240563, 432, 20133, 6),
	(240563, 282, 20133, 9),
	(240563, 334, 20111, 9),
	(240563, 156, 20044, 9),
	(240563, 173, 20054, 10),
	(240563, 159, 20061, 5),
	(240563, 257, 20081, 10),
	(240563, 7, 20053, 9),
	(240563, 118, 20061, 7),
	(240563, 64, 20033, 10),
	(240563, 199, 20112, 7),
	(240563, 387, 20034, 5),
	(240563, 462, 20083, 6),
	(240563, 420, 20112, 7),
	(159765, 349, 20054, 8),
	(159765, 24, 20062, 10),
	(194529, 59, 20071, 8),
	(194529, 341, 20141, 5),
	(194529, 217, 20142, 6),
	(194529, 103, 20121, 7),
	(194529, 37, 20072, 9),
	(194529, 405, 20062, 5),
	(194529, 415, 20032, 6),
	(253646, 397, 20082, 10),
	(253646, 332, 20074, 8),
	(253646, 375, 20031, 8),
	(253646, 75, 20032, 5),
	(253646, 26, 20142, 5),
	(253646, 312, 20141, 8),
	(253646, 175, 20151, 7),
	(253646, 480, 20104, 10),
	(253646, 486, 20091, 5),
	(253646, 147, 20041, 6),
	(253646, 199, 20101, 5),
	(253646, 8, 20143, 9),
	(253646, 416, 20084, 5),
	(253646, 472, 20152, 5),
	(253646, 60, 20064, 6),
	(253646, 54, 20144, 9),
	(187396, 213, 20044, 7),
	(187396, 302, 20153, 8),
	(187396, 362, 20041, 9),
	(187396, 181, 20112, 8),
	(187396, 88, 20123, 6),
	(187396, 211, 20073, 10),
	(187396, 374, 20082, 8),
	(187396, 277, 20114, 8),
	(187396, 67, 20034, 6),
	(187396, 83, 20154, 5),
	(187396, 344, 20092, 8),
	(187396, 284, 20094, 5),
	(252678, 383, 20071, 8),
	(252678, 393, 20131, 9),
	(252678, 1, 20093, 5),
	(252678, 264, 20144, 9),
	(252678, 91, 20121, 7),
	(252678, 318, 20151, 8),
	(252678, 94, 20094, 8),
	(252678, 251, 20092, 9),
	(163698, 322, 20122, 8),
	(163698, 315, 20143, 8),
	(163698, 449, 20114, 7),
	(163698, 338, 20091, 10),
	(163698, 97, 20072, 9),
	(163698, 338, 20071, 8),
	(163698, 476, 20122, 5),
	(163698, 185, 20104, 6),
	(163698, 238, 20081, 9),
	(163698, 368, 20094, 7),
	(163698, 68, 20143, 8),
	(163698, 384, 20141, 10),
	(163698, 316, 20112, 6),
	(163698, 112, 20091, 7),
	(163698, 63, 20043, 9),
	(163698, 162, 20083, 8),
	(163698, 451, 20102, 10),
	(163698, 276, 20101, 5),
	(163698, 115, 20093, 7),
	(163698, 367, 20044, 8),
	(187783, 256, 20052, 10),
	(187783, 38, 20144, 5),
	(187783, 66, 20103, 7),
	(187783, 81, 20112, 7),
	(187783, 61, 20074, 6),
	(187783, 169, 20111, 9),
	(187783, 131, 20064, 6),
	(187783, 104, 20064, 7),
	(187783, 336, 20142, 8),
	(187783, 83, 20103, 9),
	(187783, 90, 20121, 5),
	(187783, 144, 20061, 6),
	(187783, 200, 20101, 5),
	(187783, 167, 20081, 6),
	(187783, 25, 20051, 6),
	(187783, 18, 20051, 6),
	(187783, 404, 20103, 5),
	(187783, 231, 20103, 10),
	(187783, 424, 20102, 9),
	(187783, 230, 20062, 10),
	(276617, 149, 20034, 9),
	(276617, 460, 20061, 8),
	(276617, 321, 20092, 9),
	(276617, 276, 20112, 6),
	(276617, 92, 20064, 5),
	(276617, 72, 20084, 5),
	(276617, 180, 20063, 5),
	(276617, 403, 20143, 8),
	(276617, 391, 20063, 6),
	(276617, 124, 20073, 8),
	(276617, 42, 20073, 5),
	(276617, 76, 20091, 8),
	(276617, 432, 20134, 8),
	(276617, 70, 20103, 9),
	(276617, 441, 20063, 9),
	(276617, 174, 20141, 10),
	(276617, 200, 20102, 10),
	(299870, 254, 20034, 9),
	(299870, 382, 20111, 7),
	(299870, 431, 20053, 10),
	(299870, 232, 20111, 9),
	(299870, 178, 20153, 8),
	(299870, 245, 20121, 6),
	(299870, 390, 20153, 8),
	(299870, 266, 20093, 7),
	(299870, 316, 20141, 10),
	(171081, 421, 20123, 7),
	(171081, 255, 20122, 6),
	(171081, 445, 20131, 6),
	(171081, 309, 20112, 8),
	(171081, 262, 20152, 9),
	(171081, 268, 20103, 6),
	(171081, 129, 20091, 9),
	(171081, 200, 20093, 5),
	(171081, 275, 20074, 9),
	(171081, 179, 20112, 5),
	(171081, 11, 20104, 8),
	(171081, 422, 20043, 7),
	(171081, 239, 20123, 5),
	(121062, 479, 20083, 9),
	(121062, 230, 20133, 6),
	(121062, 52, 20051, 9),
	(121062, 112, 20082, 7),
	(121062, 135, 20094, 5),
	(121062, 33, 20144, 7),
	(121062, 210, 20063, 10),
	(212903, 180, 20053, 5),
	(291841, 40, 20143, 10),
	(291841, 368, 20112, 10),
	(291841, 292, 20043, 10),
	(291841, 420, 20074, 9),
	(291841, 329, 20073, 10),
	(291841, 451, 20153, 5),
	(291841, 215, 20124, 5),
	(291841, 176, 20154, 8),
	(291841, 372, 20123, 5),
	(291841, 304, 20093, 10),
	(291841, 12, 20142, 8),
	(291841, 49, 20051, 10),
	(291841, 210, 20063, 7),
	(291841, 470, 20143, 10),
	(291841, 315, 20031, 6),
	(291841, 191, 20064, 7),
	(274715, 273, 20132, 9),
	(274715, 376, 20054, 8),
	(274715, 347, 20151, 6),
	(274715, 447, 20134, 7),
	(274715, 466, 20043, 5),
	(274715, 68, 20151, 8),
	(274715, 145, 20073, 7),
	(274715, 442, 20052, 6),
	(274715, 138, 20053, 6),
	(292334, 255, 20133, 10),
	(292334, 29, 20054, 10),
	(292334, 80, 20141, 6),
	(292334, 357, 20132, 9),
	(292334, 104, 20083, 9),
	(292334, 379, 20054, 8),
	(292334, 279, 20144, 7),
	(292334, 124, 20152, 9),
	(292334, 162, 20121, 7),
	(292334, 98, 20064, 6),
	(292334, 401, 20141, 10),
	(158389, 84, 20042, 9),
	(158389, 75, 20121, 6),
	(158389, 286, 20104, 7),
	(158389, 206, 20144, 8),
	(158389, 237, 20153, 9),
	(158389, 306, 20153, 6),
	(158389, 3, 20084, 7),
	(158389, 237, 20112, 6),
	(158389, 236, 20053, 5),
	(158389, 428, 20071, 6),
	(158389, 230, 20154, 5),
	(164109, 280, 20133, 5),
	(164109, 466, 20074, 10),
	(164109, 338, 20113, 10),
	(164109, 365, 20032, 5),
	(164109, 12, 20082, 6),
	(164109, 360, 20042, 7),
	(164109, 91, 20104, 8),
	(164109, 19, 20132, 8),
	(164109, 180, 20154, 10),
	(164109, 2, 20101, 6),
	(164109, 353, 20054, 9),
	(164109, 281, 20132, 9),
	(164109, 175, 20041, 9),
	(164109, 449, 20122, 8),
	(164109, 423, 20071, 5),
	(209918, 472, 20133, 5),
	(209918, 90, 20152, 9),
	(209918, 202, 20091, 10),
	(209918, 24, 20093, 6),
	(209918, 137, 20153, 5),
	(209918, 346, 20121, 8),
	(209918, 138, 20044, 6),
	(209918, 97, 20093, 9),
	(268769, 23, 20083, 9),
	(268769, 225, 20104, 5),
	(268769, 462, 20072, 5),
	(268769, 198, 20132, 8),
	(268769, 182, 20104, 5),
	(268769, 346, 20151, 6),
	(268769, 488, 20141, 9),
	(268769, 164, 20042, 9),
	(268769, 93, 20084, 10),
	(268769, 479, 20114, 6),
	(268769, 366, 20042, 5),
	(268769, 42, 20121, 6),
	(268769, 410, 20062, 5),
	(268769, 32, 20044, 7),
	(268769, 294, 20053, 7),
	(268769, 349, 20052, 5),
	(268769, 457, 20042, 6),
	(118878, 75, 20093, 9),
	(118878, 210, 20073, 7),
	(118878, 85, 20032, 10),
	(118878, 4, 20131, 7),
	(118878, 454, 20054, 8),
	(118878, 461, 20093, 6);

SET FOREIGN_KEY_CHECKS = 1;
